=== modified file '.bzrignore'
--- .bzrignore	2012-05-17 01:55:58 +0000
+++ .bzrignore	2019-12-04 23:52:20 +0000
@@ -12,3 +12,5 @@
 plugins.d/splashy
 plugins.d/usplash
 plugins.d/plymouth
+plugin-helpers/mandos-client-iprouteadddel
+dracut-module/password-agent

=== modified file 'DBUS-API'
--- DBUS-API	2019-02-10 04:20:26 +0000
+++ DBUS-API	2020-07-04 11:58:52 +0000
@@ -55,10 +55,10 @@
    
    | Name                    | Type | Access     | clients.conf        |
    |-------------------------+------+------------+---------------------|
-   | ApprovedByDefault       | b    | Read/Write | approved_by_default |
    | ApprovalDelay (a)       | t    | Read/Write | approval_delay      |
    | ApprovalDuration (a)    | t    | Read/Write | approval_duration   |
    | ApprovalPending (b)     | b    | Read       | N/A                 |
+   | ApprovedByDefault       | b    | Read/Write | approved_by_default |
    | Checker                 | s    | Read/Write | checker             |
    | CheckerRunning (c)      | b    | Read/Write | N/A                 |
    | Created (d)             | s    | Read       | N/A                 |
@@ -66,9 +66,9 @@
    | Expires (f)             | s    | Read       | N/A                 |
    | ExtendedTimeout (a)     | t    | Read/Write | extended_timeout    |
    | Fingerprint             | s    | Read       | fingerprint         |
-   | KeyID                   | s    | Read       | key_id              |
    | Host                    | s    | Read/Write | host                |
    | Interval (a)            | t    | Read/Write | interval            |
+   | KeyID                   | s    | Read       | key_id              |
    | LastApprovalRequest (g) | s    | Read       | N/A                 |
    | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
    | LastCheckerStatus (i)   | n    | Read       | N/A                 |
@@ -131,8 +131,8 @@
 
 * Copyright
 
-    Copyright © 2010-2019 Teddy Hogeborn
-    Copyright © 2010-2019 Björn Påhlsson
+    Copyright © 2010-2020 Teddy Hogeborn
+    Copyright © 2010-2020 Björn Påhlsson
   
 ** License:
 

=== modified file 'INSTALL'
--- INSTALL	2019-02-09 23:23:26 +0000
+++ INSTALL	2019-11-03 19:17:57 +0000
@@ -40,10 +40,13 @@
 *** Mandos Server
     + GnuTLS 3.3          https://www.gnutls.org/
       (but not 3.6.0 or later, until 3.6.6, which works)
-    + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.7          https://www.python.org/
+    + Avahi 0.6.16        https://www.avahi.org/
+    + Python 3           https://www.python.org/
+      Note: Python 2.7 is still supported, if the "mandos",
+      "mandos-ctl", and "mandos-monitor" files are edited to contain
+      "#!/usr/bin/python" instead of python3.
     + dbus-python 0.82.4 https://dbus.freedesktop.org/doc/dbus-python/
-    + PyGObject 3.7.1     https://wiki.gnome.org/Projects/PyGObject
+    + PyGObject 3.8      https://wiki.gnome.org/Projects/PyGObject
     + pkg-config https://www.freedesktop.org/wiki/Software/pkg-config/
     + Urwid 1.0.1         http://urwid.org/
       (Only needed by the "mandos-monitor" tool.)
@@ -53,26 +56,33 @@
     + ssh-keyscan from OpenSSH http://www.openssh.com/
     
     Package names:
-    avahi-daemon python python-dbus python-gi python-urwid pkg-config
-    fping ssh-client
+    avahi-daemon python3 python3-dbus python3-gi python3-urwid
+    pkg-config fping ssh-client
     
 *** Mandos Client
-    + GNU C Library 2.16 https://gnu.org/software/libc/
-    + initramfs-tools 0.85i
-                        https://tracker.debian.org/pkg/initramfs-tools
+    + GNU C Library 2.17 https://gnu.org/software/libc/
     + GnuTLS 3.3        https://www.gnutls.org/
       (but not 3.6.0 or later, until 3.6.6 which works)
-    + Avahi 0.6.16      http://www.avahi.org/
+    + Avahi 0.6.16      https://www.avahi.org/
     + GnuPG 1.4.9       https://www.gnupg.org/
     + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
     + pkg-config https://www.freedesktop.org/wiki/Software/pkg-config/
+    + libnl-route 3     https://www.infradead.org/~tgr/libnl/
+    + GLib 2.40         http://www.gtk.org/
+    
+    One of:
+    + initramfs-tools 0.85i
+                        https://tracker.debian.org/pkg/initramfs-tools
+    + dracut 044+241
+         http://www.kernel.org/pub/linux/utils/boot/dracut/dracut.html
     
     Strongly recommended:
     + OpenSSH           http://www.openssh.com/
     
     Package names:
-    initramfs-tools libgnutls-dev gnutls-bin libavahi-core-dev gnupg
-    libgpgme11-dev pkg-config ssh
+    initramfs-tools dracut libgnutls-dev gnutls-bin libavahi-core-dev
+    gnupg libgpgme11-dev pkg-config ssh libnl-route-3-dev
+    libglib2.0-dev
 
 * Installing the Mandos server
   
@@ -80,7 +90,7 @@
   
   2. On the computer to run as a Mandos server, run the following
      command:
-     For Debian: su -c 'make install-server'
+     For Debian: su - -c 'make install-server'
      For Ubuntu: sudo make install-server
      
      (This creates a configuration without any clients configured; you
@@ -92,14 +102,14 @@
   
   2. On the computer to run as a Mandos client, run the following
      command:
-     For Debian: su -c 'make install-client'
+     For Debian: su - -c 'make install-client'
      For Ubuntu: sudo make install-client
      
      This will also create an OpenPGP key, which will take some time
      and entropy, so be patient.
   
   3. Run the following command:
-     For Debian: su -c 'mandos-keygen --password'
+     For Debian: su - -c 'mandos-keygen --password'
      For Ubuntu: sudo mandos-keygen --password
      
      When prompted, enter the password/passphrase for the encrypted
@@ -117,7 +127,7 @@
 	# update-initramfs -k all -u
   
   5. On the server computer, start the server by running the command
-     For Debian: su -c 'invoke-rc.d mandos start'
+     For Debian: su - -c 'invoke-rc.d mandos start'
      For Ubuntu: sudo service mandos start
      
      At this point, it is possible to verify that the correct password

=== modified file 'Makefile'
--- Makefile	2019-02-11 06:31:42 +0000
+++ Makefile	2021-03-21 18:44:59 +0000
@@ -10,10 +10,12 @@
 	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
 	-Wredundant-decls -Wnested-externs -Winline -Wvla \
 	-Wvolatile-register-var -Woverlength-strings
-#DEBUG:=-ggdb3 -fsanitize=address 
-# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
-# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
-FORTIFY:=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+
+#DEBUG:=-ggdb3 -fsanitize=address $(SANITIZE)
+## Check which sanitizing options can be used
+#SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
+#	echo 'int main(){}' | $(CC) --language=c $(option) \
+#	/dev/stdin -o /dev/null >/dev/null 2>&1 && echo $(option)))
 # <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
 ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
         -fsanitize=shift -fsanitize=integer-divide-by-zero \
@@ -23,11 +25,11 @@
         -fsanitize=object-size -fsanitize=float-divide-by-zero \
         -fsanitize=float-cast-overflow -fsanitize=nonnull-attribute \
         -fsanitize=returns-nonnull-attribute -fsanitize=bool \
-        -fsanitize=enum
-# Check which sanitizing options can be used
-SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
-	echo 'int main(){}' | $(CC) --language=c $(option) /dev/stdin \
-	-o /dev/null >/dev/null 2>&1 && echo $(option)))
+        -fsanitize=enum -fsanitize-address-use-after-scope
+
+# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
+# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
+FORTIFY:=-D_FORTIFY_SOURCE=3 -fstack-protector-all -fPIC
 LINK_FORTIFY_LD:=-z relro -z now
 LINK_FORTIFY:=
 
@@ -39,12 +41,18 @@
 #COVERAGE=--coverage
 OPTIMIZE:=-Os -fno-strict-aliasing
 LANGUAGE:=-std=gnu11
+FEATURES:=-D_FILE_OFFSET_BITS=64
 htmldir:=man
-version:=1.8.3
+version:=1.8.14
 SED:=sed
-
-USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
+PKG_CONFIG?=pkg-config
+
+USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos \
+	|| getent passwd nobody || echo 65534)))
+GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos \
+	|| getent group nogroup || echo 65534)))
+
+LINUXVERSION:=$(shell uname --kernel-release)
 
 ## Use these settings for a traditional /usr/local install
 # PREFIX:=$(DESTDIR)/usr/local
@@ -52,6 +60,7 @@
 # KEYDIR:=$(DESTDIR)/etc/mandos/keys
 # MANDIR:=$(PREFIX)/man
 # INITRAMFSTOOLS:=$(DESTDIR)/etc/initramfs-tools
+# DRACUTMODULE:=$(DESTDIR)/usr/lib/dracut/modules.d/90mandos
 # STATEDIR:=$(DESTDIR)/var/lib/mandos
 # LIBDIR:=$(PREFIX)/lib
 ##
@@ -62,10 +71,12 @@
 KEYDIR:=$(DESTDIR)/etc/keys/mandos
 MANDIR:=$(PREFIX)/share/man
 INITRAMFSTOOLS:=$(DESTDIR)/usr/share/initramfs-tools
+DRACUTMODULE:=$(DESTDIR)/usr/lib/dracut/modules.d/90mandos
 STATEDIR:=$(DESTDIR)/var/lib/mandos
 LIBDIR:=$(shell \
 	for d in \
-	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
+	"/usr/lib/`dpkg-architecture \
+			-qDEB_HOST_MULTIARCH 2>/dev/null`" \
 	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
 		if [ -d "$$d" -a "$$d" = "$${d%/}" ]; then \
 			echo "$(DESTDIR)$$d"; \
@@ -74,23 +85,30 @@
 	done)
 ##
 
-SYSTEMD:=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
-TMPFILES:=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)
+SYSTEMD:=$(DESTDIR)$(shell $(PKG_CONFIG) systemd \
+			--variable=systemdsystemunitdir)
+TMPFILES:=$(DESTDIR)$(shell $(PKG_CONFIG) systemd \
+			--variable=tmpfilesdir)
+SYSUSERS:=$(DESTDIR)$(shell $(PKG_CONFIG) systemd \
+			--variable=sysusersdir)
 
-GNUTLS_CFLAGS:=$(shell pkg-config --cflags-only-I gnutls)
-GNUTLS_LIBS:=$(shell pkg-config --libs gnutls)
-AVAHI_CFLAGS:=$(shell pkg-config --cflags-only-I avahi-core)
-AVAHI_LIBS:=$(shell pkg-config --libs avahi-core)
+GNUTLS_CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I gnutls)
+GNUTLS_LIBS:=$(shell $(PKG_CONFIG) --libs gnutls)
+AVAHI_CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I avahi-core)
+AVAHI_LIBS:=$(shell $(PKG_CONFIG) --libs avahi-core)
 GPGME_CFLAGS:=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
 GPGME_LIBS:=$(shell gpgme-config --libs; getconf LFS_LIBS; \
 	getconf LFS_LDFLAGS)
-LIBNL3_CFLAGS:=$(shell pkg-config --cflags-only-I libnl-route-3.0)
-LIBNL3_LIBS:=$(shell pkg-config --libs libnl-route-3.0)
+LIBNL3_CFLAGS:=$(shell $(PKG_CONFIG) --cflags-only-I libnl-route-3.0)
+LIBNL3_LIBS:=$(shell $(PKG_CONFIG) --libs libnl-route-3.0)
+GLIB_CFLAGS:=$(shell $(PKG_CONFIG) --cflags glib-2.0)
+GLIB_LIBS:=$(shell $(PKG_CONFIG) --libs glib-2.0)
 
 # Do not change these two
-CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
-	$(OPTIMIZE) $(LANGUAGE) -DVERSION='"$(version)"'
-LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
+	$(LANGUAGE) $(FEATURES) -DVERSION='"$(version)"'
+LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(strip \
+	) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -102,9 +120,9 @@
 	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
 	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
-	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
-	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
-	fi >/dev/null)
+	&& command -v man >/dev/null; then LANG=en_US.UTF-8 \
+	MANWIDTH=80 man --warnings --encoding=UTF-8 --local-file \
+	$(notdir $@); fi >/dev/null)
 
 DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
@@ -123,10 +141,12 @@
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
 PLUGIN_HELPERS:=plugin-helpers/mandos-client-iprouteadddel
-CPROGS:=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+CPROGS:=plugin-runner dracut-module/password-agent $(PLUGINS) \
+	$(PLUGIN_HELPERS)
 PROGS:=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS:=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
+	dracut-module/password-agent.8mandos \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
@@ -136,10 +156,13 @@
 
 objects:=$(addsuffix .o,$(CPROGS))
 
+.PHONY: all
 all: $(PROGS) mandos.lsm
 
+.PHONY: doc
 doc: $(DOCS)
 
+.PHONY: html
 html: $(htmldocs)
 
 %.5: %.xml common.ent legalnotice.xml
@@ -204,6 +227,15 @@
 		overview.xml legalnotice.xml
 	$(DOCBOOKTOHTML)
 
+dracut-module/password-agent.8mandos: \
+		dracut-module/password-agent.xml common.ent \
+		overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+dracut-module/password-agent.8mandos.xhtml: \
+		dracut-module/password-agent.xml common.ent \
+		overview.xml legalnotice.xml
+	$(DOCBOOKTOHTML)
+
 plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
 					common.ent \
 					mandos-options.xml \
@@ -252,53 +284,64 @@
 		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
 		$@)
 
-# Need to add the GnuTLS, Avahi and GPGME libraries, and can't use
-# -fsanitize=leak because GnuTLS and GPGME both leak memory.
-plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(CC) $(filter-out -fsanitize=leak,$(CFLAGS)) $(strip\
-	) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) $(strip\
-		) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(strip\
-		) -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
-		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
-
-plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
-	$(LINK.c) $(LIBNL3_CFLAGS) $^ $(LIBNL3_LIBS) $(strip\
-		) $(LOADLIBES) $(LDLIBS) -o $@
-
-.PHONY : all doc html clean distclean mostlyclean maintainer-clean \
-	check run-client run-server install install-html \
-	install-server install-client-nokey install-client uninstall \
-	uninstall-server uninstall-client purge purge-server \
-	purge-client
-
+# Need to add the GnuTLS, Avahi and GPGME libraries
+plugins.d/mandos-client: CFLAGS += $(GNUTLS_CFLAGS) $(strip \
+	) $(AVAHI_CFLAGS) $(GPGME_CFLAGS)
+plugins.d/mandos-client: LDLIBS += $(GNUTLS_LIBS) $(strip \
+	) $(AVAHI_LIBS) $(GPGME_LIBS)
+
+# Need to add the libnl-route library
+plugin-helpers/mandos-client-iprouteadddel: CFLAGS += $(LIBNL3_CFLAGS)
+plugin-helpers/mandos-client-iprouteadddel: LDLIBS += $(LIBNL3_LIBS)
+
+# Need to add the GLib and pthread libraries
+dracut-module/password-agent: CFLAGS += $(GLIB_CFLAGS)
+dracut-module/password-agent: LDLIBS += $(GLIB_LIBS) -lpthread
+
+.PHONY: clean
 clean:
 	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core
 
+.PHONY: distclean
 distclean: clean
+.PHONY: mostlyclean
 mostlyclean: clean
+.PHONY: maintainer-clean
 maintainer-clean: clean
 	-rm --force --recursive keydir confdir statedir
 
-check:	all
+.PHONY: check
+check: all
 	./mandos --check
 	./mandos-ctl --check
+	./mandos-keygen --version
+	./plugin-runner --version
+	./plugin-helpers/mandos-client-iprouteadddel --version
+	./dracut-module/password-agent --test
 
 # Run the client with a local config and key
-run-client: all keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem
-	@echo "###################################################################"
-	@echo "# The following error messages are harmless and can be safely     #"
-	@echo "# ignored:                                                        #"
-	@echo "# From plugin-runner: setgid: Operation not permitted             #"
-	@echo "#                     setuid: Operation not permitted             #"
-	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client:                                             #"
-	@echo "#             Failed to raise privileges: Operation not permitted #"
-	@echo "#             Warning: network hook \"*\" exited with status *      #"
-	@echo "#                                                                 #"
-	@echo "# (The messages are caused by not running as root, but you should #"
-	@echo "# NOT run \"make run-client\" as root unless you also unpacked and  #"
-	@echo "# compiled Mandos as root, which is also NOT recommended.)        #"
-	@echo "###################################################################"
+.PHONY: run-client
+run-client: all keydir/seckey.txt keydir/pubkey.txt \
+			keydir/tls-privkey.pem keydir/tls-pubkey.pem
+	@echo '######################################################'
+	@echo '# The following error messages are harmless and can  #'
+	@echo '#  be safely ignored:                                #'
+	@echo '## From plugin-runner:                               #'
+	@echo '# setgid: Operation not permitted                    #'
+	@echo '# setuid: Operation not permitted                    #'
+	@echo '## From askpass-fifo:                                #'
+	@echo '# mkfifo: Permission denied                          #'
+	@echo '## From mandos-client:                               #'
+	@echo '# Failed to raise privileges: Operation not permi... #'
+	@echo '# Warning: network hook "*" exited with status *     #'
+	@echo '# ioctl SIOCSIFFLAGS +IFF_UP: Operation not permi... #'
+	@echo '# Failed to bring up interface "*": Operation not... #'
+	@echo '#                                                    #'
+	@echo '# (The messages are caused by not running as root,   #'
+	@echo '# but you should NOT run "make run-client" as root   #'
+	@echo '# unless you also unpacked and compiled Mandos as    #'
+	@echo '# root, which is also NOT recommended.)              #'
+	@echo '######################################################'
 # We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
 		--plugin-helper-dir=plugin-helpers \
@@ -311,8 +354,15 @@
 keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem: mandos-keygen
 	install --directory keydir
 	./mandos-keygen --dir keydir --force
+	if ! [ -e keydir/tls-privkey.pem ]; then \
+		install --mode=u=rw /dev/null keydir/tls-privkey.pem; \
+	fi
+	if ! [ -e keydir/tls-pubkey.pem ]; then \
+		install --mode=u=rw /dev/null keydir/tls-pubkey.pem; \
+	fi
 
 # Run the server with a local config
+.PHONY: run-server
 run-server: confdir/mandos.conf confdir/clients.conf statedir
 	./mandos --debug --no-dbus --configdir=confdir \
 		--statedir=statedir $(SERVERARGS)
@@ -329,13 +379,16 @@
 statedir:
 	install --directory statedir
 
+.PHONY: install
 install: install-server install-client-nokey
 
+.PHONY: install-html
 install-html: html
 	install --directory $(htmldir)
 	install --mode=u=rw,go=r --target-directory=$(htmldir) \
 		$(htmldocs)
 
+.PHONY: install-server
 install-server: doc
 	install --directory $(CONFDIR)
 	if install --directory --mode=u=rwx --owner=$(USER) \
@@ -344,10 +397,16 @@
 	elif install --directory --mode=u=rwx $(STATEDIR); then \
 		chown -- $(USER):$(GROUP) $(STATEDIR) || :; \
 	fi
-	if [ "$(TMPFILES)" != "$(DESTDIR)" -a -d "$(TMPFILES)" ]; then \
+	if [ "$(TMPFILES)" != "$(DESTDIR)" \
+			-a -d "$(TMPFILES)" ]; then \
 		install --mode=u=rw,go=r tmpfiles.d-mandos.conf \
 			$(TMPFILES)/mandos.conf; \
 	fi
+	if [ "$(SYSUSERS)" != "$(DESTDIR)" \
+			-a -d "$(SYSUSERS)" ]; then \
+		install --mode=u=rw,go=r sysusers.d-mandos.conf \
+			$(SYSUSERS)/mandos.conf; \
+	fi
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl
@@ -382,11 +441,17 @@
 	gzip --best --to-stdout intro.8mandos \
 		> $(MANDIR)/man8/intro.8mandos.gz
 
+.PHONY: install-client-nokey
 install-client-nokey: all doc
 	install --directory $(LIBDIR)/mandos $(CONFDIR)
 	install --directory --mode=u=rwx $(KEYDIR) \
 		$(LIBDIR)/mandos/plugins.d \
 		$(LIBDIR)/mandos/plugin-helpers
+	if [ "$(SYSUSERS)" != "$(DESTDIR)" \
+			-a -d "$(SYSUSERS)" ]; then \
+		install --mode=u=rw,go=r sysusers.d-mandos.conf \
+			$(SYSUSERS)/mandos-client.conf; \
+	fi
 	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d" \
@@ -397,7 +462,8 @@
 	install --mode=u=rwx,go=rx \
 		--target-directory=$(LIBDIR)/mandos plugin-runner
 	install --mode=u=rwx,go=rx \
-		--target-directory=$(LIBDIR)/mandos mandos-to-cryptroot-unlock
+		--target-directory=$(LIBDIR)/mandos \
+		mandos-to-cryptroot-unlock
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-keygen
 	install --mode=u=rwx,go=rx \
@@ -425,10 +491,21 @@
 		$(INITRAMFSTOOLS)/hooks/mandos
 	install --mode=u=rw,go=r initramfs-tools-conf \
 		$(INITRAMFSTOOLS)/conf.d/mandos-conf
+	install --mode=u=rw,go=r initramfs-tools-conf-hook \
+		$(INITRAMFSTOOLS)/conf-hooks.d/zz-mandos
 	install initramfs-tools-script \
 		$(INITRAMFSTOOLS)/scripts/init-premount/mandos
 	install initramfs-tools-script-stop \
 		$(INITRAMFSTOOLS)/scripts/local-premount/mandos
+	install --directory $(DRACUTMODULE)
+	install --mode=u=rw,go=r --target-directory=$(DRACUTMODULE) \
+		dracut-module/ask-password-mandos.path \
+		dracut-module/ask-password-mandos.service
+	install --mode=u=rwxs,go=rx \
+		--target-directory=$(DRACUTMODULE) \
+		dracut-module/module-setup.sh \
+		dracut-module/cmdline-mandos.sh \
+		dracut-module/password-agent
 	install --mode=u=rw,go=r plugin-runner.conf $(CONFDIR)
 	gzip --best --to-stdout mandos-keygen.8 \
 		> $(MANDIR)/man8/mandos-keygen.8.gz
@@ -446,15 +523,29 @@
 		> $(MANDIR)/man8/askpass-fifo.8mandos.gz
 	gzip --best --to-stdout plugins.d/plymouth.8mandos \
 		> $(MANDIR)/man8/plymouth.8mandos.gz
+	gzip --best --to-stdout dracut-module/password-agent.8mandos \
+		> $(MANDIR)/man8/password-agent.8mandos.gz
 
+.PHONY: install-client
 install-client: install-client-nokey
 # Post-installation stuff
 	-$(PREFIX)/sbin/mandos-keygen --dir "$(KEYDIR)"
-	update-initramfs -k all -u
+	if command -v update-initramfs >/dev/null; then \
+	    update-initramfs -k all -u; \
+	elif command -v dracut >/dev/null; then \
+	    for initrd in $(DESTDIR)/boot/initr*-$(LINUXVERSION); do \
+		if [ -w "$$initrd" ]; then \
+		    chmod go-r "$$initrd"; \
+		    dracut --force "$$initrd"; \
+		fi; \
+	    done; \
+	fi
 	echo "Now run mandos-keygen --password --dir $(KEYDIR)"
 
+.PHONY: uninstall
 uninstall: uninstall-server uninstall-client
 
+.PHONY: uninstall-server
 uninstall-server:
 	-rm --force $(PREFIX)/sbin/mandos \
 		$(PREFIX)/sbin/mandos-ctl \
@@ -467,6 +558,7 @@
 	update-rc.d -f mandos remove
 	-rmdir $(CONFDIR)
 
+.PHONY: uninstall-client
 uninstall-client:
 # Refuse to uninstall client if /etc/crypttab is explicitly configured
 # to use it.
@@ -483,6 +575,12 @@
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
 		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
+		$(INITRAMFSTOOLS)/scripts/local-premount/mandos \
+		$(DRACUTMODULE)/ask-password-mandos.path \
+		$(DRACUTMODULE)/ask-password-mandos.service \
+		$(DRACUTMODULE)/module-setup.sh \
+		$(DRACUTMODULE)/cmdline-mandos.sh \
+		$(DRACUTMODULE)/password-agent \
 		$(MANDIR)/man8/mandos-keygen.8.gz \
 		$(MANDIR)/man8/plugin-runner.8mandos.gz \
 		$(MANDIR)/man8/mandos-client.8mandos.gz
@@ -491,12 +589,21 @@
 		$(MANDIR)/man8/splashy.8mandos.gz \
 		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
 		$(MANDIR)/man8/plymouth.8mandos.gz \
+		$(MANDIR)/man8/password-agent.8mandos.gz \
 	-rmdir $(LIBDIR)/mandos/plugins.d $(CONFDIR)/plugins.d \
-		 $(LIBDIR)/mandos $(CONFDIR) $(KEYDIR)
-	update-initramfs -k all -u
+		 $(LIBDIR)/mandos $(CONFDIR) $(KEYDIR) $(DRACUTMODULE)
+	if command -v update-initramfs >/dev/null; then \
+	    update-initramfs -k all -u; \
+	elif command -v dracut >/dev/null; then \
+	    for initrd in $(DESTDIR)/boot/initr*-$(LINUXVERSION); do \
+		test -w "$$initrd" && dracut --force "$$initrd"; \
+	    done; \
+	fi
 
+.PHONY: purge
 purge: purge-server purge-client
 
+.PHONY: purge-server
 purge-server: uninstall-server
 	-rm --force $(CONFDIR)/mandos.conf $(CONFDIR)/clients.conf \
 		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
@@ -507,6 +614,7 @@
 		$(DESTDIR)/var/run/mandos.pid
 	-rmdir $(CONFDIR)
 
+.PHONY: purge-client
 purge-client: uninstall-client
 	-shred --remove $(KEYDIR)/seckey.txt $(KEYDIR)/tls-privkey.pem
 	-rm --force $(CONFDIR)/plugin-runner.conf \

=== modified file 'NEWS'
--- NEWS	2019-02-11 06:31:42 +0000
+++ NEWS	2021-02-03 08:57:27 +0000
@@ -1,6 +1,70 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.8.14 (2021-02-03)
+* Client
+** Create /dev/fd symlink (if necessary) in plugin-runner(8mandos) and
+   mandos-client(8mandos) (Workaround for Debian bug #981302)
+
+Version 1.8.13 (2020-11-30)
+* Client
+** Fix unreliable test in password-agent(8mandos).
+
+Version 1.8.12 (2020-07-04)
+* Client
+** Fix compatibility with the GNU C Library version 2.31.
+** In initramfs-tools boots, only use setsid(1) when available.
+
+Version 1.8.11 (2020-04-08)
+* Client
+** Fix file descriptor leak when adding or removing local routes to
+   unreachable hosts on the local network.
+
+Version 1.8.10 (2020-03-21)
+* Server
+** Fix bug when setting a client's D-Bus "Secret" property
+** Start client checkers after a random delay
+** When using systemd, allow easier modification of server options
+** Better log messages in mandos-monitor
+* Client
+** When using dracut & systemd, allow easier modification of options
+
+Version 1.8.9 (2019-09-03)
+* No user-visible changes
+
+Version 1.8.8 (2019-08-18)
+* No user-visible changes
+
+Version 1.8.7 (2019-08-05)
+* Client:
+** Always compile with LFS (Large File Support) enabled.
+* Server
+** Improve intro(8mandos) manual page to cover dracut(8) support.
+
+Version 1.8.6 (2019-08-03)
+* Client:
+** dracut support: In password-agent, properly ignore deleted and
+   renamed question files, and also fix memory alignment issue.
+
+Version 1.8.5 (2019-07-30)
+* Client
+** Support dracut(8) as well as initramfs-tools(7).
+** Minor bug fix: Allow the mandos-keygen --passfile option to use
+   passfiles with names starting with "-".
+** Document known limitation of mandos-keygen --password; it strips
+   white space from start and end of the password.
+* Server
+** Bug fix: The server used to fail to restart if the "port" setting
+   was used.  This has been fixed.
+** Minor bug fix: Reap zombies left over from checker runs.  (Debian
+   bug #933387)
+
+Version 1.8.4 (2019-04-09)
+* Client
+** Fix minor memory leak in plugin-runner.
+* Server
+** mandos-ctl now has a --debug option to show D-Bus calls.
+
 Version 1.8.3 (2019-02-11)
 * No user-visible changes.
 

=== modified file 'TODO'
--- TODO	2019-02-13 08:45:09 +0000
+++ TODO	2020-02-09 03:42:50 +0000
@@ -6,49 +6,47 @@
 * mandos-applet
 
 * mandos-client
-** TODO A --server option which only adds to the server list.
-   (Unlike --connect, which implicitly disables zeroconf.)
-** TODO [#B] Use capabilities instead of seteuid().
-   https://forums.grsecurity.net/viewtopic.php?f=7&t=2522
-** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
-** TODO [#C] Make start_mandos_communication() take "struct server".
-** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
-** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
-** TODO [#B] Use reallocarray() with GNU LibC 2.29 or later.
+** TODO A ~--server~ option which only adds to the server list.
+   (Unlike ~--connect~, which implicitly disables ZeroConf.)
+** TODO [#B] Use [[man:capabilities][capabilities]] instead of [[info:libc#Setting%20User%20ID][seteuid()]].
+   [[https://forums.grsecurity.net/viewtopic.php?f=7&t=2522]]
+** TODO [#B] Use ~getaddrinfo(hints=AI_NUMERICHOST)~ instead of ~inet_pton()~
+** TODO [#C] Make ~start_mandos_communication()~ take ~struct server~.
+** TODO [#C] ~--interfaces=regex,eth*,noregex~ [[man:bridge-utils-interfaces][bridge-utils-interfaces(5)]]
+** TODO [#A] Detect partial writes to stdout and exit with ~EX_TEMPFAIL~
 
 * splashy
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
+** TODO [#B] use [[info:libc#Scanning%20Directory%20Content][scandir(3)]] instead of [[info:libc#Reading/Closing%20Directory][readdir(3)]]
+** TODO [#A] Detect partial writes to stdout and exit with ~EX_TEMPFAIL~
 
 * usplash (Deprecated)
 ** TODO [#B] Make it work again
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
+** TODO [#B] use [[info:libc#Scanning%20Directory%20Content][scandir(3)]] instead of [[info:libc#Reading/Closing%20Directory][readdir(3)]]
+** TODO [#A] Detect partial writes to stdout and exit with ~EX_TEMPFAIL~
 
 * askpass-fifo
-** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
+** TODO [#A] Detect partial writes to stdout and exit with ~EX_TEMPFAIL~
 
 * password-prompt
-** TODO [#B] lock stdin (with flock()?)
-** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
+** TODO [#B] lock stdin (with [[info:libc#File%20Locks][flock()]]?)
+** TODO [#A] Detect partial writes to stdout and exit with ~EX_TEMPFAIL~
 
 * plymouth
-** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
-** TODO [#B] Use reallocarray() with GNU LibC 2.29 or later.
+** TODO [#A] Detect partial writes to stdout and exit with ~EX_TEMPFAIL~
 
 * TODO [#B] passdev
 
 * plugin-runner
 ** TODO handle printing for errors for plugins
 *** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
-** TODO [#C] use same file name rules as run-parts(8)
+** TODO [#C] use same file name rules as [[man:run-parts][run-parts(8)]]
 ** kernel command line option for debug info
-** TODO [#A] Restart plugins which exit with EX_TEMPFAIL
+** TODO [#A] Restart plugins which exit with ~EX_TEMPFAIL~
 
 * mandos (server)
-** TODO [#B] --notify-command
+** TODO [#B] ~--notify-command~
    This would allow the mandos.service to use
-   --notify-command="systemd-notify --pid --ready"
+   ~--notify-command="systemd-notify --pid --ready"~
 ** TODO [#B] python-systemd
 *** import systemd.daemon; systemd.daemon.notify()
 ** TODO [#B] Log level							  :BUGS:
@@ -61,32 +59,28 @@
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on number of secrets given
 ** D-Bus Client method NeedsPassword(50) - Timeout, default disapprove
-    + SetPass(u"gazonk", True) -> Approval, persistent
+    + SetPass("gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
 ** TODO Separate logging logic to own object
-** TODO [#B] Limit approval_delay to max gnutls/tls timeout value
-** TODO [#B] break the wait on approval_delay if connection dies
-** TODO Generate Client.runtime_expansions from client options + extra
+** TODO [#B] Limit ~approval_delay~ to max GnuTLS/TLS timeout value
+** TODO [#B] break the wait on ~approval_delay~ if connection dies
+** TODO Generate ~Client.runtime_expansions~ from client options + extra
 ** TODO Allow %%(checker)s as a runtime expansion
 ** TODO D-Bus AddClient() method on server object
 ** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
 ** TODO Save state periodically to recover better from hard shutdowns
 ** TODO CheckerCompleted method, deprecate CheckedOK
-** TODO Secret Service API?
-   https://standards.freedesktop.org/secret-service/
+** TODO [[https://standards.freedesktop.org/secret-service/][Secret Service]] API?
 ** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				  :2:
+** TODO Remove old ~string_to_delta~ format                               :2:
 ** TODO http://0pointer.de/blog/projects/stateless.html
-*** File in /usr/lib/sysusers.d to create user+group "_mandos"
+*** File in /usr/lib/sysusers.d to create user+group "~_mandos~"
 ** TODO Error handling on error parsing config files
 ** TODO init.d script error handling
 ** TODO D-Bus server properties; address, port, interface, etc.		  :2:
-** Python 3								  :2:
-*** TODO [#C] In Python 3.3, use shlex.quote() instead of re.escape()
 
 * mandos-ctl
-*** Handle "no D-Bus server" and/or "no Mandos server found" better
 ** TODO Remove old string_to_delta format				  :2:
 
 * TODO mandos-dispatch
@@ -94,7 +88,7 @@
   arguments.
 
 * mandos-monitor
-** TODO --servicename						       :BUGS:
+** TODO ~--servicename~                                                :BUGS:
 ** TODO help should be toggleable
 ** Urwid client data displayer
    Better view of client data in the listing
@@ -102,17 +96,17 @@
 ** Print a nice "We are sorry" message, save stack trace to log.
 
 * mandos-keygen
-** TODO "--secfile" option
+** TODO "~--secfile~" option
    Using the "secfile" option instead of "secret"
-** TODO [#B] "--test" option
+** TODO [#B] "~--test~" option
    For testing decryption before rebooting.
 
 * Package
 ** /usr/share/initramfs-tools/hooks/mandos
-*** TODO [#C] use same file name rules as run-parts(8)
+*** TODO [#C] use same file name rules as [[man:run-parts][run-parts(8)]]
 *** TODO [#C] Do not install in initrd.img if configured not to.
     Use "/etc/initramfs-tools/hooksconf.d/mandos"?
-** TODO [#C] $(pkg-config --variable=completionsdir bash-completion)
+** TODO [#C] ~$(pkg-config --variable=completionsdir bash-completion)~
    From XML sources directly?
 
 * Side Stuff
@@ -123,3 +117,4 @@
 
 
 #+STARTUP: showall
+#+FILETAGS: :mandos:

=== modified file 'clients.conf'
--- clients.conf	2019-02-09 23:34:15 +0000
+++ clients.conf	2022-04-23 20:36:45 +0000
@@ -4,6 +4,7 @@
 
 # How long until a client is disabled and not be allowed to get the
 # data this server holds.
+# (RFC 3339 duration syntax)
 ;timeout = PT5M
 
 # How often to run the checker to confirm that a client is still up.
@@ -11,11 +12,13 @@
 # running.  The server will wait for a checker to complete until the
 # above "timeout" occurs, at which time the client will be disabled,
 # and any running checker killed.
+# (RFC 3339 duration syntax)
 ;interval = PT2M
 
 # Extended timeout is an added timeout that is given once after a
 # password has been sent sucessfully to a client.  This allows for
 # additional delays caused by file system checks and quota checks.
+# (RFC 3339 duration syntax)
 ;extended_timeout = PT15M
 
 # What command to run as "the checker".
@@ -25,9 +28,11 @@
 ;approved_by_default = True
 
 # How long to wait for approval.
+# (RFC 3339 duration syntax)
 ;approval_delay = PT0S
 
 # How long one approval will last.
+# (RFC 3339 duration syntax)
 ;approval_duration = PT1S
 
 # Whether this client is enabled by default

=== modified file 'common.ent'
--- common.ent	2019-02-11 06:31:42 +0000
+++ common.ent	2021-02-03 08:57:27 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.8.3">
+<!ENTITY version "1.8.14">

=== modified file 'debian/changelog'
--- debian/changelog	2019-02-11 11:52:07 +0000
+++ debian/changelog	2021-02-03 08:57:27 +0000
@@ -1,3 +1,161 @@
+mandos (1.8.14-1) unstable; urgency=medium
+
+  * New upstream release.  Includes workaround for #981302
+  * debian/po/fr.po: Fix msgid to match template.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 03 Feb 2021 09:53:29 +0100
+
+mandos (1.8.13-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "password-agent autopkgtest does not seem to be reliable"
+    by making the test more reliable (Closes: #975457)
+  * debian/mandos-client.templates: Rename "_description" header to
+    "_Description".
+  * debian/control (Standards-Version): Change to "4.5.1".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Mon, 30 Nov 2020 19:15:43 +0100
+
+mandos (1.8.12-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "FTBFS with glibc 2.31 (uses removed stime function)" by using
+    clock_settime() instead. (Closes: #964226)
+  * debian/copyright: Update copyright year to 2020.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 04 Jul 2020 14:58:26 +0200
+
+mandos (1.8.11-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 08 Apr 2020 20:37:32 +0200
+
+mandos (1.8.10-1) unstable; urgency=medium
+
+  * Fix "[INTL:pt] Updated Portuguese translation - debconf messages"
+    by including the contributed translation (Closes: #942595)
+  * Fix "[INTL:nl] Dutch translation of debconf messages" by including the
+    contributed translation (Closes: #946006)
+  * Fix "flaky autopkgtest on arm64" by skipping the flaky test on
+    non-amd64 (Closes: #953799)
+  * debian/control (Standards-Version): Update to "4.5.0".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 21 Mar 2020 17:45:01 +0100
+
+mandos (1.8.9-2) unstable; urgency=medium
+
+  * Fix failing autopkgtest.
+  * debian/tests/control (mandos-check/Restrictions): Add "allow-stderr".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 04 Sep 2019 23:14:06 +0200
+
+mandos (1.8.9-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "Python2 removal in sid/bullseye" by using Python 3 instead
+    (Closes: #936987)
+  * debian/control (Build-Depends, Build-Depends-Indep): Move "systemd"
+    from indep to regular build-depends.
+    (Build-Depends-Indep, Package: mandos/Depends): Depend on Python 3 and
+    Python 3 modules instead of Python 2.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Tue, 03 Sep 2019 20:58:27 +0200
+
+mandos (1.8.8-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/po/de.po: New; Fix "[INTL:de] Initial German debconf
+    translation" by including the contributed translation (Closes:
+    #934373)
+  * debian/po/fr.po: New; Fix "[INTL:fr] French debconf templates
+    translation" by including the contributed translation (Closes:
+    #934888)
+  * debian/po/sv.po: New Swedish translation.
+  * debian/mandos.postinst: Only reload D-Bus daemon if new user was
+    created.
+  * debian/mandos.dirs (usr/lib/sysusers.d): New.
+  * debian/mandos-client.dirs (usr/lib/sysusers.d): - '' -
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 18 Aug 2019 22:01:13 +0200
+
+mandos (1.8.7-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/upstream/metadata: New.
+  * debian/mandos-client.postrm: Use the same logic as the
+    update_initramfs function in debian/mandos-client.postinst.
+  * debian/mandos-client.templates (mandos-client/key_id): Line which
+    should not be wrapped should be prefixed by a space.
+  * debian/mandos.templates (mandos/key_id): - '' -
+  * debian/po/en_US.po: New "translation" from ASCII to UTF-8.
+  * debian/po/templates.pot: Updated.
+  * debian/source/lintian-overrides
+    (package-uses-old-debhelper-compat-version): New; set to "10".
+  * debian/mandos-client.lintian-overrides
+    (maintainer-script-supports-ancient-package-version): New.
+    debian/mandos.lintian-overrides
+    (maintainer-script-supports-ancient-package-version): - '' -
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Mon, 05 Aug 2019 23:22:00 +0200
+
+mandos (1.8.6-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "mandos FTCBFS: hard codes build architecture pkg-config"
+    by making pkg-config overridable (Closes: #933701)
+  * debian/mandos.postinst (configure): After creating (or renaming) user
+    & group, reload D-Bus daemon (if present).
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 03 Aug 2019 14:51:01 +0200
+
+mandos (1.8.5-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "does not reap children" by reaping children (Closes: #933387)
+  * debian/mandos-client.README.Debian: Use new-style interface name.
+  * debian/tests/control: New file; implements autopkgtest support.
+  * debian/mandos-client.lintian-overrides
+    (manpage-has-errors-from-man): Remove; unnecessary.
+  * debian/mandos.lintian-overrides
+    (init.d-script-needs-depends-on-lsb-base): - '' -
+  * debian/mandos-client.postinst (update_initramfs): Upstream now
+    supports dracut(8), so update commands here to and run the correct
+    command to update initramfs.
+  * debian/control (Build-Depends): Add GLib -dev package.
+    (mandos-client/Depends): Add dracut(8) as an alternative dependency to
+    initramfs-tools.
+    (mandos-client/Conflicts): New; set to "dracut-config-generic".
+    (debian/mandos-client.README.Debian): Update for dracut(8) support.
+  * debian/mandos-client.templates: Reflowed by debconf-gettextize(1).
+  * debian/mandos.templates: - '' -
+  * debian/po/POTFILES.in: New.
+  * debian/po/templates.pot: - '' -
+  * debian/source/lintian-overrides: New.
+  * debian/control (Standards-Version): Update to "4.4.0".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Tue, 30 Jul 2019 20:41:29 +0200
+
+mandos (1.8.4-1) unstable; urgency=medium
+
+  * Fix "dirs in initrd are not accessible by mandos plugin-runner" by
+    making sure UMASK is set, no matter what other packages have installed
+    in "/usr/share/initramfs-tools/conf-hooks.d". (Closes: #926641)
+  * Fix "LeakSanitizer: detected memory leaks, fails to decrypt"
+    by fixing memory leak in plugin-runner. (Closes: #926643)
+  * debian/mandos-client.dirs: Add
+    "usr/share/initramfs-tools/conf-hooks.d", needed by fix for #926641.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Tue, 09 Apr 2019 22:05:39 +0200
+
+mandos (1.8.3-3) unstable; urgency=medium
+
+  * Fix "src:mandos: modifies d/control during build" by not doing that
+    anymore.  (Closes: #922202)
+  * debian/rules (override_dh_shlibdeps-arch): Commented out.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 13 Feb 2019 09:52:39 +0100
+
 mandos (1.8.3-2) unstable; urgency=medium
 
   * debian/rules (override_dh_shlibdeps-arch): New; conditionally edit

=== modified file 'debian/control'
--- debian/control	2019-02-11 06:14:29 +0000
+++ debian/control	2020-11-30 16:25:32 +0000
@@ -6,12 +6,12 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 10), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
-	libgnutls28-dev (>= 3.3.0),
+	libglib2.0-dev (>=2.40), libgnutls28-dev (>= 3.3.0),
 	libgnutls28-dev (>= 3.6.6) | libgnutls28-dev (<< 3.6.0),
-	xsltproc, pkg-config, libnl-route-3-dev
-Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
-	python-dbus, python-gi
-Standards-Version: 4.3.0
+	xsltproc, pkg-config, libnl-route-3-dev, systemd
+Build-Depends-Indep: python3 (>= 3), python3-dbus, python3-gi,
+	po-debconf
+Standards-Version: 4.5.1
 Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: https://www.recompile.se/mandos
@@ -19,11 +19,11 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
-	libgnutls30 (>= 3.3.0),
+Depends: ${misc:Depends}, python3 (>= 3), libgnutls30 (>= 3.3.0),
 	libgnutls30 (>= 3.6.6) | libgnutls30 (<< 3.6.0),
-	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
-	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6),
+	python3-dbus, python3-gi, avahi-daemon, adduser,
+	python3-urwid, gnupg2 | gnupg,
+	systemd-sysv | lsb-base (>= 3.0-6),
 	debconf (>= 1.5.5) | debconf-2.0
 Recommends: ssh-client | fping
 Suggests: libc6-dev | libc-dev, c-compiler
@@ -46,12 +46,14 @@
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser,
 	cryptsetup (<< 2:2.0.3-1) | cryptsetup-initramfs,
-	initramfs-tools (>= 0.99), dpkg-dev (>=1.16.0),
+	initramfs-tools (>= 0.99) | dracut (>= 044+241-3),
+	dpkg-dev (>=1.16.0),
 	gnutls-bin (>= 3.6.6) | libgnutls30 (<< 3.6.0),
 	debconf (>= 1.5.5) | debconf-2.0
 Recommends: ssh
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
+Conflicts: dracut-config-generic
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows
  computers to have encrypted root file systems and at the

=== modified file 'debian/copyright'
--- debian/copyright	2019-02-10 04:20:26 +0000
+++ debian/copyright	2021-02-03 08:33:43 +0000
@@ -4,8 +4,8 @@
 Source: <https://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2019 Teddy Hogeborn
-	   Copyright © 2008-2019 Björn Påhlsson
+Copyright: Copyright © 2008-2021 Teddy Hogeborn
+	   Copyright © 2008-2021 Björn Påhlsson
 License: GPL-3+
     This file is part of Mandos.
     .

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2019-02-09 23:23:26 +0000
+++ debian/mandos-client.README.Debian	2019-07-27 10:11:45 +0000
@@ -49,7 +49,11 @@
   setting is changed, it will be necessary to update the initrd image
   by running this command:
   
+	(For initramfs-tools:)
 	update-initramfs -k all -u
+	
+	(For dracut:)
+	dpkg-reconfigure dracut
   
   The device can also be overridden at boot time on the Linux kernel
   command line using the sixth colon-separated field of the "ip="
@@ -60,12 +64,12 @@
   Note that since the network interfaces are used in the initial RAM
   disk environment, the network interfaces *must* exist at that stage.
   Thus, an interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, only real interfaces (such as "eth0") can be used.
-  This can be overcome by writing a "network hook" program to create
-  an interface (see mandos-client(8mandos)) and placing it in
-  "/etc/mandos/network-hooks.d", from where it will be copied into the
-  initial RAM disk.  Example network hook scripts can be found in
-  "/usr/share/doc/mandos-client/examples/network-hooks.d".
+  "tun0"; instead, only real interfaces (such as "enp1s0" or "eth0")
+  can be used. This can be overcome by writing a "network hook"
+  program to create an interface (see mandos-client(8mandos)) and
+  placing it in "/etc/mandos/network-hooks.d", from where it will be
+  copied into the initial RAM disk.  Example network hook scripts can
+  be found in "/usr/share/doc/mandos-client/examples/network-hooks.d".
 
 * User-Supplied Plugins
   
@@ -73,7 +77,11 @@
   to the normal Mandos plugins.  When adding or changing plugins, do
   not forget to update the initital RAM disk image:
   
+	(For initramfs-tools:)
 	update-initramfs -k all -u
+	
+	(For dracut:)
+	dpkg-reconfigure dracut
 
 * Do *NOT* Edit "/etc/crypttab"
   
@@ -108,4 +116,4 @@
   policy or other reasons, simply replace the existing dhparams.pem
   file and update the initital RAM disk image.
 
- -- Teddy Hogeborn <teddy@recompile.se>, Sat,  9 Feb 2019 15:08:04 +0100
+ -- Teddy Hogeborn <teddy@recompile.se>, Mon, 15 Jul 2019 16:47:02 +0200

=== modified file 'debian/mandos-client.dirs'
--- debian/mandos-client.dirs	2018-08-19 14:32:00 +0000
+++ debian/mandos-client.dirs	2019-08-18 04:14:31 +0000
@@ -2,5 +2,7 @@
 usr/sbin
 usr/share/initramfs-tools/hooks
 usr/share/initramfs-tools/conf.d
+usr/share/initramfs-tools/conf-hooks.d
 usr/share/initramfs-tools/scripts/init-premount
 usr/share/initramfs-tools/scripts/local-premount
+usr/lib/sysusers.d

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2019-02-10 03:50:20 +0000
+++ debian/mandos-client.lintian-overrides	2019-08-05 21:14:05 +0000
@@ -39,5 +39,6 @@
 # The notice displayed from the postinst script really is critical
 mandos-client binary: postinst-uses-db-input
 
-# It is a really long line
-mandos-client binary: manpage-has-errors-from-man usr/share/man/man8/plugin-runner.8mandos.gz *: warning *: can't break line
+# These are very important to work around bugs or changes in the old
+# versions, and there is no pressing need to remove them.
+mandos-client binary: maintainer-script-supports-ancient-package-version *

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2019-02-10 10:39:26 +0000
+++ debian/mandos-client.postinst	2019-07-27 10:11:45 +0000
@@ -22,7 +22,27 @@
 # Update the initial RAM file system image
 update_initramfs()
 {
-    update-initramfs -u -k all
+    if command -v update-initramfs >/dev/null; then
+	update-initramfs -k all -u
+    elif command -v dracut >/dev/null; then
+	dracut_version="`dpkg-query --showformat='${Version}' --show dracut`"
+	if dpkg --compare-versions "$dracut_version" lt 043-1 \
+		&& bash -c '. /etc/dracut.conf; . /etc/dracut.conf.d/*; [ "$hostonly" != yes ]'; then
+	    echo 'Dracut is not configured to use hostonly mode!' >&2
+	    return 1
+	fi
+	# Logic taken from dracut.postinst
+	for kernel in /boot/vmlinu[xz]-*; do
+	    kversion="${kernel#/boot/vmlinu[xz]-}"
+	    # Dracut preserves old permissions of initramfs image
+	    # files, so we adjust permissions before creating new
+	    # initramfs image containing secret keys.
+	    chmod go-r /boot/initrd.img-"$kversion"
+	    if [ "$kversion" != "*" ]; then
+		/etc/kernel/postinst.d/dracut "$kversion"
+	    fi
+	done
+    fi
     
     if dpkg --compare-versions "$2" lt-nl "1.0.10-1"; then
         # Make old initrd.img files unreadable too, in case they were

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2019-02-09 23:23:26 +0000
+++ debian/mandos-client.postrm	2019-08-05 14:31:51 +0000
@@ -31,7 +31,17 @@
 # Update the initial RAM file system image
 update_initramfs()
 {
-    update-initramfs -u -k all || :
+    if command -v update-initramfs >/dev/null; then
+	update-initramfs -k all -u
+    elif command -v dracut >/dev/null; then
+	# Logic taken from dracut.postinst
+	for kernel in /boot/vmlinu[xz]-*; do
+	    kversion="${kernel#/boot/vmlinu[xz]-}"
+	    if [ "$kversion" != "*" ]; then
+		/etc/kernel/postinst.d/dracut "$kversion"
+	    fi
+	done
+    fi
 }
 
 case "$1" in

=== modified file 'debian/mandos-client.templates'
--- debian/mandos-client.templates	2019-02-10 03:50:20 +0000
+++ debian/mandos-client.templates	2020-11-30 16:19:48 +0000
@@ -1,10 +1,19 @@
 Template: mandos-client/key_id
 Type: note
-Description: New client option "${key_id}" is REQUIRED on server
- A new "key_id" client option is REQUIRED in the server's clients.conf file, otherwise this computer most likely will not reboot unattended.  This option:
- .
- ${key_id}
- .
- must be added (all on one line!) on the Mandos server host, in the file /etc/mandos/clients.conf, right before the "fingerprint" option for this Mandos client.  You must edit that file on that server and add this option.
- .
- With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS session keys.  A new TLS key pair has been generated and will be used as identification, but the key ID of the public key needs to be added to the server, since this will now be used to identify the client to the server.
+_Description: New client option "${key_id}" is REQUIRED on server
+ A new "key_id" client option is REQUIRED in the server's clients.conf
+ file, otherwise this computer most likely will not reboot unattended. 
+ This option:
+ .
+  ${key_id}
+ .
+ must be added (all on one line!) on the Mandos server host, in the file
+ /etc/mandos/clients.conf, right before the "fingerprint" option for this
+ Mandos client.  You must edit that file on that server and add this
+ option.
+ .
+ With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as
+ TLS session keys.  A new TLS key pair has been generated and will be used
+ as identification, but the key ID of the public key needs to be added to
+ the server, since this will now be used to identify the client to the
+ server.

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2016-03-19 12:10:15 +0000
+++ debian/mandos.dirs	2019-08-18 00:23:21 +0000
@@ -7,3 +7,4 @@
 var/lib/mandos
 lib/systemd/system
 usr/lib/tmpfiles.d
+usr/lib/sysusers.d

=== modified file 'debian/mandos.lintian-overrides'
--- debian/mandos.lintian-overrides	2019-02-10 03:50:20 +0000
+++ debian/mandos.lintian-overrides	2019-08-05 21:14:05 +0000
@@ -2,7 +2,6 @@
 # it, so it must be kept unreadable for non-root users.
 #
 mandos binary: non-standard-file-perm etc/mandos/clients.conf 0600 != 0644
-mandos: init.d-script-needs-depends-on-lsb-base etc/init.d/mandos (line 46)
 
 # The debconf templates is only used for displaying information
 # detected in the postinst, not for saving answers to questions, so we
@@ -11,3 +10,7 @@
 
 # The notice displayed from the postinst script really is critical
 mandos binary: postinst-uses-db-input
+
+# These are very important to work around bugs or changes in the old
+# versions, and there is no pressing need to remove them.
+mandos binary: maintainer-script-supports-ancient-package-version *

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2019-02-10 08:41:14 +0000
+++ debian/mandos.postinst	2019-08-18 00:05:36 +0000
@@ -27,6 +27,11 @@
 		*:Mandos\ password\ system,,,:/nonexistent:/bin/false)
 		    usermod --login _mandos mandos
 		    groupmod --new-name _mandos mandos
+		    # Reload D-Bus daemon to be aware of the _mandos
+		    # user & group
+		    if [ -x /etc/init.d/dbus ]; then
+			invoke-rc.d dbus force-reload || :
+		    fi
 		    ;;
 	    esac
 	fi
@@ -36,6 +41,11 @@
 		--home /nonexistent --no-create-home --group \
 		--disabled-password --gecos "Mandos password system" \
 		_mandos
+	    # Reload D-Bus daemon to be aware of the _mandos user &
+	    # group
+	    if [ -x /etc/init.d/dbus ]; then
+		invoke-rc.d dbus force-reload || :
+	    fi
 	elif dpkg --compare-versions "$2" eq 1.7.4-1 \
 		|| dpkg --compare-versions "$2" eq "1.7.4-1~bpo8+1"
 	then

=== modified file 'debian/mandos.templates'
--- debian/mandos.templates	2019-02-10 08:41:14 +0000
+++ debian/mandos.templates	2020-11-30 09:40:14 +0000
@@ -1,19 +1,29 @@
 Template: mandos/key_id
 Type: note
-Description: New client option "key_id" is REQUIRED on server
- A new "key_id" client option is REQUIRED in the clients.conf file, otherwise the client most likely will not reboot unattended.  This option:
- .
- key_id = <HEXSTRING>
- .
- must be added in the file /etc/mandos/clients.conf, right before the "fingerprint" option, for each Mandos client.  You must edit that file and add this option for all clients.  To see the correct key ID for each client, run this command (on each client):
- .
- mandos-keygen -F/dev/null|grep ^key_id
- .
- Note: the client must all also be using GnuTLS 3.6.6 or later; the server cannot serve passwords for both old and new clients!
- .
- Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS session keys.  A new TLS key pair will be generated on each client and will be used as identification, but the key ID of the public key needs to be added to this server, since this will now be used to identify the client to the server.
+_Description: New client option "key_id" is REQUIRED on server
+ A new "key_id" client option is REQUIRED in the clients.conf file,
+ otherwise the client most likely will not reboot unattended.  This option:
+ .
+  key_id = <HEXSTRING>
+ .
+ must be added in the file /etc/mandos/clients.conf, right before the
+ "fingerprint" option, for each Mandos client.  You must edit that file and
+ add this option for all clients.  To see the correct key ID for each
+ client, run this command (on each client):
+ .
+  mandos-keygen -F/dev/null|grep ^key_id
+ .
+ Note: the clients must all also be using GnuTLS 3.6.6 or later; the server
+ cannot serve passwords for both old and new clients!
+ .
+ Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP
+ keys as TLS session keys.  A new TLS key pair will be generated on each
+ client and will be used as identification, but the key ID of the public
+ key needs to be added to this server, since this will now be used to
+ identify the client to the server.
 
 Template: mandos/removed_bad_key_ids
 Type: note
-Description: Bad key IDs have been removed from clients.conf
- Bad key IDs, which were reported by a bug in Mandos client 1.8.0, have been removed from /etc/mandos/clients.conf
+_Description: Bad key IDs have been removed from clients.conf
+ Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been
+ removed from /etc/mandos/clients.conf

=== added file 'debian/po/POTFILES.in'
--- debian/po/POTFILES.in	1970-01-01 00:00:00 +0000
+++ debian/po/POTFILES.in	2019-07-27 19:28:14 +0000
@@ -0,0 +1,2 @@
+[type: gettext/rfc822deb] mandos.templates
+[type: gettext/rfc822deb] mandos-client.templates

=== added file 'debian/po/de.po'
--- debian/po/de.po	1970-01-01 00:00:00 +0000
+++ debian/po/de.po	2019-08-16 19:28:16 +0000
@@ -0,0 +1,155 @@
+# German debconf translation of mandos.
+# This file is distributed under the same license as the mandos package.
+# Copyright (C) 2008-2019 Teddy Hogeborn and Björn Påhlsson
+# Copyright (C) of this file 2019 Chris Leick <c.leick@vollbio.de>.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: mandos 1.8.7-1\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2019-08-05 22:57+0200\n"
+"PO-Revision-Date: 2019-08-10 12:06+0100\n"
+"Last-Translator: Chris Leick <c.leick@vollbio.de>\n"
+"Language-Team: German <debian-l10n-german@lists.debian.org>\n"
+"Language: de\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "New client option \"key_id\" is REQUIRED on server"
+msgstr "Auf diesem Server ist die Client-Option »key_id« ERFORDERLICH"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the clients.conf file, "
+"otherwise the client most likely will not reboot unattended.  This option:"
+msgstr ""
+"In der Datei clients.conf ist eine neue Client-Option »key_id« ERFORDERLICH, "
+"andernfalls werden die Clients höchstwahrscheinlich nicht unbeaufsichtigt neu "
+"starten. Die Option"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " key_id = <HEXSTRING>"
+msgstr " key_id = <HEXADEZIMALZEICHENKETTE>"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"\"fingerprint\" option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+msgstr ""
+"muss der Datei /etc/mandos/clients.conf kurz vor der Option »fingerprint« "
+"auf jedem Mandos-Client hinzugefügt werden. Sie müssen diese Datei bearbeiten "
+"und diese Option auf allen Clients hinzufügen. Um die korrekte "
+"Schlüsselkennung für jeden Client anzusehen, führen Sie (auf jedem Client) "
+"diesen Befehl aus:"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " mandos-keygen -F/dev/null|grep ^key_id"
+msgstr " mandos-keygen -F/dev/null|grep ^key_id"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+msgstr ""
+"Hinweis: Die Clients müssen außerdem alle GnuTLS 3.6.6 oder neuer nutzen; der "
+"Server kann keine Passwörter für sowohl alte als auch neue Clients anbieten!"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server."
+msgstr ""
+"Begründung: Mit GnuTLS 3.6.6 wurde erzwungen, dass Mandos die Benutzung von "
+"OpenPGP als TLS-Sitzungsschlüssel stoppt. Auf jedem Client wird ein neues "
+"TLS-Schlüsselpaar erzeugt und zur Identifizierung benutzt, aber der "
+"öffentliche Schlüssel muss auf diesem Server hinzugefügt werden, da dies nun "
+"zur Identifizierung des Clients auf dem Server verwendet wird."
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid "Bad key IDs have been removed from clients.conf"
+msgstr "Falsche Schlüsselkennungen wurden aus der clients.conf entfernt."
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+msgstr ""
+"Falsche Schlüsselkennungen, die durch einen Fehler im Mandos-Client 1.8.0 "
+"erzeugt wurden, wurden aus /etc/mandos/clients.conf entfernt."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid "New client option \"${key_id}\" is REQUIRED on server"
+msgstr "Auf dem Server ist die neue Client-Option »${key_id}« ERFORDERLICH."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the server's clients.conf "
+"file, otherwise this computer most likely will not reboot unattended.  This "
+"option:"
+msgstr ""
+"In der Datei clients.conf des Servers ist eine neue  Client-Option »key_id« "
+"ERFORDERLICH, andernfalls wird dieser Rechner höchstwahrscheinlich nicht "
+"unbeaufsichtigt neu starten. Die Option "
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid " ${key_id}"
+msgstr " ${key_id}"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"must be added (all on one line!) on the Mandos server host, in the file /etc/"
+"mandos/clients.conf, right before the \"fingerprint\" option for this Mandos "
+"client.  You must edit that file on that server and add this option."
+msgstr ""
+"muss (in einer einzigen Zeile!) der Datei /etc/mandos/clients.conf auf dem "
+"Mandos-Server kurz vor der Option »fingerprint« für diesen Mandos-Client "
+"hinzugefügt werden. Sie müssen diese Datei auf diesem Server bearbeiten und "
+"diese Option hinzufügen."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."
+msgstr ""
+"Mit GnuTLS 3.6.6 wurde erzwungen, dass Mandos die Benutzung von OpenPGP als "
+"TLS-Sitzungsschlüssel stoppt. Ein neues TLS-Schlüsselpaar wurde erzeugt und "
+"wird zur Identifizierung benutzt, aber die Schlüsselkennung des öffentlichen "
+"Schlüssels muss auf diesem Server hinzugefügt werden, da dies nun "
+"zur Identifizierung des Clients auf dem Server verwendet wird."

=== added file 'debian/po/en_US.po'
--- debian/po/en_US.po	1970-01-01 00:00:00 +0000
+++ debian/po/en_US.po	2019-08-05 21:00:35 +0000
@@ -0,0 +1,150 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the mandos package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: mandos\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2019-08-05 22:57+0200\n"
+"PO-Revision-Date: 2019-08-05 22:59+0200\n"
+"Last-Translator: Teddy Hogeborn <teddy@recompile.se>\n"
+"Language-Team: English\n"
+"Language: en_US\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "New client option \"key_id\" is REQUIRED on server"
+msgstr "New client option “key_id” is REQUIRED on server"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the clients.conf file, "
+"otherwise the client most likely will not reboot unattended.  This option:"
+msgstr ""
+"A new “key_id” client option is REQUIRED in the clients.conf file, otherwise "
+"the client most likely will not reboot unattended.  This option:"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " key_id = <HEXSTRING>"
+msgstr " key_id = <HEXSTRING>"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"\"fingerprint\" option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+msgstr ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"“fingerprint” option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " mandos-keygen -F/dev/null|grep ^key_id"
+msgstr " mandos-keygen -F/dev/null|grep ^key id"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+msgstr ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server."
+msgstr ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server. "
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid "Bad key IDs have been removed from clients.conf"
+msgstr "Bad key IDs have been removed from clients.conf"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+msgstr ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid "New client option \"${key_id}\" is REQUIRED on server"
+msgstr "New client option “${key_id}” is REQUIRED on server"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the server's clients.conf "
+"file, otherwise this computer most likely will not reboot unattended.  This "
+"option:"
+msgstr ""
+"A new “key_id” client option is REQUIRED in the server’s clients.conf file, "
+"otherwise this computer most likely will not reboot unattended.  This option:"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid " ${key_id}"
+msgstr " ${key_id}"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"must be added (all on one line!) on the Mandos server host, in the file /etc/"
+"mandos/clients.conf, right before the \"fingerprint\" option for this Mandos "
+"client.  You must edit that file on that server and add this option."
+msgstr ""
+"must be added (all on one line!) on the Mandos server host, in the file /"
+"etc/ mandos/clients.conf, right before the “fingerprint” option for this "
+"Mandos client.  You must edit that file on that server and add this option."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."
+msgstr ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."

=== added file 'debian/po/fr.po'
--- debian/po/fr.po	1970-01-01 00:00:00 +0000
+++ debian/po/fr.po	2021-02-04 17:59:45 +0000
@@ -0,0 +1,156 @@
+# Translation of mandos debconf templates to French
+# Copyright (C) 2019, French l10n team <debian-l10n-french@lists.debian.org>
+# This file is distributed under the same license as the mandos package.
+# Grégoire Scano <gregoire.scano@malloc.fr>, 2019.
+msgid ""
+msgstr ""
+"Project-Id-Version: mandos\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2019-07-27 21:06+0200\n"
+"PO-Revision-Date: 2019-08-11 15:58+0800\n"
+"Last-Translator: Grégoire Scano <gregoire.scano@malloc.fr>\n"
+"Language-Team: French <debian-l10n-french@lists.debian.org>\n"
+"Language: fr_FR\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "New client option \"key_id\" is REQUIRED on server"
+msgstr "La nouvelle option de client « key_id » est NÉCESSAIRE sur le serveur"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the clients.conf file, "
+"otherwise the client most likely will not reboot unattended.  This option:"
+msgstr ""
+"Une nouvelle option de client « key_id » est NÉCESSAIRE dans le fichier "
+"clients.conf, autrement le client ne redémarrera probablement pas de lui-"
+"même. Cette option :"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "key_id = <HEXSTRING>"
+msgstr "key_id = <CHAÎNE HEXADÉCIMALE>"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"\"fingerprint\" option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+msgstr ""
+"doit être ajoutée dans le fichier /etc/mandos/clients.conf, juste avant "
+"l'option « fingerprint », pour chaque client Mandos. Vous devez éditer ce "
+"fichier et ajouter cette option pour tous les clients. Pour voir "
+"l'identifiant de clef correct pour chaque client, exécutez la commande (sur "
+"chaque client) :"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " mandos-keygen -F/dev/null|grep ^key_id"
+msgstr " mandos-keygen -F/dev/null|grep ^key_id"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+msgstr ""
+"Note : les clients doivent également tous utiliser GnuTLS 3.6.6 ou "
+"ultérieur ; le serveur ne peut pas servir des mots de passe pour des clients "
+"anciens et récents en même temps !"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server."
+msgstr ""
+"Explication : avec GnuTLS 3.6.6, Mandos a été contraint d'arrêter d'utiliser "
+"des clefs OpenPGP comme clefs de session TLS. Une nouvelle paire de clefs "
+"TLS sera générée pour chaque client et sera utilisée pour l'identification, "
+"mais l'identifiant de la clef publique doit être ajouté à ce serveur, "
+"puisqu'il sera utilisé pour identifier le client auprès du serveur."
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid "Bad key IDs have been removed from clients.conf"
+msgstr "Les identifiants de clef incorrects ont été supprimés de clients.conf"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+msgstr ""
+"Les identifiants de clef incorrects, créés par un bogue dans le client "
+"Mandos 1.8.0, ont été supprimés de /etc/mandos/clients.conf"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid "New client option \"${key_id}\" is REQUIRED on server"
+msgstr ""
+"La nouvelle option de client « ${key_id} » est NÉCESSAIRE sur le serveur"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the server's clients.conf "
+"file, otherwise this computer most likely will not reboot unattended.  This "
+"option:"
+msgstr ""
+"Une nouvelle option de client « key_id » est NÉCESSAIRE dans le fichier "
+"clients.conf du serveur, autrement cette machine ne pourra pas redémarrer "
+"d'elle-même. Cette option :"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid " ${key_id}"
+msgstr " ${key_id}"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"must be added (all on one line!) on the Mandos server host, in the file /etc/"
+"mandos/clients.conf, right before the \"fingerprint\" option for this Mandos "
+"client.  You must edit that file on that server and add this option."
+msgstr ""
+"doit être ajoutée (tout sur une seule ligne !) sur le serveur Mandos hôte, "
+"dans le fichier /etc/mandos/clients.conf, juste avant l'option "
+"« fingerprint » de ce client Mandos. Vous devez éditer ce fichier sur ce "
+"serveur et ajouter cette option."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."
+msgstr ""
+"Avec GnuTLS 3.6.6, Mandos a été contraint d'arrêter d'utiliser des clefs "
+"OpenPGP comme clefs de session TLS. Une nouvelle paire de clefs TLS a été "
+"générée et sera utilisée pour l'identification, mais l'identifiant de la "
+"clef publique doit être ajouté au serveur, puisqu'il sera utilisé pour "
+"identifier le client auprès du serveur."

=== added file 'debian/po/nl.po'
--- debian/po/nl.po	1970-01-01 00:00:00 +0000
+++ debian/po/nl.po	2019-12-05 03:38:07 +0000
@@ -0,0 +1,156 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the mandos package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: mandos_1.8.9-2\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2019-08-05 22:57+0200\n"
+"PO-Revision-Date: 2019-11-12 14:26+0100\n"
+"Language: nl\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Last-Translator: Frans Spiesschaert <Frans.Spiesschaert@yucom.be>\n"
+"Language-Team: Debian Dutch l10n Team <debian-l10n-dutch@lists.debian.org>\n"
+"X-Generator: Poedit 1.8.11\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "New client option \"key_id\" is REQUIRED on server"
+msgstr "Nieuwe client-optie \"key_id\" is VERPLICHT op de server"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the clients.conf file, "
+"otherwise the client most likely will not reboot unattended.  This option:"
+msgstr ""
+"In het bestand clients.conf is een nieuwe client-optie \"key_id\" VERPLICHT, "
+"anders zal de client hoogstwaarschijnlijk niet onbeheerd heropstarten. Deze "
+"optie:"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " key_id = <HEXSTRING>"
+msgstr " key_id = <HEXTEKENREEKS>"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"\"fingerprint\" option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+msgstr ""
+"moet voor elke Mandos-client toegevoegd worden in het bestand /etc/mandos/"
+"clients.conf, net voor de optie \"fingerprint\". U moet dat bestand bewerken "
+"en deze optie voor alle clients toevoegen. Om van elke client het correcte "
+"key_id te kennen, moet u het volgende commando (op iedere client) uitvoeren:"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " mandos-keygen -F/dev/null|grep ^key_id"
+msgstr " mandos-keygen -F/dev/null|grep ^key_id"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+msgstr ""
+"Opmerking: alle clients moeten GnuTLS 3.6.6 of recenter gebruiken; de server "
+"is niet in staat om wachtwoorden te geven voor zowel oude als nieuwe clients!"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server."
+msgstr ""
+"Motivering: met de komst van GnuTLS 3.6.6 werd Mandos gedwongen te stoppen "
+"met het gebruik van OpenPGP-sleutels als TLS-sessiesleutels. Op iedere "
+"client zal een nieuw TLS-sleutelpaar gegenereerd worden om als identificatie "
+"te dienen, maar de sleutel-ID van de publieke sleutel moet op deze server "
+"toegevoegd worden, aangezien deze nu gebruikt zal worden om de client bij de "
+"server te identificeren."
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid "Bad key IDs have been removed from clients.conf"
+msgstr "Slechte sleutel-ID's werden uit clients.conf verwijderd"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+msgstr ""
+"Slechte sleutel-ID's die wegens een bug in Mandos client 1.8.0 gecreëerd "
+"werden, werden verwijderd uit /etc/mandos/clients.conf"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid "New client option \"${key_id}\" is REQUIRED on server"
+msgstr "Nieuwe client-optie \"${key_id}\" is VERPLICHT op de server"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the server's clients.conf "
+"file, otherwise this computer most likely will not reboot unattended.  This "
+"option:"
+msgstr ""
+"In het bestand clients.conf op de server is een nieuwe client-optie \"key_id"
+"\" VERPLICHT, anders zal deze computer hoogstwaarschijnlijk niet onbeheerd "
+"heropstarten. Deze optie:"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid " ${key_id}"
+msgstr " ${key_id}"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"must be added (all on one line!) on the Mandos server host, in the file /etc/"
+"mandos/clients.conf, right before the \"fingerprint\" option for this Mandos "
+"client.  You must edit that file on that server and add this option."
+msgstr ""
+"moet voor deze Mandos-client op de Mandos-servercomputer toegevoegd worden "
+"(alles op één regel!) in het bestand /etc/mandos/clients.conf, net voor de "
+"optie \"fingerprint\". U moet dat bestand op de server bewerken en deze "
+"optie toevoegen."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."
+msgstr ""
+"Met de komst van GnuTLS 3.6.6 werd Mandos gedwongen te stoppen met het "
+"gebruik van OpenPGP-sleutels als TLS-sessiesleutels. Een nieuw TLS-"
+"sleutelpaar werd gegenereerd om als identificatie te dienen, maar de sleutel-"
+"ID van de publieke sleutel moet op de server toegevoegd worden, aangezien "
+"deze nu gebruikt zal worden om de client bij de server te identificeren."

=== added file 'debian/po/pt.po'
--- debian/po/pt.po	1970-01-01 00:00:00 +0000
+++ debian/po/pt.po	2019-10-19 17:37:00 +0000
@@ -0,0 +1,158 @@
+# Translation of mandos debconf messages to European Portuguese
+# Copyright (C) 2019 THE mandos'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the mandos package.
+#
+# Américo Monteiro <a_monteiro@gmx.com>, 2019.
+msgid ""
+msgstr ""
+"Project-Id-Version: mandos 1.8.9-2\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2019-08-05 22:57+0200\n"
+"PO-Revision-Date: 2019-10-18 18:45+0000\n"
+"Last-Translator: Américo Monteiro <a_monteiro@gmx.com>\n"
+"Language-Team: Portuguese <>\n"
+"Language: pt\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=2; plural=(n != 1);\n"
+"X-Generator: Lokalize 2.0\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "New client option \"key_id\" is REQUIRED on server"
+msgstr "Nova opção \"key_id\" de cliente é NECESSÁRIA no servidor"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the clients.conf file, "
+"otherwise the client most likely will not reboot unattended.  This option:"
+msgstr ""
+"Uma nova opção de cliente \"key_id\" é NECESSÁRIA no ficheiro clients.conf, "
+"caso contrário o mais provável é o cliente não conseguir reinicicar sozinho. "
+"Esta opção:"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " key_id = <HEXSTRING>"
+msgstr " key_id = <HEXSTRING>"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"\"fingerprint\" option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+msgstr ""
+"tem de ser adicionada ao ficheiro /etc/mandos/clients.conf, logo antes "
+"da opção \"fingerprint\", para cada cliente Mandos. Você tem de editar esse "
+"ficheiro e adicionar esta opção para todos os clientes. Para ver a key ID "
+"para cada cliente, corra este comando (em cada cliente):"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " mandos-keygen -F/dev/null|grep ^key_id"
+msgstr " mandos-keygen -F/dev/null|grep ^key_id"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+msgstr ""
+"Note: os clientes têm de também usar GnuTLS 3.6.6 ou posterior; o servidor "
+"não consegue servir palavras passe para ambos clientes antigos e novos!"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server."
+msgstr ""
+"Razão: Com GnuTLS 3.6.6, o Mandos foi forçado a parar de usar chaves OpenPGP "
+"como chaves de sessão TLS. Será gerado um novo par de chaves TLS em cada "
+"cliente e será usado como identificação, mas o ID de chave da chave pública "
+"precisa de ser adicionada a este servidor, pois esta irá agora ser usada "
+"para identificar o cliente no servidor."
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid "Bad key IDs have been removed from clients.conf"
+msgstr "IDs de chave errados foram removidos de clients.conf"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+msgstr ""
+"IDs de chave errados, que foram criados por um bug no cliente Mandos 1.8.0, "
+"foram removidos de /etc/mandos/clients.conf"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid "New client option \"${key_id}\" is REQUIRED on server"
+msgstr "Nova opção \"${key_id}\" de cliente é NECESSÁRIA no servidor"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the server's clients.conf "
+"file, otherwise this computer most likely will not reboot unattended.  This "
+"option:"
+msgstr ""
+"Uma nova opção \"key_id\" de cliente é NECESSÁRIA no ficheiro clients.conf "
+"do servidor, caso contrário, é bem provável que este computador não consiga "
+"reiniciar sozinho. Esta opção:"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid " ${key_id}"
+msgstr " ${key_id}"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"must be added (all on one line!) on the Mandos server host, in the file /etc/"
+"mandos/clients.conf, right before the \"fingerprint\" option for this Mandos "
+"client.  You must edit that file on that server and add this option."
+msgstr ""
+"tem de ser adicionada (toda numa linha) na máquina servidor do Mandos, no "
+"ficheiro /etc/mandos/clients.conf, logo antes da opção \"fingerprint\" para "
+"este cliente Mandos. Você tem de editar esse ficheiro nesse servidor e "
+"adicionar esta opção."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."
+msgstr ""
+"Com GnuTLS 3.6.6, o Mandos foi forçado a parar de usar chaves OpenPGP "
+"como chaves de sessão TLS. Foi gerado um novo par de chaves TLS e será "
+"usado como identificação, mas o ID de chave da chave pública precisa de ser "
+"adicionada ao servidor, pois esta irá agora ser usada para identificar o "
+"cliente no servidor."
+
+

=== added file 'debian/po/sv.po'
--- debian/po/sv.po	1970-01-01 00:00:00 +0000
+++ debian/po/sv.po	2019-08-16 20:47:52 +0000
@@ -0,0 +1,156 @@
+# Translation of mandos debconf templates to Swedish
+# Copyright (C) 2019, Mandos Maintainers <mandos@recompile.se>
+# This file is distributed under the same license as the mandos package.
+# Teddy Hogeborn <teddy@recompile.se>, 2019.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: mandos\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2019-08-05 22:57+0200\n"
+"PO-Revision-Date: 2019-08-16 22:45+0200\n"
+"Last-Translator: Teddy Hogeborn <teddy@recompile.se>\n"
+"Language-Team: Swedish <debian-l10n-swedish@lists.debian.org>\n"
+"Language: sv\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "New client option \"key_id\" is REQUIRED on server"
+msgstr "Ny klientinställning ”key_id” KRÄVS på servern"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the clients.conf file, "
+"otherwise the client most likely will not reboot unattended.  This option:"
+msgstr ""
+"En ny klientinställning, ”key_id”, KRÄVS i filen clients.conf, annars\n"
+"kommer klienten antagligen inte att starta upp av sig själv.  Denna\n"
+"inställning:"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " key_id = <HEXSTRING>"
+msgstr " key_id = <HEXADECIMALSTRÄNG>"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"\"fingerprint\" option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+msgstr ""
+"måste läggas till i filen /etc/mandos/clients.conf, precis ovanför\n"
+"inställningen ”fingerprint”, för varje Mandosklient.  Du måste ändra i\n"
+"den filen och lägga till den inställningen för alla klienter.  För att\n"
+"se det korrekta nyckel-IDt för varje klient, kör följande kommando (på\n"
+"varje klient):"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " mandos-keygen -F/dev/null|grep ^key_id"
+msgstr " mandos-keygen -F/dev/null|grep ^key_id"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+msgstr ""
+"Observera: Alla klienter måste också använda GnuTLS 3.6.6 eller nyare;\n"
+"servern kan inte ge lösenord till både nya och gamla klienter!"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server."
+msgstr ""
+"Förklaring: Med GnuTLS 3.6.6 så har Mandos nödgats att sluta använda\n"
+"OpenPGP-nycklar som TLS-sessionsnycklar.  Ett nytt TLS-nyckelpar\n"
+"kommer att genereras på varje klient och kommer att användas för\n"
+"identifiering, men nyckel-IDt för den publika nyckeln måste läggas\n"
+"till på denna server, då denna numera kommer att användas för att\n"
+"identifiera klienten för servern."
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid "Bad key IDs have been removed from clients.conf"
+msgstr "Dåliga nyckel-IDn har tagits bort från clients.conf"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+msgstr ""
+"Dåliga nyckel-IDn, som skapats av en bugg i Mandosklienten 1.8.0, har\n"
+"tagits bort från /etc/mandos/clients.conf"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid "New client option \"${key_id}\" is REQUIRED on server"
+msgstr "Ny klientinställning ”${key_id}” KRÄVS på servern"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the server's clients.conf "
+"file, otherwise this computer most likely will not reboot unattended.  This "
+"option:"
+msgstr ""
+"En ny klientinställning, ”key_id”, KRÄVS i serverns clients.conf-fil,\n"
+"annars kommer denna dator antagligen inte att starta upp av sig själv.\n"
+"Denna inställning:"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid " ${key_id}"
+msgstr " ${key_id}"
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"must be added (all on one line!) on the Mandos server host, in the file /etc/"
+"mandos/clients.conf, right before the \"fingerprint\" option for this Mandos "
+"client.  You must edit that file on that server and add this option."
+msgstr ""
+"måste läggas till (allt på en rad!) på Mandosservervärddatorn, i filen\n"
+"/etc/mandos/clients.conf, precis ovanför inställningen ”fingerprint”,\n"
+"för denna Mandosklient.  Du måste ändra i den filen och lägga till den\n"
+"inställningen."
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."
+msgstr ""
+"Med GnuTLS 3.6.6 så har Mandos nödgats att sluta använda\n"
+"OpenPGP-nycklar som TLS-sessionsnycklar.  Ett nytt TLS-nyckelpar har\n"
+"genererats och kommer att användas för identifiering, men nyckel-IDt\n"
+"för den publika nyckeln måste läggas till på servern, då detta numera\n"
+"kommer att användas för att identifiera klienten för servern."

=== added file 'debian/po/templates.pot'
--- debian/po/templates.pot	1970-01-01 00:00:00 +0000
+++ debian/po/templates.pot	2019-08-05 21:00:35 +0000
@@ -0,0 +1,127 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the mandos package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: mandos\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2019-08-05 22:57+0200\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=CHARSET\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "New client option \"key_id\" is REQUIRED on server"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the clients.conf file, "
+"otherwise the client most likely will not reboot unattended.  This option:"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " key_id = <HEXSTRING>"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"must be added in the file /etc/mandos/clients.conf, right before the "
+"\"fingerprint\" option, for each Mandos client.  You must edit that file and "
+"add this option for all clients.  To see the correct key ID for each client, "
+"run this command (on each client):"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid " mandos-keygen -F/dev/null|grep ^key_id"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Note: the clients must all also be using GnuTLS 3.6.6 or later; the server "
+"cannot serve passwords for both old and new clients!"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid ""
+"Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP "
+"keys as TLS session keys.  A new TLS key pair will be generated on each "
+"client and will be used as identification, but the key ID of the public key "
+"needs to be added to this server, since this will now be used to identify "
+"the client to the server."
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid "Bad key IDs have been removed from clients.conf"
+msgstr ""
+
+#. Type: note
+#. Description
+#: ../mandos.templates:2001
+msgid ""
+"Bad key IDs, which were created by a bug in Mandos client 1.8.0, have been "
+"removed from /etc/mandos/clients.conf"
+msgstr ""
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid "New client option \"${key_id}\" is REQUIRED on server"
+msgstr ""
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"A new \"key_id\" client option is REQUIRED in the server's clients.conf "
+"file, otherwise this computer most likely will not reboot unattended.  This "
+"option:"
+msgstr ""
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid " ${key_id}"
+msgstr ""
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"must be added (all on one line!) on the Mandos server host, in the file /etc/"
+"mandos/clients.conf, right before the \"fingerprint\" option for this Mandos "
+"client.  You must edit that file on that server and add this option."
+msgstr ""
+
+#. Type: note
+#. description
+#: ../mandos-client.templates:1001
+msgid ""
+"With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS "
+"session keys.  A new TLS key pair has been generated and will be used as "
+"identification, but the key ID of the public key needs to be added to the "
+"server, since this will now be used to identify the client to the server."
+msgstr ""

=== modified file 'debian/rules'
--- debian/rules	2019-02-13 08:45:09 +0000
+++ debian/rules	2019-04-09 22:31:23 +0000
@@ -53,7 +53,7 @@
 #bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
 #bpo#		--show libgnutls30); \
 #bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
-#bpo#		&& { cp --archive debian/control debian/control.orig; sed --expression='s/libgnutls28-dev (>= 3\.6\.6) |//' debian/control; }
+#bpo#		&& { cp --archive debian/control debian/control.orig; sed --in-place --expression='s/libgnutls28-dev (>= 3\.6\.6) |//' debian/control; }
 #bpo#	dh_shlibdeps
 #bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
 #bpo#		--show libgnutls30); \

=== added file 'debian/source/lintian-overrides'
--- debian/source/lintian-overrides	1970-01-01 00:00:00 +0000
+++ debian/source/lintian-overrides	2019-08-05 21:03:31 +0000
@@ -0,0 +1,7 @@
+# We are both upstream and Debian maintainer for this package, so the
+# .asc signature can not exist until after the orig.tar.gz has been
+# built as part of the Debian package build.
+mandos source: orig-tarball-missing-upstream-signature mandos_*.tar.gz
+
+# We want to backport to stretch for as long as reasonably practical
+mandos source: package-uses-old-debhelper-compat-version 10

=== added directory 'debian/tests'
=== added file 'debian/tests/control'
--- debian/tests/control	1970-01-01 00:00:00 +0000
+++ debian/tests/control	2019-09-04 05:31:20 +0000
@@ -0,0 +1,33 @@
+Test-Command: /usr/sbin/mandos --check
+Restrictions: superficial, allow-stderr
+Features: test-name=mandos-check
+Depends: mandos
+
+Test-Command: /usr/sbin/mandos-ctl --check --verbose
+Restrictions: allow-stderr
+Features: test-name=mandos-ctl
+Depends: mandos
+
+Test-Command: /usr/sbin/mandos-keygen --version
+Restrictions: superficial
+Features: test-name=mandos-keygen-version
+Depends: mandos-client
+
+Test-Command: /usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-runner --version
+Restrictions: needs-root, superficial
+Features: test-name=plugin-runner-version
+Depends: mandos-client
+
+Test-Command: /usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers/mandos-client-iprouteadddel --version
+Restrictions: needs-root, superficial
+Features: test-name=mandos-client-iprouteadddel-version
+Depends: mandos-client
+
+Test-Command: /usr/lib/dracut/modules.d/90mandos/password-agent --test --verbose
+Features: test-name=password-agent
+Depends: mandos-client
+
+Test-Command: /usr/lib/dracut/modules.d/90mandos/password-agent --test --verbose -p /task-creators/start_mandos_client/suid
+Restrictions: needs-root
+Features: test-name=password-agent-suid
+Depends: mandos-client

=== added file 'debian/upstream/metadata'
--- debian/upstream/metadata	1970-01-01 00:00:00 +0000
+++ debian/upstream/metadata	2019-08-04 12:39:39 +0000
@@ -0,0 +1,13 @@
+# -*- yaml -*-
+---
+Bug-Submit: mailto:mandos-dev@recompile.se
+Changelog: https://bzr.recompile.se/loggerhead/mandos/trunk/view/head:/NEWS
+Contact: mandos@recompile.se
+Documentation: https://www.recompile.se/mandos/man/intro.8mandos
+FAQ: https://www.recompile.se/mandos/man/intro.8mandos#faq
+Name: Mandos
+Other-References: https://www.recompile.se/mandos
+Registration: https://mail.recompile.se/cgi-bin/mailman/listinfo/mandos-dev
+Repository: https://ftp.recompile.se/pub/mandos/trunk
+Repository-Browse: https://bzr.recompile.se/loggerhead/mandos/trunk/files
+Security-Contact: mandos@recompile.se

=== added directory 'dracut-module'
=== added file 'dracut-module/ask-password-mandos.path'
--- dracut-module/ask-password-mandos.path	1970-01-01 00:00:00 +0000
+++ dracut-module/ask-password-mandos.path	2019-07-27 10:11:45 +0000
@@ -0,0 +1,47 @@
+# -*- systemd -*-
+# 
+# Copyright © 2019 Teddy Hogeborn
+# Copyright © 2019 Björn Påhlsson
+# 
+# This file is part of Mandos.
+# 
+# Mandos is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+# 
+#     Mandos is distributed in the hope that it will be useful, but
+#     WITHOUT ANY WARRANTY; without even the implied warranty of
+#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#     GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+# 
+# Contact the authors at <mandos@recompile.se>.
+# 
+# This systemd.path(5) unit will wait until there are any password
+# questions present, represented by files named "ask.*" in the
+# /run/systemd/ask-password directory, and then start the
+# "ask-password-mandos.service" systemd.service(5) unit.
+
+# This file should be installed in the root file system as
+# "/usr/lib/dracut/modules.d/90mandos/ask-password-mandos.path" and
+# will be installed in the initramfs image file as
+# "/lib/systemd/system/ask-password-mandos.path", and symlinked to
+# "/lib/systemd/system//sysinit.target.wants/ask-password-mandos.path"
+# by dracut when dracut creates the initramfs image file.
+
+[Unit]
+Description=Forward Password Requests to remote Mandos server
+Documentation=man:intro(8mandos) man:password-agent(8mandos) man:mandos-client(8mandos)
+DefaultDependencies=no
+Conflicts=shutdown.target
+Before=basic.target shutdown.target
+ConditionKernelCommandLine=!mandos=off
+ConditionFileIsExecutable=/lib/mandos/password-agent
+ConditionPathIsMountPoint=!/sysroot
+
+[Path]
+PathExistsGlob=/run/systemd/ask-password/ask.*
+MakeDirectory=yes

=== added file 'dracut-module/ask-password-mandos.service'
--- dracut-module/ask-password-mandos.service	1970-01-01 00:00:00 +0000
+++ dracut-module/ask-password-mandos.service	2020-07-04 11:58:52 +0000
@@ -0,0 +1,51 @@
+# -*- systemd -*-
+# 
+# Copyright © 2019-2020 Teddy Hogeborn
+# Copyright © 2019-2020 Björn Påhlsson
+# 
+# This file is part of Mandos.
+# 
+# Mandos is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+# 
+#     Mandos is distributed in the hope that it will be useful, but
+#     WITHOUT ANY WARRANTY; without even the implied warranty of
+#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#     GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+# 
+# Contact the authors at <mandos@recompile.se>.
+# 
+# This systemd.service(5) unit file will start the Mandos
+# password-agent(8mandos) program, which will in turn run
+# mandos-client(8mandos) to get a password and send the password to
+# any and all active password questions using the systemd “Password
+# Agent” mechanism.
+
+# This file should be installed in the root file system as
+# "/usr/lib/dracut/modules.d/90mandos/ask-password-mandos.service" and
+# will be installed in the initramfs image file as
+# "/lib/systemd/system/ask-password-mandos.service" by dracut when
+# dracut creates the initramfs image file.
+
+[Unit]
+Description=Forward Password Requests to remote Mandos server
+Documentation=man:intro(8mandos) man:password-agent(8mandos) man:mandos-client(8mandos)
+DefaultDependencies=no
+Conflicts=shutdown.target
+Before=shutdown.target
+ConditionKernelCommandLine=!mandos=off
+ConditionFileIsExecutable=/lib/mandos/password-agent
+ConditionFileIsExecutable=/lib/mandos/mandos-client
+ConditionFileNotEmpty=/etc/mandos/keys/pubkey.txt
+ConditionFileNotEmpty=/etc/mandos/keys/seckey.txt
+ConditionFileNotEmpty=/etc/mandos/keys/tls-pubkey.pem
+ConditionFileNotEmpty=/etc/mandos/keys/tls-privkey.pem
+ConditionPathIsMountPoint=!/sysroot
+
+[Service]
+ExecStart=/lib/mandos/password-agent $PASSWORD_AGENT_OPTIONS -- /lib/mandos/mandos-client --pubkey=/etc/mandos/keys/pubkey.txt --seckey=/etc/mandos/keys/seckey.txt --tls-pubkey=/etc/mandos/keys/tls-pubkey.pem --tls-privkey=/etc/mandos/keys/tls-privkey.pem $MANDOS_CLIENT_OPTIONS

=== added file 'dracut-module/cmdline-mandos.sh'
--- dracut-module/cmdline-mandos.sh	1970-01-01 00:00:00 +0000
+++ dracut-module/cmdline-mandos.sh	2019-07-27 10:11:45 +0000
@@ -0,0 +1,74 @@
+#!/bin/sh
+#
+# This file should be present in the root file system directory
+# /usr/lib/dracut/modules.d/90mandos.  When dracut creates the
+# initramfs image, dracut will run the "module-setup.sh" file in the
+# same directory, which (when *not* using the "systemd" dracut module)
+# will copy this file ("cmdline-mandos.sh") into the initramfs as
+# "/lib/dracut/hooks/cmdline/20-cmdline-mandos.sh".
+# 
+# Despite the above #!/bin/sh line and the executable flag, this file
+# is not executed; this file is sourced by the /init script in the
+# initramfs image created by dracut.
+
+if getargbool 1 mandos && [ -e /lib/dracut-crypt-lib.sh ]; then
+    cat >> /lib/dracut-crypt-lib.sh <<- "EOF"
+	ask_for_password(){
+	    local cmd; local prompt; local tries=3
+	    local ply_cmd; local ply_prompt; local ply_tries=3
+	    local tty_cmd; local tty_prompt; local tty_tries=3
+	    local ret
+	
+	    while [ $# -gt 0 ]; do
+		case "$1" in
+		    --cmd) ply_cmd="$2"; tty_cmd="$2"; shift;;
+		    --ply-cmd) ply_cmd="$2"; shift;;
+		    --tty-cmd) tty_cmd="$2"; shift;;
+		    --prompt) ply_prompt="$2"; tty_prompt="$2"; shift;;
+		    --ply-prompt) ply_prompt="$2"; shift;;
+		    --tty-prompt) tty_prompt="$2"; shift;;
+		    --tries) ply_tries="$2"; tty_tries="$2"; shift;;
+		    --ply-tries) ply_tries="$2"; shift;;
+		    --tty-tries) tty_tries="$2"; shift;;
+		    --tty-echo-off) tty_echo_off=yes;;
+		    -*) :;;
+		esac
+		shift
+	    done
+	    if [ -z "$ply_cmd" ]; then
+		ply_cmd="$tty_cmd"
+	    fi
+	    # Extract device and luksname from $ply_cmd
+	    set -- $ply_cmd
+	    shift
+	    for arg in "$@"; do
+		case "$arg" in
+		    -*) :;;
+		    *)
+			if [ -z "$device" ]; then
+			    device="$arg"
+			else
+			    luksname="$arg"
+			    break
+			fi
+			;;
+		esac
+	    done
+	    { flock -s 9;
+	      if [ -z "$ply_prompt" ]; then
+		  if [ -z "$tty_prompt" ]; then
+		      CRYPTTAB_SOURCE="$device" cryptsource="$device" CRYPTTAB_NAME="$luksname" crypttarget="$luksname" /lib/mandos/plugin-runner --config-file=/etc/mandos/plugin-runner.conf | $ply_cmd
+		  else
+		      CRYPTTAB_SOURCE="$device" cryptsource="$device" CRYPTTAB_NAME="$luksname" crypttarget="$luksname" /lib/mandos/plugin-runner --options-for=password-prompt:--prompt="${tty_prompt}" --config-file=/etc/mandos/plugin-runner.conf | $ply_cmd
+		  fi
+	      else
+		  if [ -z "$tty_prompt" ]; then
+		      CRYPTTAB_SOURCE="$device" cryptsource="$device" CRYPTTAB_NAME="$luksname" crypttarget="$luksname" /lib/mandos/plugin-runner --options-for=plymouth:--prompt="${ply_prompt}" --config-file=/etc/mandos/plugin-runner.conf | $ply_cmd
+		  else
+		      CRYPTTAB_SOURCE="$device" cryptsource="$device" CRYPTTAB_NAME="$luksname" crypttarget="$luksname" /lib/mandos/plugin-runner --options-for=password-prompt:--prompt="${tty_prompt}" --options-for=plymouth:--prompt="${ply_prompt}" --config-file=/etc/mandos/plugin-runner.conf | $ply_cmd
+		  fi
+	      fi
+	    } 9>/.console_lock
+	}
+	EOF
+fi

=== added file 'dracut-module/module-setup.sh'
--- dracut-module/module-setup.sh	1970-01-01 00:00:00 +0000
+++ dracut-module/module-setup.sh	2020-02-05 21:39:28 +0000
@@ -0,0 +1,257 @@
+#!/bin/sh
+#
+# This file should be present in the root file system directory
+# /usr/lib/dracut/modules.d/90mandos.  When dracut creates the
+# initramfs image, dracut will source this file and run the shell
+# functions defined in this file: "install", "check", "depends",
+# "cmdline", and "installkernel".
+# 
+# Despite the above #!/bin/sh line and the executable flag, this file
+# is not executed; this file is sourced by dracut when creating the
+# initramfs image file.
+
+mandos_libdir(){
+    for dir in /usr/lib \
+	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
+	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/local/lib; do
+	if [ -d "$dir"/mandos ]; then
+	    echo "$dir"/mandos
+	    return
+	fi
+    done
+    # Mandos not found
+    return 1
+}
+
+mandos_keydir(){
+    for dir in /etc/keys/mandos /etc/mandos/keys; do
+	if [ -d "$dir" ]; then
+	    echo "$dir"
+	    return
+	fi
+    done
+    # Mandos key directory not found
+    return 1
+}
+
+check(){
+    if [ "${hostonly:-no}" = "no" ]; then
+	dwarning "Mandos: Dracut not in hostonly mode"
+	return 1
+    fi
+
+    local libdir=`mandos_libdir`
+    if [ -z "$libdir" ]; then
+	dwarning "Mandos lib directory not found"
+	return 1
+    fi
+
+    local keydir=`mandos_keydir`
+    if [ -z "$keydir" ]; then
+	dwarning "Mandos key directory not found"
+	return 1
+    fi
+}
+
+install(){
+    chmod go+w,+t "$initdir"/tmp
+    local libdir=`mandos_libdir`
+    local keydir=`mandos_keydir`
+    set `{ getent passwd _mandos \
+	|| getent passwd nobody \
+	|| echo ::65534:65534:::; } \
+	| cut --delimiter=: --fields=3,4 --only-delimited \
+	--output-delimiter=" "`
+    local mandos_user="$1"
+    local mandos_group="$2"
+    inst "${libdir}" /lib/mandos
+    if dracut_module_included "systemd"; then
+	plugindir=/lib/mandos
+	inst "${libdir}/plugins.d/mandos-client" \
+	     "${plugindir}/mandos-client"
+	chmod u-s "${initdir}/${plugindir}/mandos-client"
+	inst "${moddir}/ask-password-mandos.service" \
+	     "${systemdsystemunitdir}/ask-password-mandos.service"
+	if [ -d /etc/systemd/system/ask-password-mandos.service.d ]; then
+	    inst /etc/systemd/system/ask-password-mandos.service.d
+	    inst_multiple -o /etc/systemd/system/ask-password-mandos.service.d/*.conf
+	fi
+	if [ ${mandos_user} != 65534 ]; then
+	    sed --in-place \
+		--expression="s,^ExecStart=/lib/mandos/password-agent ,&--user=${mandos_user} ," \
+		"${initdir}/${systemdsystemunitdir}/ask-password-mandos.service"
+	fi
+	if [ ${mandos_group} != 65534 ]; then
+	    sed --in-place \
+		--expression="s,^ExecStart=/lib/mandos/password-agent ,&--group=${mandos_group} ," \
+		"${initdir}/${systemdsystemunitdir}/ask-password-mandos.service"
+	fi
+    else
+	inst_hook cmdline 20 "$moddir"/cmdline-mandos.sh
+	plugindir=/lib/mandos/plugins.d
+	inst "${libdir}/plugin-runner" /lib/mandos/plugin-runner
+	inst /etc/mandos/plugin-runner.conf
+	sed --in-place \
+	    --expression='1i--options-for=mandos-client:--pubkey=/etc/mandos/keys/pubkey.txt,--seckey=/etc/mandos/keys/seckey.txt,--tls-pubkey=/etc/mandos/keys/tls-pubkey.pem,--tls-privkey=/etc/mandos/keys/tls-privkey.pem' \
+	    "${initdir}/etc/mandos/plugin-runner.conf"
+	if [ ${mandos_user} != 65534 ]; then
+	    sed --in-place --expression="1i--userid=${mandos_user}" \
+		"${initdir}/etc/mandos/plugin-runner.conf"
+	fi
+	if [ ${mandos_group} != 65534 ]; then
+	    sed --in-place \
+		--expression="1i--groupid=${mandos_group}" \
+		"${initdir}/etc/mandos/plugin-runner.conf"
+	fi
+	inst "${libdir}/plugins.d" "$plugindir"
+	chown ${mandos_user}:${mandos_group} "${initdir}/${plugindir}"
+	# Copy the packaged plugins
+	for file in "$libdir"/plugins.d/*; do
+	    base="`basename \"$file\"`"
+	    # Is this plugin overridden?
+	    if [ -e "/etc/mandos/plugins.d/$base" ]; then
+		continue
+	    fi
+	    case "$base" in
+		*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+		    : ;;
+		"*") dwarning "Mandos client plugin directory is empty." >&2 ;;
+		askpass-fifo) : ;; # Ignore packaged for dracut
+		*) inst "${file}" "${plugindir}/${base}" ;;
+	    esac
+	done
+	# Copy any user-supplied plugins
+	for file in /etc/mandos/plugins.d/*; do
+	    base="`basename \"$file\"`"
+	    case "$base" in
+		*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+		    : ;;
+		"*") : ;;
+		*) inst "$file" "${plugindir}/${base}" ;;
+	    esac
+	done
+	# Copy any user-supplied plugin helpers
+	for file in /etc/mandos/plugin-helpers/*; do
+	    base="`basename \"$file\"`"
+	    case "$base" in
+		*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+		    : ;;
+		"*") : ;;
+		*) inst "$file" "/lib/mandos/plugin-helpers/$base";;
+	    esac
+	done
+    fi
+    # Copy network hooks
+    for hook in /etc/mandos/network-hooks.d/*; do
+	basename=`basename "$hook"`
+	case "$basename" in
+	    "*") continue ;;
+	    *[!A-Za-z0-9_.-]*) continue ;;
+	    *) test -d "$hook" || inst "$hook" "/lib/mandos/network-hooks.d/$basename" ;;
+	esac
+	if [ -x "$hook" ]; then
+	    # Copy any files needed by the network hook
+	    MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=files \
+		VERBOSITY=0 "$hook" files | while read file target; do
+		if [ ! -e "${file}" ]; then
+		    dwarning "WARNING: file ${file} not found, requested by Mandos network hook '${basename}'" >&2
+		fi
+		if [ -z "${target}" ]; then
+		    inst "$file"
+		else
+		    inst "$file" "$target"
+		fi
+	    done
+	fi
+    done
+    # Copy the packaged plugin helpers
+    for file in "$libdir"/plugin-helpers/*; do
+	base="`basename \"$file\"`"
+	# Is this plugin overridden?
+	if [ -e "/etc/mandos/plugin-helpers/$base" ]; then
+	    continue
+	fi
+	case "$base" in
+	    *~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+		: ;;
+	    "*") : ;;
+	    *) inst "$file" "/lib/mandos/plugin-helpers/$base";;
+	esac
+    done
+    local gpg=/usr/bin/gpg
+    if [ -e /usr/bin/gpgconf ]; then
+	inst /usr/bin/gpgconf
+	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
+	gpgagent="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg-agent:[^:]*://p'`"
+	# Newer versions of GnuPG 2 requires the gpg-agent binary
+	if [ -e "$gpgagent" ]; then
+	    inst "$gpgagent"
+	fi
+    fi
+    inst "$gpg"
+    if dracut_module_included "systemd"; then
+	inst "${moddir}/password-agent" /lib/mandos/password-agent
+	inst "${moddir}/ask-password-mandos.path" \
+	     "${systemdsystemunitdir}/ask-password-mandos.path"
+	ln_r "${systemdsystemunitdir}/ask-password-mandos.path" \
+	     "${systemdsystemunitdir}/sysinit.target.wants/ask-password-mandos.path"
+    fi
+    # Key files
+    for file in "$keydir"/*; do
+	if [ -d "$file" ]; then
+	    continue
+	fi
+	case "$file" in
+	    *~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+		: ;;
+	    "*") : ;;
+	    *)
+		inst "$file" "/etc/mandos/keys/`basename \"$file\"`"
+		chown ${mandos_user}:${mandos_group} \
+		      "${initdir}/etc/mandos/keys/`basename \"$file\"`"
+		if [ `basename "$file"` = dhparams.pem ]; then
+		    # Use Diffie-Hellman parameters file
+		    if dracut_module_included "systemd"; then
+			sed --in-place \
+			    --expression='/^ExecStart/s/ \$MANDOS_CLIENT_OPTIONS/ --dh-params=\/etc\/mandos\/keys\/dhparams.pem&/' \
+			    "${initdir}/${systemdsystemunitdir}/ask-password-mandos.service"
+		    else
+			sed --in-place \
+			    --expression="1i--options-for=mandos-client:--dh-params=/etc/mandos/keys/dhparams.pem" \
+			    "${initdir}/etc/mandos/plugin-runner.conf"
+		    fi
+		fi
+		;;
+	esac
+    done
+}
+
+installkernel(){
+    instmods =drivers/net
+    hostonly='' instmods ipv6
+    # Copy any kernel modules needed by network hooks
+    for hook in /etc/mandos/network-hooks.d/*; do
+	basename=`basename "$hook"`
+	case "$basename" in
+	    "*") continue ;;
+	    *[!A-Za-z0-9_.-]*) continue ;;
+	esac
+	if [ -x "$hook" ]; then
+	    # Copy and load any modules needed by the network hook
+	    MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=modules \
+		VERBOSITY=0 "$hook" modules | while read module; do
+		if [ -z "${target}" ]; then
+		    instmods "$module"
+		fi
+	    done
+	fi
+    done
+}
+
+depends(){
+    echo crypt
+}
+
+cmdline(){
+    :
+}

=== added file 'dracut-module/password-agent.c'
--- dracut-module/password-agent.c	1970-01-01 00:00:00 +0000
+++ dracut-module/password-agent.c	2021-02-04 17:57:58 +0000
@@ -0,0 +1,8197 @@
+/* -*- mode: c; coding: utf-8; after-save-hook: (lambda () (let* ((find-build-directory (lambda (try-directory &optional base-directory) (let ((base-directory (or base-directory try-directory))) (cond ((equal try-directory "/") base-directory) ((file-readable-p (concat (file-name-as-directory try-directory) "Makefile")) try-directory) ((funcall find-build-directory (directory-file-name (file-name-directory try-directory)) base-directory)))))) (build-directory (funcall find-build-directory (buffer-file-name))) (local-build-directory (if (fboundp 'file-local-name) (file-local-name build-directory) (or (file-remote-p build-directory 'localname) build-directory))) (command (file-relative-name (file-name-sans-extension (buffer-file-name)) build-directory))) (pcase (progn (if (get-buffer "*Test*") (kill-buffer "*Test*")) (process-file-shell-command (let ((qbdir (shell-quote-argument local-build-directory)) (qcmd (shell-quote-argument command))) (format "cd %s && CFLAGS=-Werror make --silent %s && %s --test --verbose" qbdir qcmd qcmd)) nil "*Test*")) (0 (let ((w (get-buffer-window "*Test*"))) (if w (delete-window w)))) (_ (with-current-buffer "*Test*" (compilation-mode) (cd-absolute build-directory)) (display-buffer "*Test*" '(display-buffer-in-side-window)))))); -*- */
+/*
+ * Mandos password agent - Simple password agent to run Mandos client
+ *
+ * Copyright © 2019-2021 Teddy Hogeborn
+ * Copyright © 2019-2021 Björn Påhlsson
+ * 
+ * This file is part of Mandos.
+ * 
+ * Mandos is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ * 
+ * Mandos is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * 
+ * Contact the authors at <mandos@recompile.se>.
+ */
+
+#define _GNU_SOURCE		/* pipe2(), O_CLOEXEC, setresgid(),
+				   setresuid(), asprintf(), getline(),
+				   basename() */
+#include <inttypes.h>		/* uintmax_t, strtoumax(), PRIuMAX,
+				   PRIdMAX, intmax_t, uint32_t,
+				   SCNx32, SCNuMAX, SCNxMAX */
+#include <stddef.h>		/* size_t, NULL */
+#include <sys/types.h>		/* pid_t, uid_t, gid_t, getuid(),
+				   getpid() */
+#include <stdbool.h>		/* bool, true, false */
+#include <signal.h>		/* struct sigaction, sigset_t,
+				   sigemptyset(), sigaddset(),
+				   SIGCHLD, pthread_sigmask(),
+				   SIG_BLOCK, SIG_SETMASK, SA_RESTART,
+				   SA_NOCLDSTOP, sigfillset(), kill(),
+				   SIGTERM, sigdelset(), SIGKILL,
+				   NSIG, sigismember(), SA_ONSTACK,
+				   SIG_DFL, SIG_IGN, SIGINT, SIGQUIT,
+				   SIGHUP, SIGSTOP, SIG_UNBLOCK */
+#include <unistd.h>		/* uid_t, gid_t, close(), pipe2(),
+				   fork(), _exit(), dup2(),
+				   STDOUT_FILENO, setresgid(),
+				   setresuid(), execv(), ssize_t,
+				   read(), dup3(), getuid(), dup(),
+				   STDERR_FILENO, pause(), write(),
+				   rmdir(), unlink(), getpid() */
+#include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
+				   malloc(), free(), realloc(),
+				   setenv(), calloc(), mkdtemp(),
+				   mkostemp() */
+#include <iso646.h>		/* not, or, and, xor */
+#include <error.h>		/* error() */
+#include <sysexits.h>		/* EX_USAGE, EX_OSERR, EX_OSFILE */
+#include <errno.h>		/* errno, error_t, EACCES,
+				   ENAMETOOLONG, ENOENT, ENOTDIR,
+				   ENOMEM, EEXIST, ECHILD, EPERM,
+				   EAGAIN, EINTR, ENOBUFS, EADDRINUSE,
+				   ECONNREFUSED, ECONNRESET,
+				   ETOOMANYREFS, EMSGSIZE, EBADF,
+				   EINVAL */
+#include <string.h>		/* strdup(), memcpy(),
+				   explicit_bzero(), memset(),
+				   strcmp(), strlen(), strncpy(),
+				   memcmp(), basename(), strerror() */
+#include <argz.h>		/* argz_create(), argz_count(),
+				   argz_extract(), argz_next(),
+				   argz_add() */
+#include <sys/epoll.h>		/* epoll_create1(), EPOLL_CLOEXEC,
+				   epoll_ctl(), EPOLL_CTL_ADD,
+				   struct epoll_event, EPOLLIN,
+				   EPOLLRDHUP, EPOLLOUT,
+				   epoll_pwait() */
+#include <time.h>		/* struct timespec, clock_gettime(),
+				   CLOCK_MONOTONIC */
+#include <argp.h>		/* struct argp_option, OPTION_HIDDEN,
+				   OPTION_ALIAS, struct argp_state,
+				   ARGP_ERR_UNKNOWN, ARGP_KEY_ARGS,
+				   struct argp, argp_parse(),
+				   ARGP_NO_EXIT */
+#include <stdint.h>		/* SIZE_MAX, uint32_t */
+#include <sys/mman.h>		/* munlock(), mlock() */
+#include <fcntl.h>		/* O_CLOEXEC, O_NONBLOCK, fcntl(),
+				   F_GETFD, F_GETFL, FD_CLOEXEC,
+				   open(), O_WRONLY, O_NOCTTY,
+				   O_RDONLY, O_NOFOLLOW */
+#include <sys/wait.h>		/* waitpid(), WNOHANG, WIFEXITED(),
+				   WEXITSTATUS() */
+#include <limits.h>		/* PIPE_BUF, NAME_MAX, INT_MAX */
+#include <sys/inotify.h>	/* inotify_init1(), IN_NONBLOCK,
+				   IN_CLOEXEC, inotify_add_watch(),
+				   IN_CLOSE_WRITE, IN_MOVED_TO,
+				   IN_MOVED_FROM, IN_DELETE,
+				   IN_EXCL_UNLINK, IN_ONLYDIR,
+				   struct inotify_event */
+#include <fnmatch.h>		/* fnmatch(), FNM_FILE_NAME */
+#include <stdio.h>		/* asprintf(), FILE, stderr, fopen(),
+				   fclose(), getline(), sscanf(),
+				   feof(), ferror(), rename(),
+				   fdopen(), fprintf(), fscanf() */
+#include <glib.h>    /* GKeyFile, g_key_file_free(), g_key_file_new(),
+			GError, g_key_file_load_from_file(),
+			G_KEY_FILE_NONE, TRUE, G_FILE_ERROR_NOENT,
+			g_key_file_get_string(), guint64,
+			g_key_file_get_uint64(),
+			G_KEY_FILE_ERROR_KEY_NOT_FOUND, gconstpointer,
+			g_assert_true(), g_assert_nonnull(),
+			g_assert_null(), g_assert_false(),
+			g_assert_cmpint(), g_assert_cmpuint(),
+			g_test_skip(), g_assert_cmpstr(),
+			g_test_message(), g_test_init(), g_test_add(),
+			g_test_run(), GOptionContext,
+			g_option_context_new(),
+			g_option_context_set_help_enabled(), FALSE,
+			g_option_context_set_ignore_unknown_options(),
+			gboolean, GOptionEntry, G_OPTION_ARG_NONE,
+			g_option_context_add_main_entries(),
+			g_option_context_parse(),
+			g_option_context_free(), g_error() */
+#include <sys/un.h>		/* struct sockaddr_un, SUN_LEN */
+#include <sys/socket.h>		/* AF_LOCAL, socket(), PF_LOCAL,
+				   SOCK_DGRAM, SOCK_NONBLOCK,
+				   SOCK_CLOEXEC, connect(),
+				   struct sockaddr, socklen_t,
+				   shutdown(), SHUT_RD, send(),
+				   MSG_NOSIGNAL, bind(), recv(),
+				   socketpair() */
+#include <glob.h>		/* globfree(), glob_t, glob(),
+				   GLOB_ERR, GLOB_NOSORT, GLOB_MARK,
+				   GLOB_ABORTED, GLOB_NOMATCH,
+				   GLOB_NOSPACE */
+
+/* End of includes */
+
+/* Start of declarations of private types and functions */
+
+/* microseconds of CLOCK_MONOTONIC absolute time; 0 means unset */
+typedef uintmax_t mono_microsecs;
+
+/* "task_queue" - A queue of tasks to be run */
+typedef struct {
+  struct task_struct *tasks;	/* Tasks in this queue */
+  size_t length;		/* Number of tasks */
+  /* Memory allocated for "tasks", in bytes */
+  size_t allocated;		
+  /* Time when this queue should be run, at the latest */
+  mono_microsecs next_run;
+} __attribute__((designated_init)) task_queue;
+
+/* "task_func" - A function type for task functions
+
+   I.e. functions for the code which runs when a task is run, all have
+   this type */
+typedef void (task_func) (const struct task_struct,
+			  task_queue *const)
+  __attribute__((nonnull));
+
+/* "buffer" - A data buffer for a growing array of bytes
+
+   Used for the "password" variable */
+typedef struct {
+  char *data;
+  size_t length;
+  size_t allocated;
+} __attribute__((designated_init)) buffer;
+
+/* "string_set" - A set type which can contain strings
+
+   Used by the "cancelled_filenames" variable */
+typedef struct {
+  char *argz;			/* Do not access these except in */
+  size_t argz_len;		/* the string_set_* functions */
+} __attribute__((designated_init)) string_set;
+
+/* "task_context" - local variables for tasks
+
+   This data structure distinguishes between different tasks which are
+   using the same function.  This data structure is passed to every
+   task function when each task is run.
+
+   Note that not every task uses every struct member. */
+typedef struct task_struct {
+  task_func *const func;	 /* The function run by this task */
+  char *const question_filename; /* The question file */
+  const pid_t pid;		 /* Mandos client process ID */
+  const int epoll_fd;		 /* The epoll set file descriptor */
+  bool *const quit_now;		 /* Set to true on fatal errors */
+  const int fd;			 /* General purpose file descriptor */
+  bool *const mandos_client_exited; /* Set true when client exits */
+  buffer *const password;	    /* As read from client process */
+  bool *const password_is_read;	    /* "password" is done growing */
+  char *filename;		    /* General purpose file name */
+  /* A set of strings of all the file names of questions which have
+     been cancelled for any reason; tasks pertaining to these question
+     files should not be run */
+  string_set *const cancelled_filenames;
+  const mono_microsecs notafter; /* "NotAfter" from question file */
+  /* Updated before each queue run; is compared with queue.next_run */
+  const mono_microsecs *const current_time;
+} __attribute__((designated_init)) task_context;
+
+/* Declare all our functions here so we can define them in any order
+   below.  Note: test functions are *not* declared here, they are
+   declared in the test section. */
+__attribute__((warn_unused_result))
+static bool should_only_run_tests(int *, char **[]);
+__attribute__((warn_unused_result, cold))
+static bool run_tests(int, char *[]);
+static void handle_sigchld(__attribute__((unused)) int sig){}
+__attribute__((warn_unused_result, malloc))
+task_queue *create_queue(void);
+__attribute__((nonnull, warn_unused_result))
+bool add_to_queue(task_queue *const, const task_context);
+__attribute__((nonnull))
+void cleanup_task(const task_context *const);
+__attribute__((nonnull))
+void cleanup_queue(task_queue *const *const);
+__attribute__((pure, nonnull, warn_unused_result))
+bool queue_has_question(const task_queue *const);
+__attribute__((nonnull))
+void cleanup_close(const int *const);
+__attribute__((nonnull))
+void cleanup_string(char *const *const);
+__attribute__((nonnull))
+void cleanup_buffer(buffer *const);
+__attribute__((pure, nonnull, warn_unused_result))
+bool string_set_contains(const string_set, const char *const);
+__attribute__((nonnull, warn_unused_result))
+bool string_set_add(string_set *const, const char *const);
+__attribute__((nonnull))
+void string_set_clear(string_set *);
+void string_set_swap(string_set *const, string_set *const);
+__attribute__((nonnull, warn_unused_result))
+bool start_mandos_client(task_queue *const, const int, bool *const,
+			 bool *const, buffer *const, bool *const,
+			 const struct sigaction *const,
+			 const sigset_t, const char *const,
+			 const uid_t, const gid_t,
+			 const char *const *const);
+__attribute__((nonnull))
+task_func wait_for_mandos_client_exit;
+__attribute__((nonnull))
+task_func read_mandos_client_output;
+__attribute__((warn_unused_result))
+bool add_inotify_dir_watch(task_queue *const, const int, bool *const,
+			   buffer *const, const char *const,
+			   string_set *, const mono_microsecs *const,
+			   bool *const, bool *const);
+__attribute__((nonnull))
+task_func read_inotify_event;
+__attribute__((nonnull))
+task_func open_and_parse_question;
+__attribute__((nonnull))
+task_func cancel_old_question;
+__attribute__((nonnull))
+task_func connect_question_socket;
+__attribute__((nonnull))
+task_func send_password_to_socket;
+__attribute__((warn_unused_result))
+bool add_existing_questions(task_queue *const, const int,
+			    buffer *const, string_set *,
+			    const mono_microsecs *const,
+			    bool *const, bool *const,
+			    const char *const);
+__attribute__((nonnull, warn_unused_result))
+bool wait_for_event(const int, const mono_microsecs,
+		    const mono_microsecs);
+bool run_queue(task_queue **const, string_set *const, bool *const);
+bool clear_all_fds_from_epoll_set(const int);
+mono_microsecs get_current_time(void);
+__attribute__((nonnull, warn_unused_result))
+bool setup_signal_handler(struct sigaction *const);
+__attribute__((nonnull))
+bool restore_signal_handler(const struct sigaction *const);
+__attribute__((nonnull, warn_unused_result))
+bool block_sigchld(sigset_t *const);
+__attribute__((nonnull))
+bool restore_sigmask(const sigset_t *const);
+__attribute__((nonnull))
+bool parse_arguments(int, char *[], const bool, char **, char **,
+		     uid_t *const , gid_t *const, char **, size_t *);
+
+/* End of declarations of private types and functions */
+
+/* Start of "main" section; this section LACKS TESTS!
+
+   Code here should be as simple as possible. */
+
+/* These are required to be global by Argp */
+const char *argp_program_version = "password-agent " VERSION;
+const char *argp_program_bug_address = "<mandos@recompile.se>";
+
+int main(int argc, char *argv[]){
+
+  /* If the --test option is passed, skip all normal operations and
+     instead only run the run_tests() function, which also does all
+     its own option parsing, so we don't have to do anything here. */
+  if(should_only_run_tests(&argc, &argv)){
+    if(run_tests(argc, argv)){
+      return EXIT_SUCCESS;	/* All tests successful */
+    }
+    return EXIT_FAILURE;	/* Some test(s) failed */
+  }
+
+  __attribute__((cleanup(cleanup_string)))
+    char *agent_directory = NULL;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+
+  uid_t user = 0;
+  gid_t group = 0;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  if(not parse_arguments(argc, argv, true, &agent_directory,
+			 &helper_directory, &user, &group,
+			 &mandos_argz, &mandos_argz_length)){
+    /* This should never happen, since "true" is passed as the third
+       argument to parse_arguments() above, which should make
+       argp_parse() call exit() if any parsing error occurs. */
+    error(EX_USAGE, errno, "Failed to parse arguments");
+  }
+
+  const char default_agent_directory[] = "/run/systemd/ask-password";
+  const char default_helper_directory[]
+    = "/lib/mandos/plugin-helpers";
+  const char *const default_argv[]
+    = {"/lib/mandos/plugins.d/mandos-client", NULL };
+
+  /* Set variables to default values if unset */
+  if(agent_directory == NULL){
+    agent_directory = strdup(default_agent_directory);
+    if(agent_directory == NULL){
+      error(EX_OSERR, errno, "Failed strdup()");
+    }
+  }
+  if(helper_directory == NULL){
+    helper_directory = strdup(default_helper_directory);
+    if(helper_directory == NULL){
+      error(EX_OSERR, errno, "Failed strdup()");
+    }
+  }
+  if(user == 0){
+    user = 65534;		/* nobody */
+  }
+  if(group == 0){
+    group = 65534;		/* nogroup */
+  }
+  /* If parse_opt did not create an argz vector, create one with
+     default values */
+  if(mandos_argz == NULL){
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+    /* argz_create() takes a non-const argv for some unknown reason -
+       argz_create() isn't modifying the strings, just copying them.
+       Therefore, this cast to non-const should be safe. */
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+    errno = argz_create((char *const *)default_argv, &mandos_argz,
+			&mandos_argz_length);
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+    if(errno != 0){
+      error(EX_OSERR, errno, "Failed argz_create()");
+    }
+  }
+  /* Use argz vector to create a normal argv, usable by execv() */
+
+  char **mandos_argv = malloc((argz_count(mandos_argz,
+					  mandos_argz_length)
+			       + 1) * sizeof(char *));
+  if(mandos_argv == NULL){
+    error_t saved_errno = errno;
+    free(mandos_argz);
+    error(EX_OSERR, saved_errno, "Failed malloc()");
+  }
+  argz_extract(mandos_argz, mandos_argz_length, mandos_argv);
+
+  sigset_t orig_sigmask;
+  if(not block_sigchld(&orig_sigmask)){
+    return EX_OSERR;
+  }
+
+  struct sigaction old_sigchld_action;
+  if(not setup_signal_handler(&old_sigchld_action)){
+    return EX_OSERR;
+  }
+
+  mono_microsecs current_time = 0;
+
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  if(epoll_fd < 0){
+    error(EX_OSERR, errno, "Failed to create epoll set fd");
+  }
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  if(queue == NULL){
+    error(EX_OSERR, errno, "Failed to create task queue");
+  }
+
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+
+  /* Add tasks to queue */
+  if(not start_mandos_client(queue, epoll_fd, &mandos_client_exited,
+  			     &quit_now, &password, &password_is_read,
+  			     &old_sigchld_action, orig_sigmask,
+			     helper_directory, user, group,
+			     (const char *const *)mandos_argv)){
+    return EX_OSERR;		/* Error has already been printed */
+  }
+  /* These variables were only for start_mandos_client() and are not
+     needed anymore */
+  free(mandos_argv);
+  free(mandos_argz);
+  mandos_argz = NULL;
+  if(not add_inotify_dir_watch(queue, epoll_fd, &quit_now, &password,
+  			       agent_directory, &cancelled_filenames,
+  			       &current_time, &mandos_client_exited,
+  			       &password_is_read)){
+    switch(errno){		/* Error has already been printed */
+    case EACCES:
+    case ENAMETOOLONG:
+    case ENOENT:
+    case ENOTDIR:
+      return EX_OSFILE;
+    default:
+      return EX_OSERR;
+    }
+  }
+  if(not add_existing_questions(queue, epoll_fd, &password,
+				&cancelled_filenames, &current_time,
+				&mandos_client_exited,
+				&password_is_read, agent_directory)){
+    return EXIT_FAILURE;	/* Error has already been printed */
+  }
+
+  /* Run queue */
+  do {
+    current_time = get_current_time();
+    if(not wait_for_event(epoll_fd, queue->next_run, current_time)){
+      const error_t saved_errno = errno;
+      error(EXIT_FAILURE, saved_errno, "Failure while waiting for"
+	    " events");
+    }
+
+    current_time = get_current_time();
+    if(not run_queue(&queue, &cancelled_filenames, &quit_now)){
+      const error_t saved_errno = errno;
+      error(EXIT_FAILURE, saved_errno, "Failure while running queue");
+    }
+
+    /*  When no tasks about questions are left in the queue, break out
+	of the loop (and implicitly exit the program) */
+  } while(queue_has_question(queue));
+
+  restore_signal_handler(&old_sigchld_action);
+  restore_sigmask(&orig_sigmask);
+
+  return EXIT_SUCCESS;
+}
+
+__attribute__((warn_unused_result))
+mono_microsecs get_current_time(void){
+  struct timespec currtime;
+  if(clock_gettime(CLOCK_MONOTONIC, &currtime) != 0){
+    error(0, errno, "Failed to get current time");
+    return 0;
+  }
+  return ((mono_microsecs)currtime.tv_sec * 1000000) /* seconds */
+    + ((mono_microsecs)currtime.tv_nsec / 1000);     /* nanoseconds */
+}
+
+/* End of "main" section */
+
+/* Start of regular code section; ALL this code has tests */
+
+__attribute__((nonnull))
+bool parse_arguments(int argc, char *argv[], const bool exit_failure,
+		     char **agent_directory, char **helper_directory,
+		     uid_t *const user, gid_t *const group,
+		     char **mandos_argz, size_t *mandos_argz_length){
+
+  const struct argp_option options[] = {
+    { .name="agent-directory",.key='d', .arg="DIRECTORY",
+      .doc="Systemd password agent directory" },
+    { .name="helper-directory",.key=128, .arg="DIRECTORY",
+      .doc="Mandos Client password helper directory" },
+    { .name="plugin-helper-dir", .key=129, /* From plugin-runner */
+      .flags=OPTION_HIDDEN | OPTION_ALIAS },
+    { .name="user", .key='u', .arg="USERID",
+      .doc="User ID the Mandos Client will use as its unprivileged"
+      " user" },
+    { .name="userid", .key=130,	/* From plugin--runner */
+      .flags=OPTION_HIDDEN | OPTION_ALIAS },
+    { .name="group", .key='g', .arg="GROUPID",
+      .doc="Group ID the Mandos Client will use as its unprivileged"
+      " group" },
+    { .name="groupid", .key=131, /* From plugin--runner */
+      .flags=OPTION_HIDDEN | OPTION_ALIAS },
+    { .name="test", .key=255, /* See should_only_run_tests() */
+      .doc="Skip normal operation, and only run self-tests.  See"
+      " --test --help.", .group=10, },
+    { NULL },
+  };
+
+  __attribute__((nonnull(3)))
+    error_t parse_opt(int key, char *arg, struct argp_state *state){
+    errno = 0;
+    switch(key){
+    case 'd':			/* --agent-directory */
+      *agent_directory = strdup(arg);
+      break;
+    case 128:			/* --helper-directory */
+    case 129:			/* --plugin-helper-dir */
+      *helper_directory = strdup(arg);
+      break;
+    case 'u':			/* --user */
+    case 130:			/* --userid */
+      {
+	char *tmp;
+	uintmax_t tmp_id = 0;
+	errno = 0;
+	tmp_id = (uid_t)strtoumax(arg, &tmp, 10);
+	if(errno != 0 or tmp == arg or *tmp != '\0'
+	   or tmp_id != (uid_t)tmp_id or (uid_t)tmp_id == 0){
+	  return ARGP_ERR_UNKNOWN;
+	}
+	*user = (uid_t)tmp_id;
+	errno = 0;
+	break;
+      }
+    case 'g':			/* --group */
+    case 131:			/* --groupid */
+      {
+	char *tmp;
+	uintmax_t tmp_id = 0;
+	errno = 0;
+	tmp_id = (uid_t)strtoumax(arg, &tmp, 10);
+	if(errno != 0 or tmp == arg or *tmp != '\0'
+	   or tmp_id != (gid_t)tmp_id or (gid_t)tmp_id == 0){
+	  return ARGP_ERR_UNKNOWN;
+	}
+	*group = (gid_t)tmp_id;
+	errno = 0;
+	break;
+      }
+    case ARGP_KEY_ARGS:
+      /* Copy arguments into argz vector */
+      return argz_create(state->argv + state->next, mandos_argz,
+    			 mandos_argz_length);
+    default:
+      return ARGP_ERR_UNKNOWN;
+    }
+    return errno;
+  }
+
+  const struct argp argp = {
+    .options=options,
+    .parser=parse_opt,
+    .args_doc="[MANDOS_CLIENT [OPTION...]]\n--test",
+    .doc = "Mandos password agent -- runs Mandos client as a"
+    " systemd password agent",
+  };
+
+  errno = argp_parse(&argp, argc, argv,
+		     exit_failure ? 0 : ARGP_NO_EXIT, NULL, NULL);
+
+  return errno == 0;
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool block_sigchld(sigset_t *const orig_sigmask){
+  sigset_t sigchld_sigmask;
+  if(sigemptyset(&sigchld_sigmask) < 0){
+    error(0, errno, "Failed to empty signal set");
+    return false;
+  }
+  if(sigaddset(&sigchld_sigmask, SIGCHLD) < 0){
+    error(0, errno, "Failed to add SIGCHLD to signal set");
+    return false;
+  }
+  if(pthread_sigmask(SIG_BLOCK, &sigchld_sigmask, orig_sigmask) != 0){
+    error(0, errno, "Failed to block SIGCHLD signal");
+    return false;
+  }
+  return true;
+}
+
+__attribute__((nonnull, warn_unused_result, const))
+bool restore_sigmask(const sigset_t *const orig_sigmask){
+  if(pthread_sigmask(SIG_SETMASK, orig_sigmask, NULL) != 0){
+    error(0, errno, "Failed to restore blocked signals");
+    return false;
+  }
+  return true;
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool setup_signal_handler(struct sigaction *const old_sigchld_action){
+  struct sigaction sigchld_action = {
+    .sa_handler=handle_sigchld,
+    .sa_flags=SA_RESTART | SA_NOCLDSTOP,
+  };
+  /* Set all signals in "sa_mask" struct member; this makes all
+     signals automatically blocked during signal handler */
+  if(sigfillset(&sigchld_action.sa_mask) != 0){
+    error(0, errno, "Failed to do sigfillset()");
+    return false;
+  }
+  if(sigaction(SIGCHLD, &sigchld_action, old_sigchld_action) != 0){
+    error(0, errno, "Failed to set SIGCHLD signal handler");
+    return false;
+  }
+  return true;
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool restore_signal_handler(const struct sigaction *const
+			    old_sigchld_action){
+  if(sigaction(SIGCHLD, old_sigchld_action, NULL) != 0){
+    error(0, errno, "Failed to restore signal handler");
+    return false;
+  }
+  return true;
+}
+
+__attribute__((warn_unused_result, malloc))
+task_queue *create_queue(void){
+  task_queue *queue = malloc(sizeof(task_queue));
+  if(queue){
+    queue->tasks = NULL;
+    queue->length = 0;
+    queue->allocated = 0;
+    queue->next_run = 0;
+  }
+  return queue;
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool add_to_queue(task_queue *const queue, const task_context task){
+  if((queue->length + 1) > (SIZE_MAX / sizeof(task_context))){
+    /* overflow */
+    error(0, ENOMEM, "Failed to allocate %" PRIuMAX
+  	  " tasks for queue->tasks", (uintmax_t)(queue->length + 1));
+    errno = ENOMEM;
+    return false;
+  }
+  const size_t needed_size = sizeof(task_context)*(queue->length + 1);
+  if(needed_size > (queue->allocated)){
+    task_context *const new_tasks = realloc(queue->tasks,
+					    needed_size);
+    if(new_tasks == NULL){
+      error(0, errno, "Failed to allocate %" PRIuMAX
+	    " bytes for queue->tasks", (uintmax_t)needed_size);
+      return false;
+    }
+    queue->tasks = new_tasks;
+    queue->allocated = needed_size;
+  }
+  /* Using memcpy here is necessary because doing */
+  /* queue->tasks[queue->length++] = task; */
+  /* would violate const-ness of task members */
+  memcpy(&(queue->tasks[queue->length++]), &task,
+	 sizeof(task_context));
+  return true;
+}
+
+__attribute__((nonnull))
+void cleanup_task(const task_context *const task){
+  const error_t saved_errno = errno;
+  /* free and close all task data */
+  free(task->question_filename);
+  if(task->filename != task->question_filename){
+    free(task->filename);
+  }
+  if(task->pid > 0){
+    kill(task->pid, SIGTERM);
+  }
+  if(task->fd > 0){
+    close(task->fd);
+  }
+  errno = saved_errno;
+}
+
+__attribute__((nonnull))
+void free_queue(task_queue *const queue){
+  free(queue->tasks);
+  free(queue);
+}
+
+__attribute__((nonnull))
+void cleanup_queue(task_queue *const *const queue){
+  if(*queue == NULL){
+    return;
+  }
+  for(size_t i = 0; i < (*queue)->length; i++){
+    const task_context *const task = ((*queue)->tasks)+i;
+    cleanup_task(task);
+  }
+  free_queue(*queue);
+}
+
+__attribute__((pure, nonnull, warn_unused_result))
+bool queue_has_question(const task_queue *const queue){
+  for(size_t i=0; i < queue->length; i++){
+    if(queue->tasks[i].question_filename != NULL){
+      return true;
+    }
+  }
+  return false;
+}
+
+__attribute__((nonnull))
+void cleanup_close(const int *const fd){
+  const error_t saved_errno = errno;
+  close(*fd);
+  errno = saved_errno;
+}
+
+__attribute__((nonnull))
+void cleanup_string(char *const *const ptr){
+  free(*ptr);
+}
+
+__attribute__((nonnull))
+void cleanup_buffer(buffer *buf){
+  if(buf->allocated > 0){
+#if defined(__GLIBC_PREREQ) and __GLIBC_PREREQ(2, 25)
+    explicit_bzero(buf->data, buf->allocated);
+#else
+    memset(buf->data, '\0', buf->allocated);
+#endif
+  }
+  if(buf->data != NULL){
+    if(munlock(buf->data, buf->allocated) != 0){
+      error(0, errno, "Failed to unlock memory of old buffer");
+    }
+    free(buf->data);
+    buf->data = NULL;
+  }
+  buf->length = 0;
+  buf->allocated = 0;
+}
+
+__attribute__((pure, nonnull, warn_unused_result))
+bool string_set_contains(const string_set set, const char *const str){
+  for(const char *s = set.argz; s != NULL and set.argz_len > 0;
+      s = argz_next(set.argz, set.argz_len, s)){
+    if(strcmp(s, str) == 0){
+      return true;
+    }
+  }
+  return false;
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool string_set_add(string_set *const set, const char *const str){
+  if(string_set_contains(*set, str)){
+    return true;
+  }
+  error_t error = argz_add(&set->argz, &set->argz_len, str);
+  if(error == 0){
+    return true;
+  }
+  errno = error;
+  return false;
+}
+
+__attribute__((nonnull))
+void string_set_clear(string_set *set){
+  free(set->argz);
+  set->argz = NULL;
+  set->argz_len = 0;
+}
+
+__attribute__((nonnull))
+void string_set_swap(string_set *const set1, string_set *const set2){
+  /* Swap contents of two string sets */
+  {
+    char *const tmp_argz = set1->argz;
+    set1->argz = set2->argz;
+    set2->argz = tmp_argz;
+  }
+  {
+    const size_t tmp_argz_len = set1->argz_len;
+    set1->argz_len = set2->argz_len;
+    set2->argz_len = tmp_argz_len;
+  }
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool start_mandos_client(task_queue *const queue,
+			 const int epoll_fd,
+			 bool *const mandos_client_exited,
+			 bool *const quit_now, buffer *const password,
+			 bool *const password_is_read,
+			 const struct sigaction *const
+			 old_sigchld_action, const sigset_t sigmask,
+			 const char *const helper_directory,
+			 const uid_t user, const gid_t group,
+			 const char *const *const argv){
+  int pipefds[2];
+  if(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK) != 0){
+    error(0, errno, "Failed to pipe2(..., O_CLOEXEC | O_NONBLOCK)");
+    return false;
+  }
+
+  const pid_t pid = fork();
+  if(pid == 0){
+    if(not restore_signal_handler(old_sigchld_action)){
+      _exit(EXIT_FAILURE);
+    }
+    if(not restore_sigmask(&sigmask)){
+      _exit(EXIT_FAILURE);
+    }
+    if(close(pipefds[0]) != 0){
+      error(0, errno, "Failed to close() parent pipe fd");
+      _exit(EXIT_FAILURE);
+    }
+    if(dup2(pipefds[1], STDOUT_FILENO) == -1){
+      error(0, errno, "Failed to dup2() pipe fd to stdout");
+      _exit(EXIT_FAILURE);
+    }
+    if(close(pipefds[1]) != 0){
+      error(0, errno, "Failed to close() old child pipe fd");
+      _exit(EXIT_FAILURE);
+    }
+    if(setenv("MANDOSPLUGINHELPERDIR", helper_directory, 1) != 0){
+      error(0, errno, "Failed to setenv(\"MANDOSPLUGINHELPERDIR\","
+	    " \"%s\", 1)", helper_directory);
+      _exit(EXIT_FAILURE);
+    }
+    if(group != 0 and setresgid(group, 0, 0) == -1){
+      error(0, errno, "Failed to setresgid(-1, %" PRIuMAX ", %"
+	    PRIuMAX")", (uintmax_t)group, (uintmax_t)group);
+      _exit(EXIT_FAILURE);
+    }
+    if(user != 0 and setresuid(user, 0, 0) == -1){
+      error(0, errno, "Failed to setresuid(-1, %" PRIuMAX ", %"
+	    PRIuMAX")", (uintmax_t)user, (uintmax_t)user);
+      _exit(EXIT_FAILURE);
+    }
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+    /* For historical reasons, the "argv" argument to execv() is not
+       const, but it is safe to override this. */
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+    execv(argv[0], (char **)argv);
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+    error(0, errno, "execv(\"%s\", ...) failed", argv[0]);
+    _exit(EXIT_FAILURE);
+  }
+  close(pipefds[1]);
+
+  if(pid == -1){
+    error(0, errno, "Failed to fork()");
+    close(pipefds[0]);
+    return false;
+  }
+
+  if(not add_to_queue(queue, (task_context){
+	.func=wait_for_mandos_client_exit,
+	.pid=pid,
+	.mandos_client_exited=mandos_client_exited,
+	.quit_now=quit_now,
+      })){
+    error(0, errno, "Failed to add wait_for_mandos_client to queue");
+    close(pipefds[0]);
+    return false;
+  }
+
+  const int ret = epoll_ctl(epoll_fd, EPOLL_CTL_ADD, pipefds[0],
+			    &(struct epoll_event)
+			    { .events=EPOLLIN | EPOLLRDHUP });
+  if(ret != 0 and errno != EEXIST){
+    error(0, errno, "Failed to add file descriptor to epoll set");
+    close(pipefds[0]);
+    return false;
+  }
+
+  return add_to_queue(queue, (task_context){
+      .func=read_mandos_client_output,
+      .epoll_fd=epoll_fd,
+      .fd=pipefds[0],
+      .quit_now=quit_now,
+      .password=password,
+      .password_is_read=password_is_read,
+    });
+}
+
+__attribute__((nonnull))
+void wait_for_mandos_client_exit(const task_context task,
+				 task_queue *const queue){
+  const pid_t pid = task.pid;
+  bool *const mandos_client_exited = task.mandos_client_exited;
+  bool *const quit_now = task.quit_now;
+
+  int status;
+  switch(waitpid(pid, &status, WNOHANG)){
+  case 0:			/* Not exited yet */
+    if(not add_to_queue(queue, task)){
+      error(0, errno, "Failed to add myself to queue");
+      *quit_now = true;
+    }
+    break;
+  case -1:			/* Error */
+    error(0, errno, "waitpid(%" PRIdMAX ") failed", (intmax_t)pid);
+    if(errno != ECHILD){
+      kill(pid, SIGTERM);
+    }
+    *quit_now = true;
+    break;
+  default:			/* Has exited */
+    *mandos_client_exited = true;
+    if((not WIFEXITED(status))
+       or (WEXITSTATUS(status) != EXIT_SUCCESS)){
+      error(0, 0, "Mandos client failed or was killed");
+      *quit_now = true;
+    }
+  }
+}
+
+__attribute__((nonnull))
+void read_mandos_client_output(const task_context task,
+			       task_queue *const queue){
+  buffer *const password = task.password;
+  bool *const quit_now = task.quit_now;
+  bool *const password_is_read = task.password_is_read;
+  const int fd = task.fd;
+  const int epoll_fd = task.epoll_fd;
+
+  const size_t new_potential_size = (password->length + PIPE_BUF);
+  if(password->allocated < new_potential_size){
+    char *const new_buffer = calloc(new_potential_size, 1);
+    if(new_buffer == NULL){
+      error(0, errno, "Failed to allocate %" PRIuMAX
+	    " bytes for password", (uintmax_t)new_potential_size);
+      *quit_now = true;
+      close(fd);
+      return;
+    }
+    if(mlock(new_buffer, new_potential_size) != 0){
+      /* Warn but do not treat as fatal error */
+      if(errno != EPERM and errno != ENOMEM){
+	error(0, errno, "Failed to lock memory for password");
+      }
+    }
+    if(password->length > 0){
+      memcpy(new_buffer, password->data, password->length);
+#if defined(__GLIBC_PREREQ) and __GLIBC_PREREQ(2, 25)
+      explicit_bzero(password->data, password->allocated);
+#else
+      memset(password->data, '\0', password->allocated);
+#endif
+    }
+    if(password->data != NULL){
+      if(munlock(password->data, password->allocated) != 0){
+	error(0, errno, "Failed to unlock memory of old buffer");
+      }
+      free(password->data);
+    }
+    password->data = new_buffer;
+    password->allocated = new_potential_size;
+  }
+
+  const ssize_t read_length = read(fd, password->data
+				   + password->length, PIPE_BUF);
+
+  if(read_length == 0){	/* EOF */
+    *password_is_read = true;
+    close(fd);
+    return;
+  }
+  if(read_length < 0 and errno != EAGAIN){ /* Actual error */
+    error(0, errno, "Failed to read password from Mandos client");
+    *quit_now = true;
+    close(fd);
+    return;
+  }
+  if(read_length > 0){		/* Data has been read */
+    password->length += (size_t)read_length;
+  }
+
+  /* Either data was read, or EAGAIN was indicated, meaning no data
+     available yet */
+
+  /* Re-add the fd to the epoll set */
+  const int ret = epoll_ctl(epoll_fd, EPOLL_CTL_ADD, fd,
+			    &(struct epoll_event)
+			    { .events=EPOLLIN | EPOLLRDHUP });
+  if(ret != 0 and errno != EEXIST){
+    error(0, errno, "Failed to re-add file descriptor to epoll set");
+    *quit_now = true;
+    close(fd);
+    return;
+  }
+
+  /* Re-add myself to the queue */
+  if(not add_to_queue(queue, task)){
+    error(0, errno, "Failed to add myself to queue");
+    *quit_now = true;
+    close(fd);
+  }
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool add_inotify_dir_watch(task_queue *const queue,
+			   const int epoll_fd, bool *const quit_now,
+			   buffer *const password,
+			   const char *const dir,
+			   string_set *cancelled_filenames,
+			   const mono_microsecs *const current_time,
+			   bool *const mandos_client_exited,
+			   bool *const password_is_read){
+  const int fd = inotify_init1(IN_NONBLOCK | IN_CLOEXEC);
+  if(fd == -1){
+    error(0, errno, "Failed to create inotify instance");
+    return false;
+  }
+
+  if(inotify_add_watch(fd, dir, IN_CLOSE_WRITE | IN_MOVED_TO
+		       | IN_MOVED_FROM| IN_DELETE | IN_EXCL_UNLINK
+		       | IN_ONLYDIR)
+     == -1){
+    error(0, errno, "Failed to create inotify watch on %s", dir);
+    return false;
+  }
+
+  /* Add the inotify fd to the epoll set */
+  const int ret = epoll_ctl(epoll_fd, EPOLL_CTL_ADD, fd,
+			    &(struct epoll_event)
+			    { .events=EPOLLIN | EPOLLRDHUP });
+  if(ret != 0 and errno != EEXIST){
+    error(0, errno, "Failed to add file descriptor to epoll set");
+    close(fd);
+    return false;
+  }
+
+  const task_context read_inotify_event_task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .quit_now=quit_now,
+    .password=password,
+    .fd=fd,
+    .filename=strdup(dir),
+    .cancelled_filenames=cancelled_filenames,
+    .current_time=current_time,
+    .mandos_client_exited=mandos_client_exited,
+    .password_is_read=password_is_read,
+  };
+  if(read_inotify_event_task.filename == NULL){
+    error(0, errno, "Failed to strdup(\"%s\")", dir);
+    close(fd);
+    return false;
+  }
+
+  return add_to_queue(queue, read_inotify_event_task);
+}
+
+__attribute__((nonnull))
+void read_inotify_event(const task_context task,
+			task_queue *const queue){
+  const int fd = task.fd;
+  const int epoll_fd = task.epoll_fd;
+  char *const filename = task.filename;
+  bool *quit_now = task.quit_now;
+  buffer *const password = task.password;
+  string_set *const cancelled_filenames = task.cancelled_filenames;
+  const mono_microsecs *const current_time = task.current_time;
+  bool *const mandos_client_exited = task.mandos_client_exited;
+  bool *const password_is_read = task.password_is_read;
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + NAME_MAX + 1);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const ssize_t read_length = read(fd, ievent, ievent_size);
+  if(read_length == 0){	/* EOF */
+    error(0, 0, "Got EOF from inotify fd for directory %s", filename);
+    *quit_now = true;
+    cleanup_task(&task);
+    return;
+  }
+  if(read_length < 0 and errno != EAGAIN){ /* Actual error */
+    error(0, errno, "Failed to read from inotify fd for directory %s",
+	  filename);
+    *quit_now = true;
+    cleanup_task(&task);
+    return;
+  }
+  if(read_length > 0		/* Data has been read */
+     and fnmatch("ask.*", ievent->name, FNM_FILE_NAME) == 0){
+    char *question_filename = NULL;
+    const ssize_t question_filename_length
+      = asprintf(&question_filename, "%s/%s", filename, ievent->name);
+    if(question_filename_length < 0){
+      error(0, errno, "Failed to create file name from directory name"
+	    " %s and file name %s", filename, ievent->name);
+    } else {
+      if(ievent->mask & (IN_CLOSE_WRITE | IN_MOVED_TO)){
+	if(not add_to_queue(queue, (task_context){
+	      .func=open_and_parse_question,
+	      .epoll_fd=epoll_fd,
+	      .question_filename=question_filename,
+	      .filename=question_filename,
+	      .password=password,
+	      .cancelled_filenames=cancelled_filenames,
+	      .current_time=current_time,
+	      .mandos_client_exited=mandos_client_exited,
+	      .password_is_read=password_is_read,
+	    })){
+	  error(0, errno, "Failed to add open_and_parse_question task"
+		" for file name %s to queue", filename);
+	} else {
+	  /* Force the added task (open_and_parse_question) to run
+	     immediately */
+	  queue->next_run = 1;
+	}
+      } else if(ievent->mask & (IN_MOVED_FROM | IN_DELETE)){
+	if(not string_set_add(cancelled_filenames,
+			      question_filename)){
+	  error(0, errno, "Could not add question %s to"
+		" cancelled_questions", question_filename);
+	  *quit_now = true;
+	  free(question_filename);
+	  cleanup_task(&task);
+	  return;
+	}
+	free(question_filename);
+      }
+    }
+  }
+
+  /* Either data was read, or EAGAIN was indicated, meaning no data
+     available yet */
+
+  /* Re-add myself to the queue */
+  if(not add_to_queue(queue, task)){
+    error(0, errno, "Failed to re-add read_inotify_event(%s) to"
+	  " queue", filename);
+    *quit_now = true;
+    cleanup_task(&task);
+    return;
+  }
+
+  /* Re-add the fd to the epoll set */
+  const int ret = epoll_ctl(epoll_fd, EPOLL_CTL_ADD, fd,
+			    &(struct epoll_event)
+			    { .events=EPOLLIN | EPOLLRDHUP });
+  if(ret != 0 and errno != EEXIST){
+    error(0, errno, "Failed to re-add inotify file descriptor %d for"
+	  " directory %s to epoll set", fd, filename);
+    /* Force the added task (read_inotify_event) to run again, at most
+       one second from now */
+    if((queue->next_run == 0)
+       or (queue->next_run > (*current_time + 1000000))){
+      queue->next_run = *current_time + 1000000;
+    }
+  }
+}
+
+__attribute__((nonnull))
+void open_and_parse_question(const task_context task,
+			     task_queue *const queue){
+  __attribute__((cleanup(cleanup_string)))
+    char *question_filename = task.question_filename;
+  const int epoll_fd = task.epoll_fd;
+  buffer *const password = task.password;
+  string_set *const cancelled_filenames = task.cancelled_filenames;
+  const mono_microsecs *const current_time = task.current_time;
+  bool *const mandos_client_exited = task.mandos_client_exited;
+  bool *const password_is_read = task.password_is_read;
+
+  /* We use the GLib "Key-value file parser" functions to parse the
+     question file.  See <https://systemd.io/PASSWORD_AGENTS/> for
+     specification of contents */
+  __attribute__((nonnull))
+    void cleanup_g_key_file(GKeyFile **key_file){
+    if(*key_file != NULL){
+      g_key_file_free(*key_file);
+    }
+  }
+
+  __attribute__((cleanup(cleanup_g_key_file)))
+    GKeyFile *key_file = g_key_file_new();
+  if(key_file == NULL){
+    error(0, errno, "Failed g_key_file_new() for \"%s\"",
+	  question_filename);
+    return;
+  }
+  GError *glib_error = NULL;
+  if(g_key_file_load_from_file(key_file, question_filename,
+			       G_KEY_FILE_NONE, &glib_error) != TRUE){
+    /* If a file was removed, we should ignore it, so */
+    /* only show error message if file actually existed */
+    if(glib_error->code != G_FILE_ERROR_NOENT){
+      error(0, 0, "Failed to load question data from file \"%s\": %s",
+	    question_filename, glib_error->message);
+    }
+    return;
+  }
+
+  __attribute__((cleanup(cleanup_string)))
+    char *socket_name = g_key_file_get_string(key_file, "Ask",
+					      "Socket",
+					      &glib_error);
+  if(socket_name == NULL){
+    error(0, 0, "Question file \"%s\" did not contain \"Socket\": %s",
+	  question_filename, glib_error->message);
+    return;
+  }
+
+  if(strlen(socket_name) == 0){
+    error(0, 0, "Question file \"%s\" had empty \"Socket\" value",
+	  question_filename);
+    return;
+  }
+
+  const guint64 pid = g_key_file_get_uint64(key_file, "Ask", "PID",
+					    &glib_error);
+  if(glib_error != NULL){
+    error(0, 0, "Question file \"%s\" contained bad \"PID\": %s",
+	  question_filename, glib_error->message);
+    return;
+  }
+
+  if((pid != (guint64)((pid_t)pid))
+     or (kill((pid_t)pid, 0) != 0)){
+    error(0, 0, "PID %" PRIuMAX " in question file \"%s\" is bad or"
+	  " does not exist", (uintmax_t)pid, question_filename);
+    return;
+  }
+
+  guint64 notafter = g_key_file_get_uint64(key_file, "Ask",
+					   "NotAfter", &glib_error);
+  if(glib_error != NULL){
+    if(glib_error->code != G_KEY_FILE_ERROR_KEY_NOT_FOUND){
+      error(0, 0, "Question file \"%s\" contained bad \"NotAfter\":"
+	    " %s", question_filename, glib_error->message);
+    }
+    notafter = 0;
+  }
+  if(notafter != 0){
+    if(queue->next_run == 0 or (queue->next_run > notafter)){
+      queue->next_run = notafter;
+    }
+    if(*current_time >= notafter){
+      return;
+    }
+  }
+
+  const task_context connect_question_socket_task = {
+    .func=connect_question_socket,
+    .question_filename=strdup(question_filename),
+    .epoll_fd=epoll_fd,
+    .password=password,
+    .filename=strdup(socket_name),
+    .cancelled_filenames=task.cancelled_filenames,
+    .mandos_client_exited=mandos_client_exited,
+    .password_is_read=password_is_read,
+    .current_time=current_time,
+  };
+  if(connect_question_socket_task.question_filename == NULL
+     or connect_question_socket_task.filename == NULL
+     or not add_to_queue(queue, connect_question_socket_task)){
+    error(0, errno, "Failed to add connect_question_socket for socket"
+	  " %s (from \"%s\") to queue", socket_name,
+	  question_filename);
+    cleanup_task(&connect_question_socket_task);
+    return;
+  }
+  /* Force the added task (connect_question_socket) to run
+     immediately */
+  queue->next_run = 1;
+
+  if(notafter > 0){
+    char *const dup_filename = strdup(question_filename);
+    const task_context cancel_old_question_task = {
+      .func=cancel_old_question,
+      .question_filename=dup_filename,
+      .notafter=notafter,
+      .filename=dup_filename,
+      .cancelled_filenames=cancelled_filenames,
+      .current_time=current_time,
+    };
+    if(cancel_old_question_task.question_filename == NULL
+       or not add_to_queue(queue, cancel_old_question_task)){
+      error(0, errno, "Failed to add cancel_old_question for file "
+	    "\"%s\" to queue", question_filename);
+      cleanup_task(&cancel_old_question_task);
+      return;
+    }
+  }
+}
+
+__attribute__((nonnull))
+void cancel_old_question(const task_context task,
+			 task_queue *const queue){
+  char *const question_filename = task.question_filename;
+  string_set *const cancelled_filenames = task.cancelled_filenames;
+  const mono_microsecs notafter = task.notafter;
+  const mono_microsecs *const current_time = task.current_time;
+
+  if(*current_time >= notafter){
+    if(not string_set_add(cancelled_filenames, question_filename)){
+      error(0, errno, "Failed to cancel question for file %s",
+	    question_filename);
+    }
+    cleanup_task(&task);
+    return;
+  }
+
+  if(not add_to_queue(queue, task)){
+    error(0, errno, "Failed to add cancel_old_question for file "
+	  "%s to queue", question_filename);
+    cleanup_task(&task);
+    return;
+  }
+
+  if((queue->next_run == 0) or (queue->next_run > notafter)){
+    queue->next_run = notafter;
+  }
+}
+
+__attribute__((nonnull))
+void connect_question_socket(const task_context task,
+			     task_queue *const queue){
+  char *const question_filename = task.question_filename;
+  char *const filename = task.filename;
+  const int epoll_fd = task.epoll_fd;
+  buffer *const password = task.password;
+  string_set *const cancelled_filenames = task.cancelled_filenames;
+  bool *const mandos_client_exited = task.mandos_client_exited;
+  bool *const password_is_read = task.password_is_read;
+  const mono_microsecs *const current_time = task.current_time;
+
+  struct sockaddr_un sock_name = { .sun_family=AF_LOCAL };
+
+  if(sizeof(sock_name.sun_path) <= strlen(filename)){
+    error(0, 0, "Socket filename is larger than"
+	  " sizeof(sockaddr_un.sun_path); %" PRIuMAX ": \"%s\"",
+	  (uintmax_t)sizeof(sock_name.sun_path), filename);
+    if(not string_set_add(cancelled_filenames, question_filename)){
+      error(0, errno, "Failed to cancel question for file %s",
+	    question_filename);
+    }
+    cleanup_task(&task);
+    return;
+  }
+
+  const int fd = socket(PF_LOCAL, SOCK_DGRAM
+			| SOCK_NONBLOCK | SOCK_CLOEXEC, 0);
+  if(fd < 0){
+    error(0, errno,
+	  "Failed to create socket(PF_LOCAL, SOCK_DGRAM, 0)");
+    if(not add_to_queue(queue, task)){
+      error(0, errno, "Failed to add connect_question_socket for file"
+            " \"%s\" and socket \"%s\" to queue", question_filename,
+	    filename);
+      cleanup_task(&task);
+    } else {
+      /* Force the added task (connect_question_socket) to run
+	 immediately */
+      queue->next_run = 1;
+    }
+    return;
+  }
+
+  strncpy(sock_name.sun_path, filename, sizeof(sock_name.sun_path));
+  if(connect(fd, (struct sockaddr *)&sock_name,
+	     (socklen_t)SUN_LEN(&sock_name)) != 0){
+    error(0, errno, "Failed to connect socket to \"%s\"", filename);
+    if(not add_to_queue(queue, task)){
+      error(0, errno, "Failed to add connect_question_socket for file"
+            " \"%s\" and socket \"%s\" to queue", question_filename,
+	    filename);
+      cleanup_task(&task);
+    } else {
+      /* Force the added task (connect_question_socket) to run again,
+	 at most one second from now */
+      if((queue->next_run == 0)
+	 or (queue->next_run > (*current_time + 1000000))){
+	queue->next_run = *current_time + 1000000;
+      }
+    }
+    return;
+  }
+
+  /* Not necessary, but we can try, and merely warn on failure */
+  if(shutdown(fd, SHUT_RD) != 0){
+    error(0, errno, "Failed to shutdown reading from socket \"%s\"",
+	  filename);
+  }
+
+  /* Add the fd to the epoll set */
+  if(epoll_ctl(epoll_fd, EPOLL_CTL_ADD, fd,
+	       &(struct epoll_event){ .events=EPOLLOUT })
+     != 0){
+    error(0, errno, "Failed to add inotify file descriptor %d for"
+	  " socket %s to epoll set", fd, filename);
+    if(not add_to_queue(queue, task)){
+      error(0, errno, "Failed to add connect_question_socket for file"
+            " \"%s\" and socket \"%s\" to queue", question_filename,
+	    filename);
+      cleanup_task(&task);
+    } else {
+      /* Force the added task (connect_question_socket) to run again,
+	 at most one second from now */
+      if((queue->next_run == 0)
+	 or (queue->next_run > (*current_time + 1000000))){
+	queue->next_run = *current_time + 1000000;
+      }
+    }
+    return;
+  }
+
+  /* add task send_password_to_socket to queue */
+  const task_context send_password_to_socket_task = {
+    .func=send_password_to_socket,
+    .question_filename=question_filename,
+    .filename=filename,
+    .epoll_fd=epoll_fd,
+    .fd=fd,
+    .password=password,
+    .cancelled_filenames=cancelled_filenames,
+    .mandos_client_exited=mandos_client_exited,
+    .password_is_read=password_is_read,
+    .current_time=current_time,
+  };
+
+  if(not add_to_queue(queue, send_password_to_socket_task)){
+    error(0, errno, "Failed to add send_password_to_socket for"
+	  " file \"%s\" and socket \"%s\" to queue",
+	  question_filename, filename);
+    cleanup_task(&send_password_to_socket_task);
+  }
+}
+
+__attribute__((nonnull))
+void send_password_to_socket(const task_context task,
+			     task_queue *const queue){
+  char *const question_filename=task.question_filename;
+  char *const filename=task.filename;
+  const int epoll_fd=task.epoll_fd;
+  const int fd=task.fd;
+  buffer *const password=task.password;
+  string_set *const cancelled_filenames=task.cancelled_filenames;
+  bool *const mandos_client_exited = task.mandos_client_exited;
+  bool *const password_is_read = task.password_is_read;
+  const mono_microsecs *const current_time = task.current_time;
+
+  if(*mandos_client_exited and *password_is_read){
+
+    const size_t send_buffer_length = password->length + 2;
+    char *send_buffer = malloc(send_buffer_length);
+    if(send_buffer == NULL){
+      error(0, errno, "Failed to allocate send_buffer");
+    } else {
+      if(mlock(send_buffer, send_buffer_length) != 0){
+	/* Warn but do not treat as fatal error */
+	if(errno != EPERM and errno != ENOMEM){
+	  error(0, errno, "Failed to lock memory for password"
+		" buffer");
+	}
+      }
+      /* “[…] send a single datagram to the socket consisting of the
+	 password string either prefixed with "+" or with "-"
+	 depending on whether the password entry was successful or
+	 not. You may but don't have to include a final NUL byte in
+	 your message.
+
+	 — <https://systemd.io/PASSWORD_AGENTS/> (Tue, 15 Sep 2020
+	 14:24:20 GMT)
+      */
+      send_buffer[0] = '+';	/* Prefix with "+" */
+      /* Always add an extra NUL */
+      send_buffer[password->length + 1] = '\0';
+      if(password->length > 0){
+	memcpy(send_buffer + 1, password->data, password->length);
+      }
+      errno = 0;
+      ssize_t ssret = send(fd, send_buffer, send_buffer_length,
+			   MSG_NOSIGNAL);
+      const error_t saved_errno = (ssret < 0) ? errno : 0;
+#if defined(__GLIBC_PREREQ) and __GLIBC_PREREQ(2, 25)
+      explicit_bzero(send_buffer, send_buffer_length);
+#else
+      memset(send_buffer, '\0', send_buffer_length);
+#endif
+      if(munlock(send_buffer, send_buffer_length) != 0){
+	error(0, errno, "Failed to unlock memory of send buffer");
+      }
+      free(send_buffer);
+      if(ssret < 0 or ssret < (ssize_t)send_buffer_length){
+	switch(saved_errno){
+	case EINTR:
+	case ENOBUFS:
+	case ENOMEM:
+	case EADDRINUSE:
+	case ECONNREFUSED:
+	case ECONNRESET:
+	case ENOENT:
+	case ETOOMANYREFS:
+	case EAGAIN:
+	  /* Retry, below */
+	  break;
+	case EMSGSIZE:
+	  error(0, saved_errno, "Password of size %" PRIuMAX
+		" is too big", (uintmax_t)password->length);
+#if __GNUC__ < 7
+	  /* FALLTHROUGH */
+#else
+	  __attribute__((fallthrough));
+#endif
+	case 0:
+	  if(ssret >= 0 and ssret < (ssize_t)send_buffer_length){
+	    error(0, 0, "Password only partially sent to socket %s: %"
+		  PRIuMAX " out of %" PRIuMAX " bytes sent", filename,
+		  (uintmax_t)ssret, (uintmax_t)send_buffer_length);
+	  }
+#if __GNUC__ < 7
+	  /* FALLTHROUGH */
+#else
+	  __attribute__((fallthrough));
+#endif
+	default:
+	  error(0, saved_errno, "Failed to send() to socket %s",
+		filename);
+	  if(not string_set_add(cancelled_filenames,
+				question_filename)){
+	    error(0, errno, "Failed to cancel question for file %s",
+		  question_filename);
+	  }
+	  cleanup_task(&task);
+	  return;
+	}
+      } else {
+	/* Success */
+	cleanup_task(&task);
+	return;
+      }
+    }
+  }
+
+  /* We failed or are not ready yet; retry later */
+
+  if(not add_to_queue(queue, task)){
+    error(0, errno, "Failed to add send_password_to_socket for"
+	  " file %s and socket %s to queue", question_filename,
+	  filename);
+    cleanup_task(&task);
+  }
+
+  /* Add the fd to the epoll set */
+  if(epoll_ctl(epoll_fd, EPOLL_CTL_ADD, fd,
+	       &(struct epoll_event){ .events=EPOLLOUT })
+     != 0){
+    error(0, errno, "Failed to add socket file descriptor %d for"
+	  " socket %s to epoll set", fd, filename);
+    /* Force the added task (send_password_to_socket) to run again, at
+       most one second from now */
+    if((queue->next_run == 0)
+       or (queue->next_run > (*current_time + 1000000))){
+      queue->next_run = *current_time + 1000000;
+    }
+  }
+}
+
+__attribute__((warn_unused_result))
+bool add_existing_questions(task_queue *const queue,
+			    const int epoll_fd,
+			    buffer *const password,
+			    string_set *cancelled_filenames,
+			    const mono_microsecs *const current_time,
+			    bool *const mandos_client_exited,
+			    bool *const password_is_read,
+			    const char *const dirname){
+  __attribute__((cleanup(cleanup_string)))
+    char *dir_pattern = NULL;
+  const int ret = asprintf(&dir_pattern, "%s/ask.*", dirname);
+  if(ret < 0 or dir_pattern == NULL){
+    error(0, errno, "Could not create glob pattern for directory %s",
+	  dirname);
+    return false;
+  }
+  __attribute__((cleanup(globfree)))
+    glob_t question_filenames = {};
+  switch(glob(dir_pattern, GLOB_ERR | GLOB_NOSORT | GLOB_MARK,
+	      NULL, &question_filenames)){
+  case GLOB_ABORTED:
+  default:
+    error(0, errno, "Failed to open directory %s", dirname);
+    return false;
+  case GLOB_NOMATCH:
+    error(0, errno, "There are no question files in %s", dirname);
+    return false;
+  case GLOB_NOSPACE:
+    error(0, errno, "Could not allocate memory for question file"
+	  " names in %s", dirname);
+#if __GNUC__ < 7
+    /* FALLTHROUGH */
+#else
+    __attribute__((fallthrough));
+#endif
+  case 0:
+    for(size_t i = 0; i < question_filenames.gl_pathc; i++){
+      char *const question_filename = strdup(question_filenames
+					     .gl_pathv[i]);
+      const task_context task = {
+	.func=open_and_parse_question,
+	.epoll_fd=epoll_fd,
+	.question_filename=question_filename,
+	.filename=question_filename,
+	.password=password,
+	.cancelled_filenames=cancelled_filenames,
+	.current_time=current_time,
+	.mandos_client_exited=mandos_client_exited,
+	.password_is_read=password_is_read,
+      };
+
+      if(question_filename == NULL
+	 or not add_to_queue(queue, task)){
+	error(0, errno, "Failed to add open_and_parse_question for"
+	      " file %s to queue",
+	      question_filenames.gl_pathv[i]);
+	free(question_filename);
+      } else {
+	queue->next_run = 1;
+      }
+    }
+    return true;
+  }
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool wait_for_event(const int epoll_fd,
+		    const mono_microsecs queue_next_run,
+		    const mono_microsecs current_time){
+  __attribute__((const))
+    int milliseconds_to_wait(const mono_microsecs currtime,
+			     const mono_microsecs nextrun){
+    if(currtime >= nextrun){
+      return 0;
+    }
+    const uintmax_t wait_time_ms = (nextrun - currtime) / 1000;
+    if(wait_time_ms > (uintmax_t)INT_MAX){
+      return INT_MAX;
+    }
+    return (int)wait_time_ms;
+  }
+
+  const int wait_time_ms = milliseconds_to_wait(current_time,
+						queue_next_run);
+
+  /* Prepare unblocking of SIGCHLD during epoll_pwait */
+  sigset_t temporary_unblocked_sigmask;
+  /* Get current signal mask */
+  if(pthread_sigmask(-1, NULL, &temporary_unblocked_sigmask) != 0){
+    return false;
+  }
+  /* Remove SIGCHLD from the signal mask */
+  if(sigdelset(&temporary_unblocked_sigmask, SIGCHLD) != 0){
+    return false;
+  }
+  struct epoll_event events[8]; /* Ignored */
+  int ret = epoll_pwait(epoll_fd, events,
+			sizeof(events) / sizeof(struct epoll_event),
+			queue_next_run == 0 ? -1 : (int)wait_time_ms,
+			&temporary_unblocked_sigmask);
+  if(ret < 0 and errno != EINTR){
+    error(0, errno, "Failed epoll_pwait(epfd=%d, ..., timeout=%d,"
+	  " ...", epoll_fd,
+	  queue_next_run == 0 ? -1 : (int)wait_time_ms);
+    return false;
+  }
+  return clear_all_fds_from_epoll_set(epoll_fd);
+}
+
+bool clear_all_fds_from_epoll_set(const int epoll_fd){
+  /* Create a new empty epoll set */
+  __attribute__((cleanup(cleanup_close)))
+    const int new_epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  if(new_epoll_fd < 0){
+    return false;
+  }
+  /* dup3() the new epoll set fd over the old one, replacing it */
+  if(dup3(new_epoll_fd, epoll_fd, O_CLOEXEC) < 0){
+    return false;
+  }
+  return true;
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool run_queue(task_queue **const queue,
+	       string_set *const cancelled_filenames,
+	       bool *const quit_now){
+
+  task_queue *new_queue = create_queue();
+  if(new_queue == NULL){
+    return false;
+  }
+
+  __attribute__((cleanup(string_set_clear)))
+    string_set old_cancelled_filenames = {};
+  string_set_swap(cancelled_filenames, &old_cancelled_filenames);
+
+  /* Declare i outside the for loop, since we might need i after the
+     loop in case we aborted in the middle */
+  size_t i;
+  for(i=0; i < (*queue)->length and not *quit_now; i++){
+    task_context *const task = &((*queue)->tasks[i]);
+    const char *const question_filename = task->question_filename;
+    /* Skip any task referencing a cancelled question filename */
+    if(question_filename != NULL
+       and string_set_contains(old_cancelled_filenames,
+    			       question_filename)){
+      cleanup_task(task);
+      continue;
+    }
+    task->func(*task, new_queue);
+  }
+
+  if(*quit_now){
+    /* we might be in the middle of the queue, so clean up any
+       remaining tasks in the current queue */
+    for(; i < (*queue)->length; i++){
+      cleanup_task(&((*queue)->tasks[i]));
+    }
+    free_queue(*queue);
+    *queue = new_queue;
+    new_queue = NULL;
+    return false;
+  }
+  free_queue(*queue);
+  *queue = new_queue;
+  new_queue = NULL;
+
+  return true;
+}
+
+/* End of regular code section */
+
+/* Start of tests section; here are the tests for the above code */
+
+/* This "fixture" data structure is used by the test setup and
+   teardown functions */
+typedef struct {
+  struct sigaction orig_sigaction;
+  sigset_t orig_sigmask;
+} test_fixture;
+
+static void test_setup(test_fixture *fixture,
+		       __attribute__((unused))
+		       gconstpointer user_data){
+  g_assert_true(setup_signal_handler(&fixture->orig_sigaction));
+  g_assert_true(block_sigchld(&fixture->orig_sigmask));
+}
+
+static void test_teardown(test_fixture *fixture,
+			  __attribute__((unused))
+			  gconstpointer user_data){
+  g_assert_true(restore_signal_handler(&fixture->orig_sigaction));
+  g_assert_true(restore_sigmask(&fixture->orig_sigmask));
+}
+
+/* Utility function used by tests to search queue for matching task */
+__attribute__((pure, nonnull, warn_unused_result))
+static task_context *find_matching_task(const task_queue *const queue,
+					const task_context task){
+  /* The argument "task" structure is a pattern to match; 0 in any
+     member means any value matches, otherwise the value must match.
+     The filename strings are compared by strcmp(), not by pointer. */
+  for(size_t i = 0; i < queue->length; i++){
+    task_context *const current_task = queue->tasks+i;
+    /* Check all members of task_context, if set to a non-zero value.
+       If a member does not match, continue to next task in queue */
+
+    /* task_func *const func */
+    if(task.func != NULL and current_task->func != task.func){
+      continue;
+    }
+    /* char *const question_filename; */
+    if(task.question_filename != NULL
+       and (current_task->question_filename == NULL
+	    or strcmp(current_task->question_filename,
+		      task.question_filename) != 0)){
+      continue;
+    }
+    /* const pid_t pid; */
+    if(task.pid != 0 and current_task->pid != task.pid){
+      continue;
+    }
+    /* const int epoll_fd; */
+    if(task.epoll_fd != 0
+       and current_task->epoll_fd != task.epoll_fd){
+      continue;
+    }
+    /* bool *const quit_now; */
+    if(task.quit_now != NULL
+       and current_task->quit_now != task.quit_now){
+      continue;
+    }
+    /* const int fd; */
+    if(task.fd != 0 and current_task->fd != task.fd){
+      continue;
+    }
+    /* bool *const mandos_client_exited; */
+    if(task.mandos_client_exited != NULL
+       and current_task->mandos_client_exited
+       != task.mandos_client_exited){
+      continue;
+    }
+    /* buffer *const password; */
+    if(task.password != NULL
+       and current_task->password != task.password){
+      continue;
+    }
+    /* bool *const password_is_read; */
+    if(task.password_is_read != NULL
+       and current_task->password_is_read != task.password_is_read){
+      continue;
+    }
+    /* char *filename; */
+    if(task.filename != NULL
+       and (current_task->filename == NULL
+	    or strcmp(current_task->filename, task.filename) != 0)){
+      continue;
+    }
+    /* string_set *const cancelled_filenames; */
+    if(task.cancelled_filenames != NULL
+       and current_task->cancelled_filenames
+       != task.cancelled_filenames){
+      continue;
+    }
+    /* const mono_microsecs notafter; */
+    if(task.notafter != 0
+       and current_task->notafter != task.notafter){
+      continue;
+    }
+    /* const mono_microsecs *const current_time; */
+    if(task.current_time != NULL
+       and current_task->current_time != task.current_time){
+      continue;
+    }
+    /* Current task matches all members; return it */
+    return current_task;
+  }
+  /* No task in queue matches passed pattern task */
+  return NULL;
+}
+
+static void test_create_queue(__attribute__((unused))
+			      test_fixture *fixture,
+			      __attribute__((unused))
+			      gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *const queue = create_queue();
+  g_assert_nonnull(queue);
+  g_assert_null(queue->tasks);
+  g_assert_true(queue->length == 0);
+  g_assert_true(queue->next_run == 0);
+}
+
+static task_func dummy_func;
+
+static void test_add_to_queue(__attribute__((unused))
+			      test_fixture *fixture,
+			      __attribute__((unused))
+			      gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  g_assert_true(add_to_queue(queue,
+			     (task_context){ .func=dummy_func }));
+  g_assert_true(queue->length == 1);
+  g_assert_nonnull(queue->tasks);
+  g_assert_true(queue->tasks[0].func == dummy_func);
+}
+
+static void test_add_to_queue_overflow(__attribute__((unused))
+				       test_fixture *fixture,
+				       __attribute__((unused))
+				       gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  g_assert_true(queue->length == 0);
+  queue->length = SIZE_MAX / sizeof(task_context); /* fake max size */
+
+  FILE *real_stderr = stderr;
+  FILE *devnull = fopen("/dev/null", "we");
+  g_assert_nonnull(devnull);
+  stderr = devnull;
+  const bool ret = add_to_queue(queue,
+				(task_context){ .func=dummy_func });
+  g_assert_true(errno == ENOMEM);
+  g_assert_false(ret);
+  stderr = real_stderr;
+  g_assert_cmpint(fclose(devnull), ==, 0);
+  queue->length = 0;		/* Restore real size */
+}
+
+static void dummy_func(__attribute__((unused))
+		       const task_context task,
+		       __attribute__((unused))
+		       task_queue *const queue){
+}
+
+static void test_queue_has_question_empty(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  g_assert_false(queue_has_question(queue));
+}
+
+static void test_queue_has_question_false(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  g_assert_true(add_to_queue(queue,
+			     (task_context){ .func=dummy_func }));
+  g_assert_false(queue_has_question(queue));
+}
+
+static void test_queue_has_question_true(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  char *const question_filename
+    = strdup("/nonexistent/question_filename");
+  g_assert_nonnull(question_filename);
+  task_context task = {
+    .func=dummy_func,
+    .question_filename=question_filename,
+  };
+  g_assert_true(add_to_queue(queue, task));
+  g_assert_true(queue_has_question(queue));
+}
+
+static void test_queue_has_question_false2(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  task_context task = { .func=dummy_func };
+  g_assert_true(add_to_queue(queue, task));
+  g_assert_true(add_to_queue(queue, task));
+  g_assert_cmpint((int)queue->length, ==, 2);
+  g_assert_false(queue_has_question(queue));
+}
+
+static void test_queue_has_question_true2(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  task_context task1 = { .func=dummy_func };
+  g_assert_true(add_to_queue(queue, task1));
+  char *const question_filename
+    = strdup("/nonexistent/question_filename");
+  g_assert_nonnull(question_filename);
+  task_context task2 = {
+    .func=dummy_func,
+    .question_filename=question_filename,
+  };
+  g_assert_true(add_to_queue(queue, task2));
+  g_assert_cmpint((int)queue->length, ==, 2);
+  g_assert_true(queue_has_question(queue));
+}
+
+static void test_cleanup_buffer(__attribute__((unused))
+				test_fixture *fixture,
+				__attribute__((unused))
+				gconstpointer user_data){
+  buffer buf = {};
+
+  const size_t buffersize = 10;
+
+  buf.data = malloc(buffersize);
+  g_assert_nonnull(buf.data);
+  if(mlock(buf.data, buffersize) != 0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+
+  cleanup_buffer(&buf);
+  g_assert_null(buf.data);
+}
+
+static
+void test_string_set_new_set_contains_nothing(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(string_set_clear)))
+    string_set set = {};
+  g_assert_false(string_set_contains(set, "")); /* Empty string */
+  g_assert_false(string_set_contains(set, "test_string"));
+}
+
+static void
+test_string_set_with_added_string_contains_it(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(string_set_clear)))
+    string_set set = {};
+  g_assert_true(string_set_add(&set, "test_string"));
+  g_assert_true(string_set_contains(set, "test_string"));
+}
+
+static void
+test_string_set_cleared_does_not_contain_str(__attribute__((unused))
+					     test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  __attribute__((cleanup(string_set_clear)))
+    string_set set = {};
+  g_assert_true(string_set_add(&set, "test_string"));
+  string_set_clear(&set);
+  g_assert_false(string_set_contains(set, "test_string"));
+}
+
+static
+void test_string_set_swap_one_with_empty(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(string_set_clear)))
+    string_set set1 = {};
+  __attribute__((cleanup(string_set_clear)))
+    string_set set2 = {};
+  g_assert_true(string_set_add(&set1, "test_string1"));
+  string_set_swap(&set1, &set2);
+  g_assert_false(string_set_contains(set1, "test_string1"));
+  g_assert_true(string_set_contains(set2, "test_string1"));
+}
+
+static
+void test_string_set_swap_empty_with_one(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(string_set_clear)))
+    string_set set1 = {};
+  __attribute__((cleanup(string_set_clear)))
+    string_set set2 = {};
+  g_assert_true(string_set_add(&set2, "test_string2"));
+  string_set_swap(&set1, &set2);
+  g_assert_true(string_set_contains(set1, "test_string2"));
+  g_assert_false(string_set_contains(set2, "test_string2"));
+}
+
+static void test_string_set_swap_one_with_one(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(string_set_clear)))
+    string_set set1 = {};
+  __attribute__((cleanup(string_set_clear)))
+    string_set set2 = {};
+  g_assert_true(string_set_add(&set1, "test_string1"));
+  g_assert_true(string_set_add(&set2, "test_string2"));
+  string_set_swap(&set1, &set2);
+  g_assert_false(string_set_contains(set1, "test_string1"));
+  g_assert_true(string_set_contains(set1, "test_string2"));
+  g_assert_false(string_set_contains(set2, "test_string2"));
+  g_assert_true(string_set_contains(set2, "test_string1"));
+}
+
+static bool fd_has_cloexec_and_nonblock(const int);
+
+static bool epoll_set_contains(int, int, uint32_t);
+
+static void test_start_mandos_client(test_fixture *fixture,
+				     __attribute__((unused))
+				     gconstpointer user_data){
+
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  buffer password = {};
+  bool password_is_read = false;
+  const char helper_directory[] = "/nonexistent";
+  const char *const argv[] = { "/bin/true", NULL };
+
+  g_assert_true(start_mandos_client(queue, epoll_fd,
+				    &mandos_client_exited, &quit_now,
+				    &password, &password_is_read,
+				    &fixture->orig_sigaction,
+				    fixture->orig_sigmask,
+				    helper_directory, 0, 0, argv));
+
+  g_assert_cmpuint((unsigned int)queue->length, >=, 2);
+
+  const task_context *const added_wait_task
+    = find_matching_task(queue, (task_context){
+	.func=wait_for_mandos_client_exit,
+	.mandos_client_exited=&mandos_client_exited,
+	.quit_now=&quit_now,
+      });
+  g_assert_nonnull(added_wait_task);
+  g_assert_cmpint(added_wait_task->pid, >, 0);
+  g_assert_cmpint(kill(added_wait_task->pid, SIGKILL), ==, 0);
+  waitpid(added_wait_task->pid, NULL, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue, (task_context){
+	.func=read_mandos_client_output,
+	.epoll_fd=epoll_fd,
+	.password=&password,
+	.password_is_read=&password_is_read,
+	.quit_now=&quit_now,
+      });
+  g_assert_nonnull(added_read_task);
+  g_assert_cmpint(added_read_task->fd, >, 2);
+  g_assert_true(fd_has_cloexec_and_nonblock(added_read_task->fd));
+  g_assert_true(epoll_set_contains(epoll_fd, added_read_task->fd,
+				   EPOLLIN | EPOLLRDHUP));
+}
+
+static bool fd_has_cloexec_and_nonblock(const int fd){
+  const int socket_fd_flags = fcntl(fd, F_GETFD, 0);
+  const int socket_file_flags = fcntl(fd, F_GETFL, 0);
+  return ((socket_fd_flags >= 0)
+	  and (socket_fd_flags & FD_CLOEXEC)
+	  and (socket_file_flags >= 0)
+	  and (socket_file_flags & O_NONBLOCK));
+}
+
+__attribute__((const))
+bool is_privileged(void){
+  uid_t user = getuid() + 1;
+  if(user == 0){		/* Overflow check */
+    user++;
+  }
+  gid_t group = getuid() + 1;
+  if(group == 0){		/* Overflow check */
+    group++;
+  }
+  const pid_t pid = fork();
+  if(pid == 0){			/* Child */
+    if(setresgid((uid_t)-1, group, group) == -1){
+      if(errno != EPERM){
+	error(EXIT_FAILURE, errno, "Failed to setresgid(-1, %" PRIuMAX
+	      ", %" PRIuMAX")", (uintmax_t)group, (uintmax_t)group);
+      }
+      exit(EXIT_FAILURE);
+    }
+    if(setresuid((uid_t)-1, user, user) == -1){
+      if(errno != EPERM){
+	error(EXIT_FAILURE, errno, "Failed to setresuid(-1, %" PRIuMAX
+	      ", %" PRIuMAX")", (uintmax_t)user, (uintmax_t)user);
+      }
+      exit(EXIT_FAILURE);
+    }
+    exit(EXIT_SUCCESS);
+  }
+  if(pid == -1){
+    error(EXIT_FAILURE, errno, "Failed to fork()");
+  }
+
+  int status;
+  waitpid(pid, &status, 0);
+  if(WIFEXITED(status) and (WEXITSTATUS(status) == EXIT_SUCCESS)){
+    return true;
+  }
+  return false;
+}
+
+static bool epoll_set_contains(int epoll_fd, int fd, uint32_t events){
+  /* Only scan for events in this eventmask */
+  const uint32_t eventmask = EPOLLIN | EPOLLOUT | EPOLLRDHUP;
+  __attribute__((cleanup(cleanup_string)))
+    char *fdinfo_name = NULL;
+  int ret = asprintf(&fdinfo_name, "/proc/self/fdinfo/%d", epoll_fd);
+  g_assert_cmpint(ret, >, 0);
+  g_assert_nonnull(fdinfo_name);
+
+  FILE *fdinfo = fopen(fdinfo_name, "r");
+  g_assert_nonnull(fdinfo);
+  uint32_t reported_events;
+  buffer line = {};
+  int found_fd = -1;
+
+  do {
+    if(getline(&line.data, &line.allocated, fdinfo) < 0){
+      break;
+    }
+    /* See proc(5) for format of /proc/PID/fdinfo/FD for epoll fd's */
+    if(sscanf(line.data, "tfd: %d events: %" SCNx32 " ",
+	      &found_fd, &reported_events) == 2){
+      if(found_fd == fd){
+	break;
+      }
+    }
+  } while(not feof(fdinfo) and not ferror(fdinfo));
+  g_assert_cmpint(fclose(fdinfo), ==, 0);
+  free(line.data);
+  if(found_fd != fd){
+    return false;
+  }
+
+  if(events == 0){
+    /* Don't check events if none are given */
+    return true;
+  }
+  return (reported_events & eventmask) == (events & eventmask);
+}
+
+static void test_start_mandos_client_execv(test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  const char helper_directory[] = "/nonexistent";
+  /* Can't execv("/", ...), so this should fail */
+  const char *const argv[] = { "/", NULL };
+
+  {
+    __attribute__((cleanup(cleanup_close)))
+      const int devnull_fd = open("/dev/null",
+				  O_WRONLY | O_CLOEXEC | O_NOCTTY);
+    g_assert_cmpint(devnull_fd, >=, 0);
+    __attribute__((cleanup(cleanup_close)))
+      const int real_stderr_fd = dup(STDERR_FILENO);
+    g_assert_cmpint(real_stderr_fd, >=, 0);
+    dup2(devnull_fd, STDERR_FILENO);
+
+    const bool success = start_mandos_client(queue, epoll_fd,
+					     &mandos_client_exited,
+					     &quit_now,
+					     &password,
+					     (bool[]){false},
+					     &fixture->orig_sigaction,
+					     fixture->orig_sigmask,
+					     helper_directory, 0, 0,
+					     argv);
+    dup2(real_stderr_fd, STDERR_FILENO);
+    g_assert_true(success);
+  }
+  g_assert_cmpuint((unsigned int)queue->length, ==, 2);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+
+    {
+      __attribute__((cleanup(cleanup_close)))
+	const int devnull_fd = open("/dev/null",
+				    O_WRONLY | O_CLOEXEC | O_NOCTTY);
+      g_assert_cmpint(devnull_fd, >=, 0);
+      __attribute__((cleanup(cleanup_close)))
+	const int real_stderr_fd = dup(STDERR_FILENO);
+      g_assert_cmpint(real_stderr_fd, >=, 0);
+      g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+      dup2(devnull_fd, STDERR_FILENO);
+      const bool success = run_queue(&queue, &cancelled_filenames,
+				     &quit_now);
+      dup2(real_stderr_fd, STDERR_FILENO);
+      if(not success){
+	break;
+      }
+    }
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while(((queue->length) > 0)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_true(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(mandos_client_exited);
+}
+
+static void test_start_mandos_client_suid_euid(test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  if(not is_privileged()){
+    g_test_skip("Not privileged");
+    return;
+  }
+
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+  const char helper_directory[] = "/nonexistent";
+  const char *const argv[] = { "/usr/bin/id", "--user", NULL };
+  uid_t user = 1000;
+  gid_t group = 1001;
+
+  const bool success = start_mandos_client(queue, epoll_fd,
+					   &mandos_client_exited,
+					   &quit_now, &password,
+					   &password_is_read,
+					   &fixture->orig_sigaction,
+					   fixture->orig_sigmask,
+					   helper_directory, user,
+					   group, argv);
+  g_assert_true(success);
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while(((queue->length) > 0)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(mandos_client_exited);
+
+  g_assert_true(password_is_read);
+  g_assert_nonnull(password.data);
+
+  uintmax_t id;
+  g_assert_cmpint(sscanf(password.data, "%" SCNuMAX "\n", &id),
+		  ==, 1);
+  g_assert_true((uid_t)id == id);
+
+  g_assert_cmpuint((unsigned int)id, ==, 0);
+}
+
+static void test_start_mandos_client_suid_egid(test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  if(not is_privileged()){
+    g_test_skip("Not privileged");
+    return;
+  }
+
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+  const char helper_directory[] = "/nonexistent";
+  const char *const argv[] = { "/usr/bin/id", "--group", NULL };
+  uid_t user = 1000;
+  gid_t group = 1001;
+
+  const bool success = start_mandos_client(queue, epoll_fd,
+					   &mandos_client_exited,
+					   &quit_now, &password,
+					   &password_is_read,
+					   &fixture->orig_sigaction,
+					   fixture->orig_sigmask,
+					   helper_directory, user,
+					   group, argv);
+  g_assert_true(success);
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while(((queue->length) > 0)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(mandos_client_exited);
+
+  g_assert_true(password_is_read);
+  g_assert_nonnull(password.data);
+
+  uintmax_t id;
+  g_assert_cmpint(sscanf(password.data, "%" SCNuMAX "\n", &id),
+		  ==, 1);
+  g_assert_true((gid_t)id == id);
+
+  g_assert_cmpuint((unsigned int)id, ==, 0);
+}
+
+static void test_start_mandos_client_suid_ruid(test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  if(not is_privileged()){
+    g_test_skip("Not privileged");
+    return;
+  }
+
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+  const char helper_directory[] = "/nonexistent";
+  const char *const argv[] = { "/usr/bin/id", "--user", "--real",
+    NULL };
+  uid_t user = 1000;
+  gid_t group = 1001;
+
+  const bool success = start_mandos_client(queue, epoll_fd,
+					   &mandos_client_exited,
+					   &quit_now, &password,
+					   &password_is_read,
+					   &fixture->orig_sigaction,
+					   fixture->orig_sigmask,
+					   helper_directory, user,
+					   group, argv);
+  g_assert_true(success);
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while(((queue->length) > 0)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(mandos_client_exited);
+
+  g_assert_true(password_is_read);
+  g_assert_nonnull(password.data);
+
+  uintmax_t id;
+  g_assert_cmpint(sscanf(password.data, "%" SCNuMAX "\n", &id),
+		  ==, 1);
+  g_assert_true((uid_t)id == id);
+
+  g_assert_cmpuint((unsigned int)id, ==, user);
+}
+
+static void test_start_mandos_client_suid_rgid(test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  if(not is_privileged()){
+    g_test_skip("Not privileged");
+    return;
+  }
+
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+  const char helper_directory[] = "/nonexistent";
+  const char *const argv[] = { "/usr/bin/id", "--group", "--real",
+    NULL };
+  uid_t user = 1000;
+  gid_t group = 1001;
+
+  const bool success = start_mandos_client(queue, epoll_fd,
+					   &mandos_client_exited,
+					   &quit_now, &password,
+					   &password_is_read,
+					   &fixture->orig_sigaction,
+					   fixture->orig_sigmask,
+					   helper_directory, user,
+					   group, argv);
+  g_assert_true(success);
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while(((queue->length) > 0)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(mandos_client_exited);
+
+  g_assert_true(password_is_read);
+  g_assert_nonnull(password.data);
+
+  uintmax_t id;
+  g_assert_cmpint(sscanf(password.data, "%" SCNuMAX "\n", &id),
+		  ==, 1);
+  g_assert_true((gid_t)id == id);
+
+  g_assert_cmpuint((unsigned int)id, ==, group);
+}
+
+static void test_start_mandos_client_read(test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+  const char dummy_test_password[] = "dummy test password";
+  const char helper_directory[] = "/nonexistent";
+  const char *const argv[] = { "/bin/echo", "-n", dummy_test_password,
+    NULL };
+
+  const bool success = start_mandos_client(queue, epoll_fd,
+					   &mandos_client_exited,
+					   &quit_now, &password,
+					   &password_is_read,
+					   &fixture->orig_sigaction,
+					   fixture->orig_sigmask,
+					   helper_directory, 0, 0,
+					   argv);
+  g_assert_true(success);
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while(((queue->length) > 0)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(mandos_client_exited);
+
+  g_assert_true(password_is_read);
+  g_assert_cmpint((int)password.length, ==,
+		  sizeof(dummy_test_password)-1);
+  g_assert_nonnull(password.data);
+  g_assert_cmpint(memcmp(dummy_test_password, password.data,
+			 sizeof(dummy_test_password)-1), ==, 0);
+}
+
+static
+void test_start_mandos_client_helper_directory(test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+  const char helper_directory[] = "/nonexistent";
+  const char *const argv[] = { "/bin/sh", "-c",
+    "echo -n ${MANDOSPLUGINHELPERDIR}", NULL };
+
+  const bool success = start_mandos_client(queue, epoll_fd,
+					   &mandos_client_exited,
+					   &quit_now, &password,
+					   &password_is_read,
+					   &fixture->orig_sigaction,
+					   fixture->orig_sigmask,
+					   helper_directory, 0, 0,
+					   argv);
+  g_assert_true(success);
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while(((queue->length) > 0)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(mandos_client_exited);
+
+  g_assert_true(password_is_read);
+  g_assert_cmpint((int)password.length, ==,
+		  sizeof(helper_directory)-1);
+  g_assert_nonnull(password.data);
+  g_assert_cmpint(memcmp(helper_directory, password.data,
+			 sizeof(helper_directory)-1), ==, 0);
+}
+
+__attribute__((nonnull, warn_unused_result))
+static bool proc_status_sigblk_to_sigset(const char *const,
+					 sigset_t *const);
+
+static void test_start_mandos_client_sigmask(test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  bool password_is_read = false;
+  const char helper_directory[] = "/nonexistent";
+  /* see proc(5) for format of /proc/self/status */
+  const char *const argv[] = { "/usr/bin/awk",
+    "$1==\"SigBlk:\"{ print $2 }", "/proc/self/status", NULL };
+
+  g_assert_true(start_mandos_client(queue, epoll_fd,
+				    &mandos_client_exited, &quit_now,
+				    &password, &password_is_read,
+				    &fixture->orig_sigaction,
+				    fixture->orig_sigmask,
+				    helper_directory, 0, 0, argv));
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    queue->next_run = 0;
+    string_set cancelled_filenames = {};
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while((not (mandos_client_exited and password_is_read))
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+  g_assert_true(mandos_client_exited);
+  g_assert_true(password_is_read);
+
+  sigset_t parsed_sigmask;
+  g_assert_true(proc_status_sigblk_to_sigset(password.data,
+					     &parsed_sigmask));
+
+  for(int signum = 1; signum < NSIG; signum++){
+    const bool has_signal = sigismember(&parsed_sigmask, signum);
+    if(sigismember(&fixture->orig_sigmask, signum)){
+      g_assert_true(has_signal);
+    } else {
+      g_assert_false(has_signal);
+    }
+  }
+}
+
+__attribute__((nonnull, warn_unused_result))
+static bool proc_status_sigblk_to_sigset(const char *const sigblk,
+					 sigset_t *const sigmask){
+  /* parse /proc/PID/status SigBlk value and convert to a sigset_t */
+  uintmax_t scanned_sigmask;
+  if(sscanf(sigblk, "%" SCNxMAX " ", &scanned_sigmask) != 1){
+    return false;
+  }
+  if(sigemptyset(sigmask) != 0){
+    return false;
+  }
+  for(int signum = 1; signum < NSIG; signum++){
+    if(scanned_sigmask & ((uintmax_t)1 << (signum-1))){
+      if(sigaddset(sigmask, signum) != 0){
+	return false;
+      }
+    }
+  }
+  return true;
+}
+
+static void run_task_with_stderr_to_dev_null(const task_context task,
+					     task_queue *const queue);
+
+static
+void test_wait_for_mandos_client_exit_badpid(__attribute__((unused))
+					     test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  const task_context task = {
+    .func=wait_for_mandos_client_exit,
+    .pid=1,
+    .mandos_client_exited=&mandos_client_exited,
+    .quit_now=&quit_now,
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_false(mandos_client_exited);
+  g_assert_true(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static void run_task_with_stderr_to_dev_null(const task_context task,
+					     task_queue *const queue){
+  FILE *real_stderr = stderr;
+  FILE *devnull = fopen("/dev/null", "we");
+  g_assert_nonnull(devnull);
+
+  stderr = devnull;
+  task.func(task, queue);
+  stderr = real_stderr;
+
+  g_assert_cmpint(fclose(devnull), ==, 0);
+}
+
+static
+void test_wait_for_mandos_client_exit_noexit(test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+
+  pid_t create_eternal_process(void){
+    const pid_t pid = fork();
+    if(pid == 0){		/* Child */
+      if(not restore_signal_handler(&fixture->orig_sigaction)){
+	_exit(EXIT_FAILURE);
+      }
+      if(not restore_sigmask(&fixture->orig_sigmask)){
+	_exit(EXIT_FAILURE);
+      }
+      while(true){
+	pause();
+      }
+    }
+    return pid;
+  }
+  pid_t pid = create_eternal_process();
+  g_assert_true(pid != -1);
+
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  const task_context task = {
+    .func=wait_for_mandos_client_exit,
+    .pid=pid,
+    .mandos_client_exited=&mandos_client_exited,
+    .quit_now=&quit_now,
+  };
+  task.func(task, queue);
+
+  g_assert_false(mandos_client_exited);
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=wait_for_mandos_client_exit,
+	.pid=task.pid,
+	.mandos_client_exited=&mandos_client_exited,
+	.quit_now=&quit_now,
+      }));
+}
+
+static
+void test_wait_for_mandos_client_exit_success(test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+
+  pid_t create_successful_process(void){
+    const pid_t pid = fork();
+    if(pid == 0){		/* Child */
+      if(not restore_signal_handler(&fixture->orig_sigaction)){
+	_exit(EXIT_FAILURE);
+      }
+      if(not restore_sigmask(&fixture->orig_sigmask)){
+	_exit(EXIT_FAILURE);
+      }
+      exit(EXIT_SUCCESS);
+    }
+    return pid;
+  }
+  const pid_t pid = create_successful_process();
+  g_assert_true(pid != -1);
+
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  const task_context initial_task = {
+    .func=wait_for_mandos_client_exit,
+    .pid=pid,
+    .mandos_client_exited=&mandos_client_exited,
+    .quit_now=&quit_now,
+  };
+  g_assert_true(add_to_queue(queue, initial_task));
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  do {
+    queue->next_run = 0;
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    g_assert_true(run_queue(&queue, (string_set[]){{}}, &quit_now));
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while((not mandos_client_exited)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_true(mandos_client_exited);
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static
+void test_wait_for_mandos_client_exit_failure(test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+
+  pid_t create_failing_process(void){
+    const pid_t pid = fork();
+    if(pid == 0){		/* Child */
+      if(not restore_signal_handler(&fixture->orig_sigaction)){
+	_exit(EXIT_FAILURE);
+      }
+      if(not restore_sigmask(&fixture->orig_sigmask)){
+	_exit(EXIT_FAILURE);
+      }
+      exit(EXIT_FAILURE);
+    }
+    return pid;
+  }
+  const pid_t pid = create_failing_process();
+  g_assert_true(pid != -1);
+
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  g_assert_true(add_to_queue(queue, (task_context){
+	.func=wait_for_mandos_client_exit,
+	.pid=pid,
+	.mandos_client_exited=&mandos_client_exited,
+	.quit_now=&quit_now,
+      }));
+
+  g_assert_true(sigismember(&fixture->orig_sigmask, SIGCHLD) == 0);
+
+  __attribute__((cleanup(cleanup_close)))
+    const int devnull_fd = open("/dev/null",
+				O_WRONLY | O_CLOEXEC | O_NOCTTY);
+  g_assert_cmpint(devnull_fd, >=, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int real_stderr_fd = dup(STDERR_FILENO);
+  g_assert_cmpint(real_stderr_fd, >=, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    dup2(devnull_fd, STDERR_FILENO);
+    const bool success = run_queue(&queue, &cancelled_filenames,
+				   &quit_now);
+    dup2(real_stderr_fd, STDERR_FILENO);
+    if(not success){
+      break;
+    }
+
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while((not mandos_client_exited)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_true(quit_now);
+  g_assert_true(mandos_client_exited);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static
+void test_wait_for_mandos_client_exit_killed(test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  bool mandos_client_exited = false;
+  bool quit_now = false;
+
+  pid_t create_killed_process(void){
+    const pid_t pid = fork();
+    if(pid == 0){		/* Child */
+      if(not restore_signal_handler(&fixture->orig_sigaction)){
+	_exit(EXIT_FAILURE);
+      }
+      if(not restore_sigmask(&fixture->orig_sigmask)){
+	_exit(EXIT_FAILURE);
+      }
+      while(true){
+	pause();
+      }
+    }
+    kill(pid, SIGKILL);
+    return pid;
+  }
+  const pid_t pid = create_killed_process();
+  g_assert_true(pid != -1);
+
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  g_assert_true(add_to_queue(queue, (task_context){
+	.func=wait_for_mandos_client_exit,
+	.pid=pid,
+	.mandos_client_exited=&mandos_client_exited,
+	.quit_now=&quit_now,
+      }));
+
+  __attribute__((cleanup(cleanup_close)))
+    const int devnull_fd = open("/dev/null",
+				O_WRONLY | O_CLOEXEC, O_NOCTTY);
+  g_assert_cmpint(devnull_fd, >=, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int real_stderr_fd = dup(STDERR_FILENO);
+  g_assert_cmpint(real_stderr_fd, >=, 0);
+
+  struct timespec starttime, currtime;
+  g_assert_true(clock_gettime(CLOCK_MONOTONIC, &starttime) == 0);
+  do {
+    g_assert_true(wait_for_event(epoll_fd, queue->next_run, 0));
+    dup2(devnull_fd, STDERR_FILENO);
+    const bool success = run_queue(&queue, &cancelled_filenames,
+				   &quit_now);
+    dup2(real_stderr_fd, STDERR_FILENO);
+    if(not success){
+      break;
+    }
+
+    g_assert_true(clock_gettime(CLOCK_MONOTONIC, &currtime) == 0);
+  } while((not mandos_client_exited)
+	  and (not quit_now)
+	  and ((currtime.tv_sec - starttime.tv_sec) < 10));
+
+  g_assert_true(mandos_client_exited);
+  g_assert_true(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static bool epoll_set_does_not_contain(int, int);
+
+static
+void test_read_mandos_client_output_readerror(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+
+  /* Reading /proc/self/mem from offset 0 will always give EIO */
+  const int fd = open("/proc/self/mem",
+		      O_RDONLY | O_CLOEXEC | O_NOCTTY);
+
+  bool password_is_read = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_mandos_client_output,
+    .epoll_fd=epoll_fd,
+    .fd=fd,
+    .password=&password,
+    .password_is_read=&password_is_read,
+    .quit_now=&quit_now,
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_false(password_is_read);
+  g_assert_cmpint((int)password.length, ==, 0);
+  g_assert_true(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_true(epoll_set_does_not_contain(epoll_fd, fd));
+
+  g_assert_cmpint(close(fd), ==, -1);
+}
+
+static bool epoll_set_does_not_contain(int epoll_fd, int fd){
+  return not epoll_set_contains(epoll_fd, fd, 0);
+}
+
+static
+void test_read_mandos_client_output_nodata(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+
+  bool password_is_read = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_mandos_client_output,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .password=&password,
+    .password_is_read=&password_is_read,
+    .quit_now=&quit_now,
+  };
+  task.func(task, queue);
+  g_assert_false(password_is_read);
+  g_assert_cmpint((int)password.length, ==, 0);
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_mandos_client_output,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.password=&password,
+	.password_is_read=&password_is_read,
+	.quit_now=&quit_now,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+}
+
+static void test_read_mandos_client_output_eof(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+
+  bool password_is_read = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_mandos_client_output,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .password=&password,
+    .password_is_read=&password_is_read,
+    .quit_now=&quit_now,
+  };
+  task.func(task, queue);
+  g_assert_true(password_is_read);
+  g_assert_cmpint((int)password.length, ==, 0);
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_true(epoll_set_does_not_contain(epoll_fd, pipefds[0]));
+
+  g_assert_cmpint(close(pipefds[0]), ==, -1);
+}
+
+static
+void test_read_mandos_client_output_once(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  const char dummy_test_password[] = "dummy test password";
+  /* Start with a pre-allocated buffer */
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {
+    .data=malloc(sizeof(dummy_test_password)),
+    .length=0,
+    .allocated=sizeof(dummy_test_password),
+  };
+  g_assert_nonnull(password.data);
+  if(mlock(password.data, password.allocated) != 0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+
+  bool password_is_read = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  g_assert_true(sizeof(dummy_test_password) <= PIPE_BUF);
+  g_assert_cmpint((int)write(pipefds[1], dummy_test_password,
+			     sizeof(dummy_test_password)),
+		  ==, (int)sizeof(dummy_test_password));
+
+  task_context task = {
+    .func=read_mandos_client_output,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .password=&password,
+    .password_is_read=&password_is_read,
+    .quit_now=&quit_now,
+  };
+  task.func(task, queue);
+
+  g_assert_false(password_is_read);
+  g_assert_cmpint((int)password.length, ==,
+		  (int)sizeof(dummy_test_password));
+  g_assert_nonnull(password.data);
+  g_assert_cmpint(memcmp(password.data, dummy_test_password,
+			 sizeof(dummy_test_password)), ==, 0);
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_mandos_client_output,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.password=&password,
+	.password_is_read=&password_is_read,
+	.quit_now=&quit_now,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+}
+
+static
+void test_read_mandos_client_output_malloc(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  const char dummy_test_password[] = "dummy test password";
+  /* Start with an empty buffer */
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+
+  bool password_is_read = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  g_assert_true(sizeof(dummy_test_password) <= PIPE_BUF);
+  g_assert_cmpint((int)write(pipefds[1], dummy_test_password,
+			     sizeof(dummy_test_password)),
+		  ==, (int)sizeof(dummy_test_password));
+
+  task_context task = {
+    .func=read_mandos_client_output,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .password=&password,
+    .password_is_read=&password_is_read,
+    .quit_now=&quit_now,
+  };
+  task.func(task, queue);
+
+  g_assert_false(password_is_read);
+  g_assert_cmpint((int)password.length, ==,
+		  (int)sizeof(dummy_test_password));
+  g_assert_nonnull(password.data);
+  g_assert_cmpint(memcmp(password.data, dummy_test_password,
+			 sizeof(dummy_test_password)), ==, 0);
+
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_mandos_client_output,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.password=&password,
+	.password_is_read=&password_is_read,
+	.quit_now=&quit_now,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+}
+
+static
+void test_read_mandos_client_output_append(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  const char dummy_test_password[] = "dummy test password";
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {
+    .data=malloc(PIPE_BUF),
+    .length=PIPE_BUF,
+    .allocated=PIPE_BUF,
+  };
+  g_assert_nonnull(password.data);
+  if(mlock(password.data, password.allocated) != 0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+
+  memset(password.data, 'x', PIPE_BUF);
+  char password_expected[PIPE_BUF];
+  memcpy(password_expected, password.data, PIPE_BUF);
+
+  bool password_is_read = false;
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  g_assert_true(sizeof(dummy_test_password) <= PIPE_BUF);
+  g_assert_cmpint((int)write(pipefds[1], dummy_test_password,
+			     sizeof(dummy_test_password)),
+		  ==, (int)sizeof(dummy_test_password));
+
+  task_context task = {
+    .func=read_mandos_client_output,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .password=&password,
+    .password_is_read=&password_is_read,
+    .quit_now=&quit_now,
+  };
+  task.func(task, queue);
+
+  g_assert_false(password_is_read);
+  g_assert_cmpint((int)password.length, ==,
+		  PIPE_BUF + sizeof(dummy_test_password));
+  g_assert_nonnull(password.data);
+  g_assert_cmpint(memcmp(password_expected, password.data, PIPE_BUF),
+		  ==, 0);
+  g_assert_cmpint(memcmp(password.data + PIPE_BUF,
+			 dummy_test_password,
+			 sizeof(dummy_test_password)), ==, 0);
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_mandos_client_output,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.password=&password,
+	.password_is_read=&password_is_read,
+	.quit_now=&quit_now,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+}
+
+static char *make_temporary_directory(void);
+
+static void test_add_inotify_dir_watch(__attribute__((unused))
+				       test_fixture *fixture,
+				       __attribute__((unused))
+				       gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+
+  g_assert_true(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				      &password, tempdir,
+				      &cancelled_filenames,
+				      &current_time,
+				      &mandos_client_exited,
+				      &password_is_read));
+
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=tempdir,
+	.cancelled_filenames=&cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      });
+  g_assert_nonnull(added_read_task);
+
+  g_assert_cmpint(added_read_task->fd, >, 2);
+  g_assert_true(fd_has_cloexec_and_nonblock(added_read_task->fd));
+  g_assert_true(epoll_set_contains(added_read_task->epoll_fd,
+				   added_read_task->fd,
+				   EPOLLIN | EPOLLRDHUP));
+
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static char *make_temporary_directory(void){
+  char *name = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(name);
+  char *result = mkdtemp(name);
+  if(result == NULL){
+    free(name);
+  }
+  return result;
+}
+
+static void test_add_inotify_dir_watch_fail(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  const char nonexistent_dir[] = "/nonexistent";
+
+  FILE *real_stderr = stderr;
+  FILE *devnull = fopen("/dev/null", "we");
+  g_assert_nonnull(devnull);
+  stderr = devnull;
+  g_assert_false(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				       &password, nonexistent_dir,
+				       &cancelled_filenames,
+				       &current_time,
+				       &mandos_client_exited,
+				       &password_is_read));
+  stderr = real_stderr;
+  g_assert_cmpint(fclose(devnull), ==, 0);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static void test_add_inotify_dir_watch_nondir(__attribute__((unused))
+					      test_fixture *fixture,
+					    __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  const char not_a_directory[] = "/dev/tty";
+
+  FILE *real_stderr = stderr;
+  FILE *devnull = fopen("/dev/null", "we");
+  g_assert_nonnull(devnull);
+  stderr = devnull;
+  g_assert_false(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				       &password, not_a_directory,
+				       &cancelled_filenames,
+				       &current_time,
+				       &mandos_client_exited,
+				       &password_is_read));
+  stderr = real_stderr;
+  g_assert_cmpint(fclose(devnull), ==, 0);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static void test_add_inotify_dir_watch_EAGAIN(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+
+  g_assert_true(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				      &password, tempdir,
+				      &cancelled_filenames,
+				      &current_time,
+				      &mandos_client_exited,
+				      &password_is_read));
+
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue,
+			 (task_context){ .func=read_inotify_event });
+  g_assert_nonnull(added_read_task);
+
+  g_assert_cmpint(added_read_task->fd, >, 2);
+  g_assert_true(fd_has_cloexec_and_nonblock(added_read_task->fd));
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + NAME_MAX + 1);
+  struct inotify_event *ievent = malloc(ievent_size);
+  g_assert_nonnull(ievent);
+
+  g_assert_cmpint(read(added_read_task->fd, ievent, ievent_size), ==,
+		  -1);
+  g_assert_cmpint(errno, ==, EAGAIN);
+
+  free(ievent);
+
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static char *make_temporary_file_in_directory(const char
+					      *const dir);
+
+static
+void test_add_inotify_dir_watch_IN_CLOSE_WRITE(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+
+  g_assert_true(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				      &password, tempdir,
+				      &cancelled_filenames,
+				      &current_time,
+				      &mandos_client_exited,
+				      &password_is_read));
+
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue,
+			 (task_context){ .func=read_inotify_event });
+  g_assert_nonnull(added_read_task);
+
+  g_assert_cmpint(added_read_task->fd, >, 2);
+  g_assert_true(fd_has_cloexec_and_nonblock(added_read_task->fd));
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(filename);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + NAME_MAX + 1);
+  struct inotify_event *ievent = malloc(ievent_size);
+  g_assert_nonnull(ievent);
+
+  ssize_t read_size = 0;
+  read_size = read(added_read_task->fd, ievent, ievent_size);
+
+  g_assert_cmpint((int)read_size, >, 0);
+  g_assert_true(ievent->mask & IN_CLOSE_WRITE);
+  g_assert_cmpstr(ievent->name, ==, basename(filename));
+
+  free(ievent);
+
+  g_assert_cmpint(unlink(filename), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static char *make_temporary_prefixed_file_in_directory(const char
+						       *const prefix,
+						       const char
+						       *const dir){
+  char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%sXXXXXX", dir, prefix),
+		  >, 0);
+  g_assert_nonnull(filename);
+  const int fd = mkostemp(filename, O_CLOEXEC);
+  g_assert_cmpint(fd, >=, 0);
+  g_assert_cmpint(close(fd), ==, 0);
+  return filename;
+}
+
+static char *make_temporary_file_in_directory(const char
+					      *const dir){
+  return make_temporary_prefixed_file_in_directory("temp", dir);
+}
+
+static
+void test_add_inotify_dir_watch_IN_MOVED_TO(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *watchdir = make_temporary_directory();
+  g_assert_nonnull(watchdir);
+
+  g_assert_true(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				      &password, watchdir,
+				      &cancelled_filenames,
+				      &current_time,
+				      &mandos_client_exited,
+				      &password_is_read));
+
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue,
+			 (task_context){ .func=read_inotify_event });
+  g_assert_nonnull(added_read_task);
+
+  g_assert_cmpint(added_read_task->fd, >, 2);
+  g_assert_true(fd_has_cloexec_and_nonblock(added_read_task->fd));
+
+  char *sourcedir = make_temporary_directory();
+  g_assert_nonnull(sourcedir);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = make_temporary_file_in_directory(sourcedir);
+  g_assert_nonnull(filename);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *targetfilename = NULL;
+  g_assert_cmpint(asprintf(&targetfilename, "%s/%s", watchdir,
+			   basename(filename)), >, 0);
+  g_assert_nonnull(targetfilename);
+
+  g_assert_cmpint(rename(filename, targetfilename), ==, 0);
+  g_assert_cmpint(rmdir(sourcedir), ==, 0);
+  free(sourcedir);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + NAME_MAX + 1);
+  struct inotify_event *ievent = malloc(ievent_size);
+  g_assert_nonnull(ievent);
+
+  ssize_t read_size = read(added_read_task->fd, ievent, ievent_size);
+
+  g_assert_cmpint((int)read_size, >, 0);
+  g_assert_true(ievent->mask & IN_MOVED_TO);
+  g_assert_cmpstr(ievent->name, ==, basename(targetfilename));
+
+  free(ievent);
+
+  g_assert_cmpint(unlink(targetfilename), ==, 0);
+  g_assert_cmpint(rmdir(watchdir), ==, 0);
+}
+
+static
+void test_add_inotify_dir_watch_IN_MOVED_FROM(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(tempfilename);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *targetdir = make_temporary_directory();
+  g_assert_nonnull(targetdir);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *targetfilename = NULL;
+  g_assert_cmpint(asprintf(&targetfilename, "%s/%s", targetdir,
+			   basename(tempfilename)), >, 0);
+  g_assert_nonnull(targetfilename);
+
+  g_assert_true(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				      &password, tempdir,
+				      &cancelled_filenames,
+				      &current_time,
+				      &mandos_client_exited,
+				      &password_is_read));
+
+  g_assert_cmpint(rename(tempfilename, targetfilename), ==, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue,
+			 (task_context){ .func=read_inotify_event });
+  g_assert_nonnull(added_read_task);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + NAME_MAX + 1);
+  struct inotify_event *ievent = malloc(ievent_size);
+  g_assert_nonnull(ievent);
+
+  ssize_t read_size = read(added_read_task->fd, ievent, ievent_size);
+
+  g_assert_cmpint((int)read_size, >, 0);
+  g_assert_true(ievent->mask & IN_MOVED_FROM);
+  g_assert_cmpstr(ievent->name, ==, basename(tempfilename));
+
+  free(ievent);
+
+  g_assert_cmpint(unlink(targetfilename), ==, 0);
+  g_assert_cmpint(rmdir(targetdir), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static
+void test_add_inotify_dir_watch_IN_DELETE(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfile = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(tempfile);
+
+  g_assert_true(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				      &password, tempdir,
+				      &cancelled_filenames,
+				      &current_time,
+				      &mandos_client_exited,
+				      &password_is_read));
+  g_assert_cmpint(unlink(tempfile), ==, 0);
+
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue,
+			 (task_context){ .func=read_inotify_event });
+  g_assert_nonnull(added_read_task);
+
+  g_assert_cmpint(added_read_task->fd, >, 2);
+  g_assert_true(fd_has_cloexec_and_nonblock(added_read_task->fd));
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + NAME_MAX + 1);
+  struct inotify_event *ievent = malloc(ievent_size);
+  g_assert_nonnull(ievent);
+
+  ssize_t read_size = 0;
+  read_size = read(added_read_task->fd, ievent, ievent_size);
+
+  g_assert_cmpint((int)read_size, >, 0);
+  g_assert_true(ievent->mask & IN_DELETE);
+  g_assert_cmpstr(ievent->name, ==, basename(tempfile));
+
+  free(ievent);
+
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static
+void test_add_inotify_dir_watch_IN_EXCL_UNLINK(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfile = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(tempfile);
+  int tempfile_fd = open(tempfile, O_WRONLY | O_CLOEXEC | O_NOCTTY
+			 | O_NOFOLLOW);
+  g_assert_cmpint(tempfile_fd, >, 2);
+
+  g_assert_true(add_inotify_dir_watch(queue, epoll_fd, &quit_now,
+				      &password, tempdir,
+				      &cancelled_filenames,
+				      &current_time,
+				      &mandos_client_exited,
+				      &password_is_read));
+  g_assert_cmpint(unlink(tempfile), ==, 0);
+
+  g_assert_cmpuint((unsigned int)queue->length, >, 0);
+
+  const task_context *const added_read_task
+    = find_matching_task(queue,
+			 (task_context){ .func=read_inotify_event });
+  g_assert_nonnull(added_read_task);
+
+  g_assert_cmpint(added_read_task->fd, >, 2);
+  g_assert_true(fd_has_cloexec_and_nonblock(added_read_task->fd));
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + NAME_MAX + 1);
+  struct inotify_event *ievent = malloc(ievent_size);
+  g_assert_nonnull(ievent);
+
+  ssize_t read_size = 0;
+  read_size = read(added_read_task->fd, ievent, ievent_size);
+
+  g_assert_cmpint((int)read_size, >, 0);
+  g_assert_true(ievent->mask & IN_DELETE);
+  g_assert_cmpstr(ievent->name, ==, basename(tempfile));
+
+  g_assert_cmpint(close(tempfile_fd), ==, 0);
+
+  /* IN_EXCL_UNLINK should make the closing of the previously unlinked
+     file not appear as an ievent, so we should not see it now. */
+  read_size = read(added_read_task->fd, ievent, ievent_size);
+  g_assert_cmpint((int)read_size, ==, -1);
+  g_assert_true(errno == EAGAIN);
+
+  free(ievent);
+
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static void test_read_inotify_event_readerror(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const mono_microsecs current_time = 0;
+
+  /* Reading /proc/self/mem from offset 0 will always result in EIO */
+  const int fd = open("/proc/self/mem",
+		      O_RDONLY | O_CLOEXEC | O_NOCTTY);
+
+  bool quit_now = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=fd,
+    .quit_now=&quit_now,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+  };
+  g_assert_nonnull(task.filename);
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_true(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_true(epoll_set_does_not_contain(epoll_fd, fd));
+
+  g_assert_cmpint(close(fd), ==, -1);
+}
+
+static void test_read_inotify_event_bad_epoll(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  const mono_microsecs current_time = 17;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+  const int epoll_fd = pipefds[0]; /* This will obviously fail */
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  g_assert_nonnull(task.filename);
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_nonnull(find_matching_task(queue, task));
+  g_assert_true(queue->next_run == 1000000 + current_time);
+
+  g_assert_cmpint(close(pipefds[0]), ==, 0);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+}
+
+static void test_read_inotify_event_nodata(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  g_assert_nonnull(task.filename);
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=task.cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+}
+
+static void test_read_inotify_event_eof(__attribute__((unused))
+					test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_true(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_true(epoll_set_does_not_contain(epoll_fd, pipefds[0]));
+
+  g_assert_cmpint(close(pipefds[0]), ==, -1);
+}
+
+static
+void test_read_inotify_event_IN_CLOSE_WRITE(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ask.dummy_file_name";
+  ievent->mask = IN_CLOSE_WRITE;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run != 0);
+  g_assert_cmpuint((unsigned int)queue->length, >=, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=task.cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  g_assert_cmpuint((unsigned int)queue->length, >=, 2);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", task.filename,
+			   dummy_file_name), >, 0);
+  g_assert_nonnull(filename);
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=open_and_parse_question,
+	.epoll_fd=epoll_fd,
+	.filename=filename,
+	.question_filename=filename,
+	.password=&password,
+	.cancelled_filenames=task.cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+}
+
+static
+void test_read_inotify_event_IN_MOVED_TO(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ask.dummy_file_name";
+  ievent->mask = IN_MOVED_TO;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run != 0);
+  g_assert_cmpuint((unsigned int)queue->length, >=, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=task.cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  g_assert_cmpuint((unsigned int)queue->length, >=, 2);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", task.filename,
+			   dummy_file_name), >, 0);
+  g_assert_nonnull(filename);
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=open_and_parse_question,
+	.epoll_fd=epoll_fd,
+	.filename=filename,
+	.question_filename=filename,
+	.password=&password,
+	.cancelled_filenames=task.cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+}
+
+static
+void test_read_inotify_event_IN_MOVED_FROM(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ask.dummy_file_name";
+  ievent->mask = IN_MOVED_FROM;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=&cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", task.filename,
+			   dummy_file_name), >, 0);
+  g_assert_nonnull(filename);
+  g_assert_true(string_set_contains(*task.cancelled_filenames,
+				    filename));
+}
+
+static void test_read_inotify_event_IN_DELETE(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ask.dummy_file_name";
+  ievent->mask = IN_DELETE;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=&cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", task.filename,
+			   dummy_file_name), >, 0);
+  g_assert_nonnull(filename);
+  g_assert_true(string_set_contains(*task.cancelled_filenames,
+				    filename));
+}
+
+static void
+test_read_inotify_event_IN_CLOSE_WRITE_badname(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ignored.dummy_file_name";
+  ievent->mask = IN_CLOSE_WRITE;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=task.cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+}
+
+static void
+test_read_inotify_event_IN_MOVED_TO_badname(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ignored.dummy_file_name";
+  ievent->mask = IN_MOVED_TO;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames = &(string_set){},
+    .notafter=0,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=task.cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+}
+
+static void
+test_read_inotify_event_IN_MOVED_FROM_badname(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ignored.dummy_file_name";
+  ievent->mask = IN_MOVED_FROM;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=&cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", task.filename,
+			   dummy_file_name), >, 0);
+  g_assert_nonnull(filename);
+  g_assert_false(string_set_contains(cancelled_filenames, filename));
+}
+
+static
+void test_read_inotify_event_IN_DELETE_badname(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+
+  /* "sufficient to read at least one event." - inotify(7) */
+  const size_t ievent_max_size = (sizeof(struct inotify_event)
+				  + NAME_MAX + 1);
+  g_assert_cmpint(ievent_max_size, <=, PIPE_BUF);
+  struct {
+    struct inotify_event event;
+    char name_buffer[NAME_MAX + 1];
+  } ievent_buffer;
+  struct inotify_event *const ievent = &ievent_buffer.event;
+
+  const char dummy_file_name[] = "ignored.dummy_file_name";
+  ievent->mask = IN_DELETE;
+  ievent->len = sizeof(dummy_file_name);
+  memcpy(ievent->name, dummy_file_name, sizeof(dummy_file_name));
+  const size_t ievent_size = (sizeof(struct inotify_event)
+			      + sizeof(dummy_file_name));
+  g_assert_cmpint(write(pipefds[1], (char *)ievent, ievent_size),
+		  ==, ievent_size);
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+
+  bool quit_now = false;
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  task_context task = {
+    .func=read_inotify_event,
+    .epoll_fd=epoll_fd,
+    .fd=pipefds[0],
+    .quit_now=&quit_now,
+    .password=&password,
+    .filename=strdup("/nonexistent"),
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_false(quit_now);
+  g_assert_true(queue->next_run == 0);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=read_inotify_event,
+	.epoll_fd=epoll_fd,
+	.fd=pipefds[0],
+	.quit_now=&quit_now,
+	.password=&password,
+	.filename=task.filename,
+	.cancelled_filenames=&cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(epoll_set_contains(epoll_fd, pipefds[0],
+				   EPOLLIN | EPOLLRDHUP));
+
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", task.filename,
+			   dummy_file_name), >, 0);
+  g_assert_nonnull(filename);
+  g_assert_false(string_set_contains(cancelled_filenames, filename));
+}
+
+static
+void test_open_and_parse_question_ENOENT(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  char *const filename = strdup("/nonexistent");
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=(mono_microsecs[]){0},
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static void test_open_and_parse_question_EIO(__attribute__((unused))
+					     test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  const mono_microsecs current_time = 0;
+
+  char *filename = strdup("/proc/self/mem");
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=&password,
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static void
+test_open_and_parse_question_parse_error(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int tempfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(tempfile, >, 0);
+  const char bad_data[] = "this is bad syntax\n";
+  g_assert_cmpint(write(tempfile, bad_data, sizeof(bad_data)),
+		  ==, sizeof(bad_data));
+  g_assert_cmpint(close(tempfile), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=(mono_microsecs[]){0},
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static
+void test_open_and_parse_question_nosocket(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nPID=1\n"), >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=(mono_microsecs[]){0},
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static
+void test_open_and_parse_question_badsocket(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nSocket=\nPID=1\n"), >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=(mono_microsecs[]){0},
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static
+void test_open_and_parse_question_nopid(__attribute__((unused))
+					test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nSocket=/nonexistent\n"), >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=(mono_microsecs[]){0},
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static
+void test_open_and_parse_question_badpid(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nSocket=/nonexistent\nPID=\n"),
+		  >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=(mono_microsecs[]){0},
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static void
+test_open_and_parse_question_noexist_pid(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  const mono_microsecs current_time = 0;
+
+  /* Find value of sysctl kernel.pid_max */
+  uintmax_t pid_max = 0;
+  FILE *sysctl_pid_max = fopen("/proc/sys/kernel/pid_max", "r");
+  g_assert_nonnull(sysctl_pid_max);
+  g_assert_cmpint(fscanf(sysctl_pid_max, "%" PRIuMAX, &pid_max),
+		  ==, 1);
+  g_assert_cmpint(fclose(sysctl_pid_max), ==, 0);
+
+  pid_t nonexisting_pid = ((pid_t)pid_max)+1;
+  g_assert_true(nonexisting_pid > 0); /* Overflow check */
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nSocket=/nonexistent\nPID=%"
+			  PRIuMAX"\n", (uintmax_t)nonexisting_pid),
+		  >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const question_filename = strdup(tempfilename);
+  g_assert_nonnull(question_filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=question_filename,
+    .epoll_fd=epoll_fd,
+    .password=&password,
+    .filename=question_filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static void
+test_open_and_parse_question_no_notafter(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  const mono_microsecs current_time = 0;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nSocket=/nonexistent\nPID=%"
+			  PRIuMAX "\n", (uintmax_t)getpid()), >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=&password,
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *socket_filename = strdup("/nonexistent");
+  g_assert_nonnull(socket_filename);
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=connect_question_socket,
+	.question_filename=tempfilename,
+	.filename=socket_filename,
+	.epoll_fd=epoll_fd,
+	.password=&password,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(queue->next_run != 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static void
+test_open_and_parse_question_bad_notafter(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  const mono_microsecs current_time = 0;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nSocket=/nonexistent\nPID=%"
+			  PRIuMAX "\nNotAfter=\n",
+			  (uintmax_t)getpid()), >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=&password,
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  run_task_with_stderr_to_dev_null(task, queue);
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  __attribute__((cleanup(cleanup_string)))
+    char *socket_filename = strdup("/nonexistent");
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=connect_question_socket,
+	.question_filename=tempfilename,
+	.filename=socket_filename,
+	.epoll_fd=epoll_fd,
+	.password=&password,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+  g_assert_true(queue->next_run != 0);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static
+void assert_open_and_parse_question_with_notafter(const mono_microsecs
+						  current_time,
+						  const mono_microsecs
+						  notafter,
+						  const mono_microsecs
+						  next_queue_run){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  queue->next_run = next_queue_run;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename = strdup("/tmp/mandosXXXXXX");
+  g_assert_nonnull(tempfilename);
+  int questionfile = mkostemp(tempfilename, O_CLOEXEC);
+  g_assert_cmpint(questionfile, >, 0);
+  FILE *qf = fdopen(questionfile, "w");
+  g_assert_cmpint(fprintf(qf, "[Ask]\nSocket=/nonexistent\nPID=%"
+			  PRIuMAX "\nNotAfter=%" PRIuMAX "\n",
+			  (uintmax_t)getpid(), notafter), >, 0);
+  g_assert_cmpint(fclose(qf), ==, 0);
+
+  char *const filename = strdup(tempfilename);
+  g_assert_nonnull(filename);
+  task_context task = {
+    .func=open_and_parse_question,
+    .question_filename=filename,
+    .epoll_fd=epoll_fd,
+    .password=&password,
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+  };
+  task.func(task, queue);
+
+  if(queue->length >= 1){
+    __attribute__((cleanup(cleanup_string)))
+      char *socket_filename = strdup("/nonexistent");
+    g_assert_nonnull(find_matching_task(queue, (task_context){
+	  .func=connect_question_socket,
+	  .filename=socket_filename,
+	  .epoll_fd=epoll_fd,
+	  .password=&password,
+	  .current_time=&current_time,
+	  .cancelled_filenames=&cancelled_filenames,
+	  .mandos_client_exited=&mandos_client_exited,
+	  .password_is_read=&password_is_read,
+	}));
+    g_assert_true(queue->next_run != 0);
+  }
+
+  if(notafter == 0){
+    g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+  } else if(current_time >= notafter) {
+    g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  } else {
+    g_assert_nonnull(find_matching_task(queue, (task_context){
+	  .func=cancel_old_question,
+	  .question_filename=tempfilename,
+	  .filename=tempfilename,
+	  .notafter=notafter,
+	  .cancelled_filenames=&cancelled_filenames,
+	  .current_time=&current_time,
+	}));
+  }
+  g_assert_true(queue->next_run == 1);
+
+  g_assert_cmpint(unlink(tempfilename), ==, 0);
+}
+
+static void
+test_open_and_parse_question_notafter_0(__attribute__((unused))
+					test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  /* current_time, notafter, next_queue_run */
+  assert_open_and_parse_question_with_notafter(0, 0, 0);
+}
+
+static void
+test_open_and_parse_question_notafter_1(__attribute__((unused))
+					test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  /* current_time, notafter, next_queue_run */
+  assert_open_and_parse_question_with_notafter(0, 1, 0);
+}
+
+static void
+test_open_and_parse_question_notafter_1_1(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  /* current_time, notafter, next_queue_run */
+  assert_open_and_parse_question_with_notafter(0, 1, 1);
+}
+
+static void
+test_open_and_parse_question_notafter_1_2(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  /* current_time, notafter, next_queue_run */
+  assert_open_and_parse_question_with_notafter(0, 1, 2);
+}
+
+static void
+test_open_and_parse_question_equal_notafter(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  /* current_time, notafter, next_queue_run */
+  assert_open_and_parse_question_with_notafter(1, 1, 0);
+}
+
+static void
+test_open_and_parse_question_late_notafter(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* current_time, notafter, next_queue_run */
+  assert_open_and_parse_question_with_notafter(2, 1, 0);
+}
+
+static void assert_cancel_old_question_param(const mono_microsecs
+					     next_queue_run,
+					     const mono_microsecs
+					     notafter,
+					     const mono_microsecs
+					     current_time,
+					     const mono_microsecs
+					     next_set_to){
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  queue->next_run = next_queue_run;
+
+  char *const question_filename = strdup("/nonexistent");
+  g_assert_nonnull(question_filename);
+  task_context task = {
+    .func=cancel_old_question,
+    .question_filename=question_filename,
+    .filename=question_filename,
+    .notafter=notafter,
+    .cancelled_filenames=&cancelled_filenames,
+    .current_time=&current_time,
+  };
+  task.func(task, queue);
+
+  if(current_time >= notafter){
+    g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+    g_assert_true(string_set_contains(cancelled_filenames,
+				      "/nonexistent"));
+  } else {
+    g_assert_nonnull(find_matching_task(queue, (task_context){
+	  .func=cancel_old_question,
+	  .question_filename=question_filename,
+	  .filename=question_filename,
+	  .notafter=notafter,
+	  .cancelled_filenames=&cancelled_filenames,
+	  .current_time=&current_time,
+	}));
+
+    g_assert_false(string_set_contains(cancelled_filenames,
+				       question_filename));
+  }
+  g_assert_cmpuint((unsigned int)queue->next_run, ==,
+		   (unsigned int)next_set_to);
+}
+
+static void test_cancel_old_question_0_1_2(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* next_queue_run unset,
+     cancellation should happen because time has come,
+     next_queue_run should be unchanged */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(0, 1, 2, 0);
+}
+
+static void test_cancel_old_question_0_2_1(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* If next_queue_run is 0, meaning unset, and notafter is 2,
+     and current_time is not yet notafter or greater,
+     update value of next_queue_run to value of notafter */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(0, 2, 1, 2);
+}
+
+static void test_cancel_old_question_1_2_3(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* next_queue_run 1,
+     cancellation should happen because time has come,
+     next_queue_run should be unchanged */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(1, 2, 3, 1);
+}
+
+static void test_cancel_old_question_1_3_2(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* If next_queue_run is set,
+     and current_time is not yet notafter or greater,
+     and notafter is larger than next_queue_run
+     next_queue_run should be unchanged */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(1, 3, 2, 1);
+}
+
+static void test_cancel_old_question_2_1_3(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* next_queue_run 2,
+     cancellation should happen because time has come,
+     next_queue_run should be unchanged */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(2, 1, 3, 2);
+}
+
+static void test_cancel_old_question_2_3_1(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* If next_queue_run is set,
+     and current_time is not yet notafter or greater,
+     and notafter is larger than next_queue_run
+     next_queue_run should be unchanged */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(2, 3, 1, 2);
+}
+
+static void test_cancel_old_question_3_1_2(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* next_queue_run 3,
+     cancellation should happen because time has come,
+     next_queue_run should be unchanged */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(3, 1, 2, 3);
+}
+
+static void test_cancel_old_question_3_2_1(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  /* If next_queue_run is set,
+     and current_time is not yet notafter or greater,
+     and notafter is smaller than next_queue_run
+     update value of next_queue_run to value of notafter */
+  /* next_queue_run, notafter, current_time, next_set_to */
+  assert_cancel_old_question_param(3, 2, 1, 2);
+}
+
+static void
+test_connect_question_socket_name_too_long(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const char question_filename[] = "/nonexistent/question";
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  struct sockaddr_un unix_socket = { .sun_family=AF_LOCAL };
+  char socket_name[sizeof(unix_socket.sun_path)];
+  memset(socket_name, 'x', sizeof(socket_name));
+  socket_name[sizeof(socket_name)-1] = '\0';
+  char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", tempdir, socket_name),
+		  >, 0);
+  g_assert_nonnull(filename);
+
+  task_context task = {
+    .func=connect_question_socket,
+    .question_filename=strdup(question_filename),
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+    .current_time=(mono_microsecs[]){0},
+  };
+  g_assert_nonnull(task.question_filename);
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_true(string_set_contains(cancelled_filenames,
+				    question_filename));
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(queue->next_run == 0);
+
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static
+void test_connect_question_socket_connect_fail(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const char question_filename[] = "/nonexistent/question";
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 3;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  char socket_name[] = "nonexistent";
+  char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", tempdir, socket_name),
+		  >, 0);
+  g_assert_nonnull(filename);
+
+  task_context task = {
+    .func=connect_question_socket,
+    .question_filename=strdup(question_filename),
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=filename,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+    .current_time=&current_time,
+  };
+  g_assert_nonnull(task.question_filename);
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_nonnull(find_matching_task(queue, task));
+
+  g_assert_false(string_set_contains(cancelled_filenames,
+				     question_filename));
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+  g_assert_true(queue->next_run == 1000000 + current_time);
+
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static
+void test_connect_question_socket_bad_epoll(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = open("/dev/null",
+			      O_WRONLY | O_CLOEXEC | O_NOCTTY);
+  __attribute__((cleanup(cleanup_string)))
+    char *const question_filename = strdup("/nonexistent/question");
+  g_assert_nonnull(question_filename);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 5;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  __attribute__((cleanup(cleanup_close)))
+    const int sock_fd = socket(PF_LOCAL, SOCK_DGRAM
+			       | SOCK_NONBLOCK | SOCK_CLOEXEC, 0);
+  g_assert_cmpint(sock_fd, >=, 0);
+  struct sockaddr_un sock_name = { .sun_family=AF_LOCAL };
+  const char socket_name[] = "socket_name";
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", tempdir, socket_name),
+		  >, 0);
+  g_assert_nonnull(filename);
+  g_assert_cmpint((int)strlen(filename), <,
+		  (int)sizeof(sock_name.sun_path));
+  strncpy(sock_name.sun_path, filename, sizeof(sock_name.sun_path));
+  sock_name.sun_path[sizeof(sock_name.sun_path)-1] = '\0';
+  g_assert_cmpint((int)bind(sock_fd, (struct sockaddr *)&sock_name,
+			    (socklen_t)SUN_LEN(&sock_name)), >=, 0);
+  task_context task = {
+    .func=connect_question_socket,
+    .question_filename=strdup(question_filename),
+    .epoll_fd=epoll_fd,
+    .password=(buffer[]){{}},
+    .filename=strdup(filename),
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+    .current_time=&current_time,
+  };
+  g_assert_nonnull(task.question_filename);
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+  const task_context *const added_task
+    = find_matching_task(queue, task);
+  g_assert_nonnull(added_task);
+  g_assert_true(queue->next_run == 1000000 + current_time);
+
+  g_assert_cmpint(unlink(filename), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static
+void test_connect_question_socket_usable(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_string)))
+    char *const question_filename = strdup("/nonexistent/question");
+  g_assert_nonnull(question_filename);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  const mono_microsecs current_time = 0;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  __attribute__((cleanup(cleanup_close)))
+    const int sock_fd = socket(PF_LOCAL, SOCK_DGRAM
+			       | SOCK_NONBLOCK | SOCK_CLOEXEC, 0);
+  g_assert_cmpint(sock_fd, >=, 0);
+  struct sockaddr_un sock_name = { .sun_family=AF_LOCAL };
+  const char socket_name[] = "socket_name";
+  __attribute__((cleanup(cleanup_string)))
+    char *filename = NULL;
+  g_assert_cmpint(asprintf(&filename, "%s/%s", tempdir, socket_name),
+		  >, 0);
+  g_assert_nonnull(filename);
+  g_assert_cmpint((int)strlen(filename), <,
+		  (int)sizeof(sock_name.sun_path));
+  strncpy(sock_name.sun_path, filename, sizeof(sock_name.sun_path));
+  sock_name.sun_path[sizeof(sock_name.sun_path)-1] = '\0';
+  g_assert_cmpint((int)bind(sock_fd, (struct sockaddr *)&sock_name,
+			    (socklen_t)SUN_LEN(&sock_name)), >=, 0);
+  task_context task = {
+    .func=connect_question_socket,
+    .question_filename=strdup(question_filename),
+    .epoll_fd=epoll_fd,
+    .password=&password,
+    .filename=strdup(filename),
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=&mandos_client_exited,
+    .password_is_read=&password_is_read,
+    .current_time=&current_time,
+  };
+  g_assert_nonnull(task.question_filename);
+  task.func(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+  const task_context *const added_task
+    = find_matching_task(queue, (task_context){
+	.func=send_password_to_socket,
+	.question_filename=question_filename,
+	.filename=filename,
+	.epoll_fd=epoll_fd,
+	.password=&password,
+	.cancelled_filenames=&cancelled_filenames,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+	.current_time=&current_time,
+      });
+  g_assert_nonnull(added_task);
+  g_assert_cmpint(added_task->fd, >, 0);
+
+  g_assert_true(epoll_set_contains(epoll_fd, added_task->fd,
+				   EPOLLOUT));
+
+  const int fd = added_task->fd;
+  g_assert_cmpint(fd, >, 0);
+  g_assert_true(fd_has_cloexec_and_nonblock(fd));
+
+  /* write to fd */
+  char write_data[PIPE_BUF];
+  {
+    /* Construct test password buffer */
+    /* Start with + since that is what the real protocol uses */
+    write_data[0] = '+';
+    /* Set a special character at string end just to mark the end */
+    write_data[sizeof(write_data)-2] = 'y';
+    /* Set NUL at buffer end, as suggested by the protocol */
+    write_data[sizeof(write_data)-1] = '\0';
+    /* Fill rest of password with 'x' */
+    memset(write_data+1, 'x', sizeof(write_data)-3);
+    g_assert_cmpint((int)send(fd, write_data, sizeof(write_data),
+			      MSG_NOSIGNAL), ==, sizeof(write_data));
+  }
+
+  /* read from sock_fd */
+  char read_data[sizeof(write_data)];
+  g_assert_cmpint((int)read(sock_fd, read_data, sizeof(read_data)),
+		  ==, sizeof(read_data));
+
+  g_assert_true(memcmp(write_data, read_data, sizeof(write_data))
+		== 0);
+
+  /* writing to sock_fd should fail */
+  g_assert_cmpint(send(sock_fd, write_data, sizeof(write_data),
+		       MSG_NOSIGNAL), <, 0);
+
+  /* reading from fd should fail */
+  g_assert_cmpint((int)recv(fd, read_data, sizeof(read_data),
+			    MSG_NOSIGNAL), <, 0);
+
+  g_assert_cmpint(unlink(filename), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static void
+test_send_password_to_socket_client_not_exited(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_string)))
+    char *const question_filename = strdup("/nonexistent/question");
+  g_assert_nonnull(question_filename);
+  __attribute__((cleanup(cleanup_string)))
+    char *const filename = strdup("/nonexistent/socket");
+  g_assert_nonnull(filename);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  bool password_is_read = true;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  int socketfds[2];
+  g_assert_cmpint(socketpair(PF_LOCAL, SOCK_DGRAM
+			     | SOCK_NONBLOCK | SOCK_CLOEXEC, 0,
+			     socketfds), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_socket = socketfds[0];
+  const int write_socket = socketfds[1];
+  task_context task = {
+    .func=send_password_to_socket,
+    .question_filename=strdup(question_filename),
+    .filename=strdup(filename),
+    .epoll_fd=epoll_fd,
+    .fd=write_socket,
+    .password=&password,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=&password_is_read,
+    .current_time=(mono_microsecs[]){0},
+  };
+  g_assert_nonnull(task.question_filename);
+
+  task.func(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  const task_context *const added_task
+    = find_matching_task(queue, task);
+  g_assert_nonnull(added_task);
+  g_assert_cmpuint((unsigned int)password.length, ==, 0);
+  g_assert_true(password_is_read);
+
+  g_assert_cmpint(added_task->fd, >, 0);
+  g_assert_true(epoll_set_contains(epoll_fd, added_task->fd,
+				   EPOLLOUT));
+}
+
+static void
+test_send_password_to_socket_password_not_read(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_string)))
+    char *const question_filename = strdup("/nonexistent/question");
+  g_assert_nonnull(question_filename);
+  __attribute__((cleanup(cleanup_string)))
+    char *const filename = strdup("/nonexistent/socket");
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  buffer password = {};
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  int socketfds[2];
+  g_assert_cmpint(socketpair(PF_LOCAL, SOCK_DGRAM
+			     | SOCK_NONBLOCK | SOCK_CLOEXEC, 0,
+			     socketfds), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_socket = socketfds[0];
+  const int write_socket = socketfds[1];
+  task_context task = {
+    .func=send_password_to_socket,
+    .question_filename=strdup(question_filename),
+    .filename=strdup(filename),
+    .epoll_fd=epoll_fd,
+    .fd=write_socket,
+    .password=&password,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){false},
+    .password_is_read=(bool[]){false},
+    .current_time=(mono_microsecs[]){0},
+  };
+  g_assert_nonnull(task.question_filename);
+
+  task.func(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  const task_context *const added_task = find_matching_task(queue,
+							    task);
+  g_assert_nonnull(added_task);
+  g_assert_cmpuint((unsigned int)password.length, ==, 0);
+  g_assert_true(queue->next_run == 0);
+
+  g_assert_cmpint(added_task->fd, >, 0);
+  g_assert_true(epoll_set_contains(epoll_fd, added_task->fd,
+				   EPOLLOUT));
+}
+
+static
+void test_send_password_to_socket_EMSGSIZE(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  const char question_filename[] = "/nonexistent/question";
+  char *const filename = strdup("/nonexistent/socket");
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  int socketfds[2];
+
+  /* Find a message size which triggers EMSGSIZE */
+  __attribute__((cleanup(cleanup_string)))
+    char *message_buffer = NULL;
+  size_t message_size = PIPE_BUF + 1;
+  for(ssize_t ssret = 0; ssret >= 0; message_size += 1024){
+    if(message_size >= 1024*1024*1024){ /* 1 GiB */
+      g_test_skip("Skipping EMSGSIZE test: Will not try 1GiB");
+      return;
+    }
+    message_buffer = realloc(message_buffer, message_size);
+    if(message_buffer == NULL){
+      g_test_skip("Skipping EMSGSIZE test");
+      g_test_message("Failed to malloc() %" PRIuMAX " bytes",
+		     (uintmax_t)message_size);
+      return;
+    }
+    /* Fill buffer with 'x' */
+    memset(message_buffer, 'x', message_size);
+    /* Create a new socketpair for each message size to avoid having
+       to empty the pipe by reading the message to a separate buffer
+    */
+    g_assert_cmpint(socketpair(PF_LOCAL, SOCK_DGRAM
+			       | SOCK_NONBLOCK | SOCK_CLOEXEC, 0,
+			       socketfds), ==, 0);
+    ssret = send(socketfds[1], message_buffer, message_size,
+		 MSG_NOSIGNAL);
+    error_t saved_errno = errno;
+    g_assert_cmpint(close(socketfds[0]), ==, 0);
+    g_assert_cmpint(close(socketfds[1]), ==, 0);
+
+    if(ssret < 0){
+      if(saved_errno != EMSGSIZE) {
+	g_test_skip("Skipping EMSGSIZE test");
+	g_test_message("Error on send(%" PRIuMAX " bytes): %s",
+		       (uintmax_t)message_size,
+		       strerror(saved_errno));
+	return;
+      }
+      break;
+    } else if(ssret != (ssize_t)message_size){
+      g_test_skip("Skipping EMSGSIZE test");
+      g_test_message("Partial send(): %" PRIuMAX " of %" PRIdMAX
+		     " bytes", (uintmax_t)ssret,
+		     (intmax_t)message_size);
+      return;
+    }
+  }
+  g_test_message("EMSGSIZE triggered by %" PRIdMAX " bytes",
+		 (intmax_t)message_size);
+
+  buffer password = {
+    .data=message_buffer,
+    .length=message_size - 2,	/* Compensate for added '+' and NUL */
+    .allocated=message_size,
+  };
+  if(mlock(password.data, password.allocated) != 0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  g_assert_cmpint(socketpair(PF_LOCAL, SOCK_DGRAM
+			     | SOCK_NONBLOCK | SOCK_CLOEXEC, 0,
+			     socketfds), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_socket = socketfds[0];
+  __attribute__((cleanup(cleanup_close)))
+    const int write_socket = socketfds[1];
+  task_context task = {
+    .func=send_password_to_socket,
+    .question_filename=strdup(question_filename),
+    .filename=filename,
+    .epoll_fd=epoll_fd,
+    .fd=write_socket,
+    .password=&password,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){true},
+    .password_is_read=(bool[]){true},
+    .current_time=(mono_microsecs[]){0},
+  };
+  g_assert_nonnull(task.question_filename);
+
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+  g_assert_true(string_set_contains(cancelled_filenames,
+				    question_filename));
+}
+
+static void test_send_password_to_socket_retry(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_string)))
+    char *const question_filename = strdup("/nonexistent/question");
+  g_assert_nonnull(question_filename);
+  __attribute__((cleanup(cleanup_string)))
+    char *const filename = strdup("/nonexistent/socket");
+  g_assert_nonnull(filename);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  int socketfds[2];
+  g_assert_cmpint(socketpair(PF_LOCAL, SOCK_DGRAM
+			     | SOCK_NONBLOCK | SOCK_CLOEXEC, 0,
+			     socketfds), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_socket = socketfds[0];
+  const int write_socket = socketfds[1];
+  /* Close the server side socket to force ECONNRESET on client */
+  g_assert_cmpint(close(read_socket), ==, 0);
+  task_context task = {
+    .func=send_password_to_socket,
+    .question_filename=strdup(question_filename),
+    .filename=strdup(filename),
+    .epoll_fd=epoll_fd,
+    .fd=write_socket,
+    .password=&password,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){true},
+    .password_is_read=(bool[]){true},
+    .current_time=(mono_microsecs[]){0},
+  };
+  g_assert_nonnull(task.question_filename);
+
+  task.func(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  const task_context *const added_task = find_matching_task(queue,
+							    task);
+  g_assert_nonnull(added_task);
+  g_assert_cmpuint((unsigned int)password.length, ==, 0);
+
+  g_assert_true(epoll_set_contains(epoll_fd, added_task->fd,
+				   EPOLLOUT));
+}
+
+static
+void test_send_password_to_socket_bad_epoll(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = open("/dev/null",
+			      O_WRONLY | O_CLOEXEC | O_NOCTTY);
+  __attribute__((cleanup(cleanup_string)))
+    char *const question_filename = strdup("/nonexistent/question");
+  g_assert_nonnull(question_filename);
+  __attribute__((cleanup(cleanup_string)))
+    char *const filename = strdup("/nonexistent/socket");
+  g_assert_nonnull(filename);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+
+  const mono_microsecs current_time = 11;
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  int socketfds[2];
+  g_assert_cmpint(socketpair(PF_LOCAL, SOCK_DGRAM
+			     | SOCK_NONBLOCK | SOCK_CLOEXEC, 0,
+			     socketfds), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_socket = socketfds[0];
+  const int write_socket = socketfds[1];
+  /* Close the server side socket to force ECONNRESET on client */
+  g_assert_cmpint(close(read_socket), ==, 0);
+  task_context task = {
+    .func=send_password_to_socket,
+    .question_filename=strdup(question_filename),
+    .filename=strdup(filename),
+    .epoll_fd=epoll_fd,
+    .fd=write_socket,
+    .password=&password,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){true},
+    .password_is_read=(bool[]){true},
+    .current_time=&current_time,
+  };
+  g_assert_nonnull(task.question_filename);
+
+  run_task_with_stderr_to_dev_null(task, queue);
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  const task_context *const added_task = find_matching_task(queue,
+							    task);
+  g_assert_nonnull(added_task);
+  g_assert_true(queue->next_run == current_time + 1000000);
+  g_assert_cmpuint((unsigned int)password.length, ==, 0);
+}
+
+static void assert_send_password_to_socket_password(buffer password){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  char *const question_filename = strdup("/nonexistent/question");
+  g_assert_nonnull(question_filename);
+  char *const filename = strdup("/nonexistent/socket");
+  g_assert_nonnull(filename);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  int socketfds[2];
+  g_assert_cmpint(socketpair(PF_LOCAL, SOCK_DGRAM
+			     | SOCK_NONBLOCK | SOCK_CLOEXEC, 0,
+			     socketfds), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_socket = socketfds[0];
+  const int write_socket = socketfds[1];
+  task_context task = {
+    .func=send_password_to_socket,
+    .question_filename=question_filename,
+    .filename=filename,
+    .epoll_fd=epoll_fd,
+    .fd=write_socket,
+    .password=&password,
+    .cancelled_filenames=&cancelled_filenames,
+    .mandos_client_exited=(bool[]){true},
+    .password_is_read=(bool[]){true},
+    .current_time=(mono_microsecs[]){0},
+  };
+
+  char *expected_written_data = malloc(password.length + 2);
+  g_assert_nonnull(expected_written_data);
+  expected_written_data[0] = '+';
+  expected_written_data[password.length + 1] = '\0';
+  if(password.length > 0){
+    g_assert_nonnull(password.data);
+    memcpy(expected_written_data + 1, password.data, password.length);
+  }
+
+  task.func(task, queue);
+
+  char buf[PIPE_BUF];
+  g_assert_cmpint((int)read(read_socket, buf, PIPE_BUF), ==,
+		  (int)(password.length + 2));
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_true(memcmp(expected_written_data, buf,
+		       password.length + 2) == 0);
+
+  g_assert_true(epoll_set_does_not_contain(epoll_fd, write_socket));
+
+  free(expected_written_data);
+}
+
+static void
+test_send_password_to_socket_null_password(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  assert_send_password_to_socket_password(password);
+}
+
+static void
+test_send_password_to_socket_empty_password(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {
+    .data=malloc(1),	       /* because malloc(0) may return NULL */
+    .length=0,
+    .allocated=0,		/* deliberate lie */
+  };
+  g_assert_nonnull(password.data);
+  assert_send_password_to_socket_password(password);
+}
+
+static void
+test_send_password_to_socket_empty_str_pass(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {
+    .data=strdup(""),
+    .length=0,
+    .allocated=1,
+  };
+  if(mlock(password.data, password.allocated) != 0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+  assert_send_password_to_socket_password(password);
+}
+
+static void
+test_send_password_to_socket_text_password(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  const char dummy_test_password[] = "dummy test password";
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {
+    .data = strdup(dummy_test_password),
+    .length = strlen(dummy_test_password),
+    .allocated = sizeof(dummy_test_password),
+  };
+  if(mlock(password.data, password.allocated) != 0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+  assert_send_password_to_socket_password(password);
+}
+
+static void
+test_send_password_to_socket_binary_password(__attribute__((unused))
+					     test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {
+    .data=malloc(255),
+    .length=255,
+    .allocated=255,
+  };
+  g_assert_nonnull(password.data);
+  if(mlock(password.data, password.allocated) != 0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+  char c = 1;			/* Start at 1, avoiding NUL */
+  for(int i=0; i < 255; i++){
+    password.data[i] = c++;
+  }
+  assert_send_password_to_socket_password(password);
+}
+
+static void
+test_send_password_to_socket_nuls_in_password(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  char test_password[] = {'\0', 'a', '\0', 'b', '\0', 'c', '\0'};
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {
+    .data=malloc(sizeof(test_password)),
+    .length=sizeof(test_password),
+    .allocated=sizeof(test_password),
+  };
+  g_assert_nonnull(password.data);
+  if(mlock(password.data, password.allocated) !=0){
+    g_assert_true(errno == EPERM or errno == ENOMEM);
+  }
+  memcpy(password.data, test_password, password.allocated);
+  assert_send_password_to_socket_password(password);
+}
+
+static bool assert_add_existing_questions_to_devnull(task_queue
+						     *const,
+						     const int,
+						     buffer *const,
+						     string_set *,
+						     const
+						     mono_microsecs
+						     *const,
+						     bool *const,
+						     bool *const,
+						     const char
+						     *const);
+
+static void test_add_existing_questions_ENOENT(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+
+  g_assert_false(assert_add_existing_questions_to_devnull
+		 (queue,
+		  epoll_fd,
+		  (buffer[]){{}}, /* password */
+		  &cancelled_filenames,
+		  (mono_microsecs[]){0}, /* current_time */
+		  (bool[]){false},	 /* mandos_client_exited */
+		  (bool[]){false},	 /* password_is_read */
+		  "/nonexistent"));	 /* dirname */
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+}
+
+static
+bool assert_add_existing_questions_to_devnull(task_queue
+					      *const queue,
+					      const int
+					      epoll_fd,
+					      buffer *const
+					      password,
+					      string_set
+					      *cancelled_filenames,
+					      const mono_microsecs
+					      *const current_time,
+					      bool *const
+					      mandos_client_exited,
+					      bool *const
+					      password_is_read,
+					      const char *const
+					      dirname){
+  __attribute__((cleanup(cleanup_close)))
+    const int devnull_fd = open("/dev/null",
+				O_WRONLY | O_CLOEXEC | O_NOCTTY);
+  g_assert_cmpint(devnull_fd, >=, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int real_stderr_fd = dup(STDERR_FILENO);
+  g_assert_cmpint(real_stderr_fd, >=, 0);
+  dup2(devnull_fd, STDERR_FILENO);
+  const bool ret = add_existing_questions(queue, epoll_fd, password,
+					  cancelled_filenames,
+					  current_time,
+					  mandos_client_exited,
+					  password_is_read, dirname);
+  dup2(real_stderr_fd, STDERR_FILENO);
+  return ret;
+}
+
+static
+void test_add_existing_questions_no_questions(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+
+  g_assert_false(assert_add_existing_questions_to_devnull
+		 (queue,
+		  epoll_fd,
+		  (buffer[]){{}}, /* password */
+		  &cancelled_filenames,
+		  (mono_microsecs[]){0}, /* current_time */
+		  (bool[]){false},	 /* mandos_client_exited */
+		  (bool[]){false},	 /* password_is_read */
+		  tempdir));
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static char *make_question_file_in_directory(const char *const);
+
+static
+void test_add_existing_questions_one_question(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  __attribute__((cleanup(cleanup_string)))
+    char *question_filename
+    = make_question_file_in_directory(tempdir);
+  g_assert_nonnull(question_filename);
+
+  g_assert_true(assert_add_existing_questions_to_devnull
+		(queue,
+		 epoll_fd,
+		 &password,
+		 &cancelled_filenames,
+		 &current_time,
+		 &mandos_client_exited,
+		 &password_is_read,
+		 tempdir));
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=open_and_parse_question,
+	.epoll_fd=epoll_fd,
+	.filename=question_filename,
+	.question_filename=question_filename,
+	.password=&password,
+	.cancelled_filenames=&cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(queue->next_run == 1);
+
+  g_assert_cmpint(unlink(question_filename), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static char *make_question_file_in_directory(const char
+					     *const dir){
+  return make_temporary_prefixed_file_in_directory("ask.", dir);
+}
+
+static
+void test_add_existing_questions_two_questions(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  __attribute__((cleanup(cleanup_string)))
+    char *question_filename1
+    = make_question_file_in_directory(tempdir);
+  g_assert_nonnull(question_filename1);
+  __attribute__((cleanup(cleanup_string)))
+    char *question_filename2
+    = make_question_file_in_directory(tempdir);
+  g_assert_nonnull(question_filename2);
+
+  g_assert_true(assert_add_existing_questions_to_devnull
+		(queue,
+		 epoll_fd,
+		 &password,
+		 &cancelled_filenames,
+		 &current_time,
+		 &mandos_client_exited,
+		 &password_is_read,
+		 tempdir));
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 2);
+
+  g_assert_true(queue->next_run == 1);
+
+  __attribute__((cleanup(string_set_clear)))
+    string_set seen_questions = {};
+
+  bool queue_contains_question_opener(char *const question_filename){
+    return(find_matching_task(queue, (task_context){
+	  .func=open_and_parse_question,
+	  .epoll_fd=epoll_fd,
+	  .question_filename=question_filename,
+	  .password=&password,
+	  .cancelled_filenames=&cancelled_filenames,
+	  .current_time=&current_time,
+	  .mandos_client_exited=&mandos_client_exited,
+	  .password_is_read=&password_is_read,
+	}) != NULL);
+  }
+
+  g_assert_true(queue_contains_question_opener(question_filename1));
+  g_assert_true(queue_contains_question_opener(question_filename2));
+
+  g_assert_true(queue->next_run == 1);
+
+  g_assert_cmpint(unlink(question_filename1), ==, 0);
+  g_assert_cmpint(unlink(question_filename2), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static void
+test_add_existing_questions_non_questions(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  __attribute__((cleanup(cleanup_string)))
+    char *question_filename1
+    = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(question_filename1);
+  __attribute__((cleanup(cleanup_string)))
+    char *question_filename2
+    = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(question_filename2);
+
+  g_assert_false(assert_add_existing_questions_to_devnull
+		 (queue,
+		  epoll_fd,
+		  (buffer[]){{}}, /* password */
+		  &cancelled_filenames,
+		  (mono_microsecs[]){0}, /* current_time */
+		  (bool[]){false},	 /* mandos_client_exited */
+		  (bool[]){false},	 /* password_is_read */
+		  tempdir));
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 0);
+
+  g_assert_cmpint(unlink(question_filename1), ==, 0);
+  g_assert_cmpint(unlink(question_filename2), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static void
+test_add_existing_questions_both_types(__attribute__((unused))
+				       test_fixture *fixture,
+				       __attribute__((unused))
+				       gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  __attribute__((cleanup(cleanup_buffer)))
+    buffer password = {};
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  const mono_microsecs current_time = 0;
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+  __attribute__((cleanup(cleanup_string)))
+    char *tempdir = make_temporary_directory();
+  g_assert_nonnull(tempdir);
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename1 = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(tempfilename1);
+  __attribute__((cleanup(cleanup_string)))
+    char *tempfilename2 = make_temporary_file_in_directory(tempdir);
+  g_assert_nonnull(tempfilename2);
+  __attribute__((cleanup(cleanup_string)))
+    char *question_filename
+    = make_question_file_in_directory(tempdir);
+  g_assert_nonnull(question_filename);
+
+  g_assert_true(assert_add_existing_questions_to_devnull
+		(queue,
+		 epoll_fd,
+		 &password,
+		 &cancelled_filenames,
+		 &current_time,
+		 &mandos_client_exited,
+		 &password_is_read,
+		 tempdir));
+
+  g_assert_cmpuint((unsigned int)queue->length, ==, 1);
+
+  g_assert_nonnull(find_matching_task(queue, (task_context){
+	.func=open_and_parse_question,
+	.epoll_fd=epoll_fd,
+	.filename=question_filename,
+	.question_filename=question_filename,
+	.password=&password,
+	.cancelled_filenames=&cancelled_filenames,
+	.current_time=&current_time,
+	.mandos_client_exited=&mandos_client_exited,
+	.password_is_read=&password_is_read,
+      }));
+
+  g_assert_true(queue->next_run == 1);
+
+  g_assert_cmpint(unlink(tempfilename1), ==, 0);
+  g_assert_cmpint(unlink(tempfilename2), ==, 0);
+  g_assert_cmpint(unlink(question_filename), ==, 0);
+  g_assert_cmpint(rmdir(tempdir), ==, 0);
+}
+
+static void test_wait_for_event_timeout(__attribute__((unused))
+					test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  g_assert_true(wait_for_event(epoll_fd, 1, 0));
+}
+
+static void test_wait_for_event_event(__attribute__((unused))
+				      test_fixture *fixture,
+				      __attribute__((unused))
+				      gconstpointer user_data){
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_pipe = pipefds[0];
+  __attribute__((cleanup(cleanup_close)))
+    const int write_pipe = pipefds[1];
+  g_assert_cmpint(epoll_ctl(epoll_fd, EPOLL_CTL_ADD, read_pipe,
+			    &(struct epoll_event)
+			    { .events=EPOLLIN | EPOLLRDHUP }), ==, 0);
+  g_assert_cmpint((int)write(write_pipe, "x", 1), ==, 1);
+
+  g_assert_true(wait_for_event(epoll_fd, 0, 0));
+}
+
+static void test_wait_for_event_sigchld(test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  const pid_t pid = fork();
+  if(pid == 0){		/* Child */
+    if(not restore_signal_handler(&fixture->orig_sigaction)){
+      _exit(EXIT_FAILURE);
+    }
+    if(not restore_sigmask(&fixture->orig_sigmask)){
+      _exit(EXIT_FAILURE);
+    }
+    exit(EXIT_SUCCESS);
+  }
+  g_assert_true(pid != -1);
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  g_assert_cmpint(epoll_fd, >=, 0);
+
+  g_assert_true(wait_for_event(epoll_fd, 0, 0));
+
+  int status;
+  g_assert_true(waitpid(pid, &status, 0) == pid);
+  g_assert_true(WIFEXITED(status));
+  g_assert_cmpint(WEXITSTATUS(status), ==, EXIT_SUCCESS);
+}
+
+static void test_run_queue_zeroes_next_run(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  queue->next_run = 1;
+  __attribute__((cleanup(cleanup_close)))
+    const int epoll_fd = epoll_create1(EPOLL_CLOEXEC);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  bool quit_now = false;
+
+  g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)queue->next_run, ==, 0);
+}
+
+static
+void test_run_queue_clears_cancelled_filenames(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  bool quit_now = false;
+  const char question_filename[] = "/nonexistent/question_filename";
+  g_assert_true(string_set_add(&cancelled_filenames,
+			       question_filename));
+
+  g_assert_true(add_to_queue(queue,
+			     (task_context){ .func=dummy_func }));
+
+  g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)(queue->length), ==, 0);
+  g_assert_false(string_set_contains(cancelled_filenames,
+				     question_filename));
+}
+
+static
+void test_run_queue_skips_cancelled_filenames(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  bool quit_now = false;
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_pipe = pipefds[0];
+  g_assert_cmpint(close(pipefds[1]), ==, 0);
+  const char question_filename[] = "/nonexistent/question_filename";
+  g_assert_true(string_set_add(&cancelled_filenames,
+			       question_filename));
+  __attribute__((nonnull))
+    void quit_func(const task_context task,
+		   __attribute__((unused)) task_queue *const q){
+    g_assert_nonnull(task.quit_now);
+    *task.quit_now = true;
+  }
+  task_context task = {
+    .func=quit_func,
+    .question_filename=strdup(question_filename),
+    .quit_now=&quit_now,
+    .fd=read_pipe,
+  };
+  g_assert_nonnull(task.question_filename);
+
+  g_assert_true(add_to_queue(queue, task));
+
+  g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+  g_assert_false(quit_now);
+
+  /* read_pipe should be closed already */
+  errno = 0;
+  bool read_pipe_closed = (close(read_pipe) == -1);
+  read_pipe_closed &= (errno == EBADF);
+  g_assert_true(read_pipe_closed);
+}
+
+static void test_run_queue_one_task(__attribute__((unused))
+				    test_fixture *fixture,
+				    __attribute__((unused))
+				    gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  bool quit_now = false;
+
+  __attribute__((nonnull))
+    void next_run_func(__attribute__((unused))
+		       const task_context task,
+		       task_queue *const q){
+    q->next_run = 1;
+  }
+
+  task_context task = {
+    .func=next_run_func,
+  };
+  g_assert_true(add_to_queue(queue, task));
+
+  g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+  g_assert_cmpuint((unsigned int)(queue->next_run), ==, 1);
+  g_assert_cmpuint((unsigned int)(queue->length), ==, 0);
+}
+
+static void test_run_queue_two_tasks(__attribute__((unused))
+				     test_fixture *fixture,
+				     __attribute__((unused))
+				     gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  queue->next_run = 1;
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  bool quit_now = false;
+  bool mandos_client_exited = false;
+
+  __attribute__((nonnull))
+    void next_run_func(__attribute__((unused))
+		       const task_context task,
+		       task_queue *const q){
+    q->next_run = 1;
+  }
+
+  __attribute__((nonnull))
+    void exited_func(const task_context task,
+		     __attribute__((unused)) task_queue *const q){
+    *task.mandos_client_exited = true;
+  }
+
+  task_context task1 = {
+    .func=next_run_func,
+  };
+  g_assert_true(add_to_queue(queue, task1));
+
+  task_context task2 = {
+    .func=exited_func,
+    .mandos_client_exited=&mandos_client_exited,
+  };
+  g_assert_true(add_to_queue(queue, task2));
+
+  g_assert_true(run_queue(&queue, &cancelled_filenames, &quit_now));
+  g_assert_false(quit_now);
+  g_assert_cmpuint((unsigned int)(queue->next_run), ==, 1);
+  g_assert_true(mandos_client_exited);
+  g_assert_cmpuint((unsigned int)(queue->length), ==, 0);
+}
+
+static void test_run_queue_two_tasks_quit(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  bool quit_now = false;
+  bool mandos_client_exited = false;
+  bool password_is_read = false;
+
+  __attribute__((nonnull))
+    void set_exited_func(const task_context task,
+			 __attribute__((unused)) task_queue *const q){
+    *task.mandos_client_exited = true;
+    *task.quit_now = true;
+  }
+  task_context task1 = {
+    .func=set_exited_func,
+    .quit_now=&quit_now,
+    .mandos_client_exited=&mandos_client_exited,
+  };
+  g_assert_true(add_to_queue(queue, task1));
+
+  __attribute__((nonnull))
+    void set_read_func(const task_context task,
+		       __attribute__((unused)) task_queue *const q){
+    *task.quit_now = true;
+    *task.password_is_read = true;
+  }
+  task_context task2 = {
+    .func=set_read_func,
+    .quit_now=&quit_now,
+    .password_is_read=&password_is_read,
+  };
+  g_assert_true(add_to_queue(queue, task2));
+
+  g_assert_false(run_queue(&queue, &cancelled_filenames, &quit_now));
+  g_assert_true(quit_now);
+  g_assert_true(mandos_client_exited xor password_is_read);
+  g_assert_cmpuint((unsigned int)(queue->length), ==, 0);
+}
+
+static void test_run_queue_two_tasks_cleanup(__attribute__((unused))
+					     test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  __attribute__((cleanup(cleanup_queue)))
+    task_queue *queue = create_queue();
+  g_assert_nonnull(queue);
+  __attribute__((cleanup(string_set_clear)))
+    string_set cancelled_filenames = {};
+  int pipefds[2];
+  g_assert_cmpint(pipe2(pipefds, O_CLOEXEC | O_NONBLOCK), ==, 0);
+  __attribute__((cleanup(cleanup_close)))
+    const int read_pipe = pipefds[0];
+  __attribute__((cleanup(cleanup_close)))
+    const int write_pipe = pipefds[1];
+  bool quit_now = false;
+
+  __attribute__((nonnull))
+    void read_func(const task_context task,
+		   __attribute__((unused)) task_queue *const q){
+    *task.quit_now = true;
+  }
+  task_context task1 = {
+    .func=read_func,
+    .quit_now=&quit_now,
+    .fd=read_pipe,
+  };
+  g_assert_true(add_to_queue(queue, task1));
+
+  __attribute__((nonnull))
+    void write_func(const task_context task,
+		    __attribute__((unused)) task_queue *const q){
+    *task.quit_now = true;
+  }
+  task_context task2 = {
+    .func=write_func,
+    .quit_now=&quit_now,
+    .fd=write_pipe,
+  };
+  g_assert_true(add_to_queue(queue, task2));
+
+  g_assert_false(run_queue(&queue, &cancelled_filenames, &quit_now));
+  g_assert_true(quit_now);
+
+  /* Either read_pipe or write_pipe should be closed already */
+  errno = 0;
+  bool close_read_pipe = (close(read_pipe) == -1);
+  close_read_pipe &= (errno == EBADF);
+  errno = 0;
+  bool close_write_pipe = (close(write_pipe) == -1);
+  close_write_pipe &= (errno == EBADF);
+  g_assert_true(close_read_pipe xor close_write_pipe);
+  g_assert_cmpuint((unsigned int)(queue->length), ==, 0);
+}
+
+static void test_setup_signal_handler(__attribute__((unused))
+				      test_fixture *fixture,
+				      __attribute__((unused))
+				      gconstpointer user_data){
+  /* Save current SIGCHLD action, whatever it is */
+  struct sigaction expected_sigchld_action;
+  g_assert_cmpint(sigaction(SIGCHLD, NULL, &expected_sigchld_action),
+		  ==, 0);
+
+  /* Act; i.e. run the setup_signal_handler() function */
+  struct sigaction actual_old_sigchld_action;
+  g_assert_true(setup_signal_handler(&actual_old_sigchld_action));
+
+  /* Check that the function correctly set "actual_old_sigchld_action"
+     to the same values as the previously saved
+     "expected_sigchld_action" */
+  /* Check member sa_handler */
+  g_assert_true(actual_old_sigchld_action.sa_handler
+		== expected_sigchld_action.sa_handler);
+  /* Check member sa_mask */
+  for(int signum = 1; signum < NSIG; signum++){
+    const int expected_old_block_state
+      = sigismember(&expected_sigchld_action.sa_mask, signum);
+    g_assert_cmpint(expected_old_block_state, >=, 0);
+    const int actual_old_block_state
+      = sigismember(&actual_old_sigchld_action.sa_mask, signum);
+    g_assert_cmpint(actual_old_block_state, >=, 0);
+    g_assert_cmpint(actual_old_block_state,
+		    ==, expected_old_block_state);
+  }
+  /* Check member sa_flags */
+  g_assert_true((actual_old_sigchld_action.sa_flags
+		 & (SA_NOCLDSTOP | SA_ONSTACK | SA_RESTART))
+		== (expected_sigchld_action.sa_flags
+		    & (SA_NOCLDSTOP | SA_ONSTACK | SA_RESTART)));
+
+  /* Retrieve the current signal handler for SIGCHLD as set by
+     setup_signal_handler() */
+  struct sigaction actual_new_sigchld_action;
+  g_assert_cmpint(sigaction(SIGCHLD, NULL,
+			    &actual_new_sigchld_action), ==, 0);
+  /* Check that the signal handler (member sa_handler) is correctly
+     set to the "handle_sigchld" function */
+  g_assert_true(actual_new_sigchld_action.sa_handler != SIG_DFL);
+  g_assert_true(actual_new_sigchld_action.sa_handler != SIG_IGN);
+  g_assert_true(actual_new_sigchld_action.sa_handler
+		== handle_sigchld);
+  /* Check (in member sa_mask) that at least a handful of signals are
+     actually blocked during the signal handler */
+  for(int signum = 1; signum < NSIG; signum++){
+    int actual_new_block_state;
+    switch(signum){
+    case SIGTERM:
+    case SIGINT:
+    case SIGQUIT:
+    case SIGHUP:
+      actual_new_block_state
+	= sigismember(&actual_new_sigchld_action.sa_mask, signum);
+      g_assert_cmpint(actual_new_block_state, ==, 1);
+      continue;
+    case SIGKILL:		/* non-blockable */
+    case SIGSTOP:		/* non-blockable */
+    case SIGCHLD:		/* always blocked */
+    default:
+      continue;
+    }
+  }
+  /* Check member sa_flags */
+  g_assert_true((actual_new_sigchld_action.sa_flags
+		 & (SA_NOCLDSTOP | SA_ONSTACK | SA_RESTART))
+		== (SA_NOCLDSTOP | SA_RESTART));
+
+  /* Restore signal handler */
+  g_assert_cmpint(sigaction(SIGCHLD, &expected_sigchld_action, NULL),
+		  ==, 0);
+}
+
+static void test_restore_signal_handler(__attribute__((unused))
+					test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  /* Save current SIGCHLD action, whatever it is */
+  struct sigaction expected_sigchld_action;
+  g_assert_cmpint(sigaction(SIGCHLD, NULL, &expected_sigchld_action),
+		  ==, 0);
+  /* Since we haven't established a signal handler yet, there should
+     not be one established.  But another test may have relied on
+     restore_signal_handler() to restore the signal handler, and if
+     restore_signal_handler() is buggy (which we should be prepared
+     for in this test) the signal handler may not have been restored
+     properly; check for this: */
+  g_assert_true(expected_sigchld_action.sa_handler != handle_sigchld);
+
+  /* Establish a signal handler */
+  struct sigaction sigchld_action = {
+    .sa_handler=handle_sigchld,
+    .sa_flags=SA_RESTART | SA_NOCLDSTOP,
+  };
+  g_assert_cmpint(sigfillset(&sigchld_action.sa_mask), ==, 0);
+  g_assert_cmpint(sigaction(SIGCHLD, &sigchld_action, NULL), ==, 0);
+
+  /* Act; i.e. run the restore_signal_handler() function */
+  g_assert_true(restore_signal_handler(&expected_sigchld_action));
+
+  /* Retrieve the restored signal handler data */
+  struct sigaction actual_restored_sigchld_action;
+  g_assert_cmpint(sigaction(SIGCHLD, NULL,
+			    &actual_restored_sigchld_action), ==, 0);
+
+  /* Check that the function correctly restored the signal action, as
+     saved in "actual_restored_sigchld_action", to the same values as
+     the previously saved "expected_sigchld_action" */
+  /* Check member sa_handler */
+  g_assert_true(actual_restored_sigchld_action.sa_handler
+		== expected_sigchld_action.sa_handler);
+  /* Check member sa_mask */
+  for(int signum = 1; signum < NSIG; signum++){
+    const int expected_old_block_state
+      = sigismember(&expected_sigchld_action.sa_mask, signum);
+    g_assert_cmpint(expected_old_block_state, >=, 0);
+    const int actual_restored_block_state
+      = sigismember(&actual_restored_sigchld_action.sa_mask, signum);
+    g_assert_cmpint(actual_restored_block_state, >=, 0);
+    g_assert_cmpint(actual_restored_block_state,
+		    ==, expected_old_block_state);
+  }
+  /* Check member sa_flags */
+  g_assert_true((actual_restored_sigchld_action.sa_flags
+		 & (SA_NOCLDSTOP | SA_ONSTACK | SA_RESTART))
+		== (expected_sigchld_action.sa_flags
+		    & (SA_NOCLDSTOP | SA_ONSTACK | SA_RESTART)));
+}
+
+static void test_block_sigchld(__attribute__((unused))
+			       test_fixture *fixture,
+			       __attribute__((unused))
+			       gconstpointer user_data){
+  /* Save original signal mask */
+  sigset_t expected_sigmask;
+  g_assert_cmpint(pthread_sigmask(-1, NULL, &expected_sigmask),
+		  ==, 0);
+
+  /* Make sure SIGCHLD is unblocked for this test */
+  sigset_t sigchld_sigmask;
+  g_assert_cmpint(sigemptyset(&sigchld_sigmask), ==, 0);
+  g_assert_cmpint(sigaddset(&sigchld_sigmask, SIGCHLD), ==, 0);
+  g_assert_cmpint(pthread_sigmask(SIG_UNBLOCK, &sigchld_sigmask,
+				  NULL), ==, 0);
+
+  /* Act; i.e. run the block_sigchld() function */
+  sigset_t actual_old_sigmask;
+  g_assert_true(block_sigchld(&actual_old_sigmask));
+
+  /* Check the actual_old_sigmask; it should be the same as the
+     previously saved signal mask "expected_sigmask". */
+  for(int signum = 1; signum < NSIG; signum++){
+    const int expected_old_block_state
+      = sigismember(&expected_sigmask, signum);
+    g_assert_cmpint(expected_old_block_state, >=, 0);
+    const int actual_old_block_state
+      = sigismember(&actual_old_sigmask, signum);
+    g_assert_cmpint(actual_old_block_state, >=, 0);
+    g_assert_cmpint(actual_old_block_state,
+		    ==, expected_old_block_state);
+  }
+
+  /* Retrieve the newly set signal mask */
+  sigset_t actual_sigmask;
+  g_assert_cmpint(pthread_sigmask(-1, NULL, &actual_sigmask), ==, 0);
+
+  /* SIGCHLD should be blocked */
+  g_assert_cmpint(sigismember(&actual_sigmask, SIGCHLD), ==, 1);
+
+  /* Restore signal mask */
+  g_assert_cmpint(pthread_sigmask(SIG_SETMASK, &expected_sigmask,
+				  NULL), ==, 0);
+}
+
+static void test_restore_sigmask(__attribute__((unused))
+				 test_fixture *fixture,
+				 __attribute__((unused))
+				 gconstpointer user_data){
+  /* Save original signal mask */
+  sigset_t orig_sigmask;
+  g_assert_cmpint(pthread_sigmask(-1, NULL, &orig_sigmask), ==, 0);
+
+  /* Make sure SIGCHLD is blocked for this test */
+  sigset_t sigchld_sigmask;
+  g_assert_cmpint(sigemptyset(&sigchld_sigmask), ==, 0);
+  g_assert_cmpint(sigaddset(&sigchld_sigmask, SIGCHLD), ==, 0);
+  g_assert_cmpint(pthread_sigmask(SIG_BLOCK, &sigchld_sigmask,
+				  NULL), ==, 0);
+
+  /* Act; i.e. run the restore_sigmask() function */
+  g_assert_true(restore_sigmask(&orig_sigmask));
+
+  /* Retrieve the newly restored signal mask */
+  sigset_t restored_sigmask;
+  g_assert_cmpint(pthread_sigmask(-1, NULL, &restored_sigmask),
+		  ==, 0);
+
+  /* Check the restored_sigmask; it should be the same as the
+     previously saved signal mask "orig_sigmask". */
+  for(int signum = 1; signum < NSIG; signum++){
+    const int orig_block_state = sigismember(&orig_sigmask, signum);
+    g_assert_cmpint(orig_block_state, >=, 0);
+    const int restored_block_state = sigismember(&restored_sigmask,
+						 signum);
+    g_assert_cmpint(restored_block_state, >=, 0);
+    g_assert_cmpint(restored_block_state, ==, orig_block_state);
+  }
+
+  /* Restore signal mask */
+  g_assert_cmpint(pthread_sigmask(SIG_SETMASK, &orig_sigmask,
+				  NULL), ==, 0);
+}
+
+static void test_parse_arguments_noargs(__attribute__((unused))
+					test_fixture *fixture,
+					__attribute__((unused))
+					gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+  g_assert_null(agent_directory);
+  g_assert_null(helper_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+__attribute__((nonnull))
+static bool parse_arguments_devnull(int argc, char *argv[],
+				    const bool exit_failure,
+				    char **agent_directory,
+				    char **helper_directory,
+				    uid_t *const user,
+				    gid_t *const group,
+				    char **mandos_argz,
+				    size_t *mandos_argz_length){
+
+  FILE *real_stderr = stderr;
+  FILE *devnull = fopen("/dev/null", "we");
+  g_assert_nonnull(devnull);
+  stderr = devnull;
+
+  const bool ret = parse_arguments(argc, argv, exit_failure,
+				   agent_directory,
+				   helper_directory, user, group,
+				   mandos_argz, mandos_argz_length);
+  const error_t saved_errno = errno;
+
+  stderr = real_stderr;
+  g_assert_cmpint(fclose(devnull), ==, 0);
+
+  errno = saved_errno;
+
+  return ret;
+}
+
+static void test_parse_arguments_invalid(__attribute__((unused))
+					 test_fixture *fixture,
+					 __attribute__((unused))
+					 gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--invalid"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_false(parse_arguments_devnull(argc, argv, false,
+					 &agent_directory,
+					 &helper_directory, &user,
+					 &group, &mandos_argz,
+					 &mandos_argz_length));
+
+  g_assert_true(errno == EINVAL);
+  g_assert_null(agent_directory);
+  g_assert_null(helper_directory);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_long_dir(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--agent-directory"),
+    strdup("/tmp"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *agent_directory = NULL;
+  char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_cmpstr(agent_directory, ==, "/tmp");
+  g_assert_null(helper_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_short_dir(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("-d"),
+    strdup("/tmp"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *agent_directory = NULL;
+  char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_cmpstr(agent_directory, ==, "/tmp");
+  g_assert_null(helper_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static
+void test_parse_arguments_helper_directory(__attribute__((unused))
+					   test_fixture *fixture,
+					   __attribute__((unused))
+					   gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--helper-directory"),
+    strdup("/tmp"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_cmpstr(helper_directory, ==, "/tmp");
+  g_assert_null(agent_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static
+void test_parse_arguments_plugin_helper_dir(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--plugin-helper-dir"),
+    strdup("/tmp"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_cmpstr(helper_directory, ==, "/tmp");
+  g_assert_null(agent_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_user(__attribute__((unused))
+				      test_fixture *fixture,
+				      __attribute__((unused))
+				      gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--user"),
+    strdup("1000"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_null(helper_directory);
+  g_assert_null(agent_directory);
+  g_assert_cmpuint((unsigned int)user, ==, 1000);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_user_invalid(__attribute__((unused))
+					      test_fixture *fixture,
+					      __attribute__((unused))
+					      gconstpointer
+					      user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--user"),
+    strdup("invalid"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_false(parse_arguments_devnull(argc, argv, false,
+					 &agent_directory,
+					 &helper_directory, &user,
+					 &group, &mandos_argz,
+					 &mandos_argz_length));
+
+  g_assert_null(helper_directory);
+  g_assert_null(agent_directory);
+  g_assert_cmpuint((unsigned int)user, ==, 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static
+void test_parse_arguments_user_zero_invalid(__attribute__((unused))
+					    test_fixture *fixture,
+					    __attribute__((unused))
+					    gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--user"),
+    strdup("0"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_false(parse_arguments_devnull(argc, argv, false,
+					 &agent_directory,
+					 &helper_directory, &user,
+					 &group, &mandos_argz,
+					 &mandos_argz_length));
+
+  g_assert_null(helper_directory);
+  g_assert_null(agent_directory);
+  g_assert_cmpuint((unsigned int)user, ==, 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_group(__attribute__((unused))
+				       test_fixture *fixture,
+				       __attribute__((unused))
+				       gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--group"),
+    strdup("1000"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_null(helper_directory);
+  g_assert_null(agent_directory);
+  g_assert_true(user == 0);
+  g_assert_cmpuint((unsigned int)group, ==, 1000);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_group_invalid(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--group"),
+    strdup("invalid"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_false(parse_arguments_devnull(argc, argv, false,
+					 &agent_directory,
+					 &helper_directory, &user,
+					 &group, &mandos_argz,
+					 &mandos_argz_length));
+
+  g_assert_null(helper_directory);
+  g_assert_null(agent_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static
+void test_parse_arguments_group_zero_invalid(__attribute__((unused))
+					     test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--group"),
+    strdup("0"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_false(parse_arguments_devnull(argc, argv, false,
+					 &agent_directory,
+					 &helper_directory, &user,
+					 &group, &mandos_argz,
+					 &mandos_argz_length));
+
+  g_assert_null(helper_directory);
+  g_assert_null(agent_directory);
+  g_assert_cmpuint((unsigned int)group, ==, 0);
+  g_assert_true(group == 0);
+  g_assert_null(mandos_argz);
+  g_assert_true(mandos_argz_length == 0);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_mandos_noargs(__attribute__((unused))
+					       test_fixture *fixture,
+					       __attribute__((unused))
+					       gconstpointer
+					       user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("mandos-client"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_null(agent_directory);
+  g_assert_null(helper_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  g_assert_cmpstr(mandos_argz, ==, "mandos-client");
+  g_assert_cmpuint((unsigned int)argz_count(mandos_argz,
+					    mandos_argz_length),
+		   ==, 1);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_mandos_args(__attribute__((unused))
+					     test_fixture *fixture,
+					     __attribute__((unused))
+					     gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("mandos-client"),
+    strdup("one"),
+    strdup("two"),
+    strdup("three"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_null(agent_directory);
+  g_assert_null(helper_directory);
+  g_assert_true(user == 0);
+  g_assert_true(group == 0);
+  char *marg = mandos_argz;
+  g_assert_cmpstr(marg, ==, "mandos-client");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "one");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "two");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "three");
+  g_assert_cmpuint((unsigned int)argz_count(mandos_argz,
+					    mandos_argz_length),
+		   ==, 4);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_all_args(__attribute__((unused))
+					  test_fixture *fixture,
+					  __attribute__((unused))
+					  gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("--agent-directory"),
+    strdup("/tmp"),
+    strdup("--helper-directory"),
+    strdup("/var/tmp"),
+    strdup("--user"),
+    strdup("1"),
+    strdup("--group"),
+    strdup("2"),
+    strdup("mandos-client"),
+    strdup("one"),
+    strdup("two"),
+    strdup("three"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_cmpstr(agent_directory, ==, "/tmp");
+  g_assert_cmpstr(helper_directory, ==, "/var/tmp");
+  g_assert_true(user == 1);
+  g_assert_true(group == 2);
+  char *marg = mandos_argz;
+  g_assert_cmpstr(marg, ==, "mandos-client");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "one");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "two");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "three");
+  g_assert_cmpuint((unsigned int)argz_count(mandos_argz,
+					    mandos_argz_length),
+		   ==, 4);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+static void test_parse_arguments_mixed(__attribute__((unused))
+				       test_fixture *fixture,
+				       __attribute__((unused))
+				       gconstpointer user_data){
+  char *argv[] = {
+    strdup("prgname"),
+    strdup("mandos-client"),
+    strdup("--user"),
+    strdup("1"),
+    strdup("one"),
+    strdup("--agent-directory"),
+    strdup("/tmp"),
+    strdup("two"),
+    strdup("three"),
+    strdup("--helper-directory=/var/tmp"),
+    NULL };
+  const int argc = (sizeof(argv) / sizeof(char *)) - 1;
+
+  __attribute__((cleanup(cleanup_string)))
+    char *agent_directory = NULL;
+  __attribute__((cleanup(cleanup_string)))
+    char *helper_directory = NULL;
+  uid_t user = 0;
+  gid_t group = 0;
+  __attribute__((cleanup(cleanup_string)))
+    char *mandos_argz = NULL;
+  size_t mandos_argz_length = 0;
+
+  g_assert_true(parse_arguments(argc, argv, false, &agent_directory,
+				&helper_directory, &user, &group,
+				&mandos_argz, &mandos_argz_length));
+
+  g_assert_cmpstr(agent_directory, ==, "/tmp");
+  g_assert_cmpstr(helper_directory, ==, "/var/tmp");
+  g_assert_true(user == 1);
+  g_assert_true(group == 0);
+  char *marg = mandos_argz;
+  g_assert_cmpstr(marg, ==, "mandos-client");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "one");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "two");
+  marg = argz_next(mandos_argz, mandos_argz_length, marg);
+  g_assert_cmpstr(marg, ==, "three");
+  g_assert_cmpuint((unsigned int)argz_count(mandos_argz,
+					    mandos_argz_length),
+		   ==, 4);
+
+  for(char **arg = argv; *arg != NULL; arg++){
+    free(*arg);
+  }
+}
+
+/* End of tests section */
+
+/* Test boilerplate section; New tests should be added to the test
+   suite definition here, in the "run_tests" function.
+
+   Finally, this section also contains the should_only_run_tests()
+   function used by main() for deciding if tests should be run or to
+   start normally. */
+
+__attribute__((cold))
+static bool run_tests(int argc, char *argv[]){
+  g_test_init(&argc, &argv, NULL);
+
+  /* A macro to add a test with no setup or teardown functions */
+#define test_add(testpath, testfunc)			\
+  do {							\
+    g_test_add((testpath), test_fixture, NULL, NULL,	\
+	       (testfunc), NULL);			\
+  } while(false)
+
+  /* Test the signal-related functions first, since some other tests
+     depend on these functions in their setups and teardowns */
+  test_add("/signal-handling/setup", test_setup_signal_handler);
+  test_add("/signal-handling/restore", test_restore_signal_handler);
+  test_add("/signal-handling/block", test_block_sigchld);
+  test_add("/signal-handling/restore-sigmask", test_restore_sigmask);
+
+  /* Regular non-signal-related tests; these use no setups or
+     teardowns */
+  test_add("/parse_arguments/noargs", test_parse_arguments_noargs);
+  test_add("/parse_arguments/invalid", test_parse_arguments_invalid);
+  test_add("/parse_arguments/long-dir",
+	   test_parse_arguments_long_dir);
+  test_add("/parse_arguments/short-dir",
+	   test_parse_arguments_short_dir);
+  test_add("/parse_arguments/helper-directory",
+	   test_parse_arguments_helper_directory);
+  test_add("/parse_arguments/plugin-helper-dir",
+	   test_parse_arguments_plugin_helper_dir);
+  test_add("/parse_arguments/user", test_parse_arguments_user);
+  test_add("/parse_arguments/user-invalid",
+  	   test_parse_arguments_user_invalid);
+  test_add("/parse_arguments/user-zero-invalid",
+  	   test_parse_arguments_user_zero_invalid);
+  test_add("/parse_arguments/group", test_parse_arguments_group);
+  test_add("/parse_arguments/group-invalid",
+  	   test_parse_arguments_group_invalid);
+  test_add("/parse_arguments/group-zero-invalid",
+  	   test_parse_arguments_group_zero_invalid);
+  test_add("/parse_arguments/mandos-noargs",
+	   test_parse_arguments_mandos_noargs);
+  test_add("/parse_arguments/mandos-args",
+	   test_parse_arguments_mandos_args);
+  test_add("/parse_arguments/all-args",
+	   test_parse_arguments_all_args);
+  test_add("/parse_arguments/mixed", test_parse_arguments_mixed);
+  test_add("/queue/create", test_create_queue);
+  test_add("/queue/add", test_add_to_queue);
+  test_add("/queue/add/overflow", test_add_to_queue_overflow);
+  test_add("/queue/has_question/empty",
+	   test_queue_has_question_empty);
+  test_add("/queue/has_question/false",
+	   test_queue_has_question_false);
+  test_add("/queue/has_question/true", test_queue_has_question_true);
+  test_add("/queue/has_question/false2",
+	   test_queue_has_question_false2);
+  test_add("/queue/has_question/true2",
+	   test_queue_has_question_true2);
+  test_add("/buffer/cleanup", test_cleanup_buffer);
+  test_add("/string_set/net-set-contains-nothing",
+	   test_string_set_new_set_contains_nothing);
+  test_add("/string_set/with-added-string-contains-it",
+	   test_string_set_with_added_string_contains_it);
+  test_add("/string_set/cleared-does-not-contain-string",
+	   test_string_set_cleared_does_not_contain_str);
+  test_add("/string_set/swap/one-with-empty",
+	   test_string_set_swap_one_with_empty);
+  test_add("/string_set/swap/empty-with-one",
+	   test_string_set_swap_empty_with_one);
+  test_add("/string_set/swap/one-with-one",
+	   test_string_set_swap_one_with_one);
+
+  /* A macro to add a test using the setup and teardown functions */
+#define test_add_st(path, func)					\
+  do {								\
+    g_test_add((path), test_fixture, NULL, test_setup, (func),	\
+	       test_teardown);					\
+  } while(false)
+
+  /* Signal-related tests; these use setups and teardowns which
+     establish, during each test run, a signal handler for, and a
+     signal mask blocking, the SIGCHLD signal, just like main() */
+  test_add_st("/wait_for_event/timeout", test_wait_for_event_timeout);
+  test_add_st("/wait_for_event/event", test_wait_for_event_event);
+  test_add_st("/wait_for_event/sigchld", test_wait_for_event_sigchld);
+  test_add_st("/run_queue/zeroes-next-run",
+	      test_run_queue_zeroes_next_run);
+  test_add_st("/run_queue/clears-cancelled_filenames",
+	      test_run_queue_clears_cancelled_filenames);
+  test_add_st("/run_queue/skips-cancelled-filenames",
+  	      test_run_queue_skips_cancelled_filenames);
+  test_add_st("/run_queue/one-task", test_run_queue_one_task);
+  test_add_st("/run_queue/two-tasks", test_run_queue_two_tasks);
+  test_add_st("/run_queue/two-tasks/quit",
+	      test_run_queue_two_tasks_quit);
+  test_add_st("/run_queue/two-tasks-cleanup",
+	      test_run_queue_two_tasks_cleanup);
+  test_add_st("/task-creators/start_mandos_client",
+	      test_start_mandos_client);
+  test_add_st("/task-creators/start_mandos_client/execv",
+	      test_start_mandos_client_execv);
+  test_add_st("/task-creators/start_mandos_client/suid/euid",
+	      test_start_mandos_client_suid_euid);
+  test_add_st("/task-creators/start_mandos_client/suid/egid",
+  	      test_start_mandos_client_suid_egid);
+  test_add_st("/task-creators/start_mandos_client/suid/ruid",
+  	      test_start_mandos_client_suid_ruid);
+  test_add_st("/task-creators/start_mandos_client/suid/rgid",
+  	      test_start_mandos_client_suid_rgid);
+  test_add_st("/task-creators/start_mandos_client/read",
+	      test_start_mandos_client_read);
+  test_add_st("/task-creators/start_mandos_client/helper-directory",
+	      test_start_mandos_client_helper_directory);
+  test_add_st("/task-creators/start_mandos_client/sigmask",
+	      test_start_mandos_client_sigmask);
+  test_add_st("/task/wait_for_mandos_client_exit/badpid",
+	      test_wait_for_mandos_client_exit_badpid);
+  test_add_st("/task/wait_for_mandos_client_exit/noexit",
+	      test_wait_for_mandos_client_exit_noexit);
+  test_add_st("/task/wait_for_mandos_client_exit/success",
+	      test_wait_for_mandos_client_exit_success);
+  test_add_st("/task/wait_for_mandos_client_exit/failure",
+	      test_wait_for_mandos_client_exit_failure);
+  test_add_st("/task/wait_for_mandos_client_exit/killed",
+	      test_wait_for_mandos_client_exit_killed);
+  test_add_st("/task/read_mandos_client_output/readerror",
+	      test_read_mandos_client_output_readerror);
+  test_add_st("/task/read_mandos_client_output/nodata",
+	      test_read_mandos_client_output_nodata);
+  test_add_st("/task/read_mandos_client_output/eof",
+	      test_read_mandos_client_output_eof);
+  test_add_st("/task/read_mandos_client_output/once",
+	      test_read_mandos_client_output_once);
+  test_add_st("/task/read_mandos_client_output/malloc",
+	      test_read_mandos_client_output_malloc);
+  test_add_st("/task/read_mandos_client_output/append",
+	      test_read_mandos_client_output_append);
+  test_add_st("/task-creators/add_inotify_dir_watch",
+	      test_add_inotify_dir_watch);
+  test_add_st("/task-creators/add_inotify_dir_watch/fail",
+	      test_add_inotify_dir_watch_fail);
+  test_add_st("/task-creators/add_inotify_dir_watch/not-a-directory",
+	      test_add_inotify_dir_watch_nondir);
+  test_add_st("/task-creators/add_inotify_dir_watch/EAGAIN",
+	      test_add_inotify_dir_watch_EAGAIN);
+  test_add_st("/task-creators/add_inotify_dir_watch/IN_CLOSE_WRITE",
+	      test_add_inotify_dir_watch_IN_CLOSE_WRITE);
+  test_add_st("/task-creators/add_inotify_dir_watch/IN_MOVED_TO",
+	      test_add_inotify_dir_watch_IN_MOVED_TO);
+  test_add_st("/task-creators/add_inotify_dir_watch/IN_MOVED_FROM",
+	      test_add_inotify_dir_watch_IN_MOVED_FROM);
+  test_add_st("/task-creators/add_inotify_dir_watch/IN_EXCL_UNLINK",
+	      test_add_inotify_dir_watch_IN_EXCL_UNLINK);
+  test_add_st("/task-creators/add_inotify_dir_watch/IN_DELETE",
+	      test_add_inotify_dir_watch_IN_DELETE);
+  test_add_st("/task/read_inotify_event/readerror",
+	      test_read_inotify_event_readerror);
+  test_add_st("/task/read_inotify_event/bad-epoll",
+	      test_read_inotify_event_bad_epoll);
+  test_add_st("/task/read_inotify_event/nodata",
+	      test_read_inotify_event_nodata);
+  test_add_st("/task/read_inotify_event/eof",
+	      test_read_inotify_event_eof);
+  test_add_st("/task/read_inotify_event/IN_CLOSE_WRITE",
+	      test_read_inotify_event_IN_CLOSE_WRITE);
+  test_add_st("/task/read_inotify_event/IN_MOVED_TO",
+	      test_read_inotify_event_IN_MOVED_TO);
+  test_add_st("/task/read_inotify_event/IN_MOVED_FROM",
+	      test_read_inotify_event_IN_MOVED_FROM);
+  test_add_st("/task/read_inotify_event/IN_DELETE",
+	      test_read_inotify_event_IN_DELETE);
+  test_add_st("/task/read_inotify_event/IN_CLOSE_WRITE/badname",
+	      test_read_inotify_event_IN_CLOSE_WRITE_badname);
+  test_add_st("/task/read_inotify_event/IN_MOVED_TO/badname",
+	      test_read_inotify_event_IN_MOVED_TO_badname);
+  test_add_st("/task/read_inotify_event/IN_MOVED_FROM/badname",
+	      test_read_inotify_event_IN_MOVED_FROM_badname);
+  test_add_st("/task/read_inotify_event/IN_DELETE/badname",
+	      test_read_inotify_event_IN_DELETE_badname);
+  test_add_st("/task/open_and_parse_question/ENOENT",
+	      test_open_and_parse_question_ENOENT);
+  test_add_st("/task/open_and_parse_question/EIO",
+	      test_open_and_parse_question_EIO);
+  test_add_st("/task/open_and_parse_question/parse-error",
+	      test_open_and_parse_question_parse_error);
+  test_add_st("/task/open_and_parse_question/nosocket",
+	      test_open_and_parse_question_nosocket);
+  test_add_st("/task/open_and_parse_question/badsocket",
+	      test_open_and_parse_question_badsocket);
+  test_add_st("/task/open_and_parse_question/nopid",
+	      test_open_and_parse_question_nopid);
+  test_add_st("/task/open_and_parse_question/badpid",
+	      test_open_and_parse_question_badpid);
+  test_add_st("/task/open_and_parse_question/noexist_pid",
+	      test_open_and_parse_question_noexist_pid);
+  test_add_st("/task/open_and_parse_question/no-notafter",
+	      test_open_and_parse_question_no_notafter);
+  test_add_st("/task/open_and_parse_question/bad-notafter",
+	      test_open_and_parse_question_bad_notafter);
+  test_add_st("/task/open_and_parse_question/notafter-0",
+	      test_open_and_parse_question_notafter_0);
+  test_add_st("/task/open_and_parse_question/notafter-1",
+	      test_open_and_parse_question_notafter_1);
+  test_add_st("/task/open_and_parse_question/notafter-1-1",
+	      test_open_and_parse_question_notafter_1_1);
+  test_add_st("/task/open_and_parse_question/notafter-1-2",
+	      test_open_and_parse_question_notafter_1_2);
+  test_add_st("/task/open_and_parse_question/equal-notafter",
+	      test_open_and_parse_question_equal_notafter);
+  test_add_st("/task/open_and_parse_question/late-notafter",
+	      test_open_and_parse_question_late_notafter);
+  test_add_st("/task/cancel_old_question/0-1-2",
+	      test_cancel_old_question_0_1_2);
+  test_add_st("/task/cancel_old_question/0-2-1",
+	      test_cancel_old_question_0_2_1);
+  test_add_st("/task/cancel_old_question/1-2-3",
+	      test_cancel_old_question_1_2_3);
+  test_add_st("/task/cancel_old_question/1-3-2",
+	      test_cancel_old_question_1_3_2);
+  test_add_st("/task/cancel_old_question/2-1-3",
+	      test_cancel_old_question_2_1_3);
+  test_add_st("/task/cancel_old_question/2-3-1",
+	      test_cancel_old_question_2_3_1);
+  test_add_st("/task/cancel_old_question/3-1-2",
+	      test_cancel_old_question_3_1_2);
+  test_add_st("/task/cancel_old_question/3-2-1",
+	      test_cancel_old_question_3_2_1);
+  test_add_st("/task/connect_question_socket/name-too-long",
+	      test_connect_question_socket_name_too_long);
+  test_add_st("/task/connect_question_socket/connect-fail",
+	      test_connect_question_socket_connect_fail);
+  test_add_st("/task/connect_question_socket/bad-epoll",
+	      test_connect_question_socket_bad_epoll);
+  test_add_st("/task/connect_question_socket/usable",
+	      test_connect_question_socket_usable);
+  test_add_st("/task/send_password_to_socket/client-not-exited",
+	      test_send_password_to_socket_client_not_exited);
+  test_add_st("/task/send_password_to_socket/password-not-read",
+	      test_send_password_to_socket_password_not_read);
+  test_add_st("/task/send_password_to_socket/EMSGSIZE",
+	      test_send_password_to_socket_EMSGSIZE);
+  test_add_st("/task/send_password_to_socket/retry",
+	      test_send_password_to_socket_retry);
+  test_add_st("/task/send_password_to_socket/bad-epoll",
+	      test_send_password_to_socket_bad_epoll);
+  test_add_st("/task/send_password_to_socket/null-password",
+	      test_send_password_to_socket_null_password);
+  test_add_st("/task/send_password_to_socket/empty-password",
+	      test_send_password_to_socket_empty_password);
+  test_add_st("/task/send_password_to_socket/empty-str-password",
+	      test_send_password_to_socket_empty_str_pass);
+  test_add_st("/task/send_password_to_socket/text-password",
+	      test_send_password_to_socket_text_password);
+  test_add_st("/task/send_password_to_socket/binary-password",
+	      test_send_password_to_socket_binary_password);
+  test_add_st("/task/send_password_to_socket/nuls-in-password",
+	      test_send_password_to_socket_nuls_in_password);
+  test_add_st("/task-creators/add_existing_questions/ENOENT",
+	      test_add_existing_questions_ENOENT);
+  test_add_st("/task-creators/add_existing_questions/no-questions",
+	      test_add_existing_questions_no_questions);
+  test_add_st("/task-creators/add_existing_questions/one-question",
+	      test_add_existing_questions_one_question);
+  test_add_st("/task-creators/add_existing_questions/two-questions",
+	      test_add_existing_questions_two_questions);
+  test_add_st("/task-creators/add_existing_questions/non-questions",
+	      test_add_existing_questions_non_questions);
+  test_add_st("/task-creators/add_existing_questions/both-types",
+	      test_add_existing_questions_both_types);
+
+  return g_test_run() == 0;
+}
+
+static bool should_only_run_tests(int *argc_p, char **argv_p[]){
+  GOptionContext *context = g_option_context_new("");
+
+  g_option_context_set_help_enabled(context, FALSE);
+  g_option_context_set_ignore_unknown_options(context, TRUE);
+
+  gboolean should_run_tests = FALSE;
+  GOptionEntry entries[] = {
+    { "test", 0, 0, G_OPTION_ARG_NONE,
+      &should_run_tests, "Run tests", NULL },
+    { NULL }
+  };
+  g_option_context_add_main_entries(context, entries, NULL);
+
+  GError *error = NULL;
+
+  if(g_option_context_parse(context, argc_p, argv_p, &error) != TRUE){
+    g_option_context_free(context);
+    g_error("Failed to parse options: %s", error->message);
+  }
+
+  g_option_context_free(context);
+  return should_run_tests != FALSE;
+}

=== added file 'dracut-module/password-agent.xml'
--- dracut-module/password-agent.xml	1970-01-01 00:00:00 +0000
+++ dracut-module/password-agent.xml	2021-02-03 08:33:43 +0000
@@ -0,0 +1,467 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
+	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY COMMANDNAME "password-agent">
+<!ENTITY TIMESTAMP "2021-02-03">
+<!ENTITY % common SYSTEM "../common.ent">
+%common;
+]>
+
+<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
+  <refentryinfo>
+    <title>Mandos Manual</title>
+    <!-- Nwalsh’s docbook scripts use this to generate the footer: -->
+    <productname>Mandos</productname>
+    <productnumber>&version;</productnumber>
+    <date>&TIMESTAMP;</date>
+    <authorgroup>
+      <author>
+	<firstname>Björn</firstname>
+	<surname>Påhlsson</surname>
+	<address>
+	  <email>belorn@recompile.se</email>
+	</address>
+      </author>
+      <author>
+	<firstname>Teddy</firstname>
+	<surname>Hogeborn</surname>
+	<address>
+	  <email>teddy@recompile.se</email>
+	</address>
+      </author>
+    </authorgroup>
+    <copyright>
+      <year>2019</year>
+      <year>2020</year>
+      <holder>Teddy Hogeborn</holder>
+      <holder>Björn Påhlsson</holder>
+    </copyright>
+    <xi:include href="../legalnotice.xml"/>
+  </refentryinfo>
+
+  <refmeta>
+    <refentrytitle>&COMMANDNAME;</refentrytitle>
+    <manvolnum>8mandos</manvolnum>
+  </refmeta>
+
+  <refnamediv>
+    <refname><command>&COMMANDNAME;</command></refname>
+    <refpurpose>
+      Run Mandos client as a systemd password agent.
+    </refpurpose>
+  </refnamediv>
+
+  <refsynopsisdiv>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <arg><option>--agent-directory=<replaceable
+      >DIRECTORY</replaceable></option></arg>
+      <sbr/>
+      <arg><option>--helper-directory=<replaceable
+      >DIRECTORY</replaceable></option></arg>
+      <sbr/>
+      <!-- <arg><option>-\-plugin-helper-dir=<replaceable -->
+      <!-- >DIRECTORY</replaceable></option></arg> -->
+      <!-- <sbr/> -->
+      <arg><option>--user=<replaceable
+      >USERID</replaceable></option></arg>
+      <sbr/>
+      <!-- <arg><option>-\-userid=<replaceable -->
+      <!-- >ID</replaceable></option></arg> -->
+      <!-- <sbr/> -->
+      <arg><option>--group=<replaceable
+      >GROUPID</replaceable></option></arg>
+      <sbr/>
+      <!-- <arg><option>-\-groupid=<replaceable -->
+      <!-- >ID</replaceable></option></arg> -->
+      <!-- <sbr/> -->
+      <arg>--</arg>
+      <arg>
+	<replaceable>MANDOS_CLIENT</replaceable>
+	<group rep="repeat">
+	  <arg choice="plain"><replaceable>OPTIONS</replaceable></arg>
+	</group>
+      </arg>
+    </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <arg choice="plain"><option>--test</option></arg>
+    </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <group choice="req">
+	<arg choice="plain"><option>--help</option></arg>
+	<arg choice="plain"><option>-?</option></arg>
+      </group>
+    </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <arg choice="plain"><option>--usage</option></arg>
+    </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <group choice="req">
+	<arg choice="plain"><option>--version</option></arg>
+	<arg choice="plain"><option>-V</option></arg>
+      </group>
+    </cmdsynopsis>
+  </refsynopsisdiv>
+
+  <refsect1 id="description">
+    <title>DESCRIPTION</title>
+    <para>
+      <command>&COMMANDNAME;</command> is a program which is meant to
+      be a <citerefentry><refentrytitle>systemd</refentrytitle>
+      <manvolnum>1</manvolnum></citerefentry> <quote>Password
+      Agent</quote> (See <ulink
+      url="https://systemd.io/PASSWORD_AGENTS/">Password
+      Agents</ulink>).  The aim of this program is therefore to
+      acquire and then send a password to some other program which
+      will use the password to unlock the encrypted root disk.
+    </para>
+    <para>
+      This program is not meant to be invoked directly, but can be in
+      order to test it.
+    </para>
+  </refsect1>
+
+  <refsect1 id="purpose">
+    <title>PURPOSE</title>
+    <para>
+      The purpose of this is to enable <emphasis>remote and unattended
+      rebooting</emphasis> of client host computer with an
+      <emphasis>encrypted root file system</emphasis>.  See <xref
+      linkend="overview"/> for details.
+    </para>
+  </refsect1>
+
+  <refsect1>
+    <title>OPTIONS</title>
+    <variablelist>
+
+      <varlistentry>
+	<term><option>--agent-directory
+	<replaceable>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Specify a different agent directory.  The default is
+	    <quote><filename class="directory"
+	    >/run/systemd/ask-password</filename ></quote> as per the
+	    <ulink url="https://systemd.io/PASSWORD_AGENTS/">Password
+	    Agents</ulink> specification.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--helper-directory
+	<replaceable>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Specify a different helper directory.  The default is
+	    <quote><filename class="directory"
+			     >/lib/mandos/plugin-helpers</filename
+			     ></quote>, which
+	    will exist in the initial <acronym>RAM</acronym> disk
+	    environment.  (This will simply be passed to the
+	    <replaceable>MANDOS_CLIENT</replaceable> program via the
+	    <envar>MANDOSPLUGINHELPERDIR</envar> environment variable.
+	    See
+	    <citerefentry><refentrytitle>mandos-client</refentrytitle
+	    ><manvolnum>8mandos</manvolnum></citerefentry>.)
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--user
+	<replaceable>USERID</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Change real user ID to <replaceable>USERID</replaceable>
+	    when running <replaceable>MANDOS_CLIENT</replaceable>.
+	    The default is 65534.  <emphasis>Note:</emphasis> This
+	    must be a number, not a name.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--group
+	<replaceable>GROUPID</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Change real group ID to <replaceable>GROUPID</replaceable>
+	    when running <replaceable>MANDOS_CLIENT</replaceable>.
+	    The default is 65534.  <emphasis>Note:</emphasis> This
+	    must be a number, not a name.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><replaceable>MANDOS_CLIENT</replaceable></term>
+	<listitem>
+	  <para>
+	    This specifies the file name for
+	    <citerefentry><refentrytitle>mandos-client</refentrytitle
+	    ><manvolnum>8mandos</manvolnum></citerefentry>.  If the
+	    <quote><option>--</option></quote> option is given, any
+	    following options are passed to the <replaceable
+	    >MANDOS_CLIENT</replaceable> program.  The default is
+	    <quote><filename
+	    >/lib/mandos/plugins.d/mandos-client</filename ></quote>
+	    (which is the correct location for the initial
+	    <acronym>RAM</acronym> disk environment) without any
+	    options.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--help</option></term>
+	<term><option>-?</option></term>
+	<listitem>
+	  <para>
+	    Gives a help message about options and their meanings.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--test</option></term>
+	<listitem>
+	  <para>
+	    Ignore normal operation; instead only run self-tests.
+	    Adding the <option>--help</option> option may show more
+	    options possible in combination with
+	    <option>--test</option>.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--usage</option></term>
+	<listitem>
+	  <para>
+	    Gives a short usage message.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--version</option></term>
+	<term><option>-V</option></term>
+	<listitem>
+	  <para>
+	    Prints the program version.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+  </refsect1>
+
+  <refsect1 id="overview">
+    <title>OVERVIEW</title>
+    <xi:include href="../overview.xml"/>
+    <para>
+      This program, &COMMANDNAME;, will run on the client side in the
+      initial <acronym>RAM</acronym> disk environment, and is
+      responsible for getting a password from the Mandos client
+      program itself, and to send that password to whatever is
+      currently asking for a password using the systemd <ulink
+      url="https://systemd.io/PASSWORD_AGENTS/">Password
+      Agents</ulink> mechanism.
+    </para>
+    <para>To accomplish this, &COMMANDNAME; runs the
+    <command>mandos-client</command> program (which is the actual
+    client program communicating with the Mandos server) or,
+    alternatively, any executable file specified as
+    <replaceable>MANDOS_CLIENT</replaceable>, and, as soon as a
+    password is acquired from the
+    <replaceable>MANDOS_CLIENT</replaceable> program, sends that
+    password (as per the <ulink
+    url="https://systemd.io/PASSWORD_AGENTS/">Password Agents</ulink>
+    specification) to all currently unanswered password questions.
+    </para>
+    <para>
+      This program should be started (normally as a systemd service,
+      which in turn is normally started by a <citerefentry
+      ><refentrytitle>systemd.path</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry> file) as a reaction to
+      files named <quote><filename>ask.<replaceable>xxxx</replaceable
+      ></filename></quote> appearing in the agent directory
+      <quote><filename
+      class="directory">/run/systemd/ask-password</filename></quote>
+      (or the directory specified by
+      <option>--agent-directory</option>).
+    </para>
+  </refsect1>
+
+  <refsect1 id="exit_status">
+    <title>EXIT STATUS</title>
+    <para>
+      Exit status of this program is zero if no errors were
+      encountered, and otherwise not.
+    </para>
+  </refsect1>
+
+  <refsect1 id="environment">
+    <title>ENVIRONMENT</title>
+    <para>
+      This program does not use any environment variables itself, it
+      only passes on its environment to
+      <replaceable>MANDOS_CLIENT</replaceable>.  Also, the
+      <option>--helper-directory</option> option will affect the
+      environment variable <envar>MANDOSPLUGINHELPERDIR</envar> for
+      <replaceable>MANDOS_CLIENT</replaceable>.
+    </para>
+  </refsect1>
+
+  <refsect1 id="files">
+    <title>FILES</title>
+    <para>
+      <variablelist>
+	<varlistentry>
+	  <term><filename class="directory"
+			  >/run/systemd/ask-password</filename></term>
+	  <listitem>
+	    <para>
+	      The default directory to watch for password questions as
+	      per the <ulink
+	      url="https://systemd.io/PASSWORD_AGENTS/">Password
+	      Agents</ulink> specification; can be changed by the
+	      <option>--agent-directory</option> option.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><filename class="directory"
+			  >/lib/mandos/plugin-helpers</filename
+			  ></term>
+	  <listitem>
+	    <para>
+	      The helper directory as supplied to
+	      <replaceable>MANDOS_CLIENT</replaceable> via the
+	      <envar>MANDOSPLUGINHELPERDIR</envar> environment
+	      variable; can be changed by the
+	      <option>--helper-directory</option> option.
+	    </para>
+	  </listitem>
+	</varlistentry>
+      </variablelist>
+    </para>
+  </refsect1>
+
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <xi:include href="../bugs.xml"/>
+  </refsect1>
+
+  <refsect1 id="examples">
+    <title>EXAMPLE</title>
+    <informalexample>
+      <para>
+	Normal invocation needs no options:
+      </para>
+      <para>
+	<userinput>&COMMANDNAME;</userinput>
+      </para>
+    </informalexample>
+    <informalexample>
+      <para>
+	Run an alternative <replaceable>MANDOS_CLIENT</replaceable>
+	program::
+      </para>
+      <para>
+	<userinput>&COMMANDNAME; /usr/local/sbin/alternate</userinput>
+      </para>
+    </informalexample>
+    <informalexample>
+      <para>
+	Use alternative locations for the helper directory and the
+	Mandos client, and add extra options suitable for running in
+	the normal file system:
+      </para>
+      <para>
+	
+	<!-- do not wrap this line -->
+	<userinput>&COMMANDNAME; --helper-directory=/usr/lib/x86_64-linux-gnu/mandos/plugin-helpers -- /usr/lib/x86_64-linux-gnu/mandos/plugins.d/mandos-client --pubkey=/etc/keys/mandos/pubkey.txt --seckey=/etc/keys/mandos/seckey.txt --tls-pubkey=/etc/keys/mandos/tls-pubkey.pem --tls-privkey=/etc/keys/mandos/tls-privkey.pem</userinput>
+	
+      </para>
+    </informalexample>
+    <informalexample>
+      <para>
+	Use the default location for
+	<citerefentry><refentrytitle>mandos-client</refentrytitle>
+	<manvolnum>8mandos</manvolnum></citerefentry>, but add many
+	options to it:
+      </para>
+      <para>
+
+<!-- do not wrap this line -->
+<userinput>&COMMANDNAME; -- /lib/mandos/plugins.d/mandos-client --pubkey=/etc/mandos/keys/pubkey.txt --seckey=/etc/mandos/keys/seckey.txt --tls-pubkey=/etc/mandos/keys/tls-pubkey.pem --tls-privkey=/etc/mandos/keys/tls-privkey.pem</userinput>
+
+      </para>
+    </informalexample>
+    <informalexample>
+      <para>
+	Only run the self-tests:
+      </para>
+      <para>
+	<userinput>&COMMANDNAME; --test</userinput>
+      </para>
+    </informalexample>
+  </refsect1>
+  <refsect1 id="security">
+    <title>SECURITY</title>
+    <para>
+      This program will need to run as the root user in order to read
+      the agent directory and the <quote><filename
+      >ask.<replaceable>xxxx</replaceable></filename></quote> files
+      there, and will, when starting the Mandos client program,
+      require the ability to set the <quote>real</quote> user and
+      group ids to another user, by default user and group 65534,
+      which are assumed to be non-privileged.  This is done in order
+      to match the expectations of <citerefentry><refentrytitle
+      >mandos-client</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry>, which assumes that its executable file is
+      owned by the root user and also has the set-user-ID bit set (see
+      <citerefentry><refentrytitle>execve</refentrytitle><manvolnum
+      >2</manvolnum></citerefentry>).
+    </para>
+  </refsect1>
+
+  <refsect1 id="see_also">
+    <title>SEE ALSO</title>
+    <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>systemd</refentrytitle>
+      <manvolnum>1</manvolnum></citerefentry>,
+    </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  <ulink url="https://systemd.io/PASSWORD_AGENTS/">Password
+	  Agents</ulink>
+	</term>
+	<listitem>
+	  <para>
+	    The specification for systemd <quote>Password
+	    Agent</quote> programs, which
+	    <command>&COMMANDNAME;</command> follows.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+  </refsect1>
+
+</refentry>
+<!-- Local Variables: -->
+<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
+<!-- time-stamp-end: "[\"']>" -->
+<!-- time-stamp-format: "%:y-%02m-%02d" -->
+<!-- End: -->

=== added file 'initramfs-tools-conf-hook'
--- initramfs-tools-conf-hook	1970-01-01 00:00:00 +0000
+++ initramfs-tools-conf-hook	2019-04-09 19:33:36 +0000
@@ -0,0 +1,14 @@
+# -*- shell-script -*-
+
+# The UMASK is set by the file "initramfs-tools-conf" (which is copied
+# to /usr/share/initramfs-tools/conf.d/mandos-conf on installation)
+# since there, as described therein, is the proper place to do that.
+# However, it is possible for other packages to override the UMASK in
+# any file in /usr/share/initramfs-tools/conf-hooks.d.  Therefore,
+# this file ("initramfs-tools-conf-hook") will be installed as
+# "zz-mandos" in that directory to make sure UMASK is set correctly.
+
+# For more information on the effects of setting UMASK, see the
+# aforementioned /usr/share/initramfs-tools/conf.d/mandos-conf file.
+
+UMASK=0027

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2018-08-19 14:06:55 +0000
+++ initramfs-tools-hook	2020-02-09 17:57:08 +0000
@@ -142,8 +142,9 @@
 # Get DEVICE from initramfs.conf and other files
 . /etc/initramfs-tools/initramfs.conf
 for conf in /etc/initramfs-tools/conf.d/*; do
-    if [ -n `basename \"$conf\" | grep '^[[:alnum:]][[:alnum:]\._-]*$' \
-	| grep -v '\.dpkg-.*$'` ]; then
+    if [ -n "`basename \"$conf\" \
+	| grep '^[[:alnum:]][[:alnum:]\._-]*$' \
+	| grep -v '\.dpkg-.*$'`" ]; then
 	[ -f "${conf}" ] && . "${conf}"
     fi
 done

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2018-08-19 01:35:11 +0000
+++ initramfs-tools-script	2020-07-04 08:59:37 +0000
@@ -177,5 +177,10 @@
 	rm -f /conf/conf.d/cryptroot.mandos
     fi
 elif [ -x /usr/bin/cryptroot-unlock ]; then
-    setsid /lib/mandos/mandos-to-cryptroot-unlock &
+    # Use setsid if available
+    if command -v setsid >/dev/null 2>&1; then
+	setsid /lib/mandos/mandos-to-cryptroot-unlock &
+    else
+	/lib/mandos/mandos-to-cryptroot-unlock &
+    fi
 fi

=== modified file 'initramfs-unpack'
--- initramfs-unpack	2018-02-08 10:23:55 +0000
+++ initramfs-unpack	2019-07-27 10:11:45 +0000
@@ -2,8 +2,8 @@
 # 
 # Initramfs unpacker - unpacks initramfs images into /tmp
 # 
-# Copyright © 2013-2018 Teddy Hogeborn
-# Copyright © 2013-2018 Björn Påhlsson
+# Copyright © 2013-2019 Teddy Hogeborn
+# Copyright © 2013-2019 Björn Påhlsson
 # 
 # This file is part of Mandos.
 #
@@ -43,25 +43,40 @@
     if $cpio --quiet --list --file="$imgfile" >/dev/null 2>&1; then
 	# Number of bytes to skip to get to the compressed archive
 	skip=$(($(LANG=C $cpio --io-size=1 --list --file="$imgfile" 2>&1 \
-	    | sed --quiet --expression='s/^\([0-9]\+\) blocks$/\1/p')+8))
-	catimg="dd if=$imgfile bs=$skip skip=1 status=noxfer"
+		      | sed --quiet \
+			    --expression='s/^\([0-9]\+\) blocks$/\1/p')+8))
+	if [ -x /usr/lib/dracut/skipcpio ]; then
+	    catimg="/usr/lib/dracut/skipcpio $imgfile"
+	else
+	    catimg="dd if=$imgfile bs=$skip skip=1 status=noxfer"
+	fi
     else
+	echo "No microcode detected"
 	catimg="cat -- $imgfile"
     fi
-    # Determine the compression method
-    if { $catimg 2>/dev/null | zcat --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="zcat"
-    elif { $catimg 2>/dev/null | bzip2 --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="bzip2 --stdout --decompress"
-    elif { $catimg 2>/dev/null | lzop --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="lzop --stdout --decompress"
-    else
-	echo "Error: Could not determine type of $imgfile" >&2
-	continue
-    fi
+    while :; do
+	# Determine the compression method
+	if { $catimg 2>/dev/null | zcat --test >/dev/null 2>&1;
+	     [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
+	    decomp="zcat"
+	elif { $catimg 2>/dev/null | bzip2 --test >/dev/null 2>&1;
+	       [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
+	    decomp="bzip2 --stdout --decompress"
+	elif { $catimg 2>/dev/null | lzop --test >/dev/null 2>&1;
+	       [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
+	    decomp="lzop --stdout --decompress"
+	else
+	    skip=$((${skip}+1))
+	    echo "Could not determine compression of ${imgfile}; trying to skip ${skip} bytes" >&2
+	    catimg="dd if=$imgfile bs=$skip skip=1 status=noxfer"
+	    continue
+	fi
+	break
+    done
+    case "$catimg" in
+	*skipcpio*) echo "Microcode detected, skipping";;
+	*) echo "Microcode detected, skipping ${skip} bytes";;
+    esac
     $catimg 2>/dev/null | $decomp | ( cd -- "$imgdir" && $cpio --quiet )
     if [ ${PIPESTATUS[-1]} -eq 0 ]; then
 	echo "$imgfile unpacked into $imgdir"

=== modified file 'intro.xml'
--- intro.xml	2019-02-10 04:20:26 +0000
+++ intro.xml	2021-02-03 08:33:43 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2021-02-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -39,6 +39,7 @@
       <year>2017</year>
       <year>2018</year>
       <year>2019</year>
+      <year>2020</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -131,8 +132,9 @@
     </para>
     <para>
       So, at boot time, the Mandos client will ask for its encrypted
-      data over the network, decrypt it to get the password, use it to
-      decrypt the root file, and continue booting.
+      data over the network, decrypt the data to get the password, use
+      the password to decrypt the root file system, and the client can
+      then continue booting.
     </para>
     <para>
       Now, of course the initial RAM disk image is not on the
@@ -144,7 +146,7 @@
       long, and will no longer give out the encrypted key.  The timing
       here is the only real weak point, and the method, frequency and
       timeout of the server’s checking can be adjusted to any desired
-      level of paranoia
+      level of paranoia.
     </para>
     <para>
       (The encrypted keys on the Mandos server is on its normal file
@@ -383,7 +385,36 @@
       plugin requirements.
     </para>
   </refsect1>
-  
+
+  <refsect1 id="systemd">
+    <title>SYSTEMD</title>
+    <para>
+      More advanced startup systems like <citerefentry><refentrytitle
+      >systemd</refentrytitle><manvolnum>1</manvolnum></citerefentry>,
+      already have their own plugin-like mechanisms for allowing
+      multiple agents to independently retrieve a password and deliver
+      it to the subsystem requesting a password to unlock the root
+      file system.  On these systems, it would make no sense to run
+      <citerefentry><refentrytitle>plugin-runner</refentrytitle
+      ><manvolnum>8mandos</manvolnum></citerefentry>, the plugins of
+      which would largely duplicate the work of (and conflict with)
+      the existing systems prompting for passwords.
+    </para>
+    <para>
+      As for <citerefentry><refentrytitle>systemd</refentrytitle
+      ><manvolnum>1</manvolnum></citerefentry> in particular, it has
+      its own <ulink
+      url="https://systemd.io/PASSWORD_AGENTS/">Password
+      Agents</ulink> system.  Mandos uses this via its
+      <citerefentry><refentrytitle>password-agent</refentrytitle
+      ><manvolnum>8mandos</manvolnum></citerefentry> program, which is
+      run instead of <citerefentry><refentrytitle
+      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry> when <citerefentry><refentrytitle
+      >systemd</refentrytitle><manvolnum>1</manvolnum></citerefentry>
+      is used during system startup.
+    </para>
+  </refsect1>
   <refsect1 id="bugs">
     <title>BUGS</title>
     <xi:include href="bugs.xml"/>
@@ -404,6 +435,8 @@
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>password-agent</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>password-prompt</refentrytitle>

=== modified file 'mandos'
--- mandos	2019-02-11 06:31:42 +0000
+++ mandos	2021-03-21 20:46:40 +0000
@@ -1,5 +1,5 @@
-#!/usr/bin/python
-# -*- mode: python; coding: utf-8 -*-
+#!/usr/bin/python3 -bI
+# -*- mode: python; after-save-hook: (lambda () (let ((command (if (fboundp 'file-local-name) (file-local-name (buffer-file-name)) (or (file-remote-p (buffer-file-name) 'localname) (buffer-file-name))))) (if (= (progn (if (get-buffer "*Test*") (kill-buffer "*Test*")) (process-file-shell-command (format "%s --check" (shell-quote-argument command)) nil "*Test*")) 0) (let ((w (get-buffer-window "*Test*"))) (if w (delete-window w))) (progn (with-current-buffer "*Test*" (compilation-mode)) (display-buffer "*Test*" '(display-buffer-in-side-window)))))); coding: utf-8 -*-
 #
 # Mandos server - give out binary blobs to connecting clients.
 #
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 #
 # Everything else is
-# Copyright © 2008-2019 Teddy Hogeborn
-# Copyright © 2008-2019 Björn Påhlsson
+# Copyright © 2008-2020 Teddy Hogeborn
+# Copyright © 2008-2020 Björn Påhlsson
 #
 # This file is part of Mandos.
 #
@@ -77,9 +77,13 @@
 import itertools
 import collections
 import codecs
+import unittest
+import random
+import shlex
 
 import dbus
 import dbus.service
+import gi
 from gi.repository import GLib
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
@@ -87,6 +91,30 @@
 import xml.dom.minidom
 import inspect
 
+if sys.version_info.major == 2:
+    __metaclass__ = type
+    str = unicode
+
+# Add collections.abc.Callable if it does not exist
+try:
+    collections.abc.Callable
+except AttributeError:
+    class abc:
+        Callable = collections.Callable
+    collections.abc = abc
+    del abc
+
+# Add shlex.quote if it does not exist
+try:
+    shlex.quote
+except AttributeError:
+    shlex.quote = re.escape
+
+# Show warnings by default
+if not sys.warnoptions:
+    import warnings
+    warnings.simplefilter("default")
+
 # Try to find the value of SO_BINDTODEVICE:
 try:
     # This is where SO_BINDTODEVICE is in Python 3.3 (or 3.4?) and
@@ -112,13 +140,14 @@
             # No value found
             SO_BINDTODEVICE = None
 
-if sys.version_info.major == 2:
-    str = unicode
+if sys.version_info < (3, 2):
+    configparser.Configparser = configparser.SafeConfigParser
 
-version = "1.8.3"
+version = "1.8.14"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
+logging.captureWarnings(True)   # Show warnings via the logging system
 syslogger = None
 
 try:
@@ -179,7 +208,7 @@
     pass
 
 
-class PGPEngine(object):
+class PGPEngine:
     """A simple class for OpenPGP symmetric encryption & decryption"""
 
     def __init__(self):
@@ -189,7 +218,7 @@
             output = subprocess.check_output(["gpgconf"])
             for line in output.splitlines():
                 name, text, path = line.split(b":")
-                if name == "gpg":
+                if name == b"gpg":
                     self.gpg = path
                     break
         except OSError as e:
@@ -200,7 +229,7 @@
                           '--force-mdc',
                           '--quiet']
         # Only GPG version 1 has the --no-use-agent option.
-        if self.gpg == "gpg" or self.gpg.endswith("/gpg"):
+        if self.gpg == b"gpg" or self.gpg.endswith(b"/gpg"):
             self.gnupgargs.append("--no-use-agent")
 
     def __enter__(self):
@@ -275,9 +304,8 @@
 
 
 # Pretend that we have an Avahi module
-class Avahi(object):
-    """This isn't so much a class as it is a module-like namespace.
-    It is instantiated once, and simulates having an Avahi module."""
+class avahi:
+    """This isn't so much a class as it is a module-like namespace."""
     IF_UNSPEC = -1               # avahi-common/address.h
     PROTO_UNSPEC = -1            # avahi-common/address.h
     PROTO_INET = 0               # avahi-common/address.h
@@ -287,7 +315,8 @@
     DBUS_INTERFACE_SERVER = DBUS_NAME + ".Server"
     DBUS_PATH_SERVER = "/"
 
-    def string_array_to_txt_array(self, t):
+    @staticmethod
+    def string_array_to_txt_array(t):
         return dbus.Array((dbus.ByteArray(s.encode("utf-8"))
                            for s in t), signature="ay")
     ENTRY_GROUP_ESTABLISHED = 2  # avahi-common/defs.h
@@ -298,7 +327,6 @@
     SERVER_RUNNING = 2           # avahi-common/defs.h
     SERVER_COLLISION = 3         # avahi-common/defs.h
     SERVER_FAILURE = 4           # avahi-common/defs.h
-avahi = Avahi()
 
 
 class AvahiError(Exception):
@@ -316,7 +344,7 @@
     pass
 
 
-class AvahiService(object):
+class AvahiService:
     """An Avahi (Zeroconf) service.
 
     Attributes:
@@ -496,7 +524,8 @@
 class AvahiServiceToSyslog(AvahiService):
     def rename(self, *args, **kwargs):
         """Add the new name to the syslog messages"""
-        ret = super(AvahiServiceToSyslog, self).rename(*args, **kwargs)
+        ret = super(AvahiServiceToSyslog, self).rename(*args,
+                                                       **kwargs)
         syslogger.setFormatter(logging.Formatter(
             'Mandos ({}) [%(process)d]: %(levelname)s: %(message)s'
             .format(self.name)))
@@ -504,24 +533,14 @@
 
 
 # Pretend that we have a GnuTLS module
-class GnuTLS(object):
-    """This isn't so much a class as it is a module-like namespace.
-    It is instantiated once, and simulates having a GnuTLS module."""
+class gnutls:
+    """This isn't so much a class as it is a module-like namespace."""
 
     library = ctypes.util.find_library("gnutls")
     if library is None:
         library = ctypes.util.find_library("gnutls-deb0")
     _library = ctypes.cdll.LoadLibrary(library)
     del library
-    _need_version = b"3.3.0"
-    _tls_rawpk_version = b"3.6.6"
-
-    def __init__(self):
-        # Need to use "self" here, since this method is called before
-        # the assignment to the "gnutls" global variable happens.
-        if self.check_version(self._need_version) is None:
-            raise self.Error("Needs GnuTLS {} or later"
-                             .format(self._need_version))
 
     # Unless otherwise indicated, the constants and types below are
     # all from the gnutls/gnutls.h C header file.
@@ -544,9 +563,9 @@
     OPENPGP_FMT_RAW = 0         # gnutls/openpgp.h
 
     # Types
-    class session_int(ctypes.Structure):
+    class _session_int(ctypes.Structure):
         _fields_ = []
-    session_t = ctypes.POINTER(session_int)
+    session_t = ctypes.POINTER(_session_int)
 
     class certificate_credentials_st(ctypes.Structure):
         _fields_ = []
@@ -558,9 +577,9 @@
         _fields_ = [('data', ctypes.POINTER(ctypes.c_ubyte)),
                     ('size', ctypes.c_uint)]
 
-    class openpgp_crt_int(ctypes.Structure):
+    class _openpgp_crt_int(ctypes.Structure):
         _fields_ = []
-    openpgp_crt_t = ctypes.POINTER(openpgp_crt_int)
+    openpgp_crt_t = ctypes.POINTER(_openpgp_crt_int)
     openpgp_crt_fmt_t = ctypes.c_int  # gnutls/openpgp.h
     log_func = ctypes.CFUNCTYPE(None, ctypes.c_int, ctypes.c_char_p)
     credentials_type_t = ctypes.c_int
@@ -569,87 +588,106 @@
 
     # Exceptions
     class Error(Exception):
-        # We need to use the class name "GnuTLS" here, since this
-        # exception might be raised from within GnuTLS.__init__,
-        # which is called before the assignment to the "gnutls"
-        # global variable has happened.
         def __init__(self, message=None, code=None, args=()):
             # Default usage is by a message string, but if a return
             # code is passed, convert it to a string with
             # gnutls.strerror()
             self.code = code
             if message is None and code is not None:
-                message = GnuTLS.strerror(code)
-            return super(GnuTLS.Error, self).__init__(
+                message = gnutls.strerror(code).decode(
+                    "utf-8", errors="replace")
+            return super(gnutls.Error, self).__init__(
                 message, *args)
 
     class CertificateSecurityError(Error):
         pass
 
+    class PointerTo:
+        def __init__(self, cls):
+            self.cls = cls
+
+        def from_param(self, obj):
+            if not isinstance(obj, self.cls):
+                raise TypeError("Not of type {}: {!r}"
+                                .format(self.cls.__name__, obj))
+            return ctypes.byref(obj.from_param(obj))
+
+    class CastToVoidPointer:
+        def __init__(self, cls):
+            self.cls = cls
+
+        def from_param(self, obj):
+            if not isinstance(obj, self.cls):
+                raise TypeError("Not of type {}: {!r}"
+                                .format(self.cls.__name__, obj))
+            return ctypes.cast(obj.from_param(obj), ctypes.c_void_p)
+
+    class With_from_param:
+        @classmethod
+        def from_param(cls, obj):
+            return obj._as_parameter_
+
     # Classes
-    class Credentials(object):
+    class Credentials(With_from_param):
         def __init__(self):
-            self._c_object = gnutls.certificate_credentials_t()
-            gnutls.certificate_allocate_credentials(
-                ctypes.byref(self._c_object))
+            self._as_parameter_ = gnutls.certificate_credentials_t()
+            gnutls.certificate_allocate_credentials(self)
             self.type = gnutls.CRD_CERTIFICATE
 
         def __del__(self):
-            gnutls.certificate_free_credentials(self._c_object)
+            gnutls.certificate_free_credentials(self)
 
-    class ClientSession(object):
+    class ClientSession(With_from_param):
         def __init__(self, socket, credentials=None):
-            self._c_object = gnutls.session_t()
+            self._as_parameter_ = gnutls.session_t()
             gnutls_flags = gnutls.CLIENT
-            if gnutls.check_version("3.5.6"):
+            if gnutls.check_version(b"3.5.6"):
                 gnutls_flags |= gnutls.NO_TICKETS
             if gnutls.has_rawpk:
                 gnutls_flags |= gnutls.ENABLE_RAWPK
-            gnutls.init(ctypes.byref(self._c_object), gnutls_flags)
+            gnutls.init(self, gnutls_flags)
             del gnutls_flags
-            gnutls.set_default_priority(self._c_object)
-            gnutls.transport_set_ptr(self._c_object, socket.fileno())
-            gnutls.handshake_set_private_extensions(self._c_object,
-                                                    True)
+            gnutls.set_default_priority(self)
+            gnutls.transport_set_ptr(self, socket.fileno())
+            gnutls.handshake_set_private_extensions(self, True)
             self.socket = socket
             if credentials is None:
                 credentials = gnutls.Credentials()
-            gnutls.credentials_set(self._c_object, credentials.type,
-                                   ctypes.cast(credentials._c_object,
-                                               ctypes.c_void_p))
+            gnutls.credentials_set(self, credentials.type,
+                                   credentials)
             self.credentials = credentials
 
         def __del__(self):
-            gnutls.deinit(self._c_object)
+            gnutls.deinit(self)
 
         def handshake(self):
-            return gnutls.handshake(self._c_object)
+            return gnutls.handshake(self)
 
         def send(self, data):
             data = bytes(data)
             data_len = len(data)
             while data_len > 0:
-                data_len -= gnutls.record_send(self._c_object,
-                                               data[-data_len:],
+                data_len -= gnutls.record_send(self, data[-data_len:],
                                                data_len)
 
         def bye(self):
-            return gnutls.bye(self._c_object, gnutls.SHUT_RDWR)
+            return gnutls.bye(self, gnutls.SHUT_RDWR)
 
     # Error handling functions
     def _error_code(result):
         """A function to raise exceptions on errors, suitable
         for the 'restype' attribute on ctypes functions"""
-        if result >= 0:
+        if result >= gnutls.E_SUCCESS:
             return result
         if result == gnutls.E_NO_CERTIFICATE_FOUND:
             raise gnutls.CertificateSecurityError(code=result)
         raise gnutls.Error(code=result)
 
-    def _retry_on_error(result, func, arguments):
+    def _retry_on_error(result, func, arguments,
+                        _error_code=_error_code):
         """A function to retry on some errors, suitable
         for the 'errcheck' attribute on ctypes functions"""
-        while result < 0:
+        while result < gnutls.E_SUCCESS:
             if result not in (gnutls.E_INTERRUPTED, gnutls.E_AGAIN):
                 return _error_code(result)
             result = func(*arguments)
@@ -660,20 +698,20 @@
 
     # Functions
     priority_set_direct = _library.gnutls_priority_set_direct
-    priority_set_direct.argtypes = [session_t, ctypes.c_char_p,
+    priority_set_direct.argtypes = [ClientSession, ctypes.c_char_p,
                                     ctypes.POINTER(ctypes.c_char_p)]
     priority_set_direct.restype = _error_code
 
     init = _library.gnutls_init
-    init.argtypes = [ctypes.POINTER(session_t), ctypes.c_int]
+    init.argtypes = [PointerTo(ClientSession), ctypes.c_int]
     init.restype = _error_code
 
     set_default_priority = _library.gnutls_set_default_priority
-    set_default_priority.argtypes = [session_t]
+    set_default_priority.argtypes = [ClientSession]
     set_default_priority.restype = _error_code
 
     record_send = _library.gnutls_record_send
-    record_send.argtypes = [session_t, ctypes.c_void_p,
+    record_send.argtypes = [ClientSession, ctypes.c_void_p,
                             ctypes.c_size_t]
     record_send.restype = ctypes.c_ssize_t
     record_send.errcheck = _retry_on_error
@@ -681,24 +719,23 @@
     certificate_allocate_credentials = (
         _library.gnutls_certificate_allocate_credentials)
     certificate_allocate_credentials.argtypes = [
-        ctypes.POINTER(certificate_credentials_t)]
+        PointerTo(Credentials)]
     certificate_allocate_credentials.restype = _error_code
 
     certificate_free_credentials = (
         _library.gnutls_certificate_free_credentials)
-    certificate_free_credentials.argtypes = [
-        certificate_credentials_t]
+    certificate_free_credentials.argtypes = [Credentials]
     certificate_free_credentials.restype = None
 
     handshake_set_private_extensions = (
         _library.gnutls_handshake_set_private_extensions)
-    handshake_set_private_extensions.argtypes = [session_t,
+    handshake_set_private_extensions.argtypes = [ClientSession,
                                                  ctypes.c_int]
     handshake_set_private_extensions.restype = None
 
     credentials_set = _library.gnutls_credentials_set
-    credentials_set.argtypes = [session_t, credentials_type_t,
-                                ctypes.c_void_p]
+    credentials_set.argtypes = [ClientSession, credentials_type_t,
+                                CastToVoidPointer(Credentials)]
     credentials_set.restype = _error_code
 
     strerror = _library.gnutls_strerror
@@ -706,11 +743,11 @@
     strerror.restype = ctypes.c_char_p
 
     certificate_type_get = _library.gnutls_certificate_type_get
-    certificate_type_get.argtypes = [session_t]
+    certificate_type_get.argtypes = [ClientSession]
     certificate_type_get.restype = _error_code
 
     certificate_get_peers = _library.gnutls_certificate_get_peers
-    certificate_get_peers.argtypes = [session_t,
+    certificate_get_peers.argtypes = [ClientSession,
                                       ctypes.POINTER(ctypes.c_uint)]
     certificate_get_peers.restype = ctypes.POINTER(datum_t)
 
@@ -723,27 +760,33 @@
     global_set_log_function.restype = None
 
     deinit = _library.gnutls_deinit
-    deinit.argtypes = [session_t]
+    deinit.argtypes = [ClientSession]
     deinit.restype = None
 
     handshake = _library.gnutls_handshake
-    handshake.argtypes = [session_t]
-    handshake.restype = _error_code
+    handshake.argtypes = [ClientSession]
+    handshake.restype = ctypes.c_int
     handshake.errcheck = _retry_on_error
 
     transport_set_ptr = _library.gnutls_transport_set_ptr
-    transport_set_ptr.argtypes = [session_t, transport_ptr_t]
+    transport_set_ptr.argtypes = [ClientSession, transport_ptr_t]
     transport_set_ptr.restype = None
 
     bye = _library.gnutls_bye
-    bye.argtypes = [session_t, close_request_t]
-    bye.restype = _error_code
+    bye.argtypes = [ClientSession, close_request_t]
+    bye.restype = ctypes.c_int
     bye.errcheck = _retry_on_error
 
     check_version = _library.gnutls_check_version
     check_version.argtypes = [ctypes.c_char_p]
     check_version.restype = ctypes.c_char_p
 
+    _need_version = b"3.3.0"
+    if check_version(_need_version) is None:
+        raise self.Error("Needs GnuTLS {} or later"
+                         .format(_need_version))
+
+    _tls_rawpk_version = b"3.6.6"
     has_rawpk = bool(check_version(_tls_rawpk_version))
 
     if has_rawpk:
@@ -754,7 +797,8 @@
 
         x509_crt_fmt_t = ctypes.c_int
 
-        # All the function declarations below are from gnutls/abstract.h
+        # All the function declarations below are from
+        # gnutls/abstract.h
         pubkey_init = _library.gnutls_pubkey_init
         pubkey_init.argtypes = [ctypes.POINTER(pubkey_t)]
         pubkey_init.restype = _error_code
@@ -774,7 +818,8 @@
         pubkey_deinit.argtypes = [pubkey_t]
         pubkey_deinit.restype = None
     else:
-        # All the function declarations below are from gnutls/openpgp.h
+        # All the function declarations below are from
+        # gnutls/openpgp.h
 
         openpgp_crt_init = _library.gnutls_openpgp_crt_init
         openpgp_crt_init.argtypes = [ctypes.POINTER(openpgp_crt_t)]
@@ -786,9 +831,13 @@
                                        openpgp_crt_fmt_t]
         openpgp_crt_import.restype = _error_code
 
-        openpgp_crt_verify_self = _library.gnutls_openpgp_crt_verify_self
-        openpgp_crt_verify_self.argtypes = [openpgp_crt_t, ctypes.c_uint,
-                                            ctypes.POINTER(ctypes.c_uint)]
+        openpgp_crt_verify_self = \
+            _library.gnutls_openpgp_crt_verify_self
+        openpgp_crt_verify_self.argtypes = [
+            openpgp_crt_t,
+            ctypes.c_uint,
+            ctypes.POINTER(ctypes.c_uint),
+        ]
         openpgp_crt_verify_self.restype = _error_code
 
         openpgp_crt_deinit = _library.gnutls_openpgp_crt_deinit
@@ -803,15 +852,13 @@
                                                     ctypes.c_size_t)]
         openpgp_crt_get_fingerprint.restype = _error_code
 
-    if check_version("3.6.4"):
+    if check_version(b"3.6.4"):
         certificate_type_get2 = _library.gnutls_certificate_type_get2
-        certificate_type_get2.argtypes = [session_t, ctypes.c_int]
+        certificate_type_get2.argtypes = [ClientSession, ctypes.c_int]
         certificate_type_get2.restype = _error_code
 
     # Remove non-public functions
     del _error_code, _retry_on_error
-# Create the global "gnutls" object, simulating a module
-gnutls = GnuTLS()
 
 
 def call_pipe(connection,       # : multiprocessing.Connection
@@ -825,16 +872,16 @@
     connection.close()
 
 
-class Client(object):
+class Client:
     """A representation of a client host served by this server.
 
     Attributes:
     approved:   bool(); 'None' if not yet approved/disapproved
     approval_delay: datetime.timedelta(); Time to wait for approval
     approval_duration: datetime.timedelta(); Duration of one approval
-    checker:    subprocess.Popen(); a running checker process used
-                                    to see if the client lives.
-                                    'None' if no process is running.
+    checker: multiprocessing.Process(); a running checker process used
+             to see if the client lives. 'None' if no process is
+             running.
     checker_callback_tag: a GLib event source tag, or None
     checker_command: string; External command which is run to check
                      if client lives.  %() expansions are done at
@@ -1034,7 +1081,8 @@
         if self.checker_initiator_tag is not None:
             GLib.source_remove(self.checker_initiator_tag)
         self.checker_initiator_tag = GLib.timeout_add(
-            int(self.interval.total_seconds() * 1000),
+            random.randrange(int(self.interval.total_seconds() * 1000
+                                 + 1)),
             self.start_checker)
         # Schedule a disable() when 'timeout' has passed
         if self.disable_initiator_tag is not None:
@@ -1047,11 +1095,13 @@
     def checker_callback(self, source, condition, connection,
                          command):
         """The checker has completed, so take appropriate actions."""
-        self.checker_callback_tag = None
-        self.checker = None
         # Read return code from connection (see call_pipe)
         returncode = connection.recv()
         connection.close()
+        if self.checker is not None:
+            self.checker.join()
+        self.checker_callback_tag = None
+        self.checker = None
 
         if returncode >= 0:
             self.last_checker_status = returncode
@@ -1113,7 +1163,7 @@
         if self.checker is None:
             # Escape attributes for the shell
             escaped_attrs = {
-                attr: re.escape(str(getattr(self, attr)))
+                attr: shlex.quote(str(getattr(self, attr)))
                 for attr in self.runtime_expansions}
             try:
                 command = self.checker_command % escaped_attrs
@@ -1146,7 +1196,8 @@
                 kwargs=popen_args)
             self.checker.start()
             self.checker_callback_tag = GLib.io_add_watch(
-                pipe[0].fileno(), GLib.IO_IN,
+                GLib.IOChannel.unix_new(pipe[0].fileno()),
+                GLib.PRIORITY_DEFAULT, GLib.IO_IN,
                 self.checker_callback, pipe[0], command)
         # Re-run this periodically if run by GLib.timeout_add
         return True
@@ -1407,8 +1458,7 @@
                 raise ValueError("Byte arrays not supported for non-"
                                  "'ay' signature {!r}"
                                  .format(prop._dbus_signature))
-            value = dbus.ByteArray(b''.join(chr(byte)
-                                            for byte in value))
+            value = dbus.ByteArray(bytes(value))
         prop(value)
 
     @dbus.service.method(dbus.PROPERTIES_IFACE,
@@ -2219,7 +2269,7 @@
     del _interface
 
 
-class ProxyClient(object):
+class ProxyClient:
     def __init__(self, child_pipe, key_id, fpr, address):
         self._pipe = child_pipe
         self._pipe.send(('init', key_id, fpr, address))
@@ -2270,9 +2320,8 @@
             priority = self.server.gnutls_priority
             if priority is None:
                 priority = "NORMAL"
-            gnutls.priority_set_direct(session._c_object,
-                                       priority.encode("utf-8"),
-                                       None)
+            gnutls.priority_set_direct(session,
+                                       priority.encode("utf-8"), None)
 
             # Start communication using the Mandos protocol
             # Get protocol number
@@ -2298,17 +2347,19 @@
             approval_required = False
             try:
                 if gnutls.has_rawpk:
-                    fpr = ""
+                    fpr = b""
                     try:
                         key_id = self.key_id(
                             self.peer_certificate(session))
                     except (TypeError, gnutls.Error) as error:
                         logger.warning("Bad certificate: %s", error)
                         return
-                    logger.debug("Key ID: %s", key_id)
+                    logger.debug("Key ID: %s",
+                                 key_id.decode("utf-8",
+                                               errors="replace"))
 
                 else:
-                    key_id = ""
+                    key_id = b""
                     try:
                         fpr = self.fingerprint(
                             self.peer_certificate(session))
@@ -2403,10 +2454,10 @@
     def peer_certificate(session):
         "Return the peer's certificate as a bytestring"
         try:
-            cert_type = gnutls.certificate_type_get2(session._c_object,
-                                                     gnutls.CTYPE_PEERS)
+            cert_type = gnutls.certificate_type_get2(
+                session, gnutls.CTYPE_PEERS)
         except AttributeError:
-            cert_type = gnutls.certificate_type_get(session._c_object)
+            cert_type = gnutls.certificate_type_get(session)
         if gnutls.has_rawpk:
             valid_cert_types = frozenset((gnutls.CRT_RAWPK,))
         else:
@@ -2419,7 +2470,7 @@
             return b""
         list_size = ctypes.c_uint(1)
         cert_list = (gnutls.certificate_get_peers
-                     (session._c_object, ctypes.byref(list_size)))
+                     (session, ctypes.byref(list_size)))
         if not bool(cert_list) and list_size.value != 0:
             raise gnutls.Error("error getting peer certificate")
         if list_size.value == 0:
@@ -2447,11 +2498,12 @@
         buf = ctypes.create_string_buffer(32)
         buf_len = ctypes.c_size_t(len(buf))
         # Get the key ID from the raw public key into the buffer
-        gnutls.pubkey_get_key_id(pubkey,
-                                 gnutls.KEYID_USE_SHA256,
-                                 ctypes.cast(ctypes.byref(buf),
-                                             ctypes.POINTER(ctypes.c_ubyte)),
-                                 ctypes.byref(buf_len))
+        gnutls.pubkey_get_key_id(
+            pubkey,
+            gnutls.KEYID_USE_SHA256,
+            ctypes.cast(ctypes.byref(buf),
+                        ctypes.POINTER(ctypes.c_ubyte)),
+            ctypes.byref(buf_len))
         # Deinit the certificate
         gnutls.pubkey_deinit(pubkey)
 
@@ -2498,7 +2550,7 @@
         return hex_fpr
 
 
-class MultiprocessingMixIn(object):
+class MultiprocessingMixIn:
     """Like socketserver.ThreadingMixIn, but with multiprocessing"""
 
     def sub_process_main(self, request, address):
@@ -2516,7 +2568,7 @@
         return proc
 
 
-class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
+class MultiprocessingMixInWithPipe(MultiprocessingMixIn):
     """ adds a pipe to the MixIn """
 
     def process_request(self, request, client_address):
@@ -2537,7 +2589,7 @@
 
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
-                     socketserver.TCPServer, object):
+                     socketserver.TCPServer):
     """IPv6-capable TCP server.  Accepts 'None' as address and/or port
 
     Attributes:
@@ -2616,6 +2668,8 @@
                     raise
         # Only bind(2) the socket if we really need to.
         if self.server_address[0] or self.server_address[1]:
+            if self.server_address[1]:
+                self.allow_reuse_address = True
             if not self.server_address[0]:
                 if self.address_family == socket.AF_INET6:
                     any_address = "::"  # in6addr_any
@@ -2674,8 +2728,8 @@
     def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
         GLib.io_add_watch(
-            parent_pipe.fileno(),
-            GLib.IO_IN | GLib.IO_HUP,
+            GLib.IOChannel.unix_new(parent_pipe.fileno()),
+            GLib.PRIORITY_DEFAULT, GLib.IO_IN | GLib.IO_HUP,
             functools.partial(self.handle_ipc,
                               parent_pipe=parent_pipe,
                               proc=proc))
@@ -2700,7 +2754,8 @@
             address = request[3]
 
             for c in self.clients.values():
-                if key_id == "E3B0C44298FC1C149AFBF4C8996FB92427AE41E4649B934CA495991B7852B855":
+                if key_id == ("E3B0C44298FC1C149AFBF4C8996FB924"
+                              "27AE41E4649B934CA495991B7852B855"):
                     continue
                 if key_id and c.key_id == key_id:
                     client = c
@@ -2719,8 +2774,8 @@
                 return False
 
             GLib.io_add_watch(
-                parent_pipe.fileno(),
-                GLib.IO_IN | GLib.IO_HUP,
+                GLib.IOChannel.unix_new(parent_pipe.fileno()),
+                GLib.PRIORITY_DEFAULT, GLib.IO_IN | GLib.IO_HUP,
                 functools.partial(self.handle_ipc,
                                   parent_pipe=parent_pipe,
                                   proc=proc,
@@ -2741,7 +2796,7 @@
         if command == 'getattr':
             attrname = request[1]
             if isinstance(client_object.__getattribute__(attrname),
-                          collections.Callable):
+                          collections.abc.Callable):
                 parent_pipe.send(('function', ))
             else:
                 parent_pipe.send((
@@ -2758,20 +2813,22 @@
 def rfc3339_duration_to_delta(duration):
     """Parse an RFC 3339 "duration" and return a datetime.timedelta
 
-    >>> rfc3339_duration_to_delta("P7D")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT60S")
-    datetime.timedelta(0, 60)
-    >>> rfc3339_duration_to_delta("PT60M")
-    datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("PT24H")
-    datetime.timedelta(1)
-    >>> rfc3339_duration_to_delta("P1W")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT5M30S")
-    datetime.timedelta(0, 330)
-    >>> rfc3339_duration_to_delta("P1DT3M20S")
-    datetime.timedelta(1, 200)
+    >>> timedelta = datetime.timedelta
+    >>> rfc3339_duration_to_delta("P7D") == timedelta(7)
+    True
+    >>> rfc3339_duration_to_delta("PT60S") == timedelta(0, 60)
+    True
+    >>> rfc3339_duration_to_delta("PT60M") == timedelta(0, 3600)
+    True
+    >>> rfc3339_duration_to_delta("PT24H") == timedelta(1)
+    True
+    >>> rfc3339_duration_to_delta("P1W") == timedelta(7)
+    True
+    >>> rfc3339_duration_to_delta("PT5M30S") == timedelta(0, 330)
+    True
+    >>> rfc3339_duration_to_delta("P1DT3M20S") == timedelta(1, 200)
+    True
+    >>> del timedelta
     """
 
     # Parsing an RFC 3339 duration with regular expressions is not
@@ -2857,18 +2914,18 @@
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
 
-    >>> string_to_delta('7d')
-    datetime.timedelta(7)
-    >>> string_to_delta('60s')
-    datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
-    datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
-    datetime.timedelta(1)
-    >>> string_to_delta('1w')
-    datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
-    datetime.timedelta(0, 330)
+    >>> string_to_delta('7d') == datetime.timedelta(7)
+    True
+    >>> string_to_delta('60s') == datetime.timedelta(0, 60)
+    True
+    >>> string_to_delta('60m') == datetime.timedelta(0, 3600)
+    True
+    >>> string_to_delta('24h') == datetime.timedelta(1)
+    True
+    >>> string_to_delta('1w') == datetime.timedelta(7)
+    True
+    >>> string_to_delta('5m 30s') == datetime.timedelta(0, 330)
+    True
     """
 
     try:
@@ -2976,11 +3033,6 @@
 
     options = parser.parse_args()
 
-    if options.check:
-        import doctest
-        fail_count, test_count = doctest.testmod()
-        sys.exit(os.EX_OK if fail_count == 0 else 1)
-
     # Default values for config file for server-global settings
     if gnutls.has_rawpk:
         priority = ("SECURE128:!CTYPE-X.509:+CTYPE-RAWPK:!RSA"
@@ -3006,10 +3058,10 @@
     del priority
 
     # Parse config file for server-global settings
-    server_config = configparser.SafeConfigParser(server_defaults)
+    server_config = configparser.ConfigParser(server_defaults)
     del server_defaults
     server_config.read(os.path.join(options.configdir, "mandos.conf"))
-    # Convert the SafeConfigParser object to a dict
+    # Convert the ConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
@@ -3087,8 +3139,7 @@
                                   server_settings["servicename"])))
 
     # Parse config file with clients
-    client_config = configparser.SafeConfigParser(Client
-                                                  .client_defaults)
+    client_config = configparser.ConfigParser(Client.client_defaults)
     client_config.read(os.path.join(server_settings["configdir"],
                                     "clients.conf"))
 
@@ -3150,7 +3201,9 @@
 
         @gnutls.log_func
         def debug_gnutls(level, string):
-            logger.debug("GnuTLS: %s", string[:-1])
+            logger.debug("GnuTLS: %s",
+                         string[:-1].decode("utf-8",
+                                            errors="replace"))
 
         gnutls.global_set_log_function(debug_gnutls)
 
@@ -3165,9 +3218,10 @@
         # Close all input and output, do double fork, etc.
         daemon()
 
-    # multiprocessing will use threads, so before we use GLib we need
-    # to inform GLib that threads will be used.
-    GLib.threads_init()
+    if gi.version_info < (3, 10, 2):
+        # multiprocessing will use threads, so before we use GLib we
+        # need to inform GLib that threads will be used.
+        GLib.threads_init()
 
     global main_loop
     # From the Avahi example code
@@ -3249,13 +3303,13 @@
                              if isinstance(s, bytes)
                              else s) for s in
                             value["client_structure"]]
-                        # .name & .host
-                        for k in ("name", "host"):
+                        # .name, .host, and .checker_command
+                        for k in ("name", "host", "checker_command"):
                             if isinstance(value[k], bytes):
                                 value[k] = value[k].decode("utf-8")
-                        if not value.has_key("key_id"):
+                        if "key_id" not in value:
                             value["key_id"] = ""
-                        elif not value.has_key("fingerprint"):
+                        elif "fingerprint" not in value:
                             value["fingerprint"] = ""
                     #  old_client_settings
                     # .keys()
@@ -3266,11 +3320,12 @@
                         for key, value in
                         bytes_old_client_settings.items()}
                     del bytes_old_client_settings
-                    # .host
+                    # .host and .checker_command
                     for value in old_client_settings.values():
-                        if isinstance(value["host"], bytes):
-                            value["host"] = (value["host"]
-                                             .decode("utf-8"))
+                        for attribute in ("host", "checker_command"):
+                            if isinstance(value[attribute], bytes):
+                                value[attribute] = (value[attribute]
+                                                    .decode("utf-8"))
             os.remove(stored_state_path)
         except IOError as e:
             if e.errno == errno.ENOENT:
@@ -3601,10 +3656,11 @@
                 sys.exit(1)
             # End of Avahi example code
 
-        GLib.io_add_watch(tcp_server.fileno(), GLib.IO_IN,
-                          lambda *args, **kwargs:
-                          (tcp_server.handle_request
-                           (*args[2:], **kwargs) or True))
+        GLib.io_add_watch(
+            GLib.IOChannel.unix_new(tcp_server.fileno()),
+            GLib.PRIORITY_DEFAULT, GLib.IO_IN,
+            lambda *args, **kwargs: (tcp_server.handle_request
+                                     (*args[2:], **kwargs) or True))
 
         logger.debug("Starting main loop")
         main_loop.run()
@@ -3620,6 +3676,29 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
+
+def should_only_run_tests():
+    parser = argparse.ArgumentParser(add_help=False)
+    parser.add_argument("--check", action='store_true')
+    args, unknown_args = parser.parse_known_args()
+    run_tests = args.check
+    if run_tests:
+        # Remove --check argument from sys.argv
+        sys.argv[1:] = unknown_args
+    return run_tests
+
+# Add all tests from doctest strings
+def load_tests(loader, tests, none):
+    import doctest
+    tests.addTests(doctest.DocTestSuite())
+    return tests
 
 if __name__ == '__main__':
-    main()
+    try:
+        if should_only_run_tests():
+            # Call using ./mandos --check [--verbose]
+            unittest.main()
+        else:
+            main()
+    finally:
+        logging.shutdown()

=== modified file 'mandos-ctl'
--- mandos-ctl	2019-03-09 18:17:28 +0000
+++ mandos-ctl	2021-02-03 23:10:42 +0000
@@ -1,10 +1,10 @@
-#!/usr/bin/python
-# -*- mode: python; coding: utf-8; after-save-hook: (lambda () (let ((command (if (and (boundp 'tramp-file-name-structure) (string-match (car tramp-file-name-structure) (buffer-file-name))) (tramp-file-name-localname (tramp-dissect-file-name (buffer-file-name))) (buffer-file-name)))) (if (= (shell-command (format "%s --check" (shell-quote-argument command)) "*Test*") 0) (let ((w (get-buffer-window "*Test*"))) (if w (delete-window w)) (kill-buffer "*Test*")) (display-buffer "*Test*")))); -*-
-#
-# Mandos Monitor - Control and monitor the Mandos server
-#
-# Copyright © 2008-2019 Teddy Hogeborn
-# Copyright © 2008-2019 Björn Påhlsson
+#!/usr/bin/python3 -bbI
+# -*- after-save-hook: (lambda () (let ((command (if (fboundp 'file-local-name) (file-local-name (buffer-file-name)) (or (file-remote-p (buffer-file-name) 'localname) (buffer-file-name))))) (if (= (progn (if (get-buffer "*Test*") (kill-buffer "*Test*")) (process-file-shell-command (format "%s --check" (shell-quote-argument command)) nil "*Test*")) 0) (let ((w (get-buffer-window "*Test*"))) (if w (delete-window w))) (progn (with-current-buffer "*Test*" (compilation-mode)) (display-buffer "*Test*" '(display-buffer-in-side-window)))))); coding: utf-8 -*-
+#
+# Mandos Control - Control or query the Mandos server
+#
+# Copyright © 2008-2020 Teddy Hogeborn
+# Copyright © 2008-2020 Björn Påhlsson
 #
 # This file is part of Mandos.
 #
@@ -46,7 +46,31 @@
 import tempfile
 import contextlib
 
-import dbus
+if sys.version_info.major == 2:
+    __metaclass__ = type
+    str = unicode
+
+class gi:
+    """Dummy gi module, for the tests"""
+    class repository:
+        class GLib:
+            class Error(Exception):
+                pass
+dbussy = None
+ravel = None
+dbus_python = None
+pydbus = None
+
+try:
+    import dbussy
+    import ravel
+except ImportError:
+    try:
+        import pydbus
+        import gi
+    except ImportError:
+        import dbus as dbus_python
+
 
 # Show warnings by default
 if not sys.warnoptions:
@@ -60,81 +84,231 @@
 logging.captureWarnings(True)   # Show warnings via the logging system
 
 if sys.version_info.major == 2:
-    str = unicode
+    import StringIO
+    io.StringIO = StringIO.StringIO
 
 locale.setlocale(locale.LC_ALL, "")
 
-domain = "se.recompile"
-busname = domain + ".Mandos"
-server_path = "/"
-server_interface = domain + ".Mandos"
-client_interface = domain + ".Mandos.Client"
-version = "1.8.3"
-
-
-try:
-    dbus.OBJECT_MANAGER_IFACE
-except AttributeError:
-    dbus.OBJECT_MANAGER_IFACE = "org.freedesktop.DBus.ObjectManager"
-
-
-def milliseconds_to_string(ms):
-    td = datetime.timedelta(0, 0, 0, ms)
-    return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
-            .format(days="{}T".format(td.days) if td.days else "",
-                    hours=td.seconds // 3600,
-                    minutes=(td.seconds % 3600) // 60,
-                    seconds=td.seconds % 60))
+version = "1.8.14"
+
+
+def main():
+    parser = argparse.ArgumentParser()
+    add_command_line_options(parser)
+
+    options = parser.parse_args()
+    check_option_syntax(parser, options)
+
+    clientnames = options.client
+
+    if options.debug:
+        log.setLevel(logging.DEBUG)
+
+    if dbussy is not None and ravel is not None:
+        bus = dbussy_adapter.CachingBus(dbussy, ravel)
+    elif pydbus is not None:
+        bus = pydbus_adapter.CachingBus(pydbus)
+    else:
+        bus = dbus_python_adapter.CachingBus(dbus_python)
+
+    try:
+        all_clients = bus.get_clients_and_properties()
+    except dbus.ConnectFailed as e:
+        log.critical("Could not connect to Mandos server: %s", e)
+        sys.exit(1)
+    except dbus.Error as e:
+        log.critical(
+            "Failed to access Mandos server through D-Bus:\n%s", e)
+        sys.exit(1)
+
+    # Compile dict of (clientpath: properties) to process
+    if not clientnames:
+        clients = all_clients
+    else:
+        clients = {}
+        for name in clientnames:
+            for objpath, properties in all_clients.items():
+                if properties["Name"] == name:
+                    clients[objpath] = properties
+                    break
+            else:
+                log.critical("Client not found on server: %r", name)
+                sys.exit(1)
+
+    commands = commands_from_options(options)
+
+    for command in commands:
+        command.run(clients, bus)
+
+
+def add_command_line_options(parser):
+    parser.add_argument("--version", action="version",
+                        version="%(prog)s {}".format(version),
+                        help="show version number and exit")
+    parser.add_argument("-a", "--all", action="store_true",
+                        help="Select all clients")
+    parser.add_argument("-v", "--verbose", action="store_true",
+                        help="Print all fields")
+    parser.add_argument("-j", "--dump-json", dest="commands",
+                        action="append_const", default=[],
+                        const=command.DumpJSON(),
+                        help="Dump client data in JSON format")
+    enable_disable = parser.add_mutually_exclusive_group()
+    enable_disable.add_argument("-e", "--enable", dest="commands",
+                                action="append_const", default=[],
+                                const=command.Enable(),
+                                help="Enable client")
+    enable_disable.add_argument("-d", "--disable", dest="commands",
+                                action="append_const", default=[],
+                                const=command.Disable(),
+                                help="disable client")
+    parser.add_argument("-b", "--bump-timeout", dest="commands",
+                        action="append_const", default=[],
+                        const=command.BumpTimeout(),
+                        help="Bump timeout for client")
+    start_stop_checker = parser.add_mutually_exclusive_group()
+    start_stop_checker.add_argument("--start-checker",
+                                    dest="commands",
+                                    action="append_const", default=[],
+                                    const=command.StartChecker(),
+                                    help="Start checker for client")
+    start_stop_checker.add_argument("--stop-checker", dest="commands",
+                                    action="append_const", default=[],
+                                    const=command.StopChecker(),
+                                    help="Stop checker for client")
+    parser.add_argument("-V", "--is-enabled", dest="commands",
+                        action="append_const", default=[],
+                        const=command.IsEnabled(),
+                        help="Check if client is enabled")
+    parser.add_argument("-r", "--remove", dest="commands",
+                        action="append_const", default=[],
+                        const=command.Remove(),
+                        help="Remove client")
+    parser.add_argument("-c", "--checker", dest="commands",
+                        action="append", default=[],
+                        metavar="COMMAND", type=command.SetChecker,
+                        help="Set checker command for client")
+    parser.add_argument(
+        "-t", "--timeout", dest="commands", action="append",
+        default=[], metavar="TIME",
+        type=command.SetTimeout.argparse(string_to_delta),
+        help="Set timeout for client")
+    parser.add_argument(
+        "--extended-timeout", dest="commands", action="append",
+        default=[], metavar="TIME",
+        type=command.SetExtendedTimeout.argparse(string_to_delta),
+        help="Set extended timeout for client")
+    parser.add_argument(
+        "-i", "--interval", dest="commands", action="append",
+        default=[], metavar="TIME",
+        type=command.SetInterval.argparse(string_to_delta),
+        help="Set checker interval for client")
+    approve_deny_default = parser.add_mutually_exclusive_group()
+    approve_deny_default.add_argument(
+        "--approve-by-default", dest="commands",
+        action="append_const", default=[],
+        const=command.ApproveByDefault(),
+        help="Set client to be approved by default")
+    approve_deny_default.add_argument(
+        "--deny-by-default", dest="commands",
+        action="append_const", default=[],
+        const=command.DenyByDefault(),
+        help="Set client to be denied by default")
+    parser.add_argument(
+        "--approval-delay", dest="commands", action="append",
+        default=[], metavar="TIME",
+        type=command.SetApprovalDelay.argparse(string_to_delta),
+        help="Set delay before client approve/deny")
+    parser.add_argument(
+        "--approval-duration", dest="commands", action="append",
+        default=[], metavar="TIME",
+        type=command.SetApprovalDuration.argparse(string_to_delta),
+        help="Set duration of one client approval")
+    parser.add_argument("-H", "--host", dest="commands",
+                        action="append", default=[], metavar="STRING",
+                        type=command.SetHost,
+                        help="Set host for client")
+    parser.add_argument(
+        "-s", "--secret", dest="commands", action="append",
+        default=[], metavar="FILENAME",
+        type=command.SetSecret.argparse(argparse.FileType(mode="rb")),
+        help="Set password blob (file) for client")
+    approve_deny = parser.add_mutually_exclusive_group()
+    approve_deny.add_argument(
+        "-A", "--approve", dest="commands", action="append_const",
+        default=[], const=command.Approve(),
+        help="Approve any current client request")
+    approve_deny.add_argument("-D", "--deny", dest="commands",
+                              action="append_const", default=[],
+                              const=command.Deny(),
+                              help="Deny any current client request")
+    parser.add_argument("--debug", action="store_true",
+                        help="Debug mode (show D-Bus commands)")
+    parser.add_argument("--check", action="store_true",
+                        help="Run self-test")
+    parser.add_argument("client", nargs="*", help="Client name")
+
+
+def string_to_delta(interval):
+    """Parse a string and return a datetime.timedelta"""
+
+    try:
+        return rfc3339_duration_to_delta(interval)
+    except ValueError as e:
+        log.warning("%s - Parsing as pre-1.6.1 interval instead",
+                    ' '.join(e.args))
+    return parse_pre_1_6_1_interval(interval)
 
 
 def rfc3339_duration_to_delta(duration):
     """Parse an RFC 3339 "duration" and return a datetime.timedelta
 
-    >>> rfc3339_duration_to_delta("P7D")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT60S")
-    datetime.timedelta(0, 60)
-    >>> rfc3339_duration_to_delta("PT60M")
-    datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("P60M")
-    datetime.timedelta(1680)
-    >>> rfc3339_duration_to_delta("PT24H")
-    datetime.timedelta(1)
-    >>> rfc3339_duration_to_delta("P1W")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT5M30S")
-    datetime.timedelta(0, 330)
-    >>> rfc3339_duration_to_delta("P1DT3M20S")
-    datetime.timedelta(1, 200)
+    >>> rfc3339_duration_to_delta("P7D") == datetime.timedelta(7)
+    True
+    >>> rfc3339_duration_to_delta("PT60S") == datetime.timedelta(0, 60)
+    True
+    >>> rfc3339_duration_to_delta("PT60M") == datetime.timedelta(hours=1)
+    True
+    >>> # 60 months
+    >>> rfc3339_duration_to_delta("P60M") == datetime.timedelta(1680)
+    True
+    >>> rfc3339_duration_to_delta("PT24H") == datetime.timedelta(1)
+    True
+    >>> rfc3339_duration_to_delta("P1W") == datetime.timedelta(7)
+    True
+    >>> rfc3339_duration_to_delta("PT5M30S") == datetime.timedelta(0, 330)
+    True
+    >>> rfc3339_duration_to_delta("P1DT3M20S") == datetime.timedelta(1, 200)
+    True
     >>> # Can not be empty:
     >>> rfc3339_duration_to_delta("")
     Traceback (most recent call last):
     ...
-    ValueError: Invalid RFC 3339 duration: u''
+    ValueError: Invalid RFC 3339 duration: ""
     >>> # Must start with "P":
     >>> rfc3339_duration_to_delta("1D")
     Traceback (most recent call last):
     ...
-    ValueError: Invalid RFC 3339 duration: u'1D'
+    ValueError: Invalid RFC 3339 duration: "1D"
     >>> # Must use correct order
     >>> rfc3339_duration_to_delta("PT1S2M")
     Traceback (most recent call last):
     ...
-    ValueError: Invalid RFC 3339 duration: u'PT1S2M'
+    ValueError: Invalid RFC 3339 duration: "PT1S2M"
     >>> # Time needs time marker
     >>> rfc3339_duration_to_delta("P1H2S")
     Traceback (most recent call last):
     ...
-    ValueError: Invalid RFC 3339 duration: u'P1H2S'
+    ValueError: Invalid RFC 3339 duration: "P1H2S"
     >>> # Weeks can not be combined with anything else
     >>> rfc3339_duration_to_delta("P1D2W")
     Traceback (most recent call last):
     ...
-    ValueError: Invalid RFC 3339 duration: u'P1D2W'
+    ValueError: Invalid RFC 3339 duration: "P1D2W"
     >>> rfc3339_duration_to_delta("P2W2H")
     Traceback (most recent call last):
     ...
-    ValueError: Invalid RFC 3339 duration: u'P2W2H'
+    ValueError: Invalid RFC 3339 duration: "P2W2H"
     """
 
     # Parsing an RFC 3339 duration with regular expressions is not
@@ -211,44 +385,33 @@
                 break
         else:
             # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration: {!r}"
+            raise ValueError("Invalid RFC 3339 duration: \"{}\""
                              .format(duration))
     # End token found
     return value
 
 
-def string_to_delta(interval):
-    """Parse a string and return a datetime.timedelta"""
-
-    try:
-        return rfc3339_duration_to_delta(interval)
-    except ValueError as e:
-        log.warning("%s - Parsing as pre-1.6.1 interval instead",
-                    ' '.join(e.args))
-    return parse_pre_1_6_1_interval(interval)
-
-
 def parse_pre_1_6_1_interval(interval):
     """Parse an interval string as documented by Mandos before 1.6.1,
     and return a datetime.timedelta
 
-    >>> parse_pre_1_6_1_interval('7d')
-    datetime.timedelta(7)
-    >>> parse_pre_1_6_1_interval('60s')
-    datetime.timedelta(0, 60)
-    >>> parse_pre_1_6_1_interval('60m')
-    datetime.timedelta(0, 3600)
-    >>> parse_pre_1_6_1_interval('24h')
-    datetime.timedelta(1)
-    >>> parse_pre_1_6_1_interval('1w')
-    datetime.timedelta(7)
-    >>> parse_pre_1_6_1_interval('5m 30s')
-    datetime.timedelta(0, 330)
-    >>> parse_pre_1_6_1_interval('')
-    datetime.timedelta(0)
+    >>> parse_pre_1_6_1_interval('7d') == datetime.timedelta(days=7)
+    True
+    >>> parse_pre_1_6_1_interval('60s') == datetime.timedelta(0, 60)
+    True
+    >>> parse_pre_1_6_1_interval('60m') == datetime.timedelta(hours=1)
+    True
+    >>> parse_pre_1_6_1_interval('24h') == datetime.timedelta(days=1)
+    True
+    >>> parse_pre_1_6_1_interval('1w') == datetime.timedelta(days=7)
+    True
+    >>> parse_pre_1_6_1_interval('5m 30s') == datetime.timedelta(0, 330)
+    True
+    >>> parse_pre_1_6_1_interval('') == datetime.timedelta(0)
+    True
     >>> # Ignore unknown characters, allow any order and repetitions
-    >>> parse_pre_1_6_1_interval('2dxy7zz11y3m5m')
-    datetime.timedelta(2, 480, 18000)
+    >>> parse_pre_1_6_1_interval('2dxy7zz11y3m5m') == datetime.timedelta(2, 480, 18000)
+    True
 
     """
 
@@ -271,678 +434,1903 @@
     return value
 
 
-## Classes for commands.
-
-# Abstract classes first
-class Command(object):
-    """Abstract class for commands"""
-    def run(self, mandos, clients):
-        """Normal commands should implement run_on_one_client(), but
-        commands which want to operate on all clients at the same time
-        can override this run() method instead."""
-        self.mandos = mandos
-        for client, properties in clients.items():
-            self.run_on_one_client(client, properties)
-
-class PrintCmd(Command):
-    """Abstract class for commands printing client details"""
-    all_keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
-                    "Created", "Interval", "Host", "KeyID",
-                    "Fingerprint", "CheckerRunning", "LastEnabled",
-                    "ApprovalPending", "ApprovedByDefault",
-                    "LastApprovalRequest", "ApprovalDelay",
-                    "ApprovalDuration", "Checker", "ExtendedTimeout",
-                    "Expires", "LastCheckerStatus")
-    def run(self, mandos, clients):
-        print(self.output(clients.values()))
-
-class PropertyCmd(Command):
-    """Abstract class for Actions for setting one client property"""
-    def run_on_one_client(self, client, properties):
-        """Set the Client's D-Bus property"""
-        log.debug("D-Bus: %s:%s:%s.Set(%r, %r, %r)", busname,
-                  client.__dbus_object_path__,
-                  dbus.PROPERTIES_IFACE, client_interface,
-                  self.property, self.value_to_set
-                  if not isinstance(self.value_to_set, dbus.Boolean)
-                  else bool(self.value_to_set))
-        client.Set(client_interface, self.property, self.value_to_set,
-                   dbus_interface=dbus.PROPERTIES_IFACE)
-
-class ValueArgumentMixIn(object):
-    """Mixin class for commands taking a value as argument"""
-    def __init__(self, value):
-        self.value_to_set = value
-
-class MillisecondsValueArgumentMixIn(ValueArgumentMixIn):
-    """Mixin class for commands taking a value argument as
-    milliseconds."""
-    @property
-    def value_to_set(self):
-        return self._vts
-    @value_to_set.setter
-    def value_to_set(self, value):
-        """When setting, convert value to a datetime.timedelta"""
-        self._vts = int(round(value.total_seconds() * 1000))
-
-# Actual (non-abstract) command classes
-
-class PrintTableCmd(PrintCmd):
-    def __init__(self, verbose=False):
-        self.verbose = verbose
-
-    def output(self, clients):
-        default_keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
-        keywords = default_keywords
-        if self.verbose:
-            keywords = self.all_keywords
-        return str(self.TableOfClients(clients, keywords))
-
-    class TableOfClients(object):
-        tableheaders = {
-            "Name": "Name",
-            "Enabled": "Enabled",
-            "Timeout": "Timeout",
-            "LastCheckedOK": "Last Successful Check",
-            "LastApprovalRequest": "Last Approval Request",
-            "Created": "Created",
-            "Interval": "Interval",
-            "Host": "Host",
-            "Fingerprint": "Fingerprint",
-            "KeyID": "Key ID",
-            "CheckerRunning": "Check Is Running",
-            "LastEnabled": "Last Enabled",
-            "ApprovalPending": "Approval Is Pending",
-            "ApprovedByDefault": "Approved By Default",
-            "ApprovalDelay": "Approval Delay",
-            "ApprovalDuration": "Approval Duration",
-            "Checker": "Checker",
-            "ExtendedTimeout": "Extended Timeout",
-            "Expires": "Expires",
-            "LastCheckerStatus": "Last Checker Status",
-        }
-
-        def __init__(self, clients, keywords, tableheaders=None):
-            self.clients = clients
-            self.keywords = keywords
-            if tableheaders is not None:
-                self.tableheaders = tableheaders
-
-        def __str__(self):
-            return "\n".join(self.rows())
-
-        if sys.version_info.major == 2:
-            __unicode__ = __str__
-            def __str__(self):
-                return str(self).encode(locale.getpreferredencoding())
-
-        def rows(self):
-            format_string = self.row_formatting_string()
-            rows = [self.header_line(format_string)]
-            rows.extend(self.client_line(client, format_string)
-                        for client in self.clients)
-            return rows
-
-        def row_formatting_string(self):
-            "Format string used to format table rows"
-            return " ".join("{{{key}:{width}}}".format(
-                width=max(len(self.tableheaders[key]),
-                          *(len(self.string_from_client(client, key))
-                            for client in self.clients)),
-                key=key)
-                            for key in self.keywords)
-
-        def string_from_client(self, client, key):
-            return self.valuetostring(client[key], key)
-
-        @staticmethod
-        def valuetostring(value, keyword):
-            if isinstance(value, dbus.Boolean):
-                return "Yes" if value else "No"
-            if keyword in ("Timeout", "Interval", "ApprovalDelay",
-                           "ApprovalDuration", "ExtendedTimeout"):
-                return milliseconds_to_string(value)
-            return str(value)
-
-        def header_line(self, format_string):
-            return format_string.format(**self.tableheaders)
-
-        def client_line(self, client, format_string):
-            return format_string.format(
-                **{key: self.string_from_client(client, key)
-                   for key in self.keywords})
-
-
-
-class DumpJSONCmd(PrintCmd):
-    def output(self, clients):
-        data = {client["Name"]:
-                {key: self.dbus_boolean_to_bool(client[key])
-                 for key in self.all_keywords}
-                for client in clients.values()}
-        return json.dumps(data, indent=4, separators=(',', ': '))
-    @staticmethod
-    def dbus_boolean_to_bool(value):
-        if isinstance(value, dbus.Boolean):
-            value = bool(value)
-        return value
-
-class IsEnabledCmd(Command):
-    def run_on_one_client(self, client, properties):
-        if self.is_enabled(client, properties):
-            sys.exit(0)
-        sys.exit(1)
-    def is_enabled(self, client, properties):
-        log.debug("D-Bus: %s:%s:%s.Get(%r, %r)", busname,
-                  client.__dbus_object_path__,
-                  dbus.PROPERTIES_IFACE, client_interface,
-                  "Enabled")
-        return bool(client.Get(client_interface, "Enabled",
-                               dbus_interface=dbus.PROPERTIES_IFACE))
-
-class RemoveCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s:%s.RemoveClient(%r)", busname,
-                  server_path, server_interface,
-                  str(client.__dbus_object_path__))
-        self.mandos.RemoveClient(client.__dbus_object_path__)
-
-class ApproveCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s.Approve(True)",
-                  client.__dbus_object_path__, client_interface)
-        client.Approve(dbus.Boolean(True),
-                       dbus_interface=client_interface)
-
-class DenyCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s.Approve(False)",
-                  client.__dbus_object_path__, client_interface)
-        client.Approve(dbus.Boolean(False),
-                       dbus_interface=client_interface)
-
-class EnableCmd(PropertyCmd):
-    property = "Enabled"
-    value_to_set = dbus.Boolean(True)
-
-class DisableCmd(PropertyCmd):
-    property = "Enabled"
-    value_to_set = dbus.Boolean(False)
-
-class BumpTimeoutCmd(PropertyCmd):
-    property = "LastCheckedOK"
-    value_to_set = ""
-
-class StartCheckerCmd(PropertyCmd):
-    property = "CheckerRunning"
-    value_to_set = dbus.Boolean(True)
-
-class StopCheckerCmd(PropertyCmd):
-    property = "CheckerRunning"
-    value_to_set = dbus.Boolean(False)
-
-class ApproveByDefaultCmd(PropertyCmd):
-    property = "ApprovedByDefault"
-    value_to_set = dbus.Boolean(True)
-
-class DenyByDefaultCmd(PropertyCmd):
-    property = "ApprovedByDefault"
-    value_to_set = dbus.Boolean(False)
-
-class SetCheckerCmd(PropertyCmd, ValueArgumentMixIn):
-    property = "Checker"
-
-class SetHostCmd(PropertyCmd, ValueArgumentMixIn):
-    property = "Host"
-
-class SetSecretCmd(PropertyCmd, ValueArgumentMixIn):
-    @property
-    def value_to_set(self):
-        return self._vts
-    @value_to_set.setter
-    def value_to_set(self, value):
-        """When setting, read data from supplied file object"""
-        self._vts = value.read()
-        value.close()
-    property = "Secret"
-
-class SetTimeoutCmd(PropertyCmd, MillisecondsValueArgumentMixIn):
-    property = "Timeout"
-
-class SetExtendedTimeoutCmd(PropertyCmd,
-                            MillisecondsValueArgumentMixIn):
-    property = "ExtendedTimeout"
-
-class SetIntervalCmd(PropertyCmd, MillisecondsValueArgumentMixIn):
-    property = "Interval"
-
-class SetApprovalDelayCmd(PropertyCmd,
-                          MillisecondsValueArgumentMixIn):
-    property = "ApprovalDelay"
-
-class SetApprovalDurationCmd(PropertyCmd,
-                             MillisecondsValueArgumentMixIn):
-    property = "ApprovalDuration"
-
-def add_command_line_options(parser):
-    parser.add_argument("--version", action="version",
-                        version="%(prog)s {}".format(version),
-                        help="show version number and exit")
-    parser.add_argument("-a", "--all", action="store_true",
-                        help="Select all clients")
-    parser.add_argument("-v", "--verbose", action="store_true",
-                        help="Print all fields")
-    parser.add_argument("-j", "--dump-json", action="store_true",
-                        help="Dump client data in JSON format")
-    enable_disable = parser.add_mutually_exclusive_group()
-    enable_disable.add_argument("-e", "--enable", action="store_true",
-                                help="Enable client")
-    enable_disable.add_argument("-d", "--disable",
-                                action="store_true",
-                                help="disable client")
-    parser.add_argument("-b", "--bump-timeout", action="store_true",
-                        help="Bump timeout for client")
-    start_stop_checker = parser.add_mutually_exclusive_group()
-    start_stop_checker.add_argument("--start-checker",
-                                    action="store_true",
-                                    help="Start checker for client")
-    start_stop_checker.add_argument("--stop-checker",
-                                    action="store_true",
-                                    help="Stop checker for client")
-    parser.add_argument("-V", "--is-enabled", action="store_true",
-                        help="Check if client is enabled")
-    parser.add_argument("-r", "--remove", action="store_true",
-                        help="Remove client")
-    parser.add_argument("-c", "--checker",
-                        help="Set checker command for client")
-    parser.add_argument("-t", "--timeout", type=string_to_delta,
-                        help="Set timeout for client")
-    parser.add_argument("--extended-timeout", type=string_to_delta,
-                        help="Set extended timeout for client")
-    parser.add_argument("-i", "--interval", type=string_to_delta,
-                        help="Set checker interval for client")
-    approve_deny_default = parser.add_mutually_exclusive_group()
-    approve_deny_default.add_argument(
-        "--approve-by-default", action="store_true",
-        default=None, dest="approved_by_default",
-        help="Set client to be approved by default")
-    approve_deny_default.add_argument(
-        "--deny-by-default", action="store_false",
-        dest="approved_by_default",
-        help="Set client to be denied by default")
-    parser.add_argument("--approval-delay", type=string_to_delta,
-                        help="Set delay before client approve/deny")
-    parser.add_argument("--approval-duration", type=string_to_delta,
-                        help="Set duration of one client approval")
-    parser.add_argument("-H", "--host", help="Set host for client")
-    parser.add_argument("-s", "--secret",
-                        type=argparse.FileType(mode="rb"),
-                        help="Set password blob (file) for client")
-    approve_deny = parser.add_mutually_exclusive_group()
-    approve_deny.add_argument(
-        "-A", "--approve", action="store_true",
-        help="Approve any current client request")
-    approve_deny.add_argument("-D", "--deny", action="store_true",
-                              help="Deny any current client request")
-    parser.add_argument("--debug", action="store_true",
-                        help="Debug mode (show D-Bus commands)")
-    parser.add_argument("--check", action="store_true",
-                        help="Run self-test")
-    parser.add_argument("client", nargs="*", help="Client name")
-
-
-def commands_from_options(options):
-
-    commands = []
-
-    if options.dump_json:
-        commands.append(DumpJSONCmd())
-
-    if options.enable:
-        commands.append(EnableCmd())
-
-    if options.disable:
-        commands.append(DisableCmd())
-
-    if options.bump_timeout:
-        commands.append(BumpTimeoutCmd())
-
-    if options.start_checker:
-        commands.append(StartCheckerCmd())
-
-    if options.stop_checker:
-        commands.append(StopCheckerCmd())
-
-    if options.is_enabled:
-        commands.append(IsEnabledCmd())
-
-    if options.checker is not None:
-        commands.append(SetCheckerCmd(options.checker))
-
-    if options.timeout is not None:
-        commands.append(SetTimeoutCmd(options.timeout))
-
-    if options.extended_timeout:
-        commands.append(
-            SetExtendedTimeoutCmd(options.extended_timeout))
-
-    if options.interval is not None:
-        commands.append(SetIntervalCmd(options.interval))
-
-    if options.approved_by_default is not None:
-        if options.approved_by_default:
-            commands.append(ApproveByDefaultCmd())
-        else:
-            commands.append(DenyByDefaultCmd())
-
-    if options.approval_delay is not None:
-        commands.append(SetApprovalDelayCmd(options.approval_delay))
-
-    if options.approval_duration is not None:
-        commands.append(
-            SetApprovalDurationCmd(options.approval_duration))
-
-    if options.host is not None:
-        commands.append(SetHostCmd(options.host))
-
-    if options.secret is not None:
-        commands.append(SetSecretCmd(options.secret))
-
-    if options.approve:
-        commands.append(ApproveCmd())
-
-    if options.deny:
-        commands.append(DenyCmd())
-
-    if options.remove:
-        commands.append(RemoveCmd())
-
-    # If no command option has been given, show table of clients,
-    # optionally verbosely
-    if not commands:
-        commands.append(PrintTableCmd(verbose=options.verbose))
-
-    return commands
-
-
 def check_option_syntax(parser, options):
     """Apply additional restrictions on options, not expressible in
 argparse"""
 
-    def has_actions(options):
-        return any((options.enable,
-                    options.disable,
-                    options.bump_timeout,
-                    options.start_checker,
-                    options.stop_checker,
-                    options.is_enabled,
-                    options.remove,
-                    options.checker is not None,
-                    options.timeout is not None,
-                    options.extended_timeout is not None,
-                    options.interval is not None,
-                    options.approved_by_default is not None,
-                    options.approval_delay is not None,
-                    options.approval_duration is not None,
-                    options.host is not None,
-                    options.secret is not None,
-                    options.approve,
-                    options.deny))
+    def has_commands(options, commands=None):
+        if commands is None:
+            commands = (command.Enable,
+                        command.Disable,
+                        command.BumpTimeout,
+                        command.StartChecker,
+                        command.StopChecker,
+                        command.IsEnabled,
+                        command.Remove,
+                        command.SetChecker,
+                        command.SetTimeout,
+                        command.SetExtendedTimeout,
+                        command.SetInterval,
+                        command.ApproveByDefault,
+                        command.DenyByDefault,
+                        command.SetApprovalDelay,
+                        command.SetApprovalDuration,
+                        command.SetHost,
+                        command.SetSecret,
+                        command.Approve,
+                        command.Deny)
+        return any(isinstance(cmd, commands)
+                   for cmd in options.commands)
 
-    if has_actions(options) and not (options.client or options.all):
+    if has_commands(options) and not (options.client or options.all):
         parser.error("Options require clients names or --all.")
-    if options.verbose and has_actions(options):
+    if options.verbose and has_commands(options):
         parser.error("--verbose can only be used alone.")
-    if options.dump_json and (options.verbose
-                              or has_actions(options)):
+    if (has_commands(options, (command.DumpJSON,))
+        and (options.verbose or len(options.commands) > 1)):
         parser.error("--dump-json can only be used alone.")
-    if options.all and not has_actions(options):
+    if options.all and not has_commands(options):
         parser.error("--all requires an action.")
-    if options.is_enabled and len(options.client) > 1:
+    if (has_commands(options, (command.IsEnabled,))
+        and len(options.client) > 1):
         parser.error("--is-enabled requires exactly one client")
-    if options.remove:
-        options.remove = False
-        if has_actions(options) and not options.deny:
-            parser.error("--remove can only be combined with --deny")
-        options.remove = True
-
-
-def main():
-    parser = argparse.ArgumentParser()
-
-    add_command_line_options(parser)
-
-    options = parser.parse_args()
-
-    check_option_syntax(parser, options)
-
-    clientnames = options.client
-
-    if options.debug:
-        log.setLevel(logging.DEBUG)
-
-    try:
-        bus = dbus.SystemBus()
-        log.debug("D-Bus: Connect to: (name=%r, path=%r)", busname,
-                  server_path)
-        mandos_dbus_objc = bus.get_object(busname, server_path)
-    except dbus.exceptions.DBusException:
-        log.critical("Could not connect to Mandos server")
-        sys.exit(1)
-
-    mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                 dbus_interface=server_interface)
-    mandos_serv_object_manager = dbus.Interface(
-        mandos_dbus_objc, dbus_interface=dbus.OBJECT_MANAGER_IFACE)
-
-    # Filter out log message from dbus module
-    dbus_logger = logging.getLogger("dbus.proxies")
-    class NullFilter(logging.Filter):
-        def filter(self, record):
-            return False
-    dbus_filter = NullFilter()
-    try:
-        dbus_logger.addFilter(dbus_filter)
-        log.debug("D-Bus: %s:%s:%s.GetManagedObjects()", busname,
-                  server_path, dbus.OBJECT_MANAGER_IFACE)
-        mandos_clients = {path: ifs_and_props[client_interface]
-                          for path, ifs_and_props in
-                          mandos_serv_object_manager
-                          .GetManagedObjects().items()
-                          if client_interface in ifs_and_props}
-    except dbus.exceptions.DBusException as e:
-        log.critical("Failed to access Mandos server through D-Bus:"
-                     "\n%s", e)
-        sys.exit(1)
-    finally:
-        # restore dbus logger
-        dbus_logger.removeFilter(dbus_filter)
-
-    # Compile dict of (clients: properties) to process
-    clients = {}
-
-    if not clientnames:
-        clients = {(log.debug("D-Bus: Connect to: (name=%r, path=%r)",
-                              busname, str(path)) and False) or
-                   bus.get_object(busname, path): properties
-                   for path, properties in mandos_clients.items()}
-    else:
-        for name in clientnames:
-            for path, client in mandos_clients.items():
-                if client["Name"] == name:
-                    log.debug("D-Bus: Connect to: (name=%r, path=%r)",
-                              busname, str(path))
-                    client_objc = bus.get_object(busname, path)
-                    clients[client_objc] = client
-                    break
-            else:
-                log.critical("Client not found on server: %r", name)
-                sys.exit(1)
-
-    # Run all commands on clients
-    commands = commands_from_options(options)
-    for command in commands:
-        command.run(mandos_serv, clients)
+    if (len(options.commands) > 1
+        and has_commands(options, (command.Remove,))
+        and not has_commands(options, (command.Deny,))):
+        parser.error("--remove can only be combined with --deny")
+
+
+class dbus:
+
+    class SystemBus:
+
+        object_manager_iface = "org.freedesktop.DBus.ObjectManager"
+        def get_managed_objects(self, busname, objectpath):
+            return self.call_method("GetManagedObjects", busname,
+                                    objectpath,
+                                    self.object_manager_iface)
+
+        properties_iface = "org.freedesktop.DBus.Properties"
+        def set_property(self, busname, objectpath, interface, key,
+                         value):
+            self.call_method("Set", busname, objectpath,
+                             self.properties_iface, interface, key,
+                             value)
+
+        def call_method(self, methodname, busname, objectpath,
+                        interface, *args):
+            raise NotImplementedError()
+
+
+    class MandosBus(SystemBus):
+        busname_domain = "se.recompile"
+        busname = busname_domain + ".Mandos"
+        server_path = "/"
+        server_interface = busname_domain + ".Mandos"
+        client_interface = busname_domain + ".Mandos.Client"
+        del busname_domain
+
+        def get_clients_and_properties(self):
+            managed_objects = self.get_managed_objects(
+                self.busname, self.server_path)
+            return {objpath: properties[self.client_interface]
+                    for objpath, properties in managed_objects.items()
+                    if self.client_interface in properties}
+
+        def set_client_property(self, objectpath, key, value):
+            return self.set_property(self.busname, objectpath,
+                                     self.client_interface, key,
+                                     value)
+
+        def call_client_method(self, objectpath, method, *args):
+            return self.call_method(method, self.busname, objectpath,
+                                    self.client_interface, *args)
+
+        def call_server_method(self, method, *args):
+            return self.call_method(method, self.busname,
+                                    self.server_path,
+                                    self.server_interface, *args)
+
+    class Error(Exception):
+        pass
+
+    class ConnectFailed(Error):
+        pass
+
+
+class dbus_python_adapter:
+
+    class SystemBus(dbus.MandosBus):
+        """Use dbus-python"""
+
+        def __init__(self, module=dbus_python):
+            self.dbus_python = module
+            self.bus = self.dbus_python.SystemBus()
+
+        @contextlib.contextmanager
+        def convert_exception(self, exception_class=dbus.Error):
+            try:
+                yield
+            except self.dbus_python.exceptions.DBusException as e:
+                # This does what "raise from" would do
+                exc = exception_class(*e.args)
+                exc.__cause__ = e
+                raise exc
+
+        def call_method(self, methodname, busname, objectpath,
+                        interface, *args):
+            proxy_object = self.get_object(busname, objectpath)
+            log.debug("D-Bus: %s:%s:%s.%s(%s)", busname, objectpath,
+                      interface, methodname,
+                      ", ".join(repr(a) for a in args))
+            method = getattr(proxy_object, methodname)
+            with self.convert_exception():
+                with dbus_python_adapter.SilenceLogger(
+                        "dbus.proxies"):
+                    value = method(*args, dbus_interface=interface)
+            return self.type_filter(value)
+
+        def get_object(self, busname, objectpath):
+            log.debug("D-Bus: Connect to: (busname=%r, path=%r)",
+                      busname, objectpath)
+            with self.convert_exception(dbus.ConnectFailed):
+                return self.bus.get_object(busname, objectpath)
+
+        def type_filter(self, value):
+            """Convert the most bothersome types to Python types"""
+            if isinstance(value, self.dbus_python.Boolean):
+                return bool(value)
+            if isinstance(value, self.dbus_python.ObjectPath):
+                return str(value)
+            # Also recurse into dictionaries
+            if isinstance(value, self.dbus_python.Dictionary):
+                return {self.type_filter(key):
+                        self.type_filter(subval)
+                        for key, subval in value.items()}
+            return value
+
+        def set_client_property(self, objectpath, key, value):
+            if key == "Secret":
+                if not isinstance(value, bytes):
+                    value = value.encode("utf-8")
+                value = self.dbus_python.ByteArray(value)
+            return self.set_property(self.busname, objectpath,
+                                     self.client_interface, key,
+                                     value)
+
+    class SilenceLogger:
+        "Simple context manager to silence a particular logger"
+        def __init__(self, loggername):
+            self.logger = logging.getLogger(loggername)
+
+        def __enter__(self):
+            self.logger.addFilter(self.nullfilter)
+
+        class NullFilter(logging.Filter):
+            def filter(self, record):
+                return False
+
+        nullfilter = NullFilter()
+
+        def __exit__(self, exc_type, exc_val, exc_tb):
+            self.logger.removeFilter(self.nullfilter)
+
+
+    class CachingBus(SystemBus):
+        """A caching layer for dbus_python_adapter.SystemBus"""
+        def __init__(self, *args, **kwargs):
+            self.object_cache = {}
+            super(dbus_python_adapter.CachingBus,
+                  self).__init__(*args, **kwargs)
+        def get_object(self, busname, objectpath):
+            try:
+                return self.object_cache[(busname, objectpath)]
+            except KeyError:
+                new_object = super(
+                    dbus_python_adapter.CachingBus,
+                    self).get_object(busname, objectpath)
+                self.object_cache[(busname, objectpath)]  = new_object
+                return new_object
+
+
+class pydbus_adapter:
+    class SystemBus(dbus.MandosBus):
+        def __init__(self, module=pydbus):
+            self.pydbus = module
+            self.bus = self.pydbus.SystemBus()
+
+        @contextlib.contextmanager
+        def convert_exception(self, exception_class=dbus.Error):
+            try:
+                yield
+            except gi.repository.GLib.Error as e:
+                # This does what "raise from" would do
+                exc = exception_class(*e.args)
+                exc.__cause__ = e
+                raise exc
+
+        def call_method(self, methodname, busname, objectpath,
+                        interface, *args):
+            proxy_object = self.get(busname, objectpath)
+            log.debug("D-Bus: %s:%s:%s.%s(%s)", busname, objectpath,
+                      interface, methodname,
+                      ", ".join(repr(a) for a in args))
+            method = getattr(proxy_object[interface], methodname)
+            with self.convert_exception():
+                return method(*args)
+
+        def get(self, busname, objectpath):
+            log.debug("D-Bus: Connect to: (busname=%r, path=%r)",
+                      busname, objectpath)
+            with self.convert_exception(dbus.ConnectFailed):
+                if sys.version_info.major <= 2:
+                    with warnings.catch_warnings():
+                        warnings.filterwarnings(
+                            "ignore", "", DeprecationWarning,
+                            r"^xml\.etree\.ElementTree$")
+                        return self.bus.get(busname, objectpath)
+                else:
+                    return self.bus.get(busname, objectpath)
+
+        def set_property(self, busname, objectpath, interface, key,
+                         value):
+            proxy_object = self.get(busname, objectpath)
+            log.debug("D-Bus: %s:%s:%s.Set(%r, %r, %r)", busname,
+                      objectpath, self.properties_iface, interface,
+                      key, value)
+            setattr(proxy_object[interface], key, value)
+
+    class CachingBus(SystemBus):
+        """A caching layer for pydbus_adapter.SystemBus"""
+        def __init__(self, *args, **kwargs):
+            self.object_cache = {}
+            super(pydbus_adapter.CachingBus,
+                  self).__init__(*args, **kwargs)
+        def get(self, busname, objectpath):
+            try:
+                return self.object_cache[(busname, objectpath)]
+            except KeyError:
+                new_object = (super(pydbus_adapter.CachingBus, self)
+                              .get(busname, objectpath))
+                self.object_cache[(busname, objectpath)]  = new_object
+                return new_object
+
+
+class dbussy_adapter:
+    class SystemBus(dbus.SystemBus):
+        """Use DBussy"""
+
+        def __init__(self, dbussy, ravel):
+            self.dbussy = dbussy
+            self.ravel = ravel
+            self.bus = ravel.system_bus()
+
+        @contextlib.contextmanager
+        def convert_exception(self, exception_class=dbus.Error):
+            try:
+                yield
+            except self.dbussy.DBusError as e:
+                # This does what "raise from" would do
+                exc = exception_class(*e.args)
+                exc.__cause__ = e
+                raise exc
+
+        def call_method(self, methodname, busname, objectpath,
+                        interface, *args):
+            proxy_object = self.get_object(busname, objectpath)
+            log.debug("D-Bus: %s:%s:%s.%s(%s)", busname, objectpath,
+                      interface, methodname,
+                      ", ".join(repr(a) for a in args))
+            iface = proxy_object.get_interface(interface)
+            method = getattr(iface, methodname)
+            with self.convert_exception(dbus.Error):
+                value =  method(*args)
+            # DBussy returns values either as an empty list or as a
+            # list of one element with the return value
+            if value:
+                return self.type_filter(value[0])
+
+        def get_object(self, busname, objectpath):
+            log.debug("D-Bus: Connect to: (busname=%r, path=%r)",
+                      busname, objectpath)
+            with self.convert_exception(dbus.ConnectFailed):
+                return self.bus[busname][objectpath]
+
+        def type_filter(self, value):
+            """Convert the most bothersome types to Python types"""
+            # A D-Bus Variant value is represented as the Python type
+            # Tuple[dbussy.DBUS.Signature, Any]
+            if isinstance(value, tuple):
+                if (len(value) == 2
+                    and isinstance(value[0],
+                                   self.dbussy.DBUS.Signature)):
+                    return self.type_filter(value[1])
+            elif isinstance(value, self.dbussy.DBUS.ObjectPath):
+                return str(value)
+            # Also recurse into dictionaries
+            elif isinstance(value, dict):
+                return {self.type_filter(key):
+                        self.type_filter(subval)
+                        for key, subval in value.items()}
+            return value
+
+        def set_property(self, busname, objectpath, interface, key,
+                         value):
+            proxy_object = self.get_object(busname, objectpath)
+            log.debug("D-Bus: %s:%s:%s.Set(%r, %r, %r)", busname,
+                      objectpath, self.properties_iface, interface,
+                      key, value)
+            if key == "Secret":
+                # DBussy wants a Byte Array to be a sequence of
+                # values, not a byte string
+                value = tuple(value)
+            setattr(proxy_object.get_interface(interface), key, value)
+
+    class MandosBus(SystemBus, dbus.MandosBus):
+        pass
+
+    class CachingBus(MandosBus):
+        """A caching layer for dbussy_adapter.MandosBus"""
+        def __init__(self, *args, **kwargs):
+            self.object_cache = {}
+            super(dbussy_adapter.CachingBus, self).__init__(*args,
+                                                            **kwargs)
+        def get_object(self, busname, objectpath):
+            try:
+                return self.object_cache[(busname, objectpath)]
+            except KeyError:
+                new_object = super(
+                    dbussy_adapter.CachingBus,
+                    self).get_object(busname, objectpath)
+                self.object_cache[(busname, objectpath)]  = new_object
+                return new_object
+
+
+def commands_from_options(options):
+
+    commands = list(options.commands)
+
+    def find_cmd(cmd, commands):
+        i = 0
+        for i, c in enumerate(commands):
+            if isinstance(c, cmd):
+                return i
+        return i+1
+
+    # If command.Remove is present, move any instances of command.Deny
+    # to occur ahead of command.Remove.
+    index_of_remove = find_cmd(command.Remove, commands)
+    before_remove = commands[:index_of_remove]
+    after_remove = commands[index_of_remove:]
+    cleaned_after = []
+    for cmd in after_remove:
+        if isinstance(cmd, command.Deny):
+            before_remove.append(cmd)
+        else:
+            cleaned_after.append(cmd)
+    if cleaned_after != after_remove:
+        commands = before_remove + cleaned_after
+
+    # If no command option has been given, show table of clients,
+    # optionally verbosely
+    if not commands:
+        commands.append(command.PrintTable(verbose=options.verbose))
+
+    return commands
+
+
+class command:
+    """A namespace for command classes"""
+
+    class Base:
+        """Abstract base class for commands"""
+        def run(self, clients, bus=None):
+            """Normal commands should implement run_on_one_client(),
+but commands which want to operate on all clients at the same time can
+override this run() method instead.
+"""
+            self.bus = bus
+            for client, properties in clients.items():
+                self.run_on_one_client(client, properties)
+
+
+    class IsEnabled(Base):
+        def run(self, clients, bus=None):
+            properties = next(iter(clients.values()))
+            if properties["Enabled"]:
+                sys.exit(0)
+            sys.exit(1)
+
+
+    class Approve(Base):
+        def run_on_one_client(self, client, properties):
+            self.bus.call_client_method(client, "Approve", True)
+
+
+    class Deny(Base):
+        def run_on_one_client(self, client, properties):
+            self.bus.call_client_method(client, "Approve", False)
+
+
+    class Remove(Base):
+        def run(self, clients, bus):
+            for clientpath in frozenset(clients.keys()):
+                bus.call_server_method("RemoveClient", clientpath)
+
+
+    class Output(Base):
+        """Abstract class for commands outputting client details"""
+        all_keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
+                        "Created", "Interval", "Host", "KeyID",
+                        "Fingerprint", "CheckerRunning",
+                        "LastEnabled", "ApprovalPending",
+                        "ApprovedByDefault", "LastApprovalRequest",
+                        "ApprovalDelay", "ApprovalDuration",
+                        "Checker", "ExtendedTimeout", "Expires",
+                        "LastCheckerStatus")
+
+
+    class DumpJSON(Output):
+        def run(self, clients, bus=None):
+            data = {properties["Name"]:
+                    {key: properties[key]
+                     for key in self.all_keywords}
+                    for properties in clients.values()}
+            print(json.dumps(data, indent=4, separators=(',', ': ')))
+
+
+    class PrintTable(Output):
+        def __init__(self, verbose=False):
+            self.verbose = verbose
+
+        def run(self, clients, bus=None):
+            default_keywords = ("Name", "Enabled", "Timeout",
+                                "LastCheckedOK")
+            keywords = default_keywords
+            if self.verbose:
+                keywords = self.all_keywords
+            print(self.TableOfClients(clients.values(), keywords))
+
+        class TableOfClients:
+            tableheaders = {
+                "Name": "Name",
+                "Enabled": "Enabled",
+                "Timeout": "Timeout",
+                "LastCheckedOK": "Last Successful Check",
+                "LastApprovalRequest": "Last Approval Request",
+                "Created": "Created",
+                "Interval": "Interval",
+                "Host": "Host",
+                "Fingerprint": "Fingerprint",
+                "KeyID": "Key ID",
+                "CheckerRunning": "Check Is Running",
+                "LastEnabled": "Last Enabled",
+                "ApprovalPending": "Approval Is Pending",
+                "ApprovedByDefault": "Approved By Default",
+                "ApprovalDelay": "Approval Delay",
+                "ApprovalDuration": "Approval Duration",
+                "Checker": "Checker",
+                "ExtendedTimeout": "Extended Timeout",
+                "Expires": "Expires",
+                "LastCheckerStatus": "Last Checker Status",
+            }
+
+            def __init__(self, clients, keywords):
+                self.clients = clients
+                self.keywords = keywords
+
+            def __str__(self):
+                return "\n".join(self.rows())
+
+            if sys.version_info.major == 2:
+                __unicode__ = __str__
+                def __str__(self):
+                    return str(self).encode(
+                        locale.getpreferredencoding())
+
+            def rows(self):
+                format_string = self.row_formatting_string()
+                rows = [self.header_line(format_string)]
+                rows.extend(self.client_line(client, format_string)
+                            for client in self.clients)
+                return rows
+
+            def row_formatting_string(self):
+                "Format string used to format table rows"
+                return " ".join("{{{key}:{width}}}".format(
+                    width=max(len(self.tableheaders[key]),
+                              *(len(self.string_from_client(client,
+                                                            key))
+                                for client in self.clients)),
+                    key=key)
+                                for key in self.keywords)
+
+            def string_from_client(self, client, key):
+                return self.valuetostring(client[key], key)
+
+            @classmethod
+            def valuetostring(cls, value, keyword):
+                if isinstance(value, bool):
+                    return "Yes" if value else "No"
+                if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                               "ApprovalDuration", "ExtendedTimeout"):
+                    return cls.milliseconds_to_string(value)
+                return str(value)
+
+            def header_line(self, format_string):
+                return format_string.format(**self.tableheaders)
+
+            def client_line(self, client, format_string):
+                return format_string.format(
+                    **{key: self.string_from_client(client, key)
+                       for key in self.keywords})
+
+            @staticmethod
+            def milliseconds_to_string(ms):
+                td = datetime.timedelta(0, 0, 0, ms)
+                return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
+                        .format(days="{}T".format(td.days)
+                                if td.days else "",
+                                hours=td.seconds // 3600,
+                                minutes=(td.seconds % 3600) // 60,
+                                seconds=td.seconds % 60))
+
+
+    class PropertySetter(Base):
+        "Abstract class for Actions for setting one client property"
+
+        def run_on_one_client(self, client, properties=None):
+            """Set the Client's D-Bus property"""
+            self.bus.set_client_property(client, self.propname,
+                                         self.value_to_set)
+
+        @property
+        def propname(self):
+            raise NotImplementedError()
+
+
+    class Enable(PropertySetter):
+        propname = "Enabled"
+        value_to_set = True
+
+
+    class Disable(PropertySetter):
+        propname = "Enabled"
+        value_to_set = False
+
+
+    class BumpTimeout(PropertySetter):
+        propname = "LastCheckedOK"
+        value_to_set = ""
+
+
+    class StartChecker(PropertySetter):
+        propname = "CheckerRunning"
+        value_to_set = True
+
+
+    class StopChecker(PropertySetter):
+        propname = "CheckerRunning"
+        value_to_set = False
+
+
+    class ApproveByDefault(PropertySetter):
+        propname = "ApprovedByDefault"
+        value_to_set = True
+
+
+    class DenyByDefault(PropertySetter):
+        propname = "ApprovedByDefault"
+        value_to_set = False
+
+
+    class PropertySetterValue(PropertySetter):
+        """Abstract class for PropertySetter recieving a value as
+constructor argument instead of a class attribute."""
+        def __init__(self, value):
+            self.value_to_set = value
+
+        @classmethod
+        def argparse(cls, argtype):
+            def cmdtype(arg):
+                return cls(argtype(arg))
+            return cmdtype
+
+    class SetChecker(PropertySetterValue):
+        propname = "Checker"
+
+
+    class SetHost(PropertySetterValue):
+        propname = "Host"
+
+
+    class SetSecret(PropertySetterValue):
+        propname = "Secret"
+
+        @property
+        def value_to_set(self):
+            return self._vts
+
+        @value_to_set.setter
+        def value_to_set(self, value):
+            """When setting, read data from supplied file object"""
+            self._vts = value.read()
+            value.close()
+
+
+    class PropertySetterValueMilliseconds(PropertySetterValue):
+        """Abstract class for PropertySetterValue taking a value
+argument as a datetime.timedelta() but should store it as
+milliseconds."""
+
+        @property
+        def value_to_set(self):
+            return self._vts
+
+        @value_to_set.setter
+        def value_to_set(self, value):
+            "When setting, convert value from a datetime.timedelta"
+            self._vts = int(round(value.total_seconds() * 1000))
+
+
+    class SetTimeout(PropertySetterValueMilliseconds):
+        propname = "Timeout"
+
+
+    class SetExtendedTimeout(PropertySetterValueMilliseconds):
+        propname = "ExtendedTimeout"
+
+
+    class SetInterval(PropertySetterValueMilliseconds):
+        propname = "Interval"
+
+
+    class SetApprovalDelay(PropertySetterValueMilliseconds):
+        propname = "ApprovalDelay"
+
+
+    class SetApprovalDuration(PropertySetterValueMilliseconds):
+        propname = "ApprovalDuration"
+
 
 
-class Test_milliseconds_to_string(unittest.TestCase):
-    def test_all(self):
-        self.assertEqual(milliseconds_to_string(93785000),
-                         "1T02:03:05")
-    def test_no_days(self):
-        self.assertEqual(milliseconds_to_string(7385000), "02:03:05")
-    def test_all_zero(self):
-        self.assertEqual(milliseconds_to_string(0), "00:00:00")
-    def test_no_fractional_seconds(self):
-        self.assertEqual(milliseconds_to_string(400), "00:00:00")
-        self.assertEqual(milliseconds_to_string(900), "00:00:00")
-        self.assertEqual(milliseconds_to_string(1900), "00:00:01")
-
-class Test_string_to_delta(unittest.TestCase):
-    def test_handles_basic_rfc3339(self):
-        self.assertEqual(string_to_delta("PT0S"),
-                         datetime.timedelta())
-        self.assertEqual(string_to_delta("P0D"),
-                         datetime.timedelta())
-        self.assertEqual(string_to_delta("PT1S"),
-                         datetime.timedelta(0, 1))
-        self.assertEqual(string_to_delta("PT2H"),
-                         datetime.timedelta(0, 7200))
+class TestCaseWithAssertLogs(unittest.TestCase):
+    """unittest.TestCase.assertLogs only exists in Python 3.4"""
+
+    if not hasattr(unittest.TestCase, "assertLogs"):
+        @contextlib.contextmanager
+        def assertLogs(self, logger, level=logging.INFO):
+            capturing_handler = self.CapturingLevelHandler(level)
+            old_level = logger.level
+            old_propagate = logger.propagate
+            logger.addHandler(capturing_handler)
+            logger.setLevel(level)
+            logger.propagate = False
+            try:
+                yield capturing_handler.watcher
+            finally:
+                logger.propagate = old_propagate
+                logger.removeHandler(capturing_handler)
+                logger.setLevel(old_level)
+            self.assertGreater(len(capturing_handler.watcher.records),
+                               0)
+
+        class CapturingLevelHandler(logging.Handler):
+            def __init__(self, level, *args, **kwargs):
+                logging.Handler.__init__(self, *args, **kwargs)
+                self.watcher = self.LoggingWatcher([], [])
+            def emit(self, record):
+                self.watcher.records.append(record)
+                self.watcher.output.append(self.format(record))
+
+            LoggingWatcher = collections.namedtuple("LoggingWatcher",
+                                                    ("records",
+                                                     "output"))
+
+
+class Unique:
+    """Class for objects which exist only to be unique objects, since
+unittest.mock.sentinel only exists in Python 3.3"""
+
+
+class Test_string_to_delta(TestCaseWithAssertLogs):
+    # Just test basic RFC 3339 functionality here, the doc string for
+    # rfc3339_duration_to_delta() already has more comprehensive
+    # tests, which are run by doctest.
+
+    def test_rfc3339_zero_seconds(self):
+        self.assertEqual(datetime.timedelta(),
+                         string_to_delta("PT0S"))
+
+    def test_rfc3339_zero_days(self):
+        self.assertEqual(datetime.timedelta(), string_to_delta("P0D"))
+
+    def test_rfc3339_one_second(self):
+        self.assertEqual(datetime.timedelta(0, 1),
+                         string_to_delta("PT1S"))
+
+    def test_rfc3339_two_hours(self):
+        self.assertEqual(datetime.timedelta(0, 7200),
+                         string_to_delta("PT2H"))
+
     def test_falls_back_to_pre_1_6_1_with_warning(self):
-        # assertLogs only exists in Python 3.4
-        if hasattr(self, "assertLogs"):
-            with self.assertLogs(log, logging.WARNING):
-                value = string_to_delta("2h")
+        with self.assertLogs(log, logging.WARNING):
+            value = string_to_delta("2h")
+        self.assertEqual(datetime.timedelta(0, 7200), value)
+
+
+class Test_check_option_syntax(unittest.TestCase):
+    def setUp(self):
+        self.parser = argparse.ArgumentParser()
+        add_command_line_options(self.parser)
+
+    def test_actions_requires_client_or_all(self):
+        for action, value in self.actions.items():
+            args = self.actionargs(action, value)
+            with self.assertParseError():
+                self.parse_args(args)
+
+    # This mostly corresponds to the definition from has_commands() in
+    # check_option_syntax()
+    actions = {
+        "--enable": None,
+        "--disable": None,
+        "--bump-timeout": None,
+        "--start-checker": None,
+        "--stop-checker": None,
+        "--is-enabled": None,
+        "--remove": None,
+        "--checker": "x",
+        "--timeout": "PT0S",
+        "--extended-timeout": "PT0S",
+        "--interval": "PT0S",
+        "--approve-by-default": None,
+        "--deny-by-default": None,
+        "--approval-delay": "PT0S",
+        "--approval-duration": "PT0S",
+        "--host": "hostname",
+        "--secret": "/dev/null",
+        "--approve": None,
+        "--deny": None,
+    }
+
+    @staticmethod
+    def actionargs(action, value, *args):
+        if value is not None:
+            return [action, value] + list(args)
         else:
-            class WarningFilter(logging.Filter):
-                """Don't show, but record the presence of, warnings"""
-                def filter(self, record):
-                    is_warning = record.levelno >= logging.WARNING
-                    self.found = is_warning or getattr(self, "found",
-                                                       False)
-                    return not is_warning
-            warning_filter = WarningFilter()
-            log.addFilter(warning_filter)
+            return [action] + list(args)
+
+    @contextlib.contextmanager
+    def assertParseError(self):
+        with self.assertRaises(SystemExit) as e:
+            with self.redirect_stderr_to_devnull():
+                yield
+        # Exit code from argparse is guaranteed to be "2".  Reference:
+        # https://docs.python.org/3/library
+        # /argparse.html#exiting-methods
+        self.assertEqual(2, e.exception.code)
+
+    def parse_args(self, args):
+        options = self.parser.parse_args(args)
+        check_option_syntax(self.parser, options)
+
+    @staticmethod
+    @contextlib.contextmanager
+    def redirect_stderr_to_devnull():
+        old_stderr = sys.stderr
+        with contextlib.closing(open(os.devnull, "w")) as null:
+            sys.stderr = null
             try:
-                value = string_to_delta("2h")
+                yield
             finally:
-                log.removeFilter(warning_filter)
-            self.assertTrue(getattr(warning_filter, "found", False))
-        self.assertEqual(value, datetime.timedelta(0, 7200))
-
-
-class TestCmd(unittest.TestCase):
+                sys.stderr = old_stderr
+
+    def check_option_syntax(self, options):
+        check_option_syntax(self.parser, options)
+
+    def test_actions_all_conflicts_with_verbose(self):
+        for action, value in self.actions.items():
+            args = self.actionargs(action, value, "--all",
+                                   "--verbose")
+            with self.assertParseError():
+                self.parse_args(args)
+
+    def test_actions_with_client_conflicts_with_verbose(self):
+        for action, value in self.actions.items():
+            args = self.actionargs(action, value, "--verbose",
+                                   "client")
+            with self.assertParseError():
+                self.parse_args(args)
+
+    def test_dump_json_conflicts_with_verbose(self):
+        args = ["--dump-json", "--verbose"]
+        with self.assertParseError():
+            self.parse_args(args)
+
+    def test_dump_json_conflicts_with_action(self):
+        for action, value in self.actions.items():
+            args = self.actionargs(action, value, "--dump-json")
+            with self.assertParseError():
+                self.parse_args(args)
+
+    def test_all_can_not_be_alone(self):
+        args = ["--all"]
+        with self.assertParseError():
+            self.parse_args(args)
+
+    def test_all_is_ok_with_any_action(self):
+        for action, value in self.actions.items():
+            args = self.actionargs(action, value, "--all")
+            self.parse_args(args)
+
+    def test_any_action_is_ok_with_one_client(self):
+        for action, value in self.actions.items():
+            args = self.actionargs(action, value, "client")
+            self.parse_args(args)
+
+    def test_one_client_with_all_actions_except_is_enabled(self):
+        for action, value in self.actions.items():
+            if action == "--is-enabled":
+                continue
+            args = self.actionargs(action, value, "client")
+            self.parse_args(args)
+
+    def test_two_clients_with_all_actions_except_is_enabled(self):
+        for action, value in self.actions.items():
+            if action == "--is-enabled":
+                continue
+            args = self.actionargs(action, value, "client1",
+                                   "client2")
+            self.parse_args(args)
+
+    def test_two_clients_are_ok_with_actions_except_is_enabled(self):
+        for action, value in self.actions.items():
+            if action == "--is-enabled":
+                continue
+            args = self.actionargs(action, value, "client1",
+                                   "client2")
+            self.parse_args(args)
+
+    def test_is_enabled_fails_without_client(self):
+        args = ["--is-enabled"]
+        with self.assertParseError():
+            self.parse_args(args)
+
+    def test_is_enabled_fails_with_two_clients(self):
+        args = ["--is-enabled", "client1", "client2"]
+        with self.assertParseError():
+            self.parse_args(args)
+
+    def test_remove_can_only_be_combined_with_action_deny(self):
+        for action, value in self.actions.items():
+            if action in {"--remove", "--deny"}:
+                continue
+            args = self.actionargs(action, value, "--all",
+                                   "--remove")
+            with self.assertParseError():
+                self.parse_args(args)
+
+
+class Test_dbus_exceptions(unittest.TestCase):
+
+    def test_dbus_ConnectFailed_is_Error(self):
+        with self.assertRaises(dbus.Error):
+            raise dbus.ConnectFailed()
+
+
+class Test_dbus_MandosBus(unittest.TestCase):
+
+    class MockMandosBus(dbus.MandosBus):
+        def __init__(self):
+            self._name = "se.recompile.Mandos"
+            self._server_path = "/"
+            self._server_interface = "se.recompile.Mandos"
+            self._client_interface = "se.recompile.Mandos.Client"
+            self.calls = []
+            self.call_method_return = Unique()
+
+        def call_method(self, methodname, busname, objectpath,
+                        interface, *args):
+            self.calls.append((methodname, busname, objectpath,
+                               interface, args))
+            return self.call_method_return
+
+    def setUp(self):
+        self.bus = self.MockMandosBus()
+
+    def test_set_client_property(self):
+        self.bus.set_client_property("objectpath", "key", "value")
+        expected_call = ("Set", self.bus._name, "objectpath",
+                         "org.freedesktop.DBus.Properties",
+                         (self.bus._client_interface, "key", "value"))
+        self.assertIn(expected_call, self.bus.calls)
+
+    def test_call_client_method(self):
+        ret = self.bus.call_client_method("objectpath", "methodname")
+        self.assertIs(self.bus.call_method_return, ret)
+        expected_call = ("methodname", self.bus._name, "objectpath",
+                         self.bus._client_interface, ())
+        self.assertIn(expected_call, self.bus.calls)
+
+    def test_call_client_method_with_args(self):
+        args = (Unique(), Unique())
+        ret = self.bus.call_client_method("objectpath", "methodname",
+                                          *args)
+        self.assertIs(self.bus.call_method_return, ret)
+        expected_call = ("methodname", self.bus._name, "objectpath",
+                         self.bus._client_interface,
+                         (args[0], args[1]))
+        self.assertIn(expected_call, self.bus.calls)
+
+    def test_get_clients_and_properties(self):
+        managed_objects = {
+            "objectpath": {
+                self.bus._client_interface: {
+                    "key": "value",
+                    "bool": True,
+                },
+                "irrelevant_interface": {
+                    "key": "othervalue",
+                    "bool": False,
+                },
+            },
+            "other_objectpath": {
+                "other_irrelevant_interface": {
+                    "key": "value 3",
+                    "bool": None,
+                },
+            },
+        }
+        expected_clients_and_properties = {
+            "objectpath": {
+                "key": "value",
+                "bool": True,
+            }
+        }
+        self.bus.call_method_return = managed_objects
+        ret = self.bus.get_clients_and_properties()
+        self.assertDictEqual(expected_clients_and_properties, ret)
+        expected_call = ("GetManagedObjects", self.bus._name,
+                         self.bus._server_path,
+                         "org.freedesktop.DBus.ObjectManager", ())
+        self.assertIn(expected_call, self.bus.calls)
+
+    def test_call_server_method(self):
+        ret = self.bus.call_server_method("methodname")
+        self.assertIs(self.bus.call_method_return, ret)
+        expected_call = ("methodname", self.bus._name,
+                         self.bus._server_path,
+                         self.bus._server_interface, ())
+        self.assertIn(expected_call, self.bus.calls)
+
+    def test_call_server_method_with_args(self):
+        args = (Unique(), Unique())
+        ret = self.bus.call_server_method("methodname", *args)
+        self.assertIs(self.bus.call_method_return, ret)
+        expected_call = ("methodname", self.bus._name,
+                         self.bus._server_path,
+                         self.bus._server_interface,
+                         (args[0], args[1]))
+        self.assertIn(expected_call, self.bus.calls)
+
+
+class Test_dbus_python_adapter_SystemBus(TestCaseWithAssertLogs):
+
+    def MockDBusPython_func(self, func):
+        class mock_dbus_python:
+            """mock dbus-python module"""
+            class exceptions:
+                """Pseudo-namespace"""
+                class DBusException(Exception):
+                    pass
+            class SystemBus:
+                @staticmethod
+                def get_object(busname, objectpath):
+                    DBusObject = collections.namedtuple(
+                        "DBusObject", ("methodname", "Set"))
+                    def method(*args, **kwargs):
+                        self.assertEqual({"dbus_interface":
+                                          "interface"},
+                                         kwargs)
+                        return func(*args)
+                    def set_property(interface, key, value,
+                                     dbus_interface=None):
+                        self.assertEqual(
+                            "org.freedesktop.DBus.Properties",
+                            dbus_interface)
+                        self.assertEqual("Secret", key)
+                        return func(interface, key, value,
+                                    dbus_interface=dbus_interface)
+                    return DBusObject(methodname=method,
+                                      Set=set_property)
+            class Boolean:
+                def __init__(self, value):
+                    self.value = bool(value)
+                def __bool__(self):
+                    return self.value
+                if sys.version_info.major == 2:
+                    __nonzero__ = __bool__
+            class ObjectPath(str):
+                pass
+            class Dictionary(dict):
+                pass
+            class ByteArray(bytes):
+                pass
+        return mock_dbus_python
+
+    def call_method(self, bus, methodname, busname, objectpath,
+                    interface, *args):
+        with self.assertLogs(log, logging.DEBUG):
+            return bus.call_method(methodname, busname, objectpath,
+                                   interface, *args)
+
+    def test_call_method_returns(self):
+        expected_method_return = Unique()
+        method_args = (Unique(), Unique())
+        def func(*args):
+            self.assertEqual(len(method_args), len(args))
+            for marg, arg in zip(method_args, args):
+                self.assertIs(marg, arg)
+            return expected_method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface",
+                               *method_args)
+        self.assertIs(ret, expected_method_return)
+
+    def test_call_method_filters_bool_true(self):
+        def func():
+            return method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        method_return = mock_dbus_python.Boolean(True)
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        self.assertTrue(ret)
+        self.assertNotIsInstance(ret, mock_dbus_python.Boolean)
+
+    def test_call_method_filters_bool_false(self):
+        def func():
+            return method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        method_return = mock_dbus_python.Boolean(False)
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        self.assertFalse(ret)
+        self.assertNotIsInstance(ret, mock_dbus_python.Boolean)
+
+    def test_call_method_filters_objectpath(self):
+        def func():
+            return method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        method_return = mock_dbus_python.ObjectPath("objectpath")
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        self.assertEqual("objectpath", ret)
+        self.assertIsNot("objectpath", ret)
+        self.assertNotIsInstance(ret, mock_dbus_python.ObjectPath)
+
+    def test_call_method_filters_booleans_in_dict(self):
+        def func():
+            return method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        method_return = mock_dbus_python.Dictionary(
+        {mock_dbus_python.Boolean(True):
+         mock_dbus_python.Boolean(False),
+         mock_dbus_python.Boolean(False):
+         mock_dbus_python.Boolean(True)})
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        expected_method_return = {True: False,
+                                  False: True}
+        self.assertEqual(expected_method_return, ret)
+        self.assertNotIsInstance(ret, mock_dbus_python.Dictionary)
+
+    def test_call_method_filters_objectpaths_in_dict(self):
+        def func():
+            return method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        method_return = mock_dbus_python.Dictionary(
+        {mock_dbus_python.ObjectPath("objectpath_key_1"):
+         mock_dbus_python.ObjectPath("objectpath_value_1"),
+         mock_dbus_python.ObjectPath("objectpath_key_2"):
+         mock_dbus_python.ObjectPath("objectpath_value_2")})
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        expected_method_return = {str(key): str(value)
+                                  for key, value in
+                                  method_return.items()}
+        self.assertEqual(expected_method_return, ret)
+        self.assertIsInstance(ret, dict)
+        self.assertNotIsInstance(ret, mock_dbus_python.Dictionary)
+
+    def test_call_method_filters_dict_in_dict(self):
+        def func():
+            return method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        method_return = mock_dbus_python.Dictionary(
+        {"key1": mock_dbus_python.Dictionary({"key11": "value11",
+                                              "key12": "value12"}),
+         "key2": mock_dbus_python.Dictionary({"key21": "value21",
+                                              "key22": "value22"})})
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        expected_method_return = {
+            "key1": {"key11": "value11",
+                     "key12": "value12"},
+            "key2": {"key21": "value21",
+                     "key22": "value22"},
+        }
+        self.assertEqual(expected_method_return, ret)
+        self.assertIsInstance(ret, dict)
+        self.assertNotIsInstance(ret, mock_dbus_python.Dictionary)
+        for key, value in ret.items():
+            self.assertIsInstance(value, dict)
+            self.assertEqual(expected_method_return[key], value)
+            self.assertNotIsInstance(value,
+                                     mock_dbus_python.Dictionary)
+
+    def test_call_method_filters_dict_three_deep(self):
+        def func():
+            return method_return
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        method_return = mock_dbus_python.Dictionary(
+            {"key1":
+             mock_dbus_python.Dictionary(
+                 {"key2":
+                  mock_dbus_python.Dictionary(
+                      {"key3":
+                       mock_dbus_python.Boolean(True),
+                       }),
+                  }),
+             })
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        expected_method_return = {"key1": {"key2": {"key3": True}}}
+        self.assertEqual(expected_method_return, ret)
+        self.assertIsInstance(ret, dict)
+        self.assertNotIsInstance(ret, mock_dbus_python.Dictionary)
+        self.assertIsInstance(ret["key1"], dict)
+        self.assertNotIsInstance(ret["key1"],
+                                 mock_dbus_python.Dictionary)
+        self.assertIsInstance(ret["key1"]["key2"], dict)
+        self.assertNotIsInstance(ret["key1"]["key2"],
+                                 mock_dbus_python.Dictionary)
+        self.assertTrue(ret["key1"]["key2"]["key3"])
+        self.assertNotIsInstance(ret["key1"]["key2"]["key3"],
+                                 mock_dbus_python.Boolean)
+
+    def test_call_method_handles_exception(self):
+        dbus_logger = logging.getLogger("dbus.proxies")
+
+        def func():
+            dbus_logger.error("Test")
+            raise mock_dbus_python.exceptions.DBusException()
+
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+
+        class CountingHandler(logging.Handler):
+            count = 0
+            def emit(self, record):
+                self.count += 1
+
+        counting_handler = CountingHandler()
+
+        dbus_logger.addHandler(counting_handler)
+
+        try:
+            with self.assertRaises(dbus.Error) as e:
+                self.call_method(bus, "methodname", "busname",
+                                 "objectpath", "interface")
+        finally:
+            dbus_logger.removeFilter(counting_handler)
+
+        self.assertNotIsInstance(e.exception, dbus.ConnectFailed)
+
+        # Make sure the dbus logger was suppressed
+        self.assertEqual(0, counting_handler.count)
+
+    def test_Set_Secret_sends_bytearray(self):
+        ret = [None]
+        def func(*args, **kwargs):
+            ret[0] = (args, kwargs)
+        mock_dbus_python = self.MockDBusPython_func(func)
+        bus = dbus_python_adapter.SystemBus(mock_dbus_python)
+        bus.set_client_property("objectpath", "Secret", "value")
+        expected_call = (("se.recompile.Mandos.Client", "Secret",
+                          mock_dbus_python.ByteArray(b"value")),
+                         {"dbus_interface":
+                          "org.freedesktop.DBus.Properties"})
+        self.assertEqual(expected_call, ret[0])
+        if sys.version_info.major == 2:
+            self.assertIsInstance(ret[0][0][-1],
+                                  mock_dbus_python.ByteArray)
+
+    def test_get_object_converts_to_correct_exception(self):
+        bus = dbus_python_adapter.SystemBus(
+            self.fake_dbus_python_raises_exception_on_connect)
+        with self.assertRaises(dbus.ConnectFailed):
+            self.call_method(bus, "methodname", "busname",
+                             "objectpath", "interface")
+
+    class fake_dbus_python_raises_exception_on_connect:
+        """fake dbus-python module"""
+        class exceptions:
+            """Pseudo-namespace"""
+            class DBusException(Exception):
+                pass
+
+        @classmethod
+        def SystemBus(cls):
+            def get_object(busname, objectpath):
+                raise cls.exceptions.DBusException()
+            Bus = collections.namedtuple("Bus", ["get_object"])
+            return Bus(get_object=get_object)
+
+
+class Test_dbus_python_adapter_CachingBus(unittest.TestCase):
+    class mock_dbus_python:
+        """mock dbus-python modules"""
+        class SystemBus:
+            @staticmethod
+            def get_object(busname, objectpath):
+                return Unique()
+
+    def setUp(self):
+        self.bus = dbus_python_adapter.CachingBus(
+            self.mock_dbus_python)
+
+    def test_returns_distinct_objectpaths(self):
+        obj1 = self.bus.get_object("busname", "objectpath1")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get_object("busname", "objectpath2")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIsNot(obj1, obj2)
+
+    def test_returns_distinct_busnames(self):
+        obj1 = self.bus.get_object("busname1", "objectpath")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get_object("busname2", "objectpath")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIsNot(obj1, obj2)
+
+    def test_returns_distinct_both(self):
+        obj1 = self.bus.get_object("busname1", "objectpath")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get_object("busname2", "objectpath")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIsNot(obj1, obj2)
+
+    def test_returns_same(self):
+        obj1 = self.bus.get_object("busname", "objectpath")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get_object("busname", "objectpath")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIs(obj1, obj2)
+
+    def test_returns_same_old(self):
+        obj1 = self.bus.get_object("busname1", "objectpath1")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get_object("busname2", "objectpath2")
+        self.assertIsInstance(obj2, Unique)
+        obj1b = self.bus.get_object("busname1", "objectpath1")
+        self.assertIsInstance(obj1b, Unique)
+        self.assertIsNot(obj1, obj2)
+        self.assertIsNot(obj2, obj1b)
+        self.assertIs(obj1, obj1b)
+
+
+class Test_pydbus_adapter_SystemBus(TestCaseWithAssertLogs):
+
+    def Stub_pydbus_func(self, func):
+        class stub_pydbus:
+            """stub pydbus module"""
+            class SystemBus:
+                @staticmethod
+                def get(busname, objectpath):
+                    DBusObject = collections.namedtuple(
+                        "DBusObject", ("methodname",))
+                    return {"interface":
+                            DBusObject(methodname=func)}
+        return stub_pydbus
+
+    def call_method(self, bus, methodname, busname, objectpath,
+                    interface, *args):
+        with self.assertLogs(log, logging.DEBUG):
+            return bus.call_method(methodname, busname, objectpath,
+                                   interface, *args)
+
+    def test_call_method_returns(self):
+        expected_method_return = Unique()
+        method_args = (Unique(), Unique())
+        def func(*args):
+            self.assertEqual(len(method_args), len(args))
+            for marg, arg in zip(method_args, args):
+                self.assertIs(marg, arg)
+            return expected_method_return
+        stub_pydbus = self.Stub_pydbus_func(func)
+        bus = pydbus_adapter.SystemBus(stub_pydbus)
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface",
+                               *method_args)
+        self.assertIs(ret, expected_method_return)
+
+    def test_call_method_handles_exception(self):
+        dbus_logger = logging.getLogger("dbus.proxies")
+
+        def func():
+            raise gi.repository.GLib.Error()
+
+        stub_pydbus = self.Stub_pydbus_func(func)
+        bus = pydbus_adapter.SystemBus(stub_pydbus)
+
+        with self.assertRaises(dbus.Error) as e:
+            self.call_method(bus, "methodname", "busname",
+                             "objectpath", "interface")
+
+        self.assertNotIsInstance(e.exception, dbus.ConnectFailed)
+
+    def test_get_converts_to_correct_exception(self):
+        bus = pydbus_adapter.SystemBus(
+            self.fake_pydbus_raises_exception_on_connect)
+        with self.assertRaises(dbus.ConnectFailed):
+            self.call_method(bus, "methodname", "busname",
+                             "objectpath", "interface")
+
+    class fake_pydbus_raises_exception_on_connect:
+        """fake dbus-python module"""
+        @classmethod
+        def SystemBus(cls):
+            def get(busname, objectpath):
+                raise gi.repository.GLib.Error()
+            Bus = collections.namedtuple("Bus", ["get"])
+            return Bus(get=get)
+
+    def test_set_property_uses_setattr(self):
+        class Object:
+            pass
+        obj = Object()
+        class pydbus_spy:
+            class SystemBus:
+                @staticmethod
+                def get(busname, objectpath):
+                    return {"interface": obj}
+        bus = pydbus_adapter.SystemBus(pydbus_spy)
+        value = Unique()
+        bus.set_property("busname", "objectpath", "interface", "key",
+                         value)
+        self.assertIs(value, obj.key)
+
+    def test_get_suppresses_xml_deprecation_warning(self):
+        if sys.version_info.major >= 3:
+            return
+        class stub_pydbus_get:
+            class SystemBus:
+                @staticmethod
+                def get(busname, objectpath):
+                    warnings.warn_explicit(
+                        "deprecated", DeprecationWarning,
+                        "xml.etree.ElementTree", 0)
+        bus = pydbus_adapter.SystemBus(stub_pydbus_get)
+        with warnings.catch_warnings(record=True) as w:
+            warnings.simplefilter("always")
+            bus.get("busname", "objectpath")
+            self.assertEqual(0, len(w))
+
+
+class Test_pydbus_adapter_CachingBus(unittest.TestCase):
+    class stub_pydbus:
+        """stub pydbus module"""
+        class SystemBus:
+            @staticmethod
+            def get(busname, objectpath):
+                return Unique()
+
+    def setUp(self):
+        self.bus = pydbus_adapter.CachingBus(self.stub_pydbus)
+
+    def test_returns_distinct_objectpaths(self):
+        obj1 = self.bus.get("busname", "objectpath1")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get("busname", "objectpath2")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIsNot(obj1, obj2)
+
+    def test_returns_distinct_busnames(self):
+        obj1 = self.bus.get("busname1", "objectpath")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get("busname2", "objectpath")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIsNot(obj1, obj2)
+
+    def test_returns_distinct_both(self):
+        obj1 = self.bus.get("busname1", "objectpath")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get("busname2", "objectpath")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIsNot(obj1, obj2)
+
+    def test_returns_same(self):
+        obj1 = self.bus.get("busname", "objectpath")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get("busname", "objectpath")
+        self.assertIsInstance(obj2, Unique)
+        self.assertIs(obj1, obj2)
+
+    def test_returns_same_old(self):
+        obj1 = self.bus.get("busname1", "objectpath1")
+        self.assertIsInstance(obj1, Unique)
+        obj2 = self.bus.get("busname2", "objectpath2")
+        self.assertIsInstance(obj2, Unique)
+        obj1b = self.bus.get("busname1", "objectpath1")
+        self.assertIsInstance(obj1b, Unique)
+        self.assertIsNot(obj1, obj2)
+        self.assertIsNot(obj2, obj1b)
+        self.assertIs(obj1, obj1b)
+
+
+class Test_dbussy_adapter_SystemBus(TestCaseWithAssertLogs):
+
+    class dummy_dbussy:
+        class DBUS:
+            class ObjectPath(str):
+                pass
+        class DBusError(Exception):
+            pass
+
+    def fake_ravel_func(self, func):
+        class fake_ravel:
+            @staticmethod
+            def system_bus():
+                class DBusInterfaceProxy:
+                    @staticmethod
+                    def methodname(*args):
+                        return [func(*args)]
+                class DBusObject:
+                    @staticmethod
+                    def get_interface(interface):
+                        if interface == "interface":
+                            return DBusInterfaceProxy()
+                return {"busname": {"objectpath": DBusObject()}}
+        return fake_ravel
+
+    def call_method(self, bus, methodname, busname, objectpath,
+                    interface, *args):
+        with self.assertLogs(log, logging.DEBUG):
+            return bus.call_method(methodname, busname, objectpath,
+                                   interface, *args)
+
+    def test_call_method_returns(self):
+        expected_method_return = Unique()
+        method_args = (Unique(), Unique())
+        def func(*args):
+            self.assertEqual(len(method_args), len(args))
+            for marg, arg in zip(method_args, args):
+                self.assertIs(marg, arg)
+            return expected_method_return
+        fake_ravel = self.fake_ravel_func(func)
+        bus = dbussy_adapter.SystemBus(self.dummy_dbussy, fake_ravel)
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface",
+                               *method_args)
+        self.assertIs(ret, expected_method_return)
+
+    def test_call_method_filters_objectpath(self):
+        def func():
+            return method_return
+        fake_ravel = self.fake_ravel_func(func)
+        bus = dbussy_adapter.SystemBus(self.dummy_dbussy, fake_ravel)
+        method_return = (self.dummy_dbussy.DBUS
+                         .ObjectPath("objectpath"))
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        self.assertEqual("objectpath", ret)
+        self.assertNotIsInstance(ret,
+                                 self.dummy_dbussy.DBUS.ObjectPath)
+
+    def test_call_method_filters_objectpaths_in_dict(self):
+        ObjectPath = self.dummy_dbussy.DBUS.ObjectPath
+        def func():
+            return method_return
+        fake_ravel = self.fake_ravel_func(func)
+        bus = dbussy_adapter.SystemBus(self.dummy_dbussy, fake_ravel)
+        method_return = {
+            ObjectPath("objectpath_key_1"):
+            ObjectPath("objectpath_value_1"),
+            ObjectPath("objectpath_key_2"):
+            ObjectPath("objectpath_value_2"),
+        }
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        expected_method_return = {str(key): str(value)
+                                  for key, value in
+                                  method_return.items()}
+        for key, value in ret.items():
+            self.assertNotIsInstance(key, ObjectPath)
+            self.assertNotIsInstance(value, ObjectPath)
+        self.assertEqual(expected_method_return, ret)
+        self.assertIsInstance(ret, dict)
+
+    def test_call_method_filters_objectpaths_in_dict_in_dict(self):
+        ObjectPath = self.dummy_dbussy.DBUS.ObjectPath
+        def func():
+            return method_return
+        fake_ravel = self.fake_ravel_func(func)
+        bus = dbussy_adapter.SystemBus(self.dummy_dbussy, fake_ravel)
+        method_return = {
+            ObjectPath("key1"): {
+                ObjectPath("key11"): ObjectPath("value11"),
+                ObjectPath("key12"): ObjectPath("value12"),
+            },
+            ObjectPath("key2"): {
+                ObjectPath("key21"): ObjectPath("value21"),
+                ObjectPath("key22"): ObjectPath("value22"),
+            },
+        }
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        expected_method_return = {
+            "key1": {"key11": "value11",
+                     "key12": "value12"},
+            "key2": {"key21": "value21",
+                     "key22": "value22"},
+        }
+        self.assertEqual(expected_method_return, ret)
+        for key, value in ret.items():
+            self.assertIsInstance(value, dict)
+            self.assertEqual(expected_method_return[key], value)
+            self.assertNotIsInstance(key, ObjectPath)
+            for inner_key, inner_value in value.items():
+                self.assertIsInstance(value, dict)
+                self.assertEqual(
+                    expected_method_return[key][inner_key],
+                    inner_value)
+                self.assertNotIsInstance(key, ObjectPath)
+
+    def test_call_method_filters_objectpaths_in_dict_three_deep(self):
+        ObjectPath = self.dummy_dbussy.DBUS.ObjectPath
+        def func():
+            return method_return
+        fake_ravel = self.fake_ravel_func(func)
+        bus = dbussy_adapter.SystemBus(self.dummy_dbussy, fake_ravel)
+        method_return = {
+            ObjectPath("key1"): {
+                ObjectPath("key2"): {
+                    ObjectPath("key3"): ObjectPath("value"),
+                },
+            },
+        }
+        ret = self.call_method(bus, "methodname", "busname",
+                               "objectpath", "interface")
+        expected_method_return = {"key1": {"key2": {"key3": "value"}}}
+        self.assertEqual(expected_method_return, ret)
+        self.assertIsInstance(ret, dict)
+        self.assertNotIsInstance(next(iter(ret.keys())), ObjectPath)
+        self.assertIsInstance(ret["key1"], dict)
+        self.assertNotIsInstance(next(iter(ret["key1"].keys())),
+                                 ObjectPath)
+        self.assertIsInstance(ret["key1"]["key2"], dict)
+        self.assertNotIsInstance(
+            next(iter(ret["key1"]["key2"].keys())),
+            ObjectPath)
+        self.assertEqual("value", ret["key1"]["key2"]["key3"])
+        self.assertNotIsInstance(ret["key1"]["key2"]["key3"],
+                                 self.dummy_dbussy.DBUS.ObjectPath)
+
+    def test_call_method_handles_exception(self):
+        def func():
+            raise self.dummy_dbussy.DBusError()
+
+        fake_ravel = self.fake_ravel_func(func)
+        bus = dbussy_adapter.SystemBus(self.dummy_dbussy, fake_ravel)
+
+        with self.assertRaises(dbus.Error) as e:
+            self.call_method(bus, "methodname", "busname",
+                             "objectpath", "interface")
+
+        self.assertNotIsInstance(e.exception, dbus.ConnectFailed)
+
+    def test_get_object_converts_to_correct_exception(self):
+        class fake_ravel_raises_exception_on_connect:
+            @staticmethod
+            def system_bus():
+                class Bus:
+                    @staticmethod
+                    def __getitem__(key):
+                        if key == "objectpath":
+                            raise self.dummy_dbussy.DBusError()
+                        raise Exception(key)
+                return {"busname": Bus()}
+        def func():
+            raise self.dummy_dbussy.DBusError()
+        bus = dbussy_adapter.SystemBus(
+            self.dummy_dbussy,
+            fake_ravel_raises_exception_on_connect)
+        with self.assertRaises(dbus.ConnectFailed):
+            self.call_method(bus, "methodname", "busname",
+                             "objectpath", "interface")
+
+
+class Test_commands_from_options(unittest.TestCase):
+
+    def setUp(self):
+        self.parser = argparse.ArgumentParser()
+        add_command_line_options(self.parser)
+
+    def test_is_enabled(self):
+        self.assert_command_from_args(["--is-enabled", "client"],
+                                      command.IsEnabled)
+
+    def assert_command_from_args(self, args, command_cls, length=1,
+                                 clients=None, **cmd_attrs):
+        """Assert that parsing ARGS should result in an instance of
+COMMAND_CLS with (optionally) all supplied attributes (CMD_ATTRS)."""
+        options = self.parser.parse_args(args)
+        check_option_syntax(self.parser, options)
+        commands = commands_from_options(options)
+        self.assertEqual(length, len(commands))
+        for command in commands:
+            if isinstance(command, command_cls):
+                break
+        else:
+            self.assertIsInstance(command, command_cls)
+        if clients is not None:
+            self.assertEqual(clients, options.client)
+        for key, value in cmd_attrs.items():
+            self.assertEqual(value, getattr(command, key))
+
+    def assert_commands_from_args(self, args, commands, clients=None):
+        for cmd in commands:
+            self.assert_command_from_args(args, cmd,
+                                          length=len(commands),
+                                          clients=clients)
+
+    def test_is_enabled_short(self):
+        self.assert_command_from_args(["-V", "client"],
+                                      command.IsEnabled)
+
+    def test_approve(self):
+        self.assert_command_from_args(["--approve", "client"],
+                                      command.Approve)
+
+    def test_approve_short(self):
+        self.assert_command_from_args(["-A", "client"],
+                                      command.Approve)
+
+    def test_deny(self):
+        self.assert_command_from_args(["--deny", "client"],
+                                      command.Deny)
+
+    def test_deny_short(self):
+        self.assert_command_from_args(["-D", "client"], command.Deny)
+
+    def test_remove(self):
+        self.assert_command_from_args(["--remove", "client"],
+                                      command.Remove)
+
+    def test_deny_before_remove(self):
+        options = self.parser.parse_args(["--deny", "--remove",
+                                          "client"])
+        check_option_syntax(self.parser, options)
+        commands = commands_from_options(options)
+        self.assertEqual(2, len(commands))
+        self.assertIsInstance(commands[0], command.Deny)
+        self.assertIsInstance(commands[1], command.Remove)
+
+    def test_deny_before_remove_reversed(self):
+        options = self.parser.parse_args(["--remove", "--deny",
+                                          "--all"])
+        check_option_syntax(self.parser, options)
+        commands = commands_from_options(options)
+        self.assertEqual(2, len(commands))
+        self.assertIsInstance(commands[0], command.Deny)
+        self.assertIsInstance(commands[1], command.Remove)
+
+    def test_remove_short(self):
+        self.assert_command_from_args(["-r", "client"],
+                                      command.Remove)
+
+    def test_dump_json(self):
+        self.assert_command_from_args(["--dump-json"],
+                                      command.DumpJSON)
+
+    def test_enable(self):
+        self.assert_command_from_args(["--enable", "client"],
+                                      command.Enable)
+
+    def test_enable_short(self):
+        self.assert_command_from_args(["-e", "client"],
+                                      command.Enable)
+
+    def test_disable(self):
+        self.assert_command_from_args(["--disable", "client"],
+                                      command.Disable)
+
+    def test_disable_short(self):
+        self.assert_command_from_args(["-d", "client"],
+                                      command.Disable)
+
+    def test_bump_timeout(self):
+        self.assert_command_from_args(["--bump-timeout", "client"],
+                                      command.BumpTimeout)
+
+    def test_bump_timeout_short(self):
+        self.assert_command_from_args(["-b", "client"],
+                                      command.BumpTimeout)
+
+    def test_start_checker(self):
+        self.assert_command_from_args(["--start-checker", "client"],
+                                      command.StartChecker)
+
+    def test_stop_checker(self):
+        self.assert_command_from_args(["--stop-checker", "client"],
+                                      command.StopChecker)
+
+    def test_approve_by_default(self):
+        self.assert_command_from_args(["--approve-by-default",
+                                       "client"],
+                                      command.ApproveByDefault)
+
+    def test_deny_by_default(self):
+        self.assert_command_from_args(["--deny-by-default", "client"],
+                                      command.DenyByDefault)
+
+    def test_checker(self):
+        self.assert_command_from_args(["--checker", ":", "client"],
+                                      command.SetChecker,
+                                      value_to_set=":")
+
+    def test_checker_empty(self):
+        self.assert_command_from_args(["--checker", "", "client"],
+                                      command.SetChecker,
+                                      value_to_set="")
+
+    def test_checker_short(self):
+        self.assert_command_from_args(["-c", ":", "client"],
+                                      command.SetChecker,
+                                      value_to_set=":")
+
+    def test_host(self):
+        self.assert_command_from_args(
+            ["--host", "client.example.org", "client"],
+            command.SetHost, value_to_set="client.example.org")
+
+    def test_host_short(self):
+        self.assert_command_from_args(
+            ["-H", "client.example.org", "client"], command.SetHost,
+            value_to_set="client.example.org")
+
+    def test_secret_devnull(self):
+        self.assert_command_from_args(["--secret", os.path.devnull,
+                                       "client"], command.SetSecret,
+                                      value_to_set=b"")
+
+    def test_secret_tempfile(self):
+        with tempfile.NamedTemporaryFile(mode="r+b") as f:
+            value = b"secret\0xyzzy\nbar"
+            f.write(value)
+            f.seek(0)
+            self.assert_command_from_args(["--secret", f.name,
+                                           "client"],
+                                          command.SetSecret,
+                                          value_to_set=value)
+
+    def test_secret_devnull_short(self):
+        self.assert_command_from_args(["-s", os.path.devnull,
+                                       "client"], command.SetSecret,
+                                      value_to_set=b"")
+
+    def test_secret_tempfile_short(self):
+        with tempfile.NamedTemporaryFile(mode="r+b") as f:
+            value = b"secret\0xyzzy\nbar"
+            f.write(value)
+            f.seek(0)
+            self.assert_command_from_args(["-s", f.name, "client"],
+                                          command.SetSecret,
+                                          value_to_set=value)
+
+    def test_timeout(self):
+        self.assert_command_from_args(["--timeout", "PT5M", "client"],
+                                      command.SetTimeout,
+                                      value_to_set=300000)
+
+    def test_timeout_short(self):
+        self.assert_command_from_args(["-t", "PT5M", "client"],
+                                      command.SetTimeout,
+                                      value_to_set=300000)
+
+    def test_extended_timeout(self):
+        self.assert_command_from_args(["--extended-timeout", "PT15M",
+                                       "client"],
+                                      command.SetExtendedTimeout,
+                                      value_to_set=900000)
+
+    def test_interval(self):
+        self.assert_command_from_args(["--interval", "PT2M",
+                                       "client"], command.SetInterval,
+                                      value_to_set=120000)
+
+    def test_interval_short(self):
+        self.assert_command_from_args(["-i", "PT2M", "client"],
+                                      command.SetInterval,
+                                      value_to_set=120000)
+
+    def test_approval_delay(self):
+        self.assert_command_from_args(["--approval-delay", "PT30S",
+                                       "client"],
+                                      command.SetApprovalDelay,
+                                      value_to_set=30000)
+
+    def test_approval_duration(self):
+        self.assert_command_from_args(["--approval-duration", "PT1S",
+                                       "client"],
+                                      command.SetApprovalDuration,
+                                      value_to_set=1000)
+
+    def test_print_table(self):
+        self.assert_command_from_args([], command.PrintTable,
+                                      verbose=False)
+
+    def test_print_table_verbose(self):
+        self.assert_command_from_args(["--verbose"],
+                                      command.PrintTable,
+                                      verbose=True)
+
+    def test_print_table_verbose_short(self):
+        self.assert_command_from_args(["-v"], command.PrintTable,
+                                      verbose=True)
+
+
+    def test_manual_page_example_1(self):
+        self.assert_command_from_args("",
+                                      command.PrintTable,
+                                      clients=[],
+                                      verbose=False)
+
+    def test_manual_page_example_2(self):
+        self.assert_command_from_args(
+            "--verbose foo1.example.org foo2.example.org".split(),
+            command.PrintTable, clients=["foo1.example.org",
+                                         "foo2.example.org"],
+            verbose=True)
+
+    def test_manual_page_example_3(self):
+        self.assert_command_from_args("--enable --all".split(),
+                                      command.Enable,
+                                      clients=[])
+
+    def test_manual_page_example_4(self):
+        self.assert_commands_from_args(
+            ("--timeout=PT5M --interval=PT1M foo1.example.org"
+             " foo2.example.org").split(),
+            [command.SetTimeout, command.SetInterval],
+            clients=["foo1.example.org", "foo2.example.org"])
+
+    def test_manual_page_example_5(self):
+        self.assert_command_from_args("--approve --all".split(),
+                                      command.Approve,
+                                      clients=[])
+
+
+class TestCommand(unittest.TestCase):
     """Abstract class for tests of command classes"""
-    def setUp(self):
-        testcase = self
-        class MockClient(object):
-            def __init__(self, name, **attributes):
-                self.__dbus_object_path__ = "objpath_{}".format(name)
-                self.attributes = attributes
-                self.attributes["Name"] = name
-                self.calls = []
-            def Set(self, interface, property, value, dbus_interface):
-                testcase.assertEqual(interface, client_interface)
-                testcase.assertEqual(dbus_interface,
-                                     dbus.PROPERTIES_IFACE)
-                self.attributes[property] = value
-            def Get(self, interface, property, dbus_interface):
-                testcase.assertEqual(interface, client_interface)
-                testcase.assertEqual(dbus_interface,
-                                     dbus.PROPERTIES_IFACE)
-                return self.attributes[property]
-            def Approve(self, approve, dbus_interface):
-                testcase.assertEqual(dbus_interface, client_interface)
-                self.calls.append(("Approve", (approve,
-                                               dbus_interface)))
-        self.client = MockClient(
-            "foo",
-            KeyID=("92ed150794387c03ce684574b1139a65"
-                   "94a34f895daaaf09fd8ea90a27cddb12"),
-            Secret=b"secret",
-            Host="foo.example.org",
-            Enabled=dbus.Boolean(True),
-            Timeout=300000,
-            LastCheckedOK="2019-02-03T00:00:00",
-            Created="2019-01-02T00:00:00",
-            Interval=120000,
-            Fingerprint=("778827225BA7DE539C5A"
-                         "7CFA59CFF7CDBD9A5920"),
-            CheckerRunning=dbus.Boolean(False),
-            LastEnabled="2019-01-03T00:00:00",
-            ApprovalPending=dbus.Boolean(False),
-            ApprovedByDefault=dbus.Boolean(True),
-            LastApprovalRequest="",
-            ApprovalDelay=0,
-            ApprovalDuration=1000,
-            Checker="fping -q -- %(host)s",
-            ExtendedTimeout=900000,
-            Expires="2019-02-04T00:00:00",
-            LastCheckerStatus=0)
-        self.other_client = MockClient(
-            "barbar",
-            KeyID=("0558568eedd67d622f5c83b35a115f79"
-                   "6ab612cff5ad227247e46c2b020f441c"),
-            Secret=b"secretbar",
-            Host="192.0.2.3",
-            Enabled=dbus.Boolean(True),
-            Timeout=300000,
-            LastCheckedOK="2019-02-04T00:00:00",
-            Created="2019-01-03T00:00:00",
-            Interval=120000,
-            Fingerprint=("3E393AEAEFB84C7E89E2"
-                         "F547B3A107558FCA3A27"),
-            CheckerRunning=dbus.Boolean(True),
-            LastEnabled="2019-01-04T00:00:00",
-            ApprovalPending=dbus.Boolean(False),
-            ApprovedByDefault=dbus.Boolean(False),
-            LastApprovalRequest="2019-01-03T00:00:00",
-            ApprovalDelay=30000,
-            ApprovalDuration=1000,
-            Checker=":",
-            ExtendedTimeout=900000,
-            Expires="2019-02-05T00:00:00",
-            LastCheckerStatus=-2)
-        self.clients =  collections.OrderedDict(
-            [
-                (self.client, self.client.attributes),
-                (self.other_client, self.other_client.attributes),
-            ])
-        self.one_client = {self.client: self.client.attributes}
-
-class TestPrintTableCmd(TestCmd):
-    def test_normal(self):
-        output = PrintTableCmd().output(self.clients.values())
-        expected_output = """
-Name   Enabled Timeout  Last Successful Check
-foo    Yes     00:05:00 2019-02-03T00:00:00  
-barbar Yes     00:05:00 2019-02-04T00:00:00  
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-    def test_verbose(self):
-        output = PrintTableCmd(verbose=True).output(
-            self.clients.values())
-        expected_output = """
-Name   Enabled Timeout  Last Successful Check Created             Interval Host            Key ID                                                           Fingerprint                              Check Is Running Last Enabled        Approval Is Pending Approved By Default Last Approval Request Approval Delay Approval Duration Checker              Extended Timeout Expires             Last Checker Status
-foo    Yes     00:05:00 2019-02-03T00:00:00   2019-01-02T00:00:00 00:02:00 foo.example.org 92ed150794387c03ce684574b1139a6594a34f895daaaf09fd8ea90a27cddb12 778827225BA7DE539C5A7CFA59CFF7CDBD9A5920 No               2019-01-03T00:00:00 No                  Yes                                       00:00:00       00:00:01          fping -q -- %(host)s 00:15:00         2019-02-04T00:00:00 0                  
-barbar Yes     00:05:00 2019-02-04T00:00:00   2019-01-03T00:00:00 00:02:00 192.0.2.3       0558568eedd67d622f5c83b35a115f796ab612cff5ad227247e46c2b020f441c 3E393AEAEFB84C7E89E2F547B3A107558FCA3A27 Yes              2019-01-04T00:00:00 No                  No                  2019-01-03T00:00:00   00:00:30       00:00:01          :                    00:15:00         2019-02-05T00:00:00 -2                 
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-    def test_one_client(self):
-        output = PrintTableCmd().output(self.one_client.values())
-        expected_output = """
-Name Enabled Timeout  Last Successful Check
-foo  Yes     00:05:00 2019-02-03T00:00:00  
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-
-class TestDumpJSONCmd(TestCmd):
-    def setUp(self):
-        self.expected_json = {
-            "foo": {
+
+    class FakeMandosBus(dbus.MandosBus):
+        def __init__(self, testcase):
+            self.client_properties = {
                 "Name": "foo",
                 "KeyID": ("92ed150794387c03ce684574b1139a65"
                           "94a34f895daaaf09fd8ea90a27cddb12"),
+                "Secret": b"secret",
                 "Host": "foo.example.org",
                 "Enabled": True,
                 "Timeout": 300000,
@@ -962,11 +2350,12 @@
                 "ExtendedTimeout": 900000,
                 "Expires": "2019-02-04T00:00:00",
                 "LastCheckerStatus": 0,
-            },
-            "barbar": {
+            }
+            self.other_client_properties = {
                 "Name": "barbar",
                 "KeyID": ("0558568eedd67d622f5c83b35a115f79"
                           "6ab612cff5ad227247e46c2b020f441c"),
+                "Secret": b"secretbar",
                 "Host": "192.0.2.3",
                 "Enabled": True,
                 "Timeout": 300000,
@@ -981,541 +2370,436 @@
                 "ApprovedByDefault": False,
                 "LastApprovalRequest": "2019-01-03T00:00:00",
                 "ApprovalDelay": 30000,
-                "ApprovalDuration": 1000,
+                "ApprovalDuration": 93785000,
                 "Checker": ":",
                 "ExtendedTimeout": 900000,
                 "Expires": "2019-02-05T00:00:00",
                 "LastCheckerStatus": -2,
-            },
-        }
-        return super(TestDumpJSONCmd, self).setUp()
-    def test_normal(self):
-        json_data = json.loads(DumpJSONCmd().output(self.clients))
-        self.assertDictEqual(json_data, self.expected_json)
-    def test_one_client(self):
-        clients = self.one_client
-        json_data = json.loads(DumpJSONCmd().output(clients))
-        expected_json = {"foo": self.expected_json["foo"]}
-        self.assertDictEqual(json_data, expected_json)
-
-class TestIsEnabledCmd(TestCmd):
-    def test_is_enabled(self):
-        self.assertTrue(all(IsEnabledCmd().is_enabled(client, properties)
-                            for client, properties in self.clients.items()))
-    def test_is_enabled_run_exits_successfully(self):
+            }
+            self.clients =  collections.OrderedDict(
+                [
+                    ("client_objectpath", self.client_properties),
+                    ("other_client_objectpath",
+                     self.other_client_properties),
+                ])
+            self.one_client = {"client_objectpath":
+                               self.client_properties}
+            self.testcase = testcase
+            self.calls = []
+
+        def call_method(self, methodname, busname, objectpath,
+                        interface, *args):
+            self.testcase.assertEqual("se.recompile.Mandos", busname)
+            self.calls.append((methodname, busname, objectpath,
+                               interface, args))
+            if interface == "org.freedesktop.DBus.Properties":
+                if methodname == "Set":
+                    self.testcase.assertEqual(3, len(args))
+                    interface, key, value = args
+                    self.testcase.assertEqual(
+                        "se.recompile.Mandos.Client", interface)
+                    self.clients[objectpath][key] = value
+                    return
+            elif interface == "se.recompile.Mandos":
+                self.testcase.assertEqual("RemoveClient", methodname)
+                self.testcase.assertEqual(1, len(args))
+                clientpath = args[0]
+                del self.clients[clientpath]
+                return
+            elif interface == "se.recompile.Mandos.Client":
+                if methodname == "Approve":
+                    self.testcase.assertEqual(1, len(args))
+                    return
+            raise ValueError()
+
+    def setUp(self):
+        self.bus = self.FakeMandosBus(self)
+
+
+class TestBaseCommands(TestCommand):
+
+    def test_IsEnabled_exits_successfully(self):
         with self.assertRaises(SystemExit) as e:
-            IsEnabledCmd().run(None, self.one_client)
+            command.IsEnabled().run(self.bus.one_client)
         if e.exception.code is not None:
-            self.assertEqual(e.exception.code, 0)
+            self.assertEqual(0, e.exception.code)
         else:
             self.assertIsNone(e.exception.code)
-    def test_is_enabled_run_exits_with_failure(self):
-        self.client.attributes["Enabled"] = dbus.Boolean(False)
+
+    def test_IsEnabled_exits_with_failure(self):
+        self.bus.client_properties["Enabled"] = False
         with self.assertRaises(SystemExit) as e:
-            IsEnabledCmd().run(None, self.one_client)
+            command.IsEnabled().run(self.bus.one_client)
         if isinstance(e.exception.code, int):
-            self.assertNotEqual(e.exception.code, 0)
+            self.assertNotEqual(0, e.exception.code)
         else:
             self.assertIsNotNone(e.exception.code)
 
-class TestRemoveCmd(TestCmd):
-    def test_remove(self):
-        class MockMandos(object):
-            def __init__(self):
-                self.calls = []
-            def RemoveClient(self, dbus_path):
-                self.calls.append(("RemoveClient", (dbus_path,)))
-        mandos = MockMandos()
-        super(TestRemoveCmd, self).setUp()
-        RemoveCmd().run(mandos, self.clients)
-        self.assertEqual(len(mandos.calls), 2)
-        for client in self.clients:
-            self.assertIn(("RemoveClient",
-                           (client.__dbus_object_path__,)),
-                          mandos.calls)
-
-class TestApproveCmd(TestCmd):
-    def test_approve(self):
-        ApproveCmd().run(None, self.clients)
-        for client in self.clients:
-            self.assertIn(("Approve", (True, client_interface)),
-                          client.calls)
-
-class TestDenyCmd(TestCmd):
-    def test_deny(self):
-        DenyCmd().run(None, self.clients)
-        for client in self.clients:
-            self.assertIn(("Approve", (False, client_interface)),
-                          client.calls)
-
-class TestEnableCmd(TestCmd):
-    def test_enable(self):
-        for client in self.clients:
-            client.attributes["Enabled"] = False
-
-        EnableCmd().run(None, self.clients)
-
-        for client in self.clients:
-            self.assertTrue(client.attributes["Enabled"])
-
-class TestDisableCmd(TestCmd):
-    def test_disable(self):
-        DisableCmd().run(None, self.clients)
-
-        for client in self.clients:
-            self.assertFalse(client.attributes["Enabled"])
-
-class Unique(object):
-    """Class for objects which exist only to be unique objects, since
-unittest.mock.sentinel only exists in Python 3.3"""
-
-class TestPropertyCmd(TestCmd):
-    """Abstract class for tests of PropertyCmd classes"""
+    def test_Approve(self):
+        busname = "se.recompile.Mandos"
+        client_interface = "se.recompile.Mandos.Client"
+        command.Approve().run(self.bus.clients, self.bus)
+        self.assertTrue(self.bus.clients)
+        for clientpath in self.bus.clients:
+            self.assertIn(("Approve", busname, clientpath,
+                           client_interface, (True,)), self.bus.calls)
+
+    def test_Deny(self):
+        busname = "se.recompile.Mandos"
+        client_interface = "se.recompile.Mandos.Client"
+        command.Deny().run(self.bus.clients, self.bus)
+        self.assertTrue(self.bus.clients)
+        for clientpath in self.bus.clients:
+            self.assertIn(("Approve", busname, clientpath,
+                           client_interface, (False,)),
+                          self.bus.calls)
+
+    def test_Remove(self):
+        busname = "se.recompile.Mandos"
+        server_path = "/"
+        server_interface = "se.recompile.Mandos"
+        orig_clients = self.bus.clients.copy()
+        command.Remove().run(self.bus.clients, self.bus)
+        self.assertFalse(self.bus.clients)
+        for clientpath in orig_clients:
+            self.assertIn(("RemoveClient", busname,
+                           server_path, server_interface,
+                           (clientpath,)), self.bus.calls)
+
+    expected_json = {
+        "foo": {
+            "Name": "foo",
+            "KeyID": ("92ed150794387c03ce684574b1139a65"
+                      "94a34f895daaaf09fd8ea90a27cddb12"),
+            "Host": "foo.example.org",
+            "Enabled": True,
+            "Timeout": 300000,
+            "LastCheckedOK": "2019-02-03T00:00:00",
+            "Created": "2019-01-02T00:00:00",
+            "Interval": 120000,
+            "Fingerprint": ("778827225BA7DE539C5A"
+                            "7CFA59CFF7CDBD9A5920"),
+            "CheckerRunning": False,
+            "LastEnabled": "2019-01-03T00:00:00",
+            "ApprovalPending": False,
+            "ApprovedByDefault": True,
+            "LastApprovalRequest": "",
+            "ApprovalDelay": 0,
+            "ApprovalDuration": 1000,
+            "Checker": "fping -q -- %(host)s",
+            "ExtendedTimeout": 900000,
+            "Expires": "2019-02-04T00:00:00",
+            "LastCheckerStatus": 0,
+        },
+        "barbar": {
+            "Name": "barbar",
+            "KeyID": ("0558568eedd67d622f5c83b35a115f79"
+                      "6ab612cff5ad227247e46c2b020f441c"),
+            "Host": "192.0.2.3",
+            "Enabled": True,
+            "Timeout": 300000,
+            "LastCheckedOK": "2019-02-04T00:00:00",
+            "Created": "2019-01-03T00:00:00",
+            "Interval": 120000,
+            "Fingerprint": ("3E393AEAEFB84C7E89E2"
+                            "F547B3A107558FCA3A27"),
+            "CheckerRunning": True,
+            "LastEnabled": "2019-01-04T00:00:00",
+            "ApprovalPending": False,
+            "ApprovedByDefault": False,
+            "LastApprovalRequest": "2019-01-03T00:00:00",
+            "ApprovalDelay": 30000,
+            "ApprovalDuration": 93785000,
+            "Checker": ":",
+            "ExtendedTimeout": 900000,
+            "Expires": "2019-02-05T00:00:00",
+            "LastCheckerStatus": -2,
+        },
+    }
+
+    def test_DumpJSON_normal(self):
+        with self.capture_stdout_to_buffer() as buffer:
+            command.DumpJSON().run(self.bus.clients)
+        json_data = json.loads(buffer.getvalue())
+        self.assertDictEqual(self.expected_json, json_data)
+
+    @staticmethod
+    @contextlib.contextmanager
+    def capture_stdout_to_buffer():
+        capture_buffer = io.StringIO()
+        old_stdout = sys.stdout
+        sys.stdout = capture_buffer
+        try:
+            yield capture_buffer
+        finally:
+            sys.stdout = old_stdout
+
+    def test_DumpJSON_one_client(self):
+        with self.capture_stdout_to_buffer() as buffer:
+            command.DumpJSON().run(self.bus.one_client)
+        json_data = json.loads(buffer.getvalue())
+        expected_json = {"foo": self.expected_json["foo"]}
+        self.assertDictEqual(expected_json, json_data)
+
+    def test_PrintTable_normal(self):
+        with self.capture_stdout_to_buffer() as buffer:
+            command.PrintTable().run(self.bus.clients)
+        expected_output = "\n".join((
+            "Name   Enabled Timeout  Last Successful Check",
+            "foo    Yes     00:05:00 2019-02-03T00:00:00  ",
+            "barbar Yes     00:05:00 2019-02-04T00:00:00  ",
+        )) + "\n"
+        self.assertEqual(expected_output, buffer.getvalue())
+
+    def test_PrintTable_verbose(self):
+        with self.capture_stdout_to_buffer() as buffer:
+            command.PrintTable(verbose=True).run(self.bus.clients)
+        columns = (
+            (
+                "Name   ",
+                "foo    ",
+                "barbar ",
+            ),(
+                "Enabled ",
+                "Yes     ",
+                "Yes     ",
+            ),(
+                "Timeout  ",
+                "00:05:00 ",
+                "00:05:00 ",
+            ),(
+                "Last Successful Check ",
+                "2019-02-03T00:00:00   ",
+                "2019-02-04T00:00:00   ",
+            ),(
+                "Created             ",
+                "2019-01-02T00:00:00 ",
+                "2019-01-03T00:00:00 ",
+            ),(
+                "Interval ",
+                "00:02:00 ",
+                "00:02:00 ",
+            ),(
+                "Host            ",
+                "foo.example.org ",
+                "192.0.2.3       ",
+            ),(
+                ("Key ID                                             "
+                 "              "),
+                ("92ed150794387c03ce684574b1139a6594a34f895daaaf09fd8"
+                 "ea90a27cddb12 "),
+                ("0558568eedd67d622f5c83b35a115f796ab612cff5ad227247e"
+                 "46c2b020f441c "),
+            ),(
+                "Fingerprint                              ",
+                "778827225BA7DE539C5A7CFA59CFF7CDBD9A5920 ",
+                "3E393AEAEFB84C7E89E2F547B3A107558FCA3A27 ",
+            ),(
+                "Check Is Running ",
+                "No               ",
+                "Yes              ",
+            ),(
+                "Last Enabled        ",
+                "2019-01-03T00:00:00 ",
+                "2019-01-04T00:00:00 ",
+            ),(
+                "Approval Is Pending ",
+                "No                  ",
+                "No                  ",
+            ),(
+                "Approved By Default ",
+                "Yes                 ",
+                "No                  ",
+            ),(
+                "Last Approval Request ",
+                "                      ",
+                "2019-01-03T00:00:00   ",
+            ),(
+                "Approval Delay ",
+                "00:00:00       ",
+                "00:00:30       ",
+            ),(
+                "Approval Duration ",
+                "00:00:01          ",
+                "1T02:03:05        ",
+            ),(
+                "Checker              ",
+                "fping -q -- %(host)s ",
+                ":                    ",
+            ),(
+                "Extended Timeout ",
+                "00:15:00         ",
+                "00:15:00         ",
+            ),(
+                "Expires             ",
+                "2019-02-04T00:00:00 ",
+                "2019-02-05T00:00:00 ",
+            ),(
+                "Last Checker Status",
+                "0                  ",
+                "-2                 ",
+            )
+        )
+        num_lines = max(len(rows) for rows in columns)
+        expected_output = ("\n".join("".join(rows[line]
+                                             for rows in columns)
+                                     for line in range(num_lines))
+                           + "\n")
+        self.assertEqual(expected_output, buffer.getvalue())
+
+    def test_PrintTable_one_client(self):
+        with self.capture_stdout_to_buffer() as buffer:
+            command.PrintTable().run(self.bus.one_client)
+        expected_output = "\n".join((
+            "Name Enabled Timeout  Last Successful Check",
+            "foo  Yes     00:05:00 2019-02-03T00:00:00  ",
+        )) + "\n"
+        self.assertEqual(expected_output, buffer.getvalue())
+
+
+class TestPropertySetterCmd(TestCommand):
+    """Abstract class for tests of command.PropertySetter classes"""
+
     def runTest(self):
         if not hasattr(self, "command"):
-            return
-        values_to_get = getattr(self, "values_to_get",
-                                self.values_to_set)
-        for value_to_set, value_to_get in zip(self.values_to_set,
-                                              values_to_get):
-            for client in self.clients:
-                old_value = client.attributes[self.property]
-                self.assertNotIsInstance(old_value, Unique)
-                client.attributes[self.property] = Unique()
-            self.run_command(value_to_set, self.clients)
-            for client in self.clients:
-                value = client.attributes[self.property]
+            return              # Abstract TestCase class
+
+        if hasattr(self, "values_to_set"):
+            cmd_args = [(value,) for value in self.values_to_set]
+            values_to_get = getattr(self, "values_to_get",
+                                    self.values_to_set)
+        else:
+            cmd_args = [() for x in range(len(self.values_to_get))]
+            values_to_get = self.values_to_get
+        self.assertTrue(values_to_get)
+        for value_to_get, cmd_arg in zip(values_to_get, cmd_args):
+            for clientpath in self.bus.clients:
+                self.bus.clients[clientpath][self.propname] = (
+                    Unique())
+            self.command(*cmd_arg).run(self.bus.clients, self.bus)
+            self.assertTrue(self.bus.clients)
+            for clientpath in self.bus.clients:
+                value = (self.bus.clients[clientpath]
+                         [self.propname])
                 self.assertNotIsInstance(value, Unique)
-                self.assertEqual(value, value_to_get)
-    def run_command(self, value, clients):
-        self.command().run(None, clients)
-
-class TestBumpTimeoutCmd(TestPropertyCmd):
-    command = BumpTimeoutCmd
-    property = "LastCheckedOK"
-    values_to_set = [""]
-
-class TestStartCheckerCmd(TestPropertyCmd):
-    command = StartCheckerCmd
-    property = "CheckerRunning"
-    values_to_set = [dbus.Boolean(True)]
-
-class TestStopCheckerCmd(TestPropertyCmd):
-    command = StopCheckerCmd
-    property = "CheckerRunning"
-    values_to_set = [dbus.Boolean(False)]
-
-class TestApproveByDefaultCmd(TestPropertyCmd):
-    command = ApproveByDefaultCmd
-    property = "ApprovedByDefault"
-    values_to_set = [dbus.Boolean(True)]
-
-class TestDenyByDefaultCmd(TestPropertyCmd):
-    command = DenyByDefaultCmd
-    property = "ApprovedByDefault"
-    values_to_set = [dbus.Boolean(False)]
-
-class TestValueArgumentPropertyCmd(TestPropertyCmd):
-    """Abstract class for tests of PropertyCmd classes using the
-ValueArgumentMixIn"""
-    def runTest(self):
-        if type(self) is TestValueArgumentPropertyCmd:
-            return
-        return super(TestValueArgumentPropertyCmd, self).runTest()
-    def run_command(self, value, clients):
-        self.command(value).run(None, clients)
-
-class TestSetCheckerCmd(TestValueArgumentPropertyCmd):
-    command = SetCheckerCmd
-    property = "Checker"
+                self.assertEqual(value_to_get, value)
+
+
+class TestEnableCmd(TestPropertySetterCmd):
+    command = command.Enable
+    propname = "Enabled"
+    values_to_get = [True]
+
+
+class TestDisableCmd(TestPropertySetterCmd):
+    command = command.Disable
+    propname = "Enabled"
+    values_to_get = [False]
+
+
+class TestBumpTimeoutCmd(TestPropertySetterCmd):
+    command = command.BumpTimeout
+    propname = "LastCheckedOK"
+    values_to_get = [""]
+
+
+class TestStartCheckerCmd(TestPropertySetterCmd):
+    command = command.StartChecker
+    propname = "CheckerRunning"
+    values_to_get = [True]
+
+
+class TestStopCheckerCmd(TestPropertySetterCmd):
+    command = command.StopChecker
+    propname = "CheckerRunning"
+    values_to_get = [False]
+
+
+class TestApproveByDefaultCmd(TestPropertySetterCmd):
+    command = command.ApproveByDefault
+    propname = "ApprovedByDefault"
+    values_to_get = [True]
+
+
+class TestDenyByDefaultCmd(TestPropertySetterCmd):
+    command = command.DenyByDefault
+    propname = "ApprovedByDefault"
+    values_to_get = [False]
+
+
+class TestSetCheckerCmd(TestPropertySetterCmd):
+    command = command.SetChecker
+    propname = "Checker"
     values_to_set = ["", ":", "fping -q -- %s"]
 
-class TestSetHostCmd(TestValueArgumentPropertyCmd):
-    command = SetHostCmd
-    property = "Host"
-    values_to_set = ["192.0.2.3", "foo.example.org"]
-
-class TestSetSecretCmd(TestValueArgumentPropertyCmd):
-    command = SetSecretCmd
-    property = "Secret"
+
+class TestSetHostCmd(TestPropertySetterCmd):
+    command = command.SetHost
+    propname = "Host"
+    values_to_set = ["192.0.2.3", "client.example.org"]
+
+
+class TestSetSecretCmd(TestPropertySetterCmd):
+    command = command.SetSecret
+    propname = "Secret"
     values_to_set = [io.BytesIO(b""),
                      io.BytesIO(b"secret\0xyzzy\nbar")]
-    values_to_get = [b"", b"secret\0xyzzy\nbar"]
-
-class TestSetTimeoutCmd(TestValueArgumentPropertyCmd):
-    command = SetTimeoutCmd
-    property = "Timeout"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetExtendedTimeoutCmd(TestValueArgumentPropertyCmd):
-    command = SetExtendedTimeoutCmd
-    property = "ExtendedTimeout"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetIntervalCmd(TestValueArgumentPropertyCmd):
-    command = SetIntervalCmd
-    property = "Interval"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetApprovalDelayCmd(TestValueArgumentPropertyCmd):
-    command = SetApprovalDelayCmd
-    property = "ApprovalDelay"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetApprovalDurationCmd(TestValueArgumentPropertyCmd):
-    command = SetApprovalDurationCmd
-    property = "ApprovalDuration"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class Test_command_from_options(unittest.TestCase):
-    def setUp(self):
-        self.parser = argparse.ArgumentParser()
-        add_command_line_options(self.parser)
-    def assert_command_from_args(self, args, command_cls, **cmd_attrs):
-        """Assert that parsing ARGS should result in an instance of
-COMMAND_CLS with (optionally) all supplied attributes (CMD_ATTRS)."""
-        options = self.parser.parse_args(args)
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 1)
-        command = commands[0]
-        self.assertIsInstance(command, command_cls)
-        for key, value in cmd_attrs.items():
-            self.assertEqual(getattr(command, key), value)
-    def test_print_table(self):
-        self.assert_command_from_args([], PrintTableCmd,
-                                      verbose=False)
-
-    def test_print_table_verbose(self):
-        self.assert_command_from_args(["--verbose"], PrintTableCmd,
-                                      verbose=True)
-
-    def test_print_table_verbose_short(self):
-        self.assert_command_from_args(["-v"], PrintTableCmd,
-                                      verbose=True)
-
-    def test_enable(self):
-        self.assert_command_from_args(["--enable", "foo"], EnableCmd)
-
-    def test_enable_short(self):
-        self.assert_command_from_args(["-e", "foo"], EnableCmd)
-
-    def test_disable(self):
-        self.assert_command_from_args(["--disable", "foo"],
-                                      DisableCmd)
-
-    def test_disable_short(self):
-        self.assert_command_from_args(["-d", "foo"], DisableCmd)
-
-    def test_bump_timeout(self):
-        self.assert_command_from_args(["--bump-timeout", "foo"],
-                                      BumpTimeoutCmd)
-
-    def test_bump_timeout_short(self):
-        self.assert_command_from_args(["-b", "foo"], BumpTimeoutCmd)
-
-    def test_start_checker(self):
-        self.assert_command_from_args(["--start-checker", "foo"],
-                                      StartCheckerCmd)
-
-    def test_stop_checker(self):
-        self.assert_command_from_args(["--stop-checker", "foo"],
-                                      StopCheckerCmd)
-
-    def test_remove(self):
-        self.assert_command_from_args(["--remove", "foo"],
-                                      RemoveCmd)
-
-    def test_remove_short(self):
-        self.assert_command_from_args(["-r", "foo"], RemoveCmd)
-
-    def test_checker(self):
-        self.assert_command_from_args(["--checker", ":", "foo"],
-                                      SetCheckerCmd, value_to_set=":")
-
-    def test_checker_empty(self):
-        self.assert_command_from_args(["--checker", "", "foo"],
-                                      SetCheckerCmd, value_to_set="")
-
-    def test_checker_short(self):
-        self.assert_command_from_args(["-c", ":", "foo"],
-                                      SetCheckerCmd, value_to_set=":")
-
-    def test_timeout(self):
-        self.assert_command_from_args(["--timeout", "PT5M", "foo"],
-                                      SetTimeoutCmd,
-                                      value_to_set=300000)
-
-    def test_timeout_short(self):
-        self.assert_command_from_args(["-t", "PT5M", "foo"],
-                                      SetTimeoutCmd,
-                                      value_to_set=300000)
-
-    def test_extended_timeout(self):
-        self.assert_command_from_args(["--extended-timeout", "PT15M",
-                                       "foo"],
-                                      SetExtendedTimeoutCmd,
-                                      value_to_set=900000)
-
-    def test_interval(self):
-        self.assert_command_from_args(["--interval", "PT2M", "foo"],
-                                      SetIntervalCmd,
-                                      value_to_set=120000)
-
-    def test_interval_short(self):
-        self.assert_command_from_args(["-i", "PT2M", "foo"],
-                                      SetIntervalCmd,
-                                      value_to_set=120000)
-
-    def test_approve_by_default(self):
-        self.assert_command_from_args(["--approve-by-default", "foo"],
-                                      ApproveByDefaultCmd)
-
-    def test_deny_by_default(self):
-        self.assert_command_from_args(["--deny-by-default", "foo"],
-                                      DenyByDefaultCmd)
-
-    def test_approval_delay(self):
-        self.assert_command_from_args(["--approval-delay", "PT30S",
-                                       "foo"], SetApprovalDelayCmd,
-                                      value_to_set=30000)
-
-    def test_approval_duration(self):
-        self.assert_command_from_args(["--approval-duration", "PT1S",
-                                       "foo"], SetApprovalDurationCmd,
-                                      value_to_set=1000)
-
-    def test_host(self):
-        self.assert_command_from_args(["--host", "foo.example.org",
-                                       "foo"], SetHostCmd,
-                                      value_to_set="foo.example.org")
-
-    def test_host_short(self):
-        self.assert_command_from_args(["-H", "foo.example.org",
-                                       "foo"], SetHostCmd,
-                                      value_to_set="foo.example.org")
-
-    def test_secret_devnull(self):
-        self.assert_command_from_args(["--secret", os.path.devnull,
-                                       "foo"], SetSecretCmd,
-                                      value_to_set=b"")
-
-    def test_secret_tempfile(self):
-        with tempfile.NamedTemporaryFile(mode="r+b") as f:
-            value = b"secret\0xyzzy\nbar"
-            f.write(value)
-            f.seek(0)
-            self.assert_command_from_args(["--secret", f.name,
-                                           "foo"], SetSecretCmd,
-                                          value_to_set=value)
-
-    def test_secret_devnull_short(self):
-        self.assert_command_from_args(["-s", os.path.devnull, "foo"],
-                                      SetSecretCmd, value_to_set=b"")
-
-    def test_secret_tempfile_short(self):
-        with tempfile.NamedTemporaryFile(mode="r+b") as f:
-            value = b"secret\0xyzzy\nbar"
-            f.write(value)
-            f.seek(0)
-            self.assert_command_from_args(["-s", f.name, "foo"],
-                                          SetSecretCmd,
-                                          value_to_set=value)
-
-    def test_approve(self):
-        self.assert_command_from_args(["--approve", "foo"],
-                                      ApproveCmd)
-
-    def test_approve_short(self):
-        self.assert_command_from_args(["-A", "foo"], ApproveCmd)
-
-    def test_deny(self):
-        self.assert_command_from_args(["--deny", "foo"], DenyCmd)
-
-    def test_deny_short(self):
-        self.assert_command_from_args(["-D", "foo"], DenyCmd)
-
-    def test_dump_json(self):
-        self.assert_command_from_args(["--dump-json"], DumpJSONCmd)
-
-    def test_is_enabled(self):
-        self.assert_command_from_args(["--is-enabled", "foo"],
-                                      IsEnabledCmd)
-
-    def test_is_enabled_short(self):
-        self.assert_command_from_args(["-V", "foo"], IsEnabledCmd)
-
-    def test_deny_before_remove(self):
-        options = self.parser.parse_args(["--deny", "--remove", "foo"])
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 2)
-        self.assertIsInstance(commands[0], DenyCmd)
-        self.assertIsInstance(commands[1], RemoveCmd)
-
-    def test_deny_before_remove_reversed(self):
-        options = self.parser.parse_args(["--remove", "--deny", "--all"])
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 2)
-        self.assertIsInstance(commands[0], DenyCmd)
-        self.assertIsInstance(commands[1], RemoveCmd)
-
-
-class Test_check_option_syntax(unittest.TestCase):
-    # This mostly corresponds to the definition from has_actions() in
-    # check_option_syntax()
-    actions = {
-        # The actual values set here are not that important, but we do
-        # at least stick to the correct types, even though they are
-        # never used
-        "enable": True,
-        "disable": True,
-        "bump_timeout": True,
-        "start_checker": True,
-        "stop_checker": True,
-        "is_enabled": True,
-        "remove": True,
-        "checker": "x",
-        "timeout": datetime.timedelta(),
-        "extended_timeout": datetime.timedelta(),
-        "interval": datetime.timedelta(),
-        "approved_by_default": True,
-        "approval_delay": datetime.timedelta(),
-        "approval_duration": datetime.timedelta(),
-        "host": "x",
-        "secret": io.BytesIO(b"x"),
-        "approve": True,
-        "deny": True,
-    }
-
-    def setUp(self):
-        self.parser = argparse.ArgumentParser()
-        add_command_line_options(self.parser)
-
-    @contextlib.contextmanager
-    def assertParseError(self):
-        with self.assertRaises(SystemExit) as e:
-            with self.temporarily_suppress_stderr():
-                yield
-        # Exit code from argparse is guaranteed to be "2".  Reference:
-        # https://docs.python.org/3/library/argparse.html#exiting-methods
-        self.assertEqual(e.exception.code, 2)
-
-    @staticmethod
-    @contextlib.contextmanager
-    def temporarily_suppress_stderr():
-        null = os.open(os.path.devnull, os.O_RDWR)
-        stderrcopy = os.dup(sys.stderr.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        os.close(null)
-        try:
-            yield
-        finally:
-            # restore stderr
-            os.dup2(stderrcopy, sys.stderr.fileno())
-            os.close(stderrcopy)
-
-    def check_option_syntax(self, options):
-        check_option_syntax(self.parser, options)
-
-    def test_actions_requires_client_or_all(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_actions_conflicts_with_verbose(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.verbose = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_dump_json_conflicts_with_verbose(self):
-        options = self.parser.parse_args()
-        options.dump_json = True
-        options.verbose = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_dump_json_conflicts_with_action(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.dump_json = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_all_can_not_be_alone(self):
-        options = self.parser.parse_args()
-        options.all = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_all_is_ok_with_any_action(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.all = True
-            self.check_option_syntax(options)
-
-    def test_is_enabled_fails_without_client(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_is_enabled_works_with_one_client(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        options.client = ["foo"]
-        self.check_option_syntax(options)
-
-    def test_is_enabled_fails_with_two_clients(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        options.client = ["foo", "barbar"]
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_remove_can_only_be_combined_with_action_deny(self):
-        for action, value in self.actions.items():
-            if action in {"remove", "deny"}:
-                continue
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.all = True
-            options.remove = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
+    values_to_get = [f.getvalue() for f in values_to_set]
+
+
+class TestSetTimeoutCmd(TestPropertySetterCmd):
+    command = command.SetTimeout
+    propname = "Timeout"
+    values_to_set = [datetime.timedelta(),
+                     datetime.timedelta(minutes=5),
+                     datetime.timedelta(seconds=1),
+                     datetime.timedelta(weeks=1),
+                     datetime.timedelta(weeks=52)]
+    values_to_get = [dt.total_seconds()*1000 for dt in values_to_set]
+
+
+class TestSetExtendedTimeoutCmd(TestPropertySetterCmd):
+    command = command.SetExtendedTimeout
+    propname = "ExtendedTimeout"
+    values_to_set = [datetime.timedelta(),
+                     datetime.timedelta(minutes=5),
+                     datetime.timedelta(seconds=1),
+                     datetime.timedelta(weeks=1),
+                     datetime.timedelta(weeks=52)]
+    values_to_get = [dt.total_seconds()*1000 for dt in values_to_set]
+
+
+class TestSetIntervalCmd(TestPropertySetterCmd):
+    command = command.SetInterval
+    propname = "Interval"
+    values_to_set = [datetime.timedelta(),
+                     datetime.timedelta(minutes=5),
+                     datetime.timedelta(seconds=1),
+                     datetime.timedelta(weeks=1),
+                     datetime.timedelta(weeks=52)]
+    values_to_get = [dt.total_seconds()*1000 for dt in values_to_set]
+
+
+class TestSetApprovalDelayCmd(TestPropertySetterCmd):
+    command = command.SetApprovalDelay
+    propname = "ApprovalDelay"
+    values_to_set = [datetime.timedelta(),
+                     datetime.timedelta(minutes=5),
+                     datetime.timedelta(seconds=1),
+                     datetime.timedelta(weeks=1),
+                     datetime.timedelta(weeks=52)]
+    values_to_get = [dt.total_seconds()*1000 for dt in values_to_set]
+
+
+class TestSetApprovalDurationCmd(TestPropertySetterCmd):
+    command = command.SetApprovalDuration
+    propname = "ApprovalDuration"
+    values_to_set = [datetime.timedelta(),
+                     datetime.timedelta(minutes=5),
+                     datetime.timedelta(seconds=1),
+                     datetime.timedelta(weeks=1),
+                     datetime.timedelta(weeks=52)]
+    values_to_get = [dt.total_seconds()*1000 for dt in values_to_set]
 
 
 
@@ -1536,8 +2820,11 @@
     return tests
 
 if __name__ == "__main__":
-    if should_only_run_tests():
-        # Call using ./tdd-python-script --check [--verbose]
-        unittest.main()
-    else:
-        main()
+    try:
+        if should_only_run_tests():
+            # Call using ./tdd-python-script --check [--verbose]
+            unittest.main()
+        else:
+            main()
+    finally:
+        logging.shutdown()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2019-03-08 23:55:34 +0000
+++ mandos-ctl.xml	2019-07-29 16:35:53 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2019-03-09">
+<!ENTITY TIMESTAMP "2019-07-29">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -557,7 +557,11 @@
   
   <refsect1 id="example">
     <title>EXAMPLE</title>
+    <!-- Name of test methods in class Test_commands_from_options are
+         written in comments below.  When adding an example, add a
+         test too which tests the documented behavior. -->
     <informalexample>
+      <!-- Test method: test_manual_page_example_1() -->
       <para>
 	To list all clients:
       </para>
@@ -567,6 +571,7 @@
     </informalexample>
     
     <informalexample>
+      <!-- Test method: test_manual_page_example_2() -->
       <para>
 	To list <emphasis>all</emphasis> settings for the clients
         named <quote>foo1.example.org</quote> and <quote
@@ -581,6 +586,7 @@
     </informalexample>
     
     <informalexample>
+      <!-- Test method: test_manual_page_example_3() -->
       <para>
 	To enable all clients:
       </para>
@@ -590,6 +596,7 @@
     </informalexample>
     
     <informalexample>
+      <!-- Test method: test_manual_page_example_4() -->
       <para>
 	To change timeout and interval value for the clients
         named <quote>foo1.example.org</quote> and <quote
@@ -598,14 +605,15 @@
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --timeout="PT5M" --interval="PT1M" foo1.example.org foo2.example.org</userinput>
+<userinput>&COMMANDNAME; --timeout=PT5M --interval=PT1M foo1.example.org foo2.example.org</userinput>
 
       </para>
     </informalexample>
     
     <informalexample>
+      <!-- Test method: test_manual_page_example_5() -->
       <para>
-	To approve all clients currently waiting for it:
+	To approve all clients currently waiting for approval:
       </para>
       <para>
 	<userinput>&COMMANDNAME; --approve --all</userinput>

=== modified file 'mandos-keygen'
--- mandos-keygen	2019-02-11 06:31:42 +0000
+++ mandos-keygen	2021-02-03 08:57:27 +0000
@@ -23,7 +23,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.8.3"
+VERSION="1.8.14"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -381,7 +381,7 @@
     
     while [ ! -s "$SECFILE" ]; do
 	if [ -n "$PASSFILE" ]; then
-	    cat "$PASSFILE"
+	    cat -- "$PASSFILE"
 	else
 	    tty --quiet && stty -echo
 	    echo -n "Enter passphrase: " >/dev/tty

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2019-02-10 04:20:26 +0000
+++ mandos-keygen.xml	2019-07-18 00:02:43 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2019-07-18">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -363,7 +363,9 @@
 	    >8</manvolnum></citerefentry>.  The host name or the name
 	    specified with the <option>--name</option> option is used
 	    for the section header.  All other options are ignored,
-	    and no key is created.
+	    and no key is created.  Note: white space is stripped from
+	    the beginning and from the end of the password; See <xref
+	    linkend="bugs"/>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -375,7 +377,8 @@
 	<listitem>
 	  <para>
 	    The same as <option>--password</option>, but read from
-	    <replaceable>FILE</replaceable>, not the terminal.
+	    <replaceable>FILE</replaceable>, not the terminal, and
+	    white space is not stripped from the password in any way.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -489,6 +492,13 @@
   
   <refsect1 id="bugs">
     <title>BUGS</title>
+    <para>
+      The <option>--password</option>/<option>-p</option> option
+      strips white space from the start and from the end of the
+      password before using it.  If this is a problem, use the
+      <option>--passfile</option> option instead, which does not do
+      this.
+    </para>
     <xi:include href="bugs.xml"/>
   </refsect1>
   

=== modified file 'mandos-monitor'
--- mandos-monitor	2019-02-11 06:31:42 +0000
+++ mandos-monitor	2021-02-03 08:57:27 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python
+#!/usr/bin/python3 -bbI
 # -*- mode: python; coding: utf-8 -*-
 #
 # Mandos Monitor - Control and monitor the Mandos server
@@ -33,8 +33,10 @@
 
 import sys
 import os
-
+import warnings
 import datetime
+import locale
+import logging
 
 import urwid.curses_display
 import urwid
@@ -44,22 +46,25 @@
 
 import dbus
 
-import locale
-
-import logging
-
 if sys.version_info.major == 2:
+    __metaclass__ = type
     str = unicode
 
-locale.setlocale(locale.LC_ALL, '')
-
-logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
+log = logging.getLogger(os.path.basename(sys.argv[0]))
+logging.basicConfig(level="NOTSET", # Show all messages
+                    format="%(message)s") # Show basic log messages
+
+logging.captureWarnings(True)   # Show warnings via the logging system
+
+locale.setlocale(locale.LC_ALL, "")
+
+logging.getLogger("dbus.proxies").setLevel(logging.CRITICAL)
 
 # Some useful constants
-domain = 'se.recompile'
-server_interface = domain + '.Mandos'
-client_interface = domain + '.Mandos.Client'
-version = "1.8.3"
+domain = "se.recompile"
+server_interface = domain + ".Mandos"
+client_interface = domain + ".Mandos.Client"
+version = "1.8.14"
 
 try:
     dbus.OBJECT_MANAGER_IFACE
@@ -84,7 +89,7 @@
                              int(fraction*1000000))  # Microseconds
 
 
-class MandosClientPropertyCache(object):
+class MandosClientPropertyCache:
     """This wraps a Mandos Client D-Bus proxy object, caches the
     properties and calls a hook function when any of them are
     changed.
@@ -122,15 +127,13 @@
     """
 
     def __init__(self, server_proxy_object=None, update_hook=None,
-                 delete_hook=None, logger=None, **kwargs):
+                 delete_hook=None, **kwargs):
         # Called on update
         self.update_hook = update_hook
         # Called on delete
         self.delete_hook = delete_hook
         # Mandos Server proxy object
         self.server_proxy_object = server_proxy_object
-        # Logger
-        self.logger = logger
 
         self._update_timer_callback_tag = None
 
@@ -163,8 +166,7 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        self.logger('Created client {}'
-                    .format(self.properties["Name"]), level=0)
+        log.debug("Created client %s", self.properties["Name"])
 
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
@@ -172,54 +174,49 @@
         """
         if flag and self._update_timer_callback_tag is None:
             # Will update the shown timer value every second
-            self._update_timer_callback_tag = (GLib.timeout_add
-                                               (1000,
-                                                self.update_timer))
+            self._update_timer_callback_tag = (
+                GLib.timeout_add(1000,
+                                 glib_safely(self.update_timer)))
         elif not (flag or self._update_timer_callback_tag is None):
             GLib.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
 
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            self.logger('Checker for client {} (command "{}")'
-                        ' succeeded'.format(self.properties["Name"],
-                                            command), level=0)
+            log.debug('Checker for client %s (command "%s")'
+                      " succeeded", self.properties["Name"], command)
             self.update()
             return
         # Checker failed
         if os.WIFEXITED(condition):
-            self.logger('Checker for client {} (command "{}") failed'
-                        ' with exit code {}'
-                        .format(self.properties["Name"], command,
-                                os.WEXITSTATUS(condition)))
+            log.info('Checker for client %s (command "%s") failed'
+                     " with exit code %d", self.properties["Name"],
+                     command, os.WEXITSTATUS(condition))
         elif os.WIFSIGNALED(condition):
-            self.logger('Checker for client {} (command "{}") was'
-                        ' killed by signal {}'
-                        .format(self.properties["Name"], command,
-                                os.WTERMSIG(condition)))
+            log.info('Checker for client %s (command "%s") was'
+                     " killed by signal %d", self.properties["Name"],
+                     command, os.WTERMSIG(condition))
         self.update()
 
     def checker_started(self, command):
         """Server signals that a checker started."""
-        self.logger('Client {} started checker "{}"'
-                    .format(self.properties["Name"],
-                            command), level=0)
+        log.debug('Client %s started checker "%s"',
+                  self.properties["Name"], command)
 
     def got_secret(self):
-        self.logger('Client {} received its secret'
-                    .format(self.properties["Name"]))
+        log.info("Client %s received its secret",
+                 self.properties["Name"])
 
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client {} needs approval within {} seconds'
+            message = "Client %s needs approval within %f seconds"
         else:
-            message = 'Client {} will get its secret in {} seconds'
-        self.logger(message.format(self.properties["Name"],
-                                   timeout/1000))
+            message = "Client %s will get its secret in %f seconds"
+        log.info(message, self.properties["Name"], timeout/1000)
 
     def rejected(self, reason):
-        self.logger('Client {} was rejected; reason: {}'
-                    .format(self.properties["Name"], reason))
+        log.info("Client %s was rejected; reason: %s",
+                 self.properties["Name"], reason)
 
     def selectable(self):
         """Make this a "selectable" widget.
@@ -251,7 +248,7 @@
         # Rebuild focus and non-focus widgets using current properties
 
         # Base part of a client. Name!
-        base = '{name}: '.format(name=self.properties["Name"])
+        base = "{name}: ".format(name=self.properties["Name"])
         if not self.properties["Enabled"]:
             message = "DISABLED"
             self.using_timer(False)
@@ -279,11 +276,11 @@
                 timer = datetime.timedelta(0)
             else:
                 expires = (datetime.datetime.strptime
-                           (expires, '%Y-%m-%dT%H:%M:%S.%f'))
+                           (expires, "%Y-%m-%dT%H:%M:%S.%f"))
                 timer = max(expires - datetime.datetime.utcnow(),
                             datetime.timedelta())
-            message = ('A checker has failed! Time until client'
-                       ' gets disabled: {}'
+            message = ("A checker has failed! Time until client"
+                       " gets disabled: {}"
                        .format(str(timer).rsplit(".", 1)[0]))
             self.using_timer(True)
         else:
@@ -387,6 +384,16 @@
             self.update()
 
 
+def glib_safely(func, retval=True):
+    def safe_func(*args, **kwargs):
+        try:
+            return func(*args, **kwargs)
+        except Exception:
+            log.exception("")
+            return retval
+    return safe_func
+
+
 class ConstrainedListBox(urwid.ListBox):
     """Like a normal urwid.ListBox, but will consume all "up" or
     "down" key presses, thus not allowing any containing widgets to
@@ -400,11 +407,11 @@
         return ret
 
 
-class UserInterface(object):
+class UserInterface:
     """This is the entire user interface - the whole screen
     with boxes, lists of client widgets, etc.
     """
-    def __init__(self, max_log_length=1000, log_level=1):
+    def __init__(self, max_log_length=1000):
         DBusGMainLoop(set_as_default=True)
 
         self.screen = urwid.curses_display.Screen()
@@ -447,8 +454,6 @@
         self.log = urwid.SimpleListWalker([])
         self.max_log_length = max_log_length
 
-        self.log_level = log_level
-
         # We keep a reference to the log widget so we can remove it
         # from the ListWalker without it getting destroyed
         self.logbox = ConstrainedListBox(self.log)
@@ -458,19 +463,19 @@
         self.log_visible = True
         self.log_wrap = "any"
 
+        self.loghandler = UILogHandler(self)
+
         self.rebuild()
-        self.log_message_raw(("bold",
-                              "Mandos Monitor version " + version))
-        self.log_message_raw(("bold",
-                              "q: Quit  ?: Help"))
+        self.add_log_line(("bold",
+                           "Mandos Monitor version " + version))
+        self.add_log_line(("bold", "q: Quit  ?: Help"))
 
-        self.busname = domain + '.Mandos'
+        self.busname = domain + ".Mandos"
         self.main_loop = GLib.MainLoop()
 
-    def client_not_found(self, fingerprint, address):
-        self.log_message("Client with address {} and fingerprint {}"
-                         " could not be found"
-                         .format(address, fingerprint))
+    def client_not_found(self, key_id, address):
+        log.info("Client with address %s and key ID %s could"
+                 " not be found", address, key_id)
 
     def rebuild(self):
         """This rebuilds the User Interface.
@@ -487,22 +492,11 @@
             self.uilist.append(self.logbox)
         self.topwidget = urwid.Pile(self.uilist)
 
-    def log_message(self, message, level=1):
-        """Log message formatted with timestamp"""
-        if level < self.log_level:
-            return
-        timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw("{}: {}".format(timestamp, message),
-                             level=level)
-
-    def log_message_raw(self, markup, level=1):
-        """Add a log message to the log buffer."""
-        if level < self.log_level:
-            return
+    def add_log_line(self, markup):
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
         if self.max_log_length:
             if len(self.log) > self.max_log_length:
-                del self.log[0:len(self.log)-self.max_log_length-1]
+                del self.log[0:(len(self.log) - self.max_log_length)]
         self.logbox.set_focus(len(self.logbox.body.contents)-1,
                               coming_from="above")
         self.refresh()
@@ -511,8 +505,7 @@
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        self.log_message("Log visibility changed to: {}"
-                         .format(self.log_visible), level=0)
+        log.debug("Log visibility changed to: %s", self.log_visible)
 
     def change_log_display(self):
         """Change type of log display.
@@ -523,8 +516,7 @@
             self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message("Wrap mode: {}".format(self.log_wrap),
-                         level=0)
+        log.debug("Wrap mode: %s", self.log_wrap)
 
     def find_and_remove_client(self, path, interfaces):
         """Find a client by its object path and remove it.
@@ -538,8 +530,7 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            self.log_message("Unknown client {!r} removed"
-                             .format(path))
+            log.warning("Unknown client %s removed", path)
             return
         client.delete()
 
@@ -558,7 +549,6 @@
             proxy_object=client_proxy_object,
             update_hook=self.refresh,
             delete_hook=self.remove_client,
-            logger=self.log_message,
             properties=dict(ifs_and_props[client_interface])),
                         path=path)
 
@@ -584,6 +574,11 @@
 
     def run(self):
         """Start the main loop and exit when it's done."""
+        log.addHandler(self.loghandler)
+        self.orig_log_propagate = log.propagate
+        log.propagate = False
+        self.orig_log_level = log.level
+        log.setLevel("INFO")
         self.bus = dbus.SystemBus()
         mandos_dbus_objc = self.bus.get_object(
             self.busname, "/", follow_name_owner_changes=True)
@@ -593,11 +588,9 @@
             mandos_clients = (self.mandos_serv
                               .GetAllClientsWithProperties())
             if not mandos_clients:
-                self.log_message_raw(("bold",
-                                      "Note: Server has no clients."))
+                log.warning("Note: Server has no clients.")
         except dbus.exceptions.DBusException:
-            self.log_message_raw(("bold",
-                                  "Note: No Mandos server running."))
+            log.warning("Note: No Mandos server running.")
             mandos_clients = dbus.Dictionary()
 
         (self.mandos_serv
@@ -623,22 +616,26 @@
                 proxy_object=client_proxy_object,
                 properties=client,
                 update_hook=self.refresh,
-                delete_hook=self.remove_client,
-                logger=self.log_message),
+                delete_hook=self.remove_client),
                             path=path)
 
         self.refresh()
-        self._input_callback_tag = (GLib.io_add_watch
-                                    (sys.stdin.fileno(),
-                                     GLib.IO_IN,
-                                     self.process_input))
+        self._input_callback_tag = (
+            GLib.io_add_watch(
+                GLib.IOChannel.unix_new(sys.stdin.fileno()),
+                GLib.PRIORITY_DEFAULT, GLib.IO_IN,
+                glib_safely(self.process_input)))
         self.main_loop.run()
         # Main loop has finished, we should close everything now
         GLib.source_remove(self._input_callback_tag)
-        self.screen.stop()
+        with warnings.catch_warnings():
+            warnings.simplefilter("ignore", BytesWarning)
+            self.screen.stop()
 
     def stop(self):
         self.main_loop.quit()
+        log.removeHandler(self.loghandler)
+        log.propagate = self.orig_log_propagate
 
     def process_input(self, source, condition):
         keys = self.screen.get_input()
@@ -677,26 +674,25 @@
                 if not self.log_visible:
                     self.log_visible = True
                     self.rebuild()
-                self.log_message_raw(("bold",
-                                      "  ".
-                                      join(("q: Quit",
-                                            "?: Help",
-                                            "l: Log window toggle",
-                                            "TAB: Switch window",
-                                            "w: Wrap (log lines)",
-                                            "v: Toggle verbose log",
-                                            ))))
-                self.log_message_raw(("bold",
-                                      "  "
-                                      .join(("Clients:",
-                                             "+: Enable",
-                                             "-: Disable",
-                                             "R: Remove",
-                                             "s: Start new checker",
-                                             "S: Stop checker",
-                                             "C: Checker OK",
-                                             "a: Approve",
-                                             "d: Deny"))))
+                self.add_log_line(("bold",
+                                   "  ".join(("q: Quit",
+                                              "?: Help",
+                                              "l: Log window toggle",
+                                              "TAB: Switch window",
+                                              "w: Wrap (log lines)",
+                                              "v: Toggle verbose log",
+                                   ))))
+                self.add_log_line(("bold",
+                                   "  ".join(("Clients:",
+                                              "+: Enable",
+                                              "-: Disable",
+                                              "R: Remove",
+                                              "s: Start new checker",
+                                              "S: Stop checker",
+                                              "C: Checker OK",
+                                              "a: Approve",
+                                              "d: Deny",
+                                   ))))
                 self.refresh()
             elif key == "tab":
                 if self.topwidget.get_focus() is self.logbox:
@@ -705,12 +701,12 @@
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
             elif key == "v":
-                if self.log_level == 0:
-                    self.log_level = 1
-                    self.log_message("Verbose mode: Off")
+                if log.level < logging.INFO:
+                    log.setLevel(logging.INFO)
+                    log.info("Verbose mode: Off")
                 else:
-                    self.log_level = 0
-                    self.log_message("Verbose mode: On")
+                    log.setLevel(logging.NOTSET)
+                    log.info("Verbose mode: On")
             # elif (key == "end" or key == "meta >" or key == "G"
             #       or key == ">"):
             #     pass            # xxx end-of-buffer
@@ -735,12 +731,28 @@
         return True
 
 
+class UILogHandler(logging.Handler):
+    def __init__(self, ui, *args, **kwargs):
+        self.ui = ui
+        super(UILogHandler, self).__init__(*args, **kwargs)
+        self.setFormatter(
+            logging.Formatter("%(asctime)s: %(message)s"))
+    def emit(self, record):
+        msg = self.format(record)
+        if record.levelno > logging.INFO:
+            msg = ("bold", msg)
+        self.ui.add_log_line(msg)
+
+
 ui = UserInterface()
 try:
     ui.run()
 except KeyboardInterrupt:
-    ui.screen.stop()
-except Exception as e:
-    ui.log_message(str(e))
-    ui.screen.stop()
+    with warnings.catch_warnings():
+        warnings.filterwarnings("ignore", "", BytesWarning)
+        ui.screen.stop()
+except Exception:
+    with warnings.catch_warnings():
+        warnings.filterwarnings("ignore", "", BytesWarning)
+        ui.screen.stop()
     raise

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2019-02-09 23:23:26 +0000
+++ mandos-options.xml	2019-07-25 21:42:40 +0000
@@ -49,9 +49,10 @@
   <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is
-    <quote><literal>SECURE128&#8203;:!CTYPE-X.509&#8203;:+CTYPE-RAWPK&#8203;:!RSA&#8203;:!VERS-ALL&#8203;:+VERS-TLS1.3&#8203;:%PROFILE_ULTRA</literal></quote>
+    <!-- &#x200b; is Unicode ZERO WIDTH SPACE; allows line breaks -->
+    <quote><literal>SECURE128&#x200b;:!CTYPE-X.509&#x200b;:+CTYPE-RAWPK&#x200b;:!RSA&#x200b;:!VERS-ALL&#x200b;:+VERS-TLS1.3&#x200b;:%PROFILE_ULTRA</literal></quote>
     when using raw public keys in TLS, and
-    <quote><literal>SECURE256&#8203;:!CTYPE-X.509&#8203;:+CTYPE-OPENPGP&#8203;:!RSA&#8203;:+SIGN-DSA-SHA256</literal></quote>
+    <quote><literal>SECURE256&#x200b;:!CTYPE-X.509&#x200b;:+CTYPE-OPENPGP&#x200b;:!RSA&#x200b;:+SIGN-DSA-SHA256</literal></quote>
     when using OpenPGP keys in TLS,.  See <citerefentry><refentrytitle
     >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.

=== modified file 'mandos-to-cryptroot-unlock'
--- mandos-to-cryptroot-unlock	2018-08-19 14:58:40 +0000
+++ mandos-to-cryptroot-unlock	2020-07-04 11:58:52 +0000
@@ -2,8 +2,8 @@
 # 
 # Script to get password from plugin-runner to cryptroot-unlock
 # 
-# Copyright © 2018 Teddy Hogeborn
-# Copyright © 2018 Björn Påhlsson
+# Copyright © 2018-2019 Teddy Hogeborn
+# Copyright © 2018-2019 Björn Påhlsson
 # 
 # This file is part of Mandos.
 # 
@@ -61,7 +61,7 @@
 # Keep running plugin-runner and trying any password, until either a
 # password is accepted by cryptroot-unlock, or plugin-runner fails, or
 # the file /run/mandos-keep-running has been removed.
-while type cryptroot-unlock >/dev/null 2>&1; do
+while command -v cryptroot-unlock >/dev/null 2>&1; do
     /lib/mandos/plugin-runner > "$passfile" &
     echo $! > /run/mandos-plugin-runner.pid
     wait %% || break

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2019-02-10 04:20:26 +0000
+++ mandos.conf.xml	2019-06-20 18:54:10 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2019-06-20">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -227,11 +227,11 @@
       <programlisting>
 [DEFAULT]
 # A configuration example
-interface = eth0
+interface = enp1s0
 address = fe80::aede:48ff:fe71:f6f2
 port = 1025
 debug = True
-priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA
+priority = SECURE128:!CTYPE-X.509:+CTYPE-RAWPK:!RSA:!VERS-ALL:+VERS-TLS1.3:%PROFILE_ULTRA
 servicename = Daena
 use_dbus = False
 use_ipv6 = True

=== modified file 'mandos.lsm'
--- mandos.lsm	2019-02-11 06:31:42 +0000
+++ mandos.lsm	2021-02-03 08:57:27 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.8.3
-Entered-date:	2019-02-11
+Version:	1.8.14
+Entered-date:	2021-02-03
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	https://www.recompile.se/mandos
-		182K mandos_1.8.3.orig.tar.gz
+		235K mandos_1.8.14.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		182K mandos_1.8.3.orig.tar.gz
+		235K mandos_1.8.14.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.7, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other

=== modified file 'mandos.service'
--- mandos.service	2017-08-20 14:14:14 +0000
+++ mandos.service	2020-02-07 20:53:34 +0000
@@ -14,7 +14,8 @@
 ## If the server's D-Bus interface is disabled, the "BusName" setting
 ## should be removed or commented out.
 BusName=se.recompile.Mandos
-ExecStart=/usr/sbin/mandos --foreground
+EnvironmentFile=/etc/default/mandos
+ExecStart=/usr/sbin/mandos --foreground $DAEMON_ARGS
 Restart=always
 KillMode=mixed
 ## Using socket activation won't work, because systemd always does

=== modified file 'mandos.xml'
--- mandos.xml	2019-02-10 04:20:26 +0000
+++ mandos.xml	2019-07-24 06:16:09 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2019-07-24">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -695,7 +695,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.avahi.org/">Avahi</ulink>
+	  <ulink url="https://www.avahi.org/">Avahi</ulink>
 	</term>
       <listitem>
 	<para>

=== modified file 'plugin-helpers/mandos-client-iprouteadddel.c'
--- plugin-helpers/mandos-client-iprouteadddel.c	2018-02-18 01:29:21 +0000
+++ plugin-helpers/mandos-client-iprouteadddel.c	2021-02-03 08:40:41 +0000
@@ -2,8 +2,8 @@
 /* 
  * iprouteadddel - Add or delete direct route to a local IP address
  * 
- * Copyright © 2015-2018 Teddy Hogeborn
- * Copyright © 2015-2018 Björn Påhlsson
+ * Copyright © 2015-2018, 2021 Teddy Hogeborn
+ * Copyright © 2015-2018, 2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -25,49 +25,57 @@
 
 #define _GNU_SOURCE		/* program_invocation_short_name */
 #include <stdbool.h>		/* bool, false, true */
-#include <stdio.h>		/* fprintf(), stderr, FILE, vfprintf */
-#include <errno.h>		/* program_invocation_short_name,
-				   errno, perror(), EINVAL, ENOMEM */
-#include <stdarg.h>		/* va_list, va_start */
-#include <stdlib.h> 		/* EXIT_SUCCESS */
-#include <argp.h>		/* struct argp_option, error_t, struct
-				   argp_state, ARGP_KEY_ARG,
+#include <argp.h>		/* argp_program_version,
+				   argp_program_bug_address,
+				   struct argp_option,
+				   struct argp_state, ARGP_KEY_ARG,
 				   argp_usage(), ARGP_KEY_END,
 				   ARGP_ERR_UNKNOWN, struct argp,
-				   argp_parse() */
-#include <sysexits.h>		/* EX_USAGE, EX_OSERR */
-#include <netinet/ip.h>		/* sa_family_t, AF_INET6, AF_INET */
-#include <inttypes.h>		/* PRIdMAX, intmax_t */
-
+				   argp_parse(), ARGP_IN_ORDER */
+#include <errno.h>		/* errno,
+				   program_invocation_short_name,
+				   error_t, EINVAL, ENOMEM */
+#include <stdio.h>		/* fprintf(), stderr, perror(), FILE,
+				   vfprintf() */
+#include <stdarg.h>		/* va_list, va_start(), vfprintf() */
+#include <stdlib.h>		/* EXIT_SUCCESS */
 #include <netlink/netlink.h>	/* struct nl_addr, nl_addr_parse(),
 				   nl_geterror(),
-				   nl_addr_get_family(),
+				   nl_addr_get_family(), NLM_F_EXCL,
 				   nl_addr_put() */
-#include <netlink/route/route.h> /* struct rtnl_route,
-				    struct rtnl_nexthop,
-				    rtnl_route_alloc(),
-				    rtnl_route_set_family(),
-				    rtnl_route_set_protocol(),
-				    RTPROT_BOOT,
-				    rtnl_route_set_scope(),
-				    RT_SCOPE_LINK,
-				    rtnl_route_set_type(),
-				    RTN_UNICAST,
-				    rtnl_route_set_dst(),
-				    rtnl_route_set_table(),
-				    RT_TABLE_MAIN,
-				    rtnl_route_nh_alloc(),
-				    rtnl_route_nh_set_ifindex(),
-				    rtnl_route_add_nexthop(),
-				    rtnl_route_add(),
-				    rtnl_route_delete(),
-				    rtnl_route_put(),
-				    rtnl_route_nh_free() */
+#include <stddef.h>		/* NULL */
+#include <netlink/route/route.h>/* struct rtnl_route,
+				   struct rtnl_nexthop, NETLINK_ROUTE,
+				   rtnl_route_alloc(),
+				   rtnl_route_set_family(),
+				   rtnl_route_set_protocol(),
+				   RTPROT_BOOT,
+				   rtnl_route_set_scope(),
+				   RT_SCOPE_LINK,
+				   rtnl_route_set_type(), RTN_UNICAST,
+				   rtnl_route_set_dst(),
+				   rtnl_route_set_table(),
+				   RT_TABLE_MAIN,
+				   rtnl_route_nh_alloc(),
+				   rtnl_route_nh_set_ifindex(),
+				   rtnl_route_add_nexthop(),
+				   rtnl_route_add(),
+				   rtnl_route_delete(),
+				   rtnl_route_put(),
+				   rtnl_route_nh_free() */
 #include <netlink/socket.h>	/* struct nl_sock, nl_socket_alloc(),
 				   nl_connect(), nl_socket_free() */
-#include <netlink/route/link.h>	/* rtnl_link_get_kernel(),
+#include <strings.h>		/* strcasecmp() */
+#include <sys/socket.h>		/* AF_UNSPEC, AF_INET6, AF_INET */
+#include <sysexits.h>		/* EX_USAGE, EX_OSERR */
+#include <netlink/route/link.h> /* struct rtnl_link,
+				   rtnl_link_get_kernel(),
 				   rtnl_link_get_ifindex(),
 				   rtnl_link_put() */
+#include <netinet/in.h>		/* sa_family_t */
+#include <inttypes.h>		/* PRIdMAX, intmax_t */
+#include <stdint.h>		/* uint8_t */
+
 
 bool debug = false;
 const char *argp_program_version = "mandos-client-iprouteadddel " VERSION;
@@ -85,7 +93,7 @@
 __attribute__((format (gnu_printf, 2, 3), nonnull))
 int fprintf_plus(FILE *stream, const char *format, ...){
   va_list ap;
-  va_start (ap, format);
+  va_start(ap, format);
   
   fprintf(stream, "Mandos plugin helper %s: ",
 	  program_invocation_short_name);

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2019-02-11 05:14:10 +0000
+++ plugin-runner.c	2021-03-21 18:48:43 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2018 Teddy Hogeborn
- * Copyright © 2008-2018 Björn Påhlsson
+ * Copyright © 2008-2021 Teddy Hogeborn
+ * Copyright © 2008-2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -23,55 +23,69 @@
  * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   O_CLOEXEC, pipe2() */
+#define _GNU_SOURCE		/* strchrnul(), TEMP_FAILURE_RETRY(),
+				   getline(), asprintf(), O_CLOEXEC,
+				   scandirat(), pipe2() */
+#include <argp.h>		/* argp_program_version,
+				   argp_program_bug_address,
+				   struct argp_option,
+				   struct argp_state, argp_error(),
+				   ARGP_NO_EXIT, argp_state_help,
+				   ARGP_HELP_STD_HELP,
+				   ARGP_HELP_USAGE, ARGP_HELP_EXIT_OK,
+				   ARGP_KEY_ARG, ARGP_ERR_UNKNOWN,
+				   struct argp, argp_parse(),
+				   ARGP_IN_ORDER, ARGP_NO_HELP */
+#include <stdbool.h>		/* bool, false, true */
+#include <sys/types.h>		/* pid_t, sig_atomic_t, uid_t, gid_t,
+				   getuid(), setgid(), setuid() */
 #include <stddef.h>		/* size_t, NULL */
-#include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
-				   realloc() */
-#include <stdbool.h>		/* bool, true, false */
-#include <stdio.h>		/* fileno(), fprintf(),
-				   stderr, STDOUT_FILENO, fclose() */
-#include <sys/types.h>	        /* fstat(), struct stat, waitpid(),
-				   WIFEXITED(), WEXITSTATUS(), wait(),
-				   pid_t, uid_t, gid_t, getuid(),
-				   getgid() */
-#include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
-				   FD_SET(), FD_ISSET(), FD_CLR */
-#include <sys/wait.h>		/* wait(), waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG() */
-#include <sys/stat.h>		/* struct stat, fstat(), S_ISREG() */
-#include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* struct dirent, scandirat() */
-#include <unistd.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, write(), STDOUT_FILENO,
-				   struct stat, fstat(), close(),
-				   setgid(), setuid(), S_ISREG(),
-				   faccessat() pipe2(), fork(),
-				   _exit(), dup2(), fexecve(), read()
-				*/
+#include <iso646.h>		/* or, and, not */
+#include <string.h>		/* strcmp(), strdup(), strchrnul(),
+				   strncmp(), strlen(), strcpy(),
+				   strsep(), strchr(), strsignal() */
+#include <stdlib.h>		/* malloc(), free(), reallocarray(),
+				   realloc(), EXIT_SUCCESS */
+#include <errno.h>		/* errno, EINTR, ENOMEM, ECHILD,
+				   error_t, EINVAL, EMFILE, ENFILE,
+				   ENOENT, ESRCH */
+#include <stdint.h>		/* SIZE_MAX */
+#define _GNU_SOURCE		/* strchrnul(), TEMP_FAILURE_RETRY(),
+				   getline(), asprintf(), O_CLOEXEC,
+				   scandirat(), pipe2() */
+#include <unistd.h>		/* TEMP_FAILURE_RETRY(), ssize_t,
+				   write(), STDOUT_FILENO, uid_t,
+				   gid_t, getuid(), fchown(), close(),
+				   symlink(), setgid(), setuid(),
+				   faccessat(), X_OK, pipe(), pipe2(),
+				   fork(), _exit(), dup2(), fexecve(),
+				   read(), getpass() */
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, openat(), scandirat(),
-				   pipe2() */
-#include <string.h>		/* strsep, strlen(), strsignal(),
-				   strcmp(), strncmp() */
-#include <errno.h>		/* errno */
-#include <argp.h>		/* struct argp_option, struct
-				   argp_state, struct argp,
-				   argp_parse(), ARGP_ERR_UNKNOWN,
-				   ARGP_KEY_END, ARGP_KEY_ARG,
-				   error_t */
-#include <signal.h> 		/* struct sigaction, sigemptyset(),
-				   sigaddset(), sigaction(),
-				   sigprocmask(), SIG_BLOCK, SIGCHLD,
-				   SIG_UNBLOCK, kill(), sig_atomic_t
-				*/
-#include <errno.h>		/* errno, EBADF */
-#include <inttypes.h>		/* intmax_t, PRIdMAX, strtoimax() */
+				   FD_CLOEXEC, open(), O_RDONLY,
+				   O_CLOEXEC, openat() */
+#include <sys/wait.h>		/* waitpid(), WNOHANG, WIFEXITED(),
+				   WEXITSTATUS(), WIFSIGNALED(),
+				   WTERMSIG(), wait() */
+#include <error.h>		/* error() */
+#include <stdio.h>		/* FILE, fprintf(), fopen(),
+				   getline(), fclose(), EOF,
+				   asprintf(), stderr */
+#include <dirent.h>		/* struct dirent, scandirat(),
+				   alphasort() */
+#include <sys/stat.h>		/* struct stat, fstat(), S_ISDIR(),
+				   lstat(), S_ISREG() */
+#include <sys/select.h>		/* fd_set, FD_ZERO(), FD_SETSIZE,
+				   FD_SET(), select(), FD_CLR(),
+				   FD_ISSET() */
+#include <signal.h>		/* struct sigaction, SA_NOCLDSTOP,
+				   sigemptyset(), sigaddset(),
+				   SIGCHLD, sigprocmask(), SIG_BLOCK,
+				   SIG_UNBLOCK, kill(), SIGTERM */
 #include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_IOERR,
 				   EX_CONFIG, EX_UNAVAILABLE, EX_OK */
-#include <errno.h> 		/* errno */
-#include <error.h>		/* error() */
-#include <fnmatch.h>		/* fnmatch() */
+#include <inttypes.h>		/* intmax_t, strtoimax(), PRIdMAX */
+#include <fnmatch.h>		/* fnmatch(), FNM_FILE_NAME,
+				   FNM_PERIOD, FNM_NOMATCH */
 
 #define BUFFER_SIZE 256
 
@@ -179,8 +193,19 @@
   /* Resize the pointed-to array to hold one more pointer */
   char **new_array = NULL;
   do {
-    new_array = realloc(*array, sizeof(char *)
-			* (size_t) ((*len) + 2));
+#if defined(__GLIBC_PREREQ) and __GLIBC_PREREQ(2, 26)
+    new_array = reallocarray(*array, (size_t)((*len) + 2),
+			     sizeof(char *));
+#else
+    if(((size_t)((*len) + 2)) > (SIZE_MAX / sizeof(char *))){
+      /* overflow */
+      new_array = NULL;
+      errno = ENOMEM;
+    } else {
+      new_array = realloc(*array, (size_t)((*len) + 2)
+			  * sizeof(char *));
+    }
+#endif
   } while(new_array == NULL and errno == EINTR);
   /* Malloc check */
   if(new_array == NULL){
@@ -313,9 +338,10 @@
 __attribute__((nonnull))
 static void free_plugin(plugin *plugin_node){
   
-  for(char **arg = plugin_node->argv; *arg != NULL; arg++){
+  for(char **arg = (plugin_node->argv)+1; *arg != NULL; arg++){
     free(*arg);
   }
+  free(plugin_node->name);
   free(plugin_node->argv);
   for(char **env = plugin_node->environ; *env != NULL; env++){
     free(*env);
@@ -585,7 +611,11 @@
       if(arg[0] == '\0'){
 	break;
       }
-      /* FALLTHROUGH */
+#if __GNUC__ >= 7
+      __attribute__((fallthrough));
+#else
+	  /* FALLTHROUGH */
+#endif
     default:
       return ARGP_ERR_UNKNOWN;
     }
@@ -703,10 +733,22 @@
 	
 	custom_argc += 1;
 	{
-	  char **new_argv = realloc(custom_argv, sizeof(char *)
-				    * ((size_t)custom_argc + 1));
+#if defined(__GLIBC_PREREQ) and __GLIBC_PREREQ(2, 26)
+	  char **new_argv = reallocarray(custom_argv,
+					 (size_t)custom_argc + 1,
+					 sizeof(char *));
+#else
+	  char **new_argv = NULL;
+	  if(((size_t)custom_argc + 1) > (SIZE_MAX / sizeof(char *))){
+	    /* overflow */
+	    errno = ENOMEM;
+	  } else {
+	    new_argv = realloc(custom_argv, ((size_t)custom_argc + 1)
+			       * sizeof(char *));
+	  }
+#endif
 	  if(new_argv == NULL){
-	    error(0, errno, "realloc");
+	    error(0, errno, "reallocarray");
 	    exitstatus = EX_OSERR;
 	    free(new_arg);
 	    free(org_line);
@@ -831,6 +873,15 @@
       }
       close(plugindir_fd);
     }
+
+    /* Work around Debian bug #981302
+       <https://bugs.debian.org/981302> */
+    if(lstat("/dev/fd", &st) != 0 and errno == ENOENT){
+      ret = symlink("/proc/self/fd", "/dev/fd");
+      if(ret == -1){
+  	error(0, errno, "Failed to create /dev/fd symlink");
+      }
+    }
   }
   
   /* Lower permissions */

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2019-02-10 04:20:26 +0000
+++ plugin-runner.xml	2019-07-25 22:44:36 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2019-07-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -628,14 +628,14 @@
       <para>
 	Read a different configuration file, run plugins from a
 	different directory, specify an alternate plugin helper
-	directory and add two options to the
+	directory and add four options to the
 	<citerefentry><refentrytitle >mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry> plugin:
       </para>
       <para>
 
 <!-- do not wrap this line -->
-<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/x86_64-linux-gnu/mandos/plugins.d --plugin-helper-dir /usr/lib/x86_64-linux-gnu/mandos/plugin-helpers --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt,--tls-pubkey=tls-pubkey.pem,--tls-privkey=tls-privkey.pem</userinput>
+<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/x86_64-linux-gnu/mandos/plugins.d --plugin-helper-dir /usr/lib/x86_64-linux-gnu/mandos/plugin-helpers --options-for=mandos-client:--pubkey=pubkey.txt,&#x200b;--seckey=seckey.txt,&#x200b;--tls-pubkey=tls-pubkey.pem,&#x200b;--tls-privkey=tls-privkey.pem</userinput>
 
       </para>
     </informalexample>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2019-02-11 07:06:55 +0000
+++ plugins.d/askpass-fifo.c	2021-02-03 08:33:43 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
+ * Copyright © 2008-2019, 2021 Teddy Hogeborn
+ * Copyright © 2008-2019, 2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -23,27 +23,31 @@
  * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
-#include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
-#include <iso646.h>		/* and */
-#include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
+#define _GNU_SOURCE		/* vasprintf(),
+				   program_invocation_short_name */
+#include <sys/types.h>		/* uid_t, gid_t, getuid(), getgid(),
+				   setgid(), setuid() */
+#include <unistd.h>		/* uid_t, gid_t, ssize_t, getuid(),
+				   getgid(), setgid(), setuid(),
+				   read(), close(), write(),
+				   STDOUT_FILENO */
+#include <stdarg.h>		/* va_list, va_start(), vfprintf() */
+#include <stdio.h>		/* vasprintf(), fprintf(), stderr,
+				   vfprintf() */
+#include <errno.h>		/* program_invocation_short_name,
+				   errno, EACCES, ENOTDIR, ELOOP,
 				   ENAMETOOLONG, ENOSPC, EROFS,
 				   ENOENT, EEXIST, EFAULT, EMFILE,
 				   ENFILE, ENOMEM, EBADF, EINVAL, EIO,
 				   EISDIR, EFBIG */
+#include <string.h>		/* strerror() */
 #include <error.h>		/* error() */
-#include <stdio.h>		/* fprintf(), vfprintf(),
-				   vasprintf() */
-#include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(),
-				   realloc(), EXIT_SUCCESS */
+#include <stdlib.h>		/* free(), realloc(), EXIT_SUCCESS */
+#include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
+#include <sysexits.h>		/* EX_OSFILE, EX_OSERR,
+				   EX_UNAVAILABLE, EX_IOERR */
 #include <fcntl.h>		/* open(), O_RDONLY */
-#include <unistd.h>		/* read(), close(), write(),
-				   STDOUT_FILENO */
-#include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
-				   EX_UNAVAILABLE, EX_IOERR */
-#include <string.h> 		/* strerror() */
-#include <stdarg.h>		/* va_list, va_start(), ... */
+#include <stddef.h>		/* NULL, size_t */
 
 uid_t uid = 65534;
 gid_t gid = 65534;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2019-02-11 05:14:10 +0000
+++ plugins.d/mandos-client.c	2021-02-03 08:33:43 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
+ * Copyright © 2008-2021 Teddy Hogeborn
+ * Copyright © 2008-2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -38,69 +38,103 @@
 #define _FILE_OFFSET_BITS 64
 #endif	/* not _FILE_OFFSET_BITS */
 
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
-
-#include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror() */
-#include <stdint.h> 		/* uint16_t, uint32_t, intptr_t */
-#include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
-				   strtof(), abort() */
+#define _GNU_SOURCE		/* program_invocation_short_name,
+				   TEMP_FAILURE_RETRY(), O_CLOEXEC,
+				   scandirat(), asprintf() */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h>		/* strcmp(), strlen(), strerror(),
-				   asprintf(), strncpy(), strsignal()
-				*/
-#include <sys/ioctl.h>		/* ioctl */
-#include <sys/types.h>		/* socket(), inet_pton(), sockaddr,
-				   sockaddr_in6, PF_INET6,
-				   SOCK_STREAM, uid_t, gid_t, open(),
-				   opendir(), DIR */
-#include <sys/stat.h>		/* open(), S_ISREG */
-#include <sys/socket.h>		/* socket(), struct sockaddr_in6,
-				   inet_pton(), connect(),
-				   getnameinfo() */
-#include <fcntl.h>		/* open(), unlinkat(), AT_REMOVEDIR */
-#include <dirent.h>		/* opendir(), struct dirent, readdir()
-				 */
-#include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
-				   strtoimax() */
-#include <errno.h>		/* perror(), errno, EINTR, EINVAL,
-				   EAI_SYSTEM, ENETUNREACH,
+#include <argp.h>		/* argp_program_version,
+				   argp_program_bug_address,
+				   struct argp_option,
+				   struct argp_state, argp_error(),
+				   argp_state_help,
+				   ARGP_HELP_STD_HELP,
+				   ARGP_HELP_EXIT_ERR,
+				   ARGP_HELP_EXIT_OK, ARGP_HELP_USAGE,
+				   argp_err_exit_status,
+				   ARGP_ERR_UNKNOWN, struct argp,
+				   argp_parse(), ARGP_IN_ORDER,
+				   ARGP_NO_HELP */
+#include <stddef.h>		/* NULL, size_t */
+#include <sys/types.h>		/* uid_t, gid_t, sig_atomic_t,
+				   seteuid(), setuid(), pid_t,
+				   setgid(), getuid(), getgid() */
+#include <unistd.h>		/* uid_t, gid_t, TEMP_FAILURE_RETRY(),
+				   seteuid(), setuid(), close(),
+				   ssize_t, read(), fork(), setgid(),
+				   _exit(), dup2(), STDIN_FILENO,
+				   STDERR_FILENO, STDOUT_FILENO,
+				   fexecve(), write(), getuid(),
+				   getgid(), fchown(), symlink(),
+				   sleep(), unlinkat(), pause() */
+#include <netinet/in.h>		/* in_port_t, struct sockaddr_in6,
+				   sa_family_t, struct sockaddr_in,
+				   htons(), IN6_IS_ADDR_LINKLOCAL,
+				   INET_ADDRSTRLEN, INET6_ADDRSTRLEN,
+				   ntohl(), IPPROTO_IP */
+#include <time.h>		/* struct timespec, clock_gettime(),
+				   CLOCK_MONOTONIC, time_t, struct tm,
+				   gmtime_r(), clock_settime(),
+				   CLOCK_REALTIME, nanosleep() */
+#include <errno.h>		/* errno,
+				   program_invocation_short_name,
+				   EINTR, EINVAL, ENETUNREACH,
 				   EHOSTUNREACH, ECONNREFUSED, EPROTO,
-				   EIO, ENOENT, ENXIO, ENOMEM, EISDIR,
-				   ENOTEMPTY,
-				   program_invocation_short_name */
-#include <time.h>		/* nanosleep(), time(), sleep() */
-#include <net/if.h>		/* ioctl, ifreq, SIOCGIFFLAGS, IFF_UP,
-				   SIOCSIFFLAGS, if_indextoname(),
-				   if_nametoindex(), IF_NAMESIZE */
-#include <netinet/in.h>		/* IN6_IS_ADDR_LINKLOCAL,
-				   INET_ADDRSTRLEN, INET6_ADDRSTRLEN
-				*/
-#include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
-				   getuid(), getgid(), seteuid(),
-				   setgid(), pause(), _exit(),
-				   unlinkat() */
-#include <arpa/inet.h>		/* inet_pton(), htons() */
-#include <iso646.h>		/* not, or, and */
-#include <argp.h>		/* struct argp_option, error_t, struct
-				   argp_state, struct argp,
-				   argp_parse(), ARGP_KEY_ARG,
-				   ARGP_KEY_END, ARGP_ERR_UNKNOWN */
-#include <signal.h>		/* sigemptyset(), sigaddset(),
-				   sigaction(), SIGTERM, sig_atomic_t,
-				   raise() */
-#include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
-				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
+				   EIO, ENOENT, ENXIO, error_t,
+				   ENOMEM, EISDIR, ENOTEMPTY */
+#include <stdio.h>		/* fprintf(), stderr, perror(), FILE,
+				   vfprintf(), off_t, SEEK_SET,
+				   stdout, fwrite(), ferror(),
+				   fflush(), asprintf() */
+#include <stdarg.h>		/* va_list, va_start(), vfprintf() */
+#include <stdlib.h>		/* realloc(), free(), malloc(),
+				   getenv(), EXIT_FAILURE, setenv(),
+				   EXIT_SUCCESS, strtof(), strtod(),
+				   srand(), mkdtemp(), abort() */
+#include <string.h>		/* strdup(), strcmp(), strlen(),
+				   strerror(), strncpy(), strspn(),
+				   memcpy(), strrchr(), strchr(),
+				   strsignal() */
+#include <fcntl.h>		/* open(), O_RDONLY, O_DIRECTORY,
+				   O_PATH, O_CLOEXEC, openat(),
+				   O_NOFOLLOW, AT_REMOVEDIR */
+#include <iso646.h>		/* or, and, not */
+#include <sys/stat.h>		/* struct stat, fstat(), fstatat(),
+				   S_ISREG(), S_IXUSR, S_IXGRP,
+				   S_IXOTH, lstat() */
+#include <net/if.h>		/* IF_NAMESIZE, if_indextoname(),
+				   if_nametoindex(), SIOCGIFFLAGS,
+				   IFF_LOOPBACK, IFF_POINTOPOINT,
+				   IFF_BROADCAST, IFF_NOARP, IFF_UP,
+				   IFF_RUNNING, SIOCSIFFLAGS */
+#include <sysexits.h>		/* EX_NOPERM, EX_OSERR,
+				   EX_UNAVAILABLE, EX_USAGE */
+#include <grp.h>		/* setgroups() */
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG() */
-#include <grp.h>		/* setgroups() */
-#include <argz.h>		/* argz_add_sep(), argz_next(),
-				   argz_delete(), argz_append(),
-				   argz_stringify(), argz_add(),
-				   argz_count() */
+				   WEXITSTATUS(), WIFSIGNALED(),
+				   WTERMSIG() */
+#include <signal.h>		/* kill(), SIGTERM, struct sigaction,
+				   SIG_DFL, sigemptyset(),
+				   sigaddset(), SIGINT, SIGHUP,
+				   SIG_IGN, raise() */
+#include <sys/socket.h>		/* struct sockaddr_storage, AF_INET6,
+				   PF_INET6, AF_INET, PF_INET,
+				   socket(), SOCK_STREAM,
+				   SOCK_CLOEXEC, struct sockaddr,
+				   connect(), SOCK_DGRAM */
+#include <argz.h>		/* argz_next(), argz_add_sep(),
+				   argz_delete(), argz_stringify(),
+				   argz_add(), argz_count() */
+#include <inttypes.h>		/* PRIuMAX, uintmax_t, uint32_t,
+				   PRIdMAX, PRIu16, intmax_t,
+				   strtoimax() */
+#include <arpa/inet.h>		/* inet_pton() */
+#include <stdint.h>		/* uint32_t, intptr_t, uint16_t */
 #include <netdb.h>		/* getnameinfo(), NI_NUMERICHOST,
 				   EAI_SYSTEM, gai_strerror() */
+#include <sys/ioctl.h>		/* ioctl() */
+#include <dirent.h>		/* struct dirent, scandirat(),
+				   alphasort(), scandir() */
+#include <limits.h>		/* INT_MAX */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -119,26 +153,22 @@
 
 /* GnuTLS */
 #include <gnutls/gnutls.h>	/* All GnuTLS types, constants and
-				   functions:
-				   gnutls_*
-				   init_gnutls_session(),
-				   GNUTLS_* */
+				   functions: gnutls_*, GNUTLS_* */
 #if GNUTLS_VERSION_NUMBER < 0x030600
 #include <gnutls/openpgp.h>
 			 /* gnutls_certificate_set_openpgp_key_file(),
 			    GNUTLS_OPENPGP_FMT_BASE64 */
 #elif GNUTLS_VERSION_NUMBER >= 0x030606
-#include <gnutls/x509.h>	/* gnutls_pkcs_encrypt_flags_t,
-				 GNUTLS_PKCS_PLAIN,
-				 GNUTLS_PKCS_NULL_PASSWORD */
+#include <gnutls/x509.h>	/* GNUTLS_PKCS_PLAIN,
+				   GNUTLS_PKCS_NULL_PASSWORD */
 #endif
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
 				   functions:
-				   gpgme_*
-				   GPGME_PROTOCOL_OpenPGP,
-				   GPG_ERR_NO_* */
+				   gpgme_*, GPG_ERR_NO_*,
+				   GPGME_IMPORT_*
+				   GPGME_PROTOCOL_OpenPGP */
 
 #define BUFFER_SIZE 256
 
@@ -396,9 +426,8 @@
 	fprintf_plus(stderr,
 		     "Setting system clock to key file mtime");
       }
-      time_t keytime = keystat.st_mtim.tv_sec;
-      if(stime(&keytime) != 0){
-	perror_plus("stime");
+      if(clock_settime(CLOCK_REALTIME, &keystat.st_mtim) != 0){
+	perror_plus("clock_settime");
       }
       ret = lower_privileges();
       if(ret != 0){
@@ -1074,6 +1103,7 @@
       ret = setgid(0);
       if(ret == -1){
 	perror_plus("setgid");
+	close(devnull);
 	_exit(EX_NOPERM);
       }
       /* Reset supplementary groups */
@@ -1081,18 +1111,19 @@
       ret = setgroups(0, NULL);
       if(ret == -1){
 	perror_plus("setgroups");
+	close(devnull);
 	_exit(EX_NOPERM);
       }
     }
     ret = dup2(devnull, STDIN_FILENO);
     if(ret == -1){
       perror_plus("dup2(devnull, STDIN_FILENO)");
+      close(devnull);
       _exit(EX_OSERR);
     }
     ret = close(devnull);
     if(ret == -1){
       perror_plus("close");
-      _exit(EX_OSERR);
     }
     ret = dup2(STDERR_FILENO, STDOUT_FILENO);
     if(ret == -1){
@@ -1133,8 +1164,13 @@
   }
   if(pid == -1){
     perror_plus("fork");
+    close(devnull);
     return false;
   }
+  ret = close(devnull);
+  if(ret == -1){
+    perror_plus("close");
+  }
   int status;
   pid_t pret = -1;
   errno = 0;
@@ -2709,9 +2745,6 @@
   }
   
   {
-    /* Work around Debian bug #633582:
-       <https://bugs.debian.org/633582> */
-    
     /* Re-raise privileges */
     ret = raise_privileges();
     if(ret != 0){
@@ -2720,6 +2753,9 @@
     } else {
       struct stat st;
       
+      /* Work around Debian bug #633582:
+	 <https://bugs.debian.org/633582> */
+
       if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
 	int seckey_fd = open(seckey, O_RDONLY);
 	if(seckey_fd == -1){
@@ -2784,6 +2820,15 @@
 	}
       }
       
+      /* Work around Debian bug #981302
+	 <https://bugs.debian.org/981302> */
+      if(lstat("/dev/fd", &st) != 0 and errno == ENOENT){
+	ret = symlink("/proc/self/fd", "/dev/fd");
+	if(ret == -1){
+	  perror_plus("Failed to create /dev/fd symlink");
+	}
+      }
+
       /* Lower privileges */
       ret = lower_privileges();
       if(ret != 0){

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/mandos-client.xml	2019-07-27 10:11:45 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2019-07-24">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -525,8 +525,8 @@
 	  <para>
 	    This environment variable will be assumed to contain the
 	    directory containing any helper executables.  The use and
-	    nature of these helper executables, if any, is
-	    purposefully not documented.
+	    nature of these helper executables, if any, is purposely
+	    not documented.
 	</para>
 	</listitem>
       </varlistentry>
@@ -816,9 +816,9 @@
   <refsect1 id="security">
     <title>SECURITY</title>
     <para>
-      This program is set-uid to root, but will switch back to the
-      original (and presumably non-privileged) user and group after
-      bringing up the network interface.
+      This program assumes that it is set-uid to root, and will switch
+      back to the original (and presumably non-privileged) user and
+      group after bringing up the network interface.
     </para>
     <para>
       To use this program for its intended purpose (see <xref
@@ -891,7 +891,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.avahi.org/">Avahi</ulink>
+	  <ulink url="https://www.avahi.org/">Avahi</ulink>
 	</term>
       <listitem>
 	<para>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2019-02-11 07:06:55 +0000
+++ plugins.d/password-prompt.c	2021-02-03 08:33:43 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
+ * Copyright © 2008-2019, 2021 Teddy Hogeborn
+ * Copyright © 2008-2019, 2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -23,46 +23,52 @@
  * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* getline(), asprintf() */
-
-#include <termios.h>		/* struct termios, tcsetattr(),
-				   TCSAFLUSH, tcgetattr(), ECHO */
-#include <unistd.h>		/* struct termios, tcsetattr(),
-				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO, readlink() */
-#include <signal.h>		/* sig_atomic_t, raise(), struct
-				   sigaction, sigemptyset(),
-				   sigaction(), sigaddset(), SIGINT,
-				   SIGQUIT, SIGHUP, SIGTERM,
+#define _GNU_SOURCE		/* vasprintf(),
+				   program_invocation_short_name,
+				   asprintf(), getline() */
+#include <sys/types.h>		/* sig_atomic_t, pid_t */
+#include <stdbool.h>		/* bool, false, true */
+#include <argp.h>		/* argp_program_version,
+				   argp_program_bug_address,
+				   struct argp_option,
+				   struct argp_state, argp_state_help,
+				   ARGP_HELP_STD_HELP,
+				   ARGP_HELP_EXIT_ERR,
+				   ARGP_HELP_EXIT_OK, ARGP_HELP_USAGE,
+				   argp_err_exit_status,
+				   ARGP_ERR_UNKNOWN, argp_parse(),
+				   ARGP_IN_ORDER, ARGP_NO_HELP */
+#include <stdarg.h>		/* va_list, va_start(), vfprintf() */
+#include <stdio.h>		/* vasprintf(), fprintf(), stderr,
+				   vfprintf(), asprintf(), getline(),
+				   stdin, feof(), clearerr(),
+				   fputc() */
+#include <errno.h>		/* program_invocation_short_name,
+				   errno, ENOENT, error_t, ENOMEM,
+				   EINVAL, EBADF, ENOTTY, EFAULT,
+				   EFBIG, EIO, ENOSPC, EINTR */
+#include <string.h>		/* strerror(), strrchr(), strcmp() */
+#include <error.h>		/* error() */
+#include <stdlib.h>		/* free(), realloc(), EXIT_SUCCESS,
+				   EXIT_FAILURE, getenv() */
+#include <unistd.h>		/* access(), R_OK, ssize_t, close(),
+				   read(), STDIN_FILENO, write(),
+				   STDOUT_FILENO */
+#include <dirent.h>		/* struct dirent, scandir(),
+				   alphasort() */
+#include <inttypes.h>		/* uintmax_t, strtoumax() */
+#include <iso646.h>		/* or, and, not */
+#include <fcntl.h>		/* open(), O_RDONLY */
+#include <stddef.h>		/* NULL, size_t */
+#include <termios.h>		/* struct termios, tcgetattr(),
+				   tcflag_t, ECHO, tcsetattr(),
+				   TCSAFLUSH */
+#include <signal.h>		/* struct sigaction, sigemptyset(),
+				   sigaddset(), SIGINT, SIGHUP,
+				   SIGTERM, SIG_IGN, SIG_DFL,
 				   raise() */
-#include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t, struct dirent, pid_t,
-				   ssize_t, open() */
-#include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getenv(), free() */
-#include <dirent.h>		/* scandir(), alphasort() */
-#include <stdio.h>		/* fprintf(), stderr, getline(),
-				   stdin, feof(), fputc(), vfprintf(),
-				   vasprintf() */
-#include <errno.h>		/* errno, EBADF, ENOTTY, EINVAL,
-				   EFAULT, EFBIG, EIO, ENOSPC, EINTR
-				*/
-#include <error.h>		/* error() */
-#include <iso646.h>		/* or, not */
-#include <stdbool.h>		/* bool, false, true */
-#include <inttypes.h>		/* strtoumax() */
-#include <sys/stat.h>		/* struct stat, lstat(), open() */
-#include <string.h>		/* strlen, rindex, memcmp, strerror()
-				 */
-#include <argp.h>		/* struct argp_option, struct
-				   argp_state, struct argp,
-				   argp_parse(), error_t,
-				   ARGP_KEY_ARG, ARGP_KEY_END,
-				   ARGP_ERR_UNKNOWN */
-#include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
-				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
-#include <fcntl.h>		/* open() */
-#include <stdarg.h>		/* va_list, va_start(), ... */
+#include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
+				   EX_IOERR, EX_OSFILE, EX_OK */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
@@ -110,6 +116,10 @@
      from the terminal.  Password-prompt will exit if it detects
      plymouth since plymouth performs the same functionality.
    */
+  if(access("/run/plymouth/pid", R_OK) == 0){
+    return true;
+  }
+  
   __attribute__((nonnull))
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
@@ -234,6 +244,7 @@
   struct termios t_new, t_old;
   char *buffer = NULL;
   char *prefix = NULL;
+  char *prompt = NULL;
   int status = EXIT_SUCCESS;
   struct sigaction old_action,
     new_action = { .sa_handler = termination_handler,
@@ -243,6 +254,9 @@
       { .name = "prefix", .key = 'p',
 	.arg = "PREFIX", .flags = 0,
 	.doc = "Prefix shown before the prompt", .group = 2 },
+      { .name = "prompt", .key = 129,
+	.arg = "PROMPT", .flags = 0,
+	.doc = "The prompt to show", .group = 2 },
       { .name = "debug", .key = 128,
 	.doc = "Debug mode", .group = 3 },
       /*
@@ -261,12 +275,15 @@
     error_t parse_opt (int key, char *arg, struct argp_state *state){
       errno = 0;
       switch (key){
-      case 'p':
+      case 'p':			/* --prefix */
 	prefix = arg;
 	break;
-      case 128:
+      case 128:			/* --debug */
 	debug = true;
 	break;
+      case 129:			/* --prompt */
+	prompt = arg;
+	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
 	 */
@@ -427,7 +444,9 @@
     if(prefix){
       fprintf(stderr, "%s ", prefix);
     }
-    {
+    if(prompt != NULL){
+      fprintf(stderr, "%s: ", prompt);
+    } else {
       const char *cryptsource = getenv("CRYPTTAB_SOURCE");
       const char *crypttarget = getenv("CRYPTTAB_NAME");
       /* Before cryptsetup 1.1.0~rc2 */
@@ -508,19 +527,23 @@
     }
     if(sret < 0){
       int e = errno;
-      if(errno != EINTR and not feof(stdin)){
-	error_plus(0, errno, "getline");
-	switch(e){
-	case EBADF:
-	  status = EX_UNAVAILABLE;
-	  break;
-	case EIO:
-	case EINVAL:
-	default:
-	  status = EX_IOERR;
-	  break;
+      if(errno != EINTR){
+	if(not feof(stdin)){
+	  error_plus(0, errno, "getline");
+	  switch(e){
+	  case EBADF:
+	    status = EX_UNAVAILABLE;
+	    break;
+	  case EIO:
+	  case EINVAL:
+	  default:
+	    status = EX_IOERR;
+	    break;
+	  }
+	  break;
+	} else {
+	  clearerr(stdin);
 	}
-	break;
       }
     }
     /* if(sret == 0), then the only sensible thing to do is to retry

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/password-prompt.xml	2019-07-27 10:11:45 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2019-07-27">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -69,6 +69,9 @@
 	>PREFIX</replaceable></arg>
       </group>
       <sbr/>
+      <arg choice="opt">
+	<option>--prompt <replaceable>PROMPT</replaceable></option>
+      </arg>
       <arg choice="opt"><option>--debug</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -110,6 +113,15 @@
       wrapper, although actual use of that function is not guaranteed
       or implied.
     </para>
+    <para>
+      This program tries to detect if a Plymouth daemon
+      (<citerefentry><refentrytitle
+      >plymouthd</refentrytitle><manvolnum>8</manvolnum></citerefentry>)
+      is running, by looking for a
+      <filename>/run/plymouth/pid</filename> file or a process named
+      <quote><literal>plymouthd</literal></quote>.  If it is detected,
+      this process will immediately exit without doing anything.
+    </para>
   </refsect1>
   
   <refsect1 id="options">
@@ -138,6 +150,18 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--prompt=<replaceable
+	>PROMPT</replaceable></option></term>
+	<listitem>
+	  <para>
+	    The password prompt.  Using this option will make this
+	    program ignore the <envar>CRYPTTAB_SOURCE</envar> and
+	    <envar>CRYPTTAB_NAME</envar> environment variables.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--debug</option></term>
 	<listitem>
 	  <para>
@@ -197,7 +221,8 @@
 	<term><envar>CRYPTTAB_NAME</envar></term>
 	<listitem>
 	  <para>
-	    If set, these environment variables will be assumed to
+	    If set, and if the <option>--prompt</option> option is not
+	    used, these environment variables will be assumed to
 	    contain the source device name and the target device
 	    mapper name, respectively, and will be shown as part of
 	    the prompt.
@@ -205,22 +230,13 @@
 	<para>
 	  These variables will normally be inherited from
 	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
+	  <manvolnum>8mandos</manvolnum></citerefentry>, which might
+	  have in turn inherited them from its calling process.
 	</para>
 	<para>
 	  This behavior is meant to exactly mirror the behavior of
-	  <command>askpass</command>, the default password prompter.
+	  <command>askpass</command>, the default password prompter
+	  from initramfs-tools.
 	</para>
 	</listitem>
       </varlistentry>
@@ -301,13 +317,13 @@
     <title>SEE ALSO</title>
     <para>
       <citerefentry><refentrytitle>intro</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>plymouthd</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>
     </para>
   </refsect1>
 </refentry>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2018-02-08 10:23:55 +0000
+++ plugins.d/plymouth.c	2021-02-03 08:33:43 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2018 Teddy Hogeborn
- * Copyright © 2010-2018 Björn Påhlsson
+ * Copyright © 2010-2021 Teddy Hogeborn
+ * Copyright © 2010-2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -23,38 +23,59 @@
  * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
-#include <signal.h>		/* sig_atomic_t, struct sigaction,
-				   sigemptyset(), sigaddset(), SIGINT,
-				   SIGHUP, SIGTERM, sigaction(),
-				   kill(), SIG_IGN */
+#define _GNU_SOURCE		/* program_invocation_short_name,
+				   vasprintf(), asprintf(),
+				   TEMP_FAILURE_RETRY() */
+#include <sys/types.h>		/* sig_atomic_t, pid_t, setuid(),
+				   geteuid(), setsid() */
+#include <argp.h>		/* argp_program_version,
+				   argp_program_bug_address,
+				   struct argp_option,
+				   struct argp_state,
+				   ARGP_ERR_UNKNOWN, struct argp,
+				   argp_parse(), ARGP_IN_ORDER */
+#include <stddef.h>		/* NULL, size_t */
 #include <stdbool.h>		/* bool, false, true */
+#include <stdio.h>		/* FILE, fprintf(), vfprintf(),
+				   vasprintf(), stderr, asprintf(),
+				   fopen(), fscanf(), fclose(),
+				   sscanf() */
+#include <stdarg.h>		/* va_list, va_start(), vfprintf() */
+#include <errno.h>		/* program_invocation_short_name,
+				   errno, ENOMEM, EINTR, ENOENT,
+				   error_t, EINVAL */
+#include <string.h>		/* strerror(), strdup(), memcmp() */
+#include <error.h>		/* error() */
+#include <stdlib.h>		/* free(), getenv(), malloc(),
+				   reallocarray(), realloc(),
+				   EXIT_FAILURE, EXIT_SUCCESS */
+#include <unistd.h>		/* TEMP_FAILURE_RETRY(), setuid(),
+				   geteuid(), setsid(), chdir(),
+				   dup2(), STDERR_FILENO,
+				   STDOUT_FILENO, fork(), _exit(),
+				   execv(), ssize_t, readlink(),
+				   close(), read(), access(), X_OK */
+#include <signal.h>		/* kill(), SIGTERM, struct sigaction,
+				   sigemptyset(), SIGINT, SIGHUP,
+				   sigaddset(), SIG_IGN */
+#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
+				   WEXITSTATUS(), WIFSIGNALED(),
+				   WTERMSIG() */
+#include <iso646.h>		/* not, and, or */
+#include <sysexits.h>		/* EX_OSERR, EX_USAGE,
+				   EX_UNAVAILABLE */
+#include <stdint.h>		/* SIZE_MAX */
+#include <dirent.h>		/* struct dirent, scandir(),
+				   alphasort() */
+#include <inttypes.h>		/* uintmax_t, strtoumax(), SCNuMAX,
+				   PRIuMAX */
+#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK() */
 #include <fcntl.h>		/* open(), O_RDONLY */
-#include <iso646.h>		/* and, or, not*/
-#include <sys/types.h>		/* size_t, ssize_t, pid_t, struct
-				   dirent, waitpid() */
-#include <sys/wait.h>		/* waitpid() */
-#include <stddef.h>		/* NULL */
-#include <string.h>		/* strchr(), memcmp() */
-#include <stdio.h>		/* asprintf(), perror(), fopen(),
-				   fscanf(), vasprintf(), fprintf(),
-				   vfprintf() */
-#include <unistd.h>		/* close(), readlink(), read(),
-				   fork(), setsid(), chdir(), dup2(),
-				   STDERR_FILENO, execv(), access() */
-#include <stdlib.h>		/* free(), EXIT_FAILURE, realloc(),
-				   EXIT_SUCCESS, malloc(), _exit(),
-				   getenv() */
-#include <dirent.h>		/* scandir(), alphasort() */
-#include <inttypes.h>		/* intmax_t, strtoumax(), SCNuMAX */
-#include <sys/stat.h>		/* struct stat, lstat() */
-#include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
-#include <error.h>		/* error() */
-#include <errno.h>		/* TEMP_FAILURE_RETRY */
 #include <argz.h>		/* argz_count(), argz_extract() */
-#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
+const char *argp_program_version = "plymouth " VERSION;
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 
 /* Used by Ubuntu 11.04 (Natty Narwahl) */
 const char plymouth_old_old_pid[] = "/dev/.initramfs/plymouth.pid";
@@ -69,6 +90,7 @@
 					"--mode=boot",
 					"--attach-to-session",
 					NULL };
+bool debug = false;
 
 static void termination_handler(__attribute__((unused))int signum){
   if(interrupted_by_signal){
@@ -77,6 +99,14 @@
   interrupted_by_signal = 1;
 }
 
+__attribute__((format (gnu_printf, 2, 3), nonnull))
+int fprintf_plus(FILE *stream, const char *format, ...){
+  va_list ap;
+  va_start (ap, format);
+  fprintf(stream, "Mandos plugin %s: ", program_invocation_short_name);
+  return vfprintf(stream, format, ap);
+}
+
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
@@ -159,11 +189,18 @@
 
 __attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
-		   const char * const *argv, bool interruptable,
+		   const char * const * const argv, bool interruptable,
 		   bool daemonize){
   int status;
   int ret;
   pid_t pid;
+  if(debug){
+    for(const char * const *arg = argv; *arg != NULL; arg++){
+      fprintf_plus(stderr, "exec_and_wait arg: %s\n", *arg);
+    }
+    fprintf_plus(stderr, "exec_and_wait end of args\n");
+  }
+
   pid = fork();
   if(pid == -1){
     error_plus(0, errno, "fork");
@@ -185,9 +222,20 @@
     char **tmp;
     int i = 0;
     for (; argv[i] != NULL; i++){
-      tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 2));
+#if defined(__GLIBC_PREREQ) and __GLIBC_PREREQ(2, 26)
+      tmp = reallocarray(new_argv, ((size_t)i + 2),
+			 sizeof(const char *));
+#else
+      if(((size_t)i + 2) > (SIZE_MAX / sizeof(const char *))){
+	/* overflow */
+	tmp = NULL;
+	errno = ENOMEM;
+      } else {
+	tmp = realloc(new_argv, ((size_t)i + 2) * sizeof(const char *));
+      }
+#endif
       if(tmp == NULL){
-	error_plus(0, errno, "realloc");
+	error_plus(0, errno, "reallocarray");
 	free(new_argv);
 	_exit(EX_OSERR);
       }
@@ -209,12 +257,24 @@
 	  and ((not interrupted_by_signal)
 	       or (not interruptable)));
   if(interrupted_by_signal and interruptable){
+    if(debug){
+      fprintf_plus(stderr, "Interrupted by signal\n");
+    }
     return false;
   }
   if(ret == -1){
     error_plus(0, errno, "waitpid");
     return false;
   }
+  if(debug){
+    if(WIFEXITED(status)){
+      fprintf_plus(stderr, "exec_and_wait exited: %d\n",
+		   WEXITSTATUS(status));
+    } else if(WIFSIGNALED(status)) {
+      fprintf_plus(stderr, "exec_and_wait signaled: %d\n",
+		   WTERMSIG(status));
+    }
+  }
   if(WIFEXITED(status) and (WEXITSTATUS(status) == 0)){
     return true;
   }
@@ -407,17 +467,69 @@
 
 int main(__attribute__((unused))int argc,
 	 __attribute__((unused))char **argv){
-  char *prompt;
+  char *prompt = NULL;
   char *prompt_arg;
   pid_t plymouth_command_pid;
   int ret;
   bool bret;
 
+  {
+    struct argp_option options[] = {
+      { .name = "prompt", .key = 128, .arg = "PROMPT",
+	.doc = "The prompt to show" },
+      { .name = "debug", .key = 129,
+	.doc = "Debug mode" },
+      { .name = NULL }
+    };
+    
+    __attribute__((nonnull(3)))
+    error_t parse_opt (int key, char *arg, __attribute__((unused))
+		       struct argp_state *state){
+      errno = 0;
+      switch (key){
+      case 128:			/* --prompt */
+	prompt = arg;
+	if(debug){
+	  fprintf_plus(stderr, "Custom prompt \"%s\"\n", prompt);
+	}
+	break;
+      case 129:			/* --debug */
+	debug = true;
+	break;
+      default:
+	return ARGP_ERR_UNKNOWN;
+      }
+      return errno;
+    }
+    
+    struct argp argp = { .options = options, .parser = parse_opt,
+			 .args_doc = "",
+			 .doc = "Mandos plymouth -- Read and"
+			 " output a password" };
+    ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, NULL, NULL);
+    switch(ret){
+    case 0:
+      break;
+    case ENOMEM:
+    default:
+      errno = ret;
+      error_plus(0, errno, "argp_parse");
+      return EX_OSERR;
+    case EINVAL:
+      error_plus(0, errno, "argp_parse");
+      return EX_USAGE;
+    }
+  }
+  
   /* test -x /bin/plymouth */
   ret = access(plymouth_path, X_OK);
   if(ret == -1){
     /* Plymouth is probably not installed.  Don't print an error
        message, just exit. */
+    if(debug){
+      fprintf_plus(stderr, "Plymouth (%s) not found\n",
+		   plymouth_path);
+    }
     exit(EX_UNAVAILABLE);
   }
   
@@ -457,17 +569,27 @@
     }
     /* Plymouth is probably not running.  Don't print an error
        message, just exit. */
+    if(debug){
+      fprintf_plus(stderr, "Plymouth not running\n");
+    }
     exit(EX_UNAVAILABLE);
   }
   
-  prompt = makeprompt();
-  ret = asprintf(&prompt_arg, "--prompt=%s", prompt);
-  free(prompt);
+  if(prompt != NULL){
+    ret = asprintf(&prompt_arg, "--prompt=%s", prompt);
+  } else {
+    char *made_prompt = makeprompt();
+    ret = asprintf(&prompt_arg, "--prompt=%s", made_prompt);
+    free(made_prompt);
+  }
   if(ret == -1){
     error_plus(EX_OSERR, errno, "asprintf");
   }
   
   /* plymouth ask-for-password --prompt="$prompt" */
+  if(debug){
+    fprintf_plus(stderr, "Prompting for password via Plymouth\n");
+  }
   bret = exec_and_wait(&plymouth_command_pid,
 		       plymouth_path, (const char *[])
 		       { plymouth_path, "ask-for-password",

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/plymouth.xml	2019-07-27 10:11:45 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2019-07-27">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -61,6 +61,28 @@
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
+      <arg choice="opt">
+	<option>--prompt <replaceable>PROMPT</replaceable></option>
+      </arg>
+      <arg><option>--debug</option></arg>
+    </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <group choice="req">
+	<arg choice="plain"><option>--help</option></arg>
+	<arg choice="plain"><option>-?</option></arg>
+      </group>
+    </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <arg choice="plain"><option>--usage</option></arg>
+    </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <group choice="req">
+	<arg choice="plain"><option>--version</option></arg>
+	<arg choice="plain"><option>-V</option></arg>
+      </group>
     </cmdsynopsis>
   </refsynopsisdiv>
   
@@ -102,8 +124,68 @@
   <refsect1 id="options">
     <title>OPTIONS</title>
     <para>
-      This program takes no options.
+      This program is commonly not invoked from the command line; it
+      is normally started by the <application>Mandos</application>
+      plugin runner, see <citerefentry><refentrytitle
+      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
+      </citerefentry>.  Any command line options this program accepts
+      are therefore normally provided by the plugin runner, and not
+      directly.
     </para>
+    
+    <variablelist>
+      <varlistentry>
+	<term><option>--prompt=<replaceable
+	>PROMPT</replaceable></option></term>
+	<listitem>
+	  <para>
+	    The password prompt.  Note that using this option will
+	    make this program ignore the <envar>cryptsource</envar>
+	    and <envar>crypttarget</envar> environment variables.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--debug</option></term>
+	<listitem>
+	  <para>
+	    Enable debug mode.  This will enable a lot of output to
+	    standard error about what the program is doing.  The
+	    program will still perform all other functions normally.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--help</option></term>
+	<term><option>-?</option></term>
+	<listitem>
+	  <para>
+	    Gives a help message about options and their meanings.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--usage</option></term>
+	<listitem>
+	  <para>
+	    Gives a short usage message.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--version</option></term>
+	<term><option>-V</option></term>
+	<listitem>
+	  <para>
+	    Prints the program version.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
   </refsect1>
   
   <refsect1 id="exit_status">
@@ -125,7 +207,8 @@
 	<term><envar>crypttarget</envar></term>
 	<listitem>
 	  <para>
-	    If set, these environment variables will be assumed to
+	    If set, and if the <option>--prompt</option> option is not
+	    used, these environment variables will be assumed to
 	    contain the source device name and the target device
 	    mapper name, respectively, and will be shown as part of
 	    the prompt.
@@ -133,22 +216,13 @@
 	<para>
 	  These variables will normally be inherited from
 	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
+	  <manvolnum>8mandos</manvolnum></citerefentry>, which might
+	  have in turn inherited them from its calling process.
 	</para>
 	<para>
 	  This behavior is meant to exactly mirror the behavior of
-	  <command>askpass</command>, the default password prompter.
+	  <command>askpass</command>, the default password prompter
+	  from initramfs-tools.
 	</para>
 	</listitem>
       </varlistentry>
@@ -221,12 +295,20 @@
     </para>
     <informalexample>
       <para>
-	This program takes no options.
+	Normal invocation needs no options:
       </para>
       <para>
 	<userinput>&COMMANDNAME;</userinput>
       </para>
     </informalexample>
+    <informalexample>
+      <para>
+	Show a different prompt.
+      </para>
+      <para>
+	<userinput>&COMMANDNAME; --prompt=Password</userinput>
+      </para>
+    </informalexample>
   </refsect1>
   
   <refsect1 id="security">
@@ -272,8 +354,6 @@
     <para>
       <citerefentry><refentrytitle>intro</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>proc</refentrytitle>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2018-02-08 10:23:55 +0000
+++ plugins.d/splashy.c	2021-02-03 08:33:43 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2018 Teddy Hogeborn
- * Copyright © 2008-2018 Björn Påhlsson
+ * Copyright © 2008-2018, 2021 Teddy Hogeborn
+ * Copyright © 2008-2018, 2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -23,40 +23,45 @@
  * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
-#include <signal.h>		/* sig_atomic_t, struct sigaction,
-				   sigemptyset(), sigaddset(), SIGINT,
-				   SIGHUP, SIGTERM, sigaction,
-				   SIG_IGN, kill(), SIGKILL */
-#include <stddef.h>		/* NULL */
-#include <stdlib.h>		/* getenv() */
-#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
-				   fprintf() */
-#include <stdlib.h>		/* EXIT_FAILURE, free(),
-				   EXIT_SUCCESS */
-#include <sys/types.h>		/* pid_t, DIR, struct dirent,
-				   ssize_t */
-#include <dirent.h>		/* opendir(), readdir(), closedir() */
-#include <inttypes.h>		/* intmax_t, strtoimax() */
-#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
-#include <iso646.h>		/* not, or, and */
-#include <unistd.h>		/* readlink(), fork(), execl(),
-				   sleep(), dup2() STDERR_FILENO,
-				   STDOUT_FILENO, _exit(),
-				   pause() */
-#include <string.h>		/* memcmp(), strerror() */
-#include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
+#define _GNU_SOURCE		/* vasprintf(),
+				   program_invocation_short_name,
+				   asprintf(), TEMP_FAILURE_RETRY() */
+#include <sys/types.h>		/* sig_atomic_t, pid_t, setuid(),
+				   geteuid(), setsid() */
+#include <stdarg.h>		/* va_list, va_start(), vfprintf() */
+#include <stdio.h>		/* vasprintf(), fprintf(), stderr,
+				   vfprintf(), asprintf() */
+#include <errno.h>		/* program_invocation_short_name,
+				   errno, EACCES, ENOTDIR, ELOOP,
 				   ENOENT, ENAMETOOLONG, EMFILE,
 				   ENFILE, ENOMEM, ENOEXEC, EINVAL,
 				   E2BIG, EFAULT, EIO, ETXTBSY,
 				   EISDIR, ELIBBAD, EPERM, EINTR,
 				   ECHILD */
+#include <string.h>		/* strerror(), memcmp() */
 #include <error.h>		/* error() */
+#include <stdlib.h>		/* free(), EXIT_FAILURE, getenv(),
+				   EXIT_SUCCESS, abort() */
+#include <stddef.h>		/* NULL */
+#include <dirent.h>		/* DIR, opendir(), struct dirent,
+				   readdir(), closedir() */
+#include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
+				   EX_UNAVAILABLE */
+#include <inttypes.h>		/* intmax_t, strtoimax() */
+#include <iso646.h>		/* or, not, and */
+#include <unistd.h>		/* ssize_t, readlink(), fork(),
+				   execl(), _exit(),
+				   TEMP_FAILURE_RETRY(), sleep(),
+				   setuid(), geteuid(), setsid(),
+				   chdir(), dup2(), STDERR_FILENO,
+				   STDOUT_FILENO, pause() */
+#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK() */
+#include <signal.h>		/* struct sigaction, sigemptyset(),
+				   sigaddset(), SIGINT, SIGHUP,
+				   SIGTERM, SIG_IGN, kill(), SIGKILL,
+				   SIG_DFL, raise() */
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
 				   WEXITSTATUS() */
-#include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
-				   EX_UNAVAILABLE */
-#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/splashy.xml	2019-07-27 10:11:45 +0000
@@ -135,18 +135,8 @@
 	<para>
 	  These variables will normally be inherited from
 	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
+	  <manvolnum>8mandos</manvolnum></citerefentry>, which might
+	  have in turn inherited them from its calling process.
 	</para>
 	<para>
 	  This behavior is meant to exactly mirror the behavior of
@@ -276,8 +266,6 @@
     <para>
       <citerefentry><refentrytitle>intro</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>proc</refentrytitle>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2018-02-08 10:23:55 +0000
+++ plugins.d/usplash.c	2021-02-03 08:33:43 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2018 Teddy Hogeborn
- * Copyright © 2008-2018 Björn Påhlsson
+ * Copyright © 2008-2018, 2021 Teddy Hogeborn
+ * Copyright © 2008-2018, 2021 Björn Påhlsson
  * 
  * This file is part of Mandos.
  * 
@@ -23,36 +23,42 @@
  * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
-#include <signal.h>		/* sig_atomic_t, struct sigaction,
-				   sigemptyset(), sigaddset(), SIGINT,
-				   SIGHUP, SIGTERM, sigaction(),
-				   SIG_IGN, kill(), SIGKILL */
+#define _GNU_SOURCE		/* vasprintf(),
+				   program_invocation_short_name,
+				   asprintf(), TEMP_FAILURE_RETRY() */
+#include <sys/types.h>		/* sig_atomic_t, pid_t, setuid(),
+				   geteuid(), setsid() */
+#include <stdarg.h>		/* va_list, va_start(), vfprintf() */
+#include <stdio.h>		/* vasprintf(), fprintf(), stderr,
+				   vfprintf(), asprintf() */
+#include <errno.h>		/* program_invocation_short_name,
+				   errno, ENOENT, EINTR */
+#include <string.h>		/* strerror(), strlen(), memcmp() */
+#include <error.h>		/* error() */
+#include <stdlib.h>		/* free(), getenv(), realloc(),
+				   EXIT_FAILURE, EXIT_SUCCESS,
+				   malloc(), abort() */
 #include <stdbool.h>		/* bool, false, true */
 #include <fcntl.h>		/* open(), O_WRONLY, O_RDONLY */
-#include <iso646.h>		/* and, or, not*/
-#include <errno.h>		/* errno, EINTR */
-#include <error.h>
-#include <sys/types.h>		/* size_t, ssize_t, pid_t, DIR, struct
-				   dirent */
-#include <stddef.h>		/* NULL */
-#include <string.h>		/* strlen(), memcmp(), strerror() */
-#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
-				   fprintf() */
-#include <unistd.h>		/* close(), write(), readlink(),
-				   read(), STDOUT_FILENO, sleep(),
-				   fork(), setuid(), geteuid(),
-				   setsid(), chdir(), dup2(),
-				   STDERR_FILENO, execv() */
-#include <stdlib.h>		/* free(), EXIT_FAILURE, realloc(),
-				   EXIT_SUCCESS, malloc(), _exit(),
-				   getenv() */
-#include <dirent.h>		/* opendir(), readdir(), closedir() */
+#include <stddef.h>		/* size_t, NULL */
+#include <unistd.h>		/* close(), ssize_t, write(),
+				   readlink(), read(), STDOUT_FILENO,
+				   sleep(), fork(), setuid(),
+				   geteuid(), setsid(), chdir(),
+				   _exit(), dup2(), STDERR_FILENO,
+				   execv(), TEMP_FAILURE_RETRY(),
+				   pause() */
+#include <dirent.h>		/* DIR, opendir(), struct dirent,
+				   readdir(), closedir() */
 #include <inttypes.h>		/* intmax_t, strtoimax() */
-#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
+#include <iso646.h>		/* or, not, and */
+#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK() */
 #include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
+#include <signal.h>		/* struct sigaction, sigemptyset(),
+				   sigaddset(), SIGINT, SIGHUP,
+				   SIGTERM, SIG_IGN, kill(), SIGKILL,
+				   SIG_DFL, raise() */
 #include <argz.h>		/* argz_count(), argz_extract() */
-#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/usplash.xml	2019-07-27 10:11:45 +0000
@@ -135,18 +135,8 @@
 	<para>
 	  These variables will normally be inherited from
 	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
+	  <manvolnum>8mandos</manvolnum></citerefentry>, which might
+	  have in turn inherited them from its calling process.
 	</para>
 	<para>
 	  This behavior is meant to exactly mirror the behavior of
@@ -290,8 +280,6 @@
     <para>
       <citerefentry><refentrytitle>intro</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>fifo</refentrytitle>
       <manvolnum>7</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== added file 'sysusers.d-mandos.conf'
--- sysusers.d-mandos.conf	1970-01-01 00:00:00 +0000
+++ sysusers.d-mandos.conf	2019-08-18 00:42:22 +0000
@@ -0,0 +1,3 @@
+# This file will be installed as mandos.conf and/or mandos-client.conf
+# in the /usr/lib/sysusers.d directory.  See sysusers.d(5)
+u _mandos - "Mandos password system"

